<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on April 24, 2009 at 2:50:27 pm</time-stamp>
<!-- Changes from: PV-Datachannel(Kila.279,sourcecontrol)  to: PV-Datachannel(Kila.279.94,sourcecontrol) -->


<methods>
<class-id>Smee.SmeeScalarParameterDescriptor</class-id> <category>compiling</category>

<body package="Smee-Core" selector="buildArgWith:with:">buildArgWith: parameterNumberStream with: builder 
	
	^([parameterNumberStream next] 
		on: parameterNumberStream class endOfStreamSignal
		do: [:ex | nil]) 
			ifNil: [builder forNil]
			ifNotNil: 
				[:num | 
				self 
					coerceArg: 
						(self 
							argNumber: num
							with: builder)
					with: builder]</body>
</methods>



<methods>
<class-id>Smee.SmeeGlobal</class-id> <category>function properties</category>

<body package="Smee-Objects" selector="parseInt:radix:">parseInt: aString radix: radixIn 
	&lt;instanceFunctionNamed: #parseInt length: 2 args: 'aString radix' comment: 'Parse the expression and return the number using the specified radix. If not a valid expression, return NaN.'&gt;
	
	| radix strm pos sign number |
	radix := radixIn ifNil: [10].
	radix := radix smeeToNumber.
	radix isZero 
		ifTrue: [radix := 10].
	strm := aString smeeToString readStream.
	radix = 10 
		ifTrue: 
			[SmeeHelper skipWhitespaceOn: strm.
			sign := SmeeHelper scanSignOn: strm.
			pos := strm position.
			((strm peekFor: $0) and: [(strm peekFor: $x) or: [strm peekFor: $X]]) 
				ifTrue: [radix := 16]
				ifFalse: 
					[strm position: pos.
					^(SmeeHelper scanStrDecimalLiteralOn: strm) 
							ifNil: [SmeeNaN]
							ifNotNil: [:num | num asInteger * sign]]].
	SmeeHelper skipWhitespaceOn: strm.
	sign := sign ifNil: [SmeeHelper scanSignOn: strm].
	pos := strm position.
	number := 
		Number 
			readIntegerFrom: strm
			radix: radix.
	^pos = strm position 
		ifTrue: [SmeeNaN]
		ifFalse: [number * sign]</body>
</methods>



<methods>
<class-id>Core.Boolean</class-id> <category>Smee</category>

<body package="Smee-Primitive Values" selector="smeeSumFromString:">smeeSumFromString: aString
	^self smeeToNumber smeeSumFromString: aString</body>
</methods>



<class>
<name>PvSystemSupport</name>
<environment>PROVISO</environment>
<super>External.ExternalInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles></includeFiles>
<includeDirectories></includeDirectories>
<libraryFiles></libraryFiles>
<libraryDirectories><item>c:\Proviso\5.1</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.SharedPriorityQueue</class-id> <category>access operations</category>

<body package="PV-Base Extensions" selector="contents">contents
	"&lt;OrderedCollection&gt; Answer the contents of the queue" 

	^[accessProtect critical: [contents copy]] valueUninterruptably</body>
</methods>


<methods>
<class-id>Core.Number</class-id> <category>testing</category>

<body package="PV-Base Extensions" selector="isFinite">isFinite

	^true</body>
</methods>


<methods>
<class-id>Core.Collection</class-id> <category>parameters</category>

<body package="PV-Base Extensions" selector="asParameterListString">asParameterListString
	
	^String streamContents: 
		[:out | 
		out nextPut: $(.
		self 
			do: [:each | out print: each]
			separatedBy: [out nextPutAll: ','].
		out nextPut: $)]</body>
</methods>


<methods>
<class-id>Kernel.BlockClosure</class-id> <category>PROVISO</category>

<body package="PV-Base Extensions" selector="onImmediateNotUnderstoodDo:">onImmediateNotUnderstoodDo: exceptionBlock 
	"Only signal MessageNotUnderstood if the message send is not an immediate send in the block"
	
	^self 
		on: MessageNotUnderstood
		do: 
			[:problem | 
			| myContext problemContext |
			myContext := thisContext supposedHome.
			problemContext := problem initialContext sender sender sender.
			(problemContext == myContext and: 
				[self method allSymbolLiterals includes: problem message selector]) 
					ifTrue: [exceptionBlock valueWithPossibleArgs: (Array with: problem)]
					ifFalse: [problem pass]]</body>
</methods>


<methods>
<class-id>Core.Date class</class-id> <category>PROVISO</category>

<body package="PV-Base Extensions" selector="secondsInDay">secondsInDay

	^SecondsInDay</body>

<body package="PV-Base Extensions" selector="secondsInWeek">secondsInWeek
	" self secondsInWeek "

	^self secondsInDay * 7</body>
</methods>


<methods>
<class-id>Core.Symbol</class-id> <category>accessing</category>

<body package="PV-Base Extensions" selector="findNextUnusedMessageIdForDL">findNextUnusedMessageIdForDL
	"DL messages start at 39000"

	^#DL39000 privateFindNextUnusedMessageId</body>

<body package="PV-Base Extensions" selector="findNextUnusedMessageIdForDC">findNextUnusedMessageIdForDC
	"DC messages start at 10000"
	^#DC10000 privateFindNextUnusedMessageId</body>

<body package="PV-Base Extensions" selector="privateFindNextUnusedMessageId">privateFindNextUnusedMessageId
	"
	#DC10000 privateFindNextUnusedMessageId
	#DL39000 privateFindNextUnusedMessageId
	"

	| firstNum letters number |
	firstNum := (1 to: self size) detect: [ :i | (self at: i) isDigit] ifNone: [(self size + 1)].
	letters := self copyFrom: 1 to: (firstNum - 1).
	number := (self copyFrom: firstNum to: self size) asNumber.

	[(Symbol findInterned: (letters, number asString)) ifNil: [^(letters, number asString)].
	number := number + 1] repeat.</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.Core.Symbol</class-id> <selector>findNextUnusedMessageId</selector>
</remove-selector>

<class>
<name>PvUnixSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvUnixSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item> <item>netdb.h</item> <item>sys/systeminfo.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libprovisodc.so</item> <item>libc.so</item> <item>libnsl.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/apikovsk/Kila/Kila.279.24</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseKila/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<class>
<name>PvLinuxSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvUnixSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvLinuxSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libc.so</item> <item>libprovisodc.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/apikovsk/Kila/Kila.279.24</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseKila/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>


<methods>
<class-id>PROVISO.PvDCBuilder</class-id> <category>targets</category>

<body package="PV-Datachannel-Build" selector="doIVEImage">doIVEImage
	"self new doIVEImage"
	&lt;prerequisites: #(doHeadlessImage) 
		products: #(iveImagePath)&gt;
	&lt;scriptIn: #buildImagePath compress: true&gt;
	
	| packages package |
	Store.RepositoryManager loadRepositoriesFromXmlOn: 
		self class defaultStoreRepositories readStream.
	"loadSilentlyPackages: does this, but it tries to load the bundle with same name, not what we want here"
	'proviso' ifNotNil: 
		[:reposName | 
		(Store.DbRegistry connectedProfile isNil or: 
			[Store.DbRegistry connectedProfile name ~= reposName]) 
				ifTrue: [self connectToRepository: reposName].
		'PV-Monitoring' ifNotNil: 
			[:packageName | 
			packages := Store.Package allVersionsWithName: packageName.
			(packages anySatisfy: #existsInImage) 
				ifFalse: 
					[package := 
						packages isEmpty 
							ifTrue: [nil]
							ifFalse: [packages first].
					package isNil 
						ifTrue: [self error: 'There is no package ' , packageName , '  in repository']
						ifFalse: 
							[Transcript
								show: 'Loading ' , packageName , ',' , package version;
								cr.
							package loadSrc]]].
		self disconnectFromRepository]</body>
</methods>

<methods>
<class-id>PROVISO.PvDCBuilder</class-id> <category>paths</category>

<body package="PV-Datachannel-Build" selector="iveImagePath">iveImagePath

	^self workingDirectory, 'ive.im'</body>
</methods>



<class>
<name>Math</name>
<environment>PROVISO.Smee</environment>
<super>Smee.SmeeAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>PV-Smee</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.Smee.Math</class-id> <category>accessing</category>

<body package="PV-Smee" selector="getAccumulatedDurationForIntervals:">getAccumulatedDurationForIntervals: aCollectionOfPvCalendarTimeIntervals
	"getDurations(intervals) on Math or PV to return array of seconds (integers) representing the durations of intervals passed in"
	"SmeeEnvironment current: PROVISO.Smee.Environment new.
	self new getAccumulatedDurationForIntervals: #(#(100 119) #( 140 160))
"

	^(self getDurationsForIntervals: aCollectionOfPvCalendarTimeIntervals) inject: 0 into: [:total :each | total + each]</body>

<body package="PV-Smee" selector="smeeGetIntervalsForTuples:from:to:criteria:defaultInOutValue:">smeeGetIntervalsForTuples: aSmeeArray from: periodStart to: periodEnd criteria: aBlock defaultInOutValue: aBoolean
	&lt;prototypeFunctionNamed: #getIntervalsForTuples 
		length: 5
		args: 'array fromTimestamp toTimestamp function boolean' 
		selector: #smeeGetIntervalsForTuples:from:to:criteria:defaultInOutValue:
		comment: 'Computes an array of intervals between start and stop timestamps (inclusive) given a criteria function'&gt;

	(aSmeeArray isKindOf: Smee.SmeeArray) ifFalse: 
		[self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10034 
			text: 'Call to getIntervalsForTuples() expects an array as the first argument'.
		^SmeeArray new].
	(periodStart smeeToInteger &gt; 0) ifFalse: 
		[self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10035
			text: 'Call to getIntervalsForTuples() expects a positive integer as the second argument.  Invalid argment: (', periodStart asString, ')'.
		^SmeeArray new].
	(periodEnd smeeToInteger &gt; 0) ifFalse: 
		[ self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10036
			text: 'Call to getIntervalsForTuples() expects a positive integer as the thjrd argument.  Invalid argment: (', periodEnd asString, ')'.
		^SmeeArray new].

	^aSmeeArray isEmpty
		ifTrue: [SmeeArray new]
		ifFalse: 
			[| intervals |
			intervals := 
				self 
					getIntervalsForTuples: aSmeeArray collection 
					from: periodStart smeeToInteger 
					to: periodEnd smeeToInteger 
					criteria: aBlock 
					defaultInOutValue: aBoolean smeeToBoolean.
			Smee.SmeeArray smeeNewWithAll: (
				intervals collect: 
					[:each | 
					Smee.SmeeObject new 
						at: #start put: each start;
						at: #end put: each end;
						yourself])]</body>

<body package="PV-Smee" selector="smeeGetDurationsForIntervals:">smeeGetDurationsForIntervals: intervalArrays
	&lt;prototypeFunctionNamed: #getDurationsForIntervals
		length: 1 
		args: 'array' " of 2 element arrays where 1st is fromTimestamp and 2nd is toTimestamp " 
		selector: #smeeGetDurationsForIntervals: 
		comment: 'Computes an array of each intervarl''s duration'&gt;

	| durations intervals |

	(intervalArrays isKindOf: Smee.SmeeArray) ifFalse: 
		[self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10037
			text: 'Call to getDurationsForIntervals() expects an array as the first argument'.
		^SmeeArray new].

	intervals := 
		intervalArrays collection collect: 
			[:each | 
			PvCalendarTimeInterval 
				start: (each at: #start) 
				end: (each at: #end)].
	durations := self getDurationsForIntervals: intervals.
	^Smee.SmeeArray smeeNewWithAll: (durations collect: [:each | each smeeToInteger])</body>

<body package="PV-Smee" selector="getIntervalsForTuples:from:to:criteria:defaultInOutValue:">getIntervalsForTuples: tuples from: periodStart to: periodEnd criteria: aBlock defaultInOutValue: aBoolean
	"Implement getIntervals(tuples, start, stop) on Math or PV to return array of intervals (start/stop) for specified period (start/stop) for down/up transition records
	- Reduce tuples to within the period boundaries
	- Get only valid transitions (normalize the sequence) -- If there are multiple consecutive 'up' or 'down' tuples, only the first one if considered.
	- Compute intervals
		If some tuples are older than the start of the period, we add synthetic up or down event with timestamp of start of the period. 
		Always add a synthetic 'up' event with timestamp of end of period + 1. 
	Example:
		tuples:
			100 0
			120 1
			140 0
		scope:
			[100-160]
		would yeild:
			[100 119]		= 20
			[140 160]		= 21
						= 41
"

	"Reduce tuples to those within scope"
	| statusChanges tuplesBeforeStartOfPeriod scope statusAtStartOfPeriod intervals |
	statusChanges := tuples collect: [:eachTuple | 
		(eachTuple at: #timestamp) -&gt;  (aBlock valueWithThis: self with: eachTuple) smeeToBoolean].
	tuplesBeforeStartOfPeriod := statusChanges select: [:each | each key &lt; periodStart].
	scope := PvCalendarTimeInterval start: periodStart end: periodEnd.
	statusChanges := statusChanges select: [:each | scope includes: each key].

	"Establish up/down for the exact start second (assume true if we have no data before that start second)"
	(statusChanges isEmpty or: [statusChanges first key ~= scope start]) ifTrue: [
		statusAtStartOfPeriod := tuplesBeforeStartOfPeriod isEmpty
							ifTrue: [aBoolean]
							ifFalse: [tuplesBeforeStartOfPeriod last value].
			statusChanges addFirst: periodStart -&gt; statusAtStartOfPeriod.
	].

	"Establish up for 1 second after end"
	statusChanges add: (periodEnd + 1) -&gt; aBoolean.

	"Ensure no 2 consecutive tuples have same value"
	intervals := OrderedCollection new.
	statusChanges fold: [:prev :next | 
		prev value = next value
			ifTrue: [prev]
			ifFalse: 
				[prev value 
					ifFalse: [intervals add: (PvCalendarTimeInterval start: prev key end: next key - 1)].
				next]].
	^intervals</body>

<body package="PV-Smee" selector="smeeGetAccumulatedDurationForIntervals:">smeeGetAccumulatedDurationForIntervals: intervalArrays
	&lt;prototypeFunctionNamed: #getAccumulatedDurationForIntervals
		length: 1 
		args: 'array' "of 2 element arrays where 1st is fromTimestamp and 2nd is toTimestamp ' "
		selector: #smeeGetAccumulatedDurationForIntervals: 
		comment: 'Computes the sum of all interval durations'&gt;

	| intervals |

	(intervalArrays isKindOf: Smee.SmeeArray) ifFalse: 
		[self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10038
			text: 'Call to getAccumulatedDurationForIntervals() expects an array as the first argument'.
		^SmeeArray new].

	intervals := 
		intervalArrays collection collect: 
			[:each | 
			PvCalendarTimeInterval 
				start: (each at: #start) 
				end: (each at: #end)].
	^(self getAccumulatedDurationForIntervals: intervals)</body>

<body package="PV-Smee" selector="smeeGetAccumulatedDurationForTuples:from:to:criteria:defaultInOutValue:">smeeGetAccumulatedDurationForTuples: tuples from: periodStart to: periodEnd criteria: aBlock defaultInOutValue: aBoolean
	&lt;prototypeFunctionNamed: #getAccumulatedDurationForTuples 
		length: 5
		args: 'array fromTimestamp toTimestamp function boolean' 
		selector: #smeeGetAccumulatedDurationForTuples:from:to:criteria:defaultInOutValue:
		comment: 'Computes the sum of all interval durations between start and stop timestamps (inclusive) given a criteria function'&gt;

	| intervals |
	(tuples isKindOf: Smee.SmeeArray) ifFalse: 
		[self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10034 
			text: 'Call to getAccumulatedDurationForTuples() expects an array as the first argument'.
		^SmeeArray new].
	(periodStart smeeToInteger &gt; 0) ifFalse: 
		[self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10035
			text: 'Call to getAccumulatedDurationForTuples() expects a positive integer as the second argument.  Invalid argment: (', periodStart asString, ')'.
		^SmeeArray new].
	(periodEnd smeeToInteger &gt; 0) ifFalse: 
		[ self system 
			logWarning: #INVALID_ARGUMENT
			messageId: #DC10036
			text: 'Call to getAccumulatedDurationForTuples() expects a positive integer as the thjrd argument.  Invalid argment: (', periodEnd asString, ')'.
		^SmeeArray new].

	intervals := self getIntervalsForTuples: tuples from: periodStart to: periodEnd criteria: aBlock defaultInOutValue: aBoolean.
	^(self getAccumulatedDurationForIntervals: intervals)</body>

<body package="PV-Smee" selector="getDurationsForIntervals:">getDurationsForIntervals: aCollectionOfPvCalendarTimeIntervals
	"getDurations(intervals) on Math or PV to return array of seconds (integers) representing the durations of intervals passed in"
	"SmeeEnvironment current: PROVISO.Smee.Environment new.
	self new getDurationsForIntervals: #(#(100 119) #( 140 160))
"

	" We get closed intervals back, hence the need to account for the last second "
	^aCollectionOfPvCalendarTimeIntervals collect: [:each | each duration]</body>
</methods>


<class>
<name>Logger</name>
<environment>PROVISO.Smee</environment>
<super>Smee.SmeeAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>filter </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>PV-Smee</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.Smee.Logger</class-id> <category>accessing</category>

<body package="PV-Smee" selector="filter">filter
	
	^filter ifNil: 
		[filter := self currentApplication ifNotNil: [:app | app smeeLogFilter]]</body>

<body package="PV-Smee" selector="filter:">filter: anObject
	filter := anObject</body>
</methods>

<methods>
<class-id>PROVISO.Smee.Logger</class-id> <category>prototype builtins</category>

<body package="PV-Smee" selector="logInfo:messageId:arguments:">logInfo: code messageId: anId arguments: args
	&lt;prototypeFunctionNamed: #logInfo length: 3 args: 'code messageId arguments&lt;rest&gt;'&gt; 

	(self shouldFilterCode: $I)
		ifTrue: [^self].
	args size &gt; 1
		ifTrue:
			[self system 
				logInfo: code smeeToString 
				messageId: anId smeeToString
				template: (self templateFrom: args)
				arguments: (self argumentsFrom: args)]
		ifFalse:
			[self system 
				logInfo: code smeeToString 
				messageId: anId smeeToString
				text: (args size = 0 ifTrue: [''] ifFalse: [args first smeeToString])]</body>

<body package="PV-Smee" selector="logFatal:messageId:text:">logFatal: code messageId: anId text: text 
	&lt;prototypeFunctionNamed: #logFatal length: 3 args: 'code messageId text'&gt;
	(self shouldFilterCode: $F)
		ifTrue: [^self].
	self system 
		logFatal: code smeeToString 
		messageId: anId smeeToString
		text: text smeeToString.
	^self</body>

<body package="PV-Smee" selector="logWarning:messageId:arguments:">logWarning: code messageId: anId arguments: args
	&lt;prototypeFunctionNamed: #logWarning length: 3 args: 'code messageId arguments&lt;rest&gt;'&gt; 

	(self shouldFilterCode: $W)
		ifTrue: [^self].
	args size &gt; 1
		ifTrue: 
			[self system 
				logWarning: code smeeToString 
				messageId: anId smeeToString
				template: (self templateFrom: args)
				arguments: (self argumentsFrom: args)]
		ifFalse:
			[self system 
				logWarning: code smeeToString
				messageId: anId smeeToString
				text: (args size = 0 ifTrue: [''] ifFalse: [args first smeeToString])]</body>

<body package="PV-Smee" selector="logDebug:code:messageId:arguments:">logDebug: severity code: code messageId: anId arguments: args 
	&lt;prototypeFunctionNamed: #logDebug length: 4 args: 'severity code messageId arguments&lt;rest&gt;'&gt;

	(self shouldFilterCode: severity smeeToString first)
		ifTrue: [^self].
	args size &gt; 1
		ifTrue:
			[self system 
				logDebug: severity smeeToString first
				code: code smeeToString
				messageId: anId smeeToString
				template: (self templateFrom: args)
				arguments: (self argumentsFrom: args)]
		ifFalse:
			[self system 
				logDebug: severity smeeToString first
				code: code smeeToString
				messageId: anId smeeToString
				text: (args size = 0 ifTrue: [''] ifFalse: [args first smeeToString])]</body>
</methods>

<methods>
<class-id>PROVISO.Smee.Logger</class-id> <category>private</category>

<body package="PV-Smee" selector="shouldFilterCode:">shouldFilterCode: severityCharacter
	" Answer false if messages with this severity code should be filtered out "
	^self filter
		ifNil: [false]
		ifNotNil:  [:str | (str includes: severityCharacter) not]</body>
</methods>


<methods>
<class-id>PROVISO.Smee.PvNamespace</class-id> <category>initialization</category>

<body package="PV-Smee" selector="initialize">initialize

	super initialize.
	prototype := SmeeNull.
	self
		smeeAddProperty: 
			(SmeeReadOnlyDontDeleteProperty 
				key: #Logger
				value: PROVISO.Smee.Logger new);
		smeeAddProperty: 
			(SmeeReadOnlyDontDeleteProperty 
				key: #Math
				value: PROVISO.Smee.Math new);
		addConstructorNamed: #IpAddress
			receiver: PROVISO.Smee.IpAddress;
		addConstructorNamed: #Repository
			receiver: PROVISO.SmeeRepository;
		addConstructorNamed: #TraceFile
			receiver: PROVISO.Smee.TraceFile;
		addConstructorNamed: #PvTrapWriter
			receiver: PvTrapWriter</body>
</methods>

<methods>
<class-id>PROVISO.Smee.PvNamespace</class-id> <category>accessing</category>

<body package="PV-Smee" selector="smeeLogger">smeeLogger
	^self smeeAt: #Logger</body>
</methods>



<methods>
<class-id>PROVISO.PvRecomputationRecord0407</class-id> <category>testing</category>

<body package="PV-Support" selector="actionLetter">actionLetter

	self action = self class actionInsert ifTrue: [^'I'].
	self action = self class actionUpdate ifTrue: [^'U'].
	self action = self class actionDelete ifTrue: [^'D'].
	^'unknown'</body>
</methods>

<methods>
<class-id>PROVISO.PvRecomputationRecord0407</class-id> <category>converting</category>

<body package="PV-Support" selector="asSparseMetricRecord">asSparseMetricRecord

	^self</body>

<body package="PV-Support" selector="asMetricRecord">asMetricRecord
	
	^(self 
		copyFrom: 1
		to: PvMetricRecord currentSparseMetricRecordClass sizeInBytes) changeClassTo: PvMetricRecord currentSparseMetricRecordClass</body>

<body package="PV-Support" selector="asPeriodicMetricRecord">asPeriodicMetricRecord

	^self</body>
</methods>

<methods>
<class-id>PROVISO.PvRecomputationRecord0407</class-id> <category>printing</category>

<body package="PV-Support" selector="printContentsOn:">printContentsOn: aStream 
	
	aStream
		nextPutAll: self stringLabelForAction;
		nextPut: $:;
		nextPutAll: 'mid=';
		print: self metricId;
		nextPutAll: ', rid=';
		print: self resourceId.
	self eventId ~= 0 
		ifTrue: 
			[aStream
				nextPutAll: ', eventId=';
				print: self eventId].
	aStream
		nextPutAll: ', date=';
		print: (PvTimestamp fromSeconds: self date);
		nextPut: $[;
		print: self date;
		nextPut: $];
		nextPutAll: ', value='.
	self value pvPrintOn: aStream.
	aStream
		nextPutAll: ', action=';
		nextPutAll: self actionLetter;
		nextPutAll: ', ref date=';
		print: (PvTimestamp fromSeconds: self referenceDate);
		nextPut: $[;
		print: self referenceDate;
		nextPut: $].</body>

<body package="PV-Support" selector="printBofDumpStyleOn:">printBofDumpStyleOn: aStream 
	
	^self printContentsOn: aStream</body>

<body package="PV-Support" selector="contentsPrintString">contentsPrintString
	
	^(String new: 128) streamContentsDo: [:stream | self printContentsOn: stream]</body>

<body package="PV-Support" selector="printOn:">printOn: aStream 
	
	aStream 
		nextPutAll: self class name;
		nextPutAll: ' ('.
	self printContentsOn: aStream.
	aStream 
		nextPutAll: ' )'.</body>
</methods>


<methods>
<class-id>PROVISO.PvStreamHeartbeat</class-id> <category>public</category>

<body package="PV-Support" selector="acceptProcessor:">acceptProcessor: aProcessor

	aProcessor processHeartbeat: self</body>
</methods>


<methods>
<class-id>PROVISO.PvSAXParser</class-id> <category>element processing</category>

<body package="PV-Support" selector="getElement">getElement

	^[super getElement] on: Error do: [:ex | nil]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAXParser</class-id> <category>actions</category>

<body package="PV-Support" selector="parseElement">parseElement
	
	self atEnd 
		ifTrue: 
			[sax endDocumentFragment.
			self closeAllFiles.
			^nil].
	atEndOfRecord := false.
	[hereChar == $&lt;] 
		whileFalse: 
			[self getNextChar.
			hereChar ifNil: [^nil]].
	self getElement.
	^self currentRecord</body>
</methods>


<methods>
<class-id>PROVISO.PvMetricRecord0302</class-id> <category>converting</category>

<body package="PV-Support" selector="asSparseMetricRecord">asSparseMetricRecord

	^self class currentSparseMetricRecordClass new
		initializeFrom: self;
		yourself</body>

<body package="PV-Support" selector="asPeriodicMetricRecord">asPeriodicMetricRecord

	^self</body>
</methods>


<methods>
<class-id>PROVISO.PvStringMetricRecord</class-id> <category>coercing</category>

<body package="PV-Support" selector="asSparseMetricRecord">asSparseMetricRecord

	^self</body>

<body package="PV-Support" selector="asPeriodicMetricRecord">asPeriodicMetricRecord

	^self</body>
</methods>


<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="PV-Support" selector="writeFormulaOperator:">writeFormulaOperator: aFormulaOperator

    | args count |
    self write: aFormulaOperator periodStart.
    self write: aFormulaOperator lastTuple.
    self write: aFormulaOperator inputs.
    
    "Write property state"
    args := aFormulaOperator smeePrototype arguments.
    count := 0.
"
    aFormulaOperator smeeProperties do: [:assn | 
        name := assn key.
        ((args anySatisfy: [:eachArg | eachArg name = name])
            or: [#(startOfPeriod prototype emitValue emitTuple duration downtime) includes: name])
                ifFalse: [count := count + 1]].
"
    self writeVarInt: (self idForClass: OrderedCollection).
    self writeSize: count.
" 
   aFormulaOperator smeeProperties do: [:assn | 
        name := assn key.
        ((args anySatisfy: [:eachArg | eachArg name = name])
            or: [#(startOfPeriod prototype emitValue emitTuple duration downtime) includes: name])
                ifFalse: [self write: assn]].
"</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>reading</category>

<body package="PV-Support" selector="readTimeSeries:">readTimeSeries: aTimeSeries

	| comingIn |
	self readTupleSource: aTimeSeries.
	comingIn := self read.
	comingIn isNil
		ifTrue: [aTimeSeries bufferedTuples: nil] 
		ifFalse: 
			[aTimeSeries initBufferedTuples.
			aTimeSeries bufferedTuples addAll: comingIn].
	^aTimeSeries</body>
</methods>


<methods>
<class-id>PROVISO.PvMetricRecord</class-id> <category>converting</category>

<body package="PV-Support" selector="asMetricRecord">asMetricRecord

	^self</body>
</methods>


<methods>
<class-id>PROVISO.PvSparseMetricRecord0405</class-id> <category>converting</category>

<body package="PV-Support" selector="asSparseMetricRecord">asSparseMetricRecord

	^self</body>

<body package="PV-Support" selector="asPeriodicMetricRecord">asPeriodicMetricRecord

	^self class currentMetricRecordClass new
		initializeFrom: self;
		yourself</body>
</methods>



<methods>
<class-id>PROVISO.PvSystem class</class-id> <category>accessing</category>

<body package="PV-Application Support" selector="islandDirectoryIfAbsent:">islandDirectoryIfAbsent: absentBlock 
	"&lt;Filename&gt; Try and locate something that looks like the master directory for the island name indicated by the bundle...look in /home/cmeshare/masters (for Unix), then root directory and current directory (for Windows)."
	
	| dirName |
	dirName := 'base' , self island.
	^[Filename 
		searchPath: #('/home/cmeshare/masters' '/' './masters' '.')
		for: dirName
		ifNotFound: absentBlock] 
			on: OsError
			do: [:ex | absentBlock value]</body>
</methods>


<methods>
<class-id>PROVISO.PvServer</class-id> <category>initialize-release</category>

<body package="PV-Application Support" selector="configureEnvironment:">configureEnvironment: anEnvironment 
	
	anEnvironment
		engine: self;
		configuration: self configuration;
		fileInterface: self fileInterface.
	self currentApplication ifNotNil: 
		[:app | 
		self system 
			logDebugThree: #LOG_FILTER_ES
			text: 'Setting Ecmascript log filter to ' , app smeeLogFilter.
		anEnvironment pvNamespace smeeLogger filter: app smeeLogFilter]</body>
</methods>


<methods>
<class-id>PROVISO.PvApplication</class-id> <category>accessing merged cfg</category>

<body package="PV-Application Support" selector="smeeLogFilter">smeeLogFilter
	
	^self mergedConfiguration 
		stringAt: 'LOG_FILTER_ES'
		ifAbsent: 
			[self mergedConfiguration 
				stringAt: 'LOG_FILTER'
				ifAbsent: [PvLogger defaultFilter]]</body>
</methods>



<methods>
<class-id>PROVISO.PvSftpResult</class-id> <category>testing</category>

<body package="PV-FTP Client" selector="message">message
	"RA# 503409.. There was one case where the Sftp framework was expecting a SftpResult object to understand #message.
I am adding this in the superclass so that any similiar situations can be dealt with the same way "

	^ self asString</body>
</methods>



<methods>
<class-id>PROVISO.MergeSortStream</class-id> <category>accessing</category>

<body package="PV-Streams-Support" selector="contents">contents
	
	^(OrderedCollection new: self size) streamContentsDo: 
		[:s | self do: [:each | s nextPut: each]]</body>
</methods>


<methods>
<class-id>PROVISO.BOFAbstractFileContainer</class-id> <category>cme lifecycle management</category>

<body package="PV-Streams-Support" selector="releaseExternalResource:">releaseExternalResource: ea 
	
	| fn dir |
	fn := ea asFilename.
	fn exists 
		ifTrue: [fn delete].
	dir := fn directory.
	^(dir exists and: [dir directoryContents isEmpty]) 
		ifTrue: 
			[[dir delete] 
				on: Error
				do: [:ex | ]]</body>

<body package="PV-Streams-Support" selector="releaseExternalResources">releaseExternalResources
	"Release (i.e. delete) any external resouces used by this container...for tuple storage to help manage storage reclamation"
	
	self dataFiles do: [:ea | self releaseExternalResource: ea]</body>
</methods>


<methods>
<class-id>PROVISO.StreamOperatorPolicy</class-id> <category>heartbeat source api</category>

<body package="PV-Streams-Support" selector="intervalsFrom:to:do:">intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock
	" Evaluate the block with all intervals that intersect time interval from aTsNumberStart to aTsNumberStop exclusive. 
	aMonadicBlock is evaluated with an instance of PvCalendarTimeInterval. "

	self subclassResponsibility</body>
</methods>

<methods>
<class-id>PROVISO.StreamOperatorPolicy</class-id> <category>testing</category>

<body package="PV-Streams-Support" selector="isStartOfNextPeriod:">isStartOfNextPeriod: aNumber

	^self startOfNextPeriod = aNumber</body>
</methods>


<methods>
<class-id>PROVISO.PeriodPolicy</class-id> <category>private</category>

<body package="PV-Streams-Support" selector="intervalContainingTimestamp:">intervalContainingTimestamp: aNumber 

	^PvCalendarTimeInterval 
		from: (self startOfPeriodContainingTimestamp: aNumber)
		to: (self endOfPeriodContainingTimestamp: aNumber)</body>
</methods>

<methods>
<class-id>PROVISO.PeriodPolicy</class-id> <category>heartbeat source api</category>

<body package="PV-Streams-Support" selector="intervalsFrom:to:do:">intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock
	" Evaluate the block with all intervals that intersect time interval from aTsNumberStart to aTsNumberStop exclusive. 
	aMonadicBlock is evaluated with an instance of PvCalendarTimeInterval. "

	| current interval |
	current := aTsNumberStart.
	[interval := self intervalContainingTimestamp: current.
	interval stop &lt;= aTsNumberStop]
		whileTrue:
			[aMonadicBlock value: interval.
			current := interval stop].</body>
</methods>


<methods>
<class-id>PROVISO.BOFFilesContainer</class-id> <category>cme lifecycle management</category>

<body package="PV-Streams-Support" selector="acquireIn:">acquireIn: aTransaction 
	" Transactionally move myself to an appropriate hourly directory in do
	and write my timestamp into last timestamp file.
	Answer myself in the new place "
	
	| doHourDirectory fn dirs files sourceFn |
	doHourDirectory := aTransaction fileInterface doHourDirectoryForHourTimestamp: (PvTimestamp fromSeconds: self timestamp) snapToHour.
	dirs := Set new.
	files := OrderedCollection new.
	self dataFiles do: 
		[:eachDatafile | 
		sourceFn := eachDatafile filename.
		dirs add: sourceFn directory.
		fn := doHourDirectory, (self label asString, '~', eachDatafile filename tail).
		fn exists
			ifTrue: 
				[self system 
					logWarning: #ALREADY_ACQUIRED 
					messageId: #DC10007 
					text: 'File ', sourceFn printString, ' is already acquired -- ignore'.
				aTransaction delete: sourceFn]
			ifFalse: 
				[aTransaction moveFrom: sourceFn to: fn.
				files add: fn]].
	dirs do: [:eachDir | aTransaction purgeEmptyDirectory: eachDir].
	^files isEmpty
		ifTrue: [nil]
		ifFalse:
			[(self species fromFilenames: files)
				timestamp: self timestamp;
				label: self label;
				position: position;
				yourself]</body>
</methods>


<methods>
<class-id>PROVISO.BOFSingleFileContainer</class-id> <category>cme lifecycle management</category>

<body package="PV-Streams-Support" selector="acquireIn:">acquireIn: aTransaction
	" Transactionally move myself to an appropriate hourly directory in do
	and write my timestamp into last timestamp file.
	Answer myself in the new place "
	| doHourDirectory fn |
	doHourDirectory := aTransaction fileInterface doHourDirectoryForHourTimestamp: (PvTimestamp fromSeconds: self timestamp) snapToHour.
	fn := doHourDirectory, (self label asString, '~', self filename tail).
	fn exists 
		ifTrue: 
			[self system 
					logWarning: #ALREADY_ACQUIRED 
					messageId: #DC10007 
					text: 'File ', self filename printString, ' is already acquired -- ignore'.
			aTransaction delete: self filename]
		ifFalse: [	aTransaction moveFrom: self filename to: fn].
	aTransaction purgeEmptyDirectory: self filename directory.
	^fn exists
		ifTrue: [nil]
		ifFalse: 
			[(self species fromFilename: fn)
				timestamp: self timestamp;
				label: self label;
				position: position;
				yourself]</body>
</methods>



<methods>
<class-id>PROVISO.PvDbSqlStatement</class-id> <category>control</category>

<body package="PV-DB-Support" selector="resetAnswer">resetAnswer
	
	promise := Promise new.
	self critical: 
		[self isAnswered 
			ifTrue: 
				[dbSession answer isSymbol 
					ifFalse: 
						[[dbSession answer close] 
							on: 
								Error , SystemNotification , 
									ExternalDatabaseConnection externalDatabaseInformationSignal
							do: 
								[:error | 
								self system 
									logDebugThree: #CLOSE_FAILED
									text: error messageText]].
				self state: self statePrepared]
			ifFalse: 
				[self system 
					logDebugThree: #COULDNT_CLOSE
					text: self state printString]]</body>
</methods>



<methods>
<class-id>PROVISO.PvAbstractDomainObjectVisitor</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptModel:">acceptModel: aPvModel 
	
	self 
		visit: aPvModel elementManager;
		visit: aPvModel subelementManager;
		visit: aPvModel propertyManager;
		visit: aPvModel relationManager;
		visit: aPvModel thresholdManager;
		visit: aPvModel calendarManager;
		visit: aPvModel requestManager;
		visit: aPvModel eventManager;
		visit: aPvModel eventPropertyManager;
		visit: aPvModel eventRelationManager</body>
</methods>


<class>
<name>PvEvent</name>
<environment>PROVISO</environment>
<super>PROVISO.PvGroupableObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>type origin username properties subelement subelementId date eventType eventTypeId relations </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>initialize-release</category>

<body package="PV-DM-Support" selector="initialize">initialize
	
	super initialize.
	self type: 'import'.
	self properties: (PvIdentityDictionary new: 16).
	self relations: PvIdentityDictionary new.
	self beEnabled</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>api</category>

<body package="PV-DM-Support" selector="smeeAddChild:">smeeAddChild: anEvent
	&lt;prototypeFunctionNamed: #add length: 1 args: 'anEvent&lt;PvEvent&gt; ' comment: 'This method is used to add a child event to an event object'&gt;

		^self addChild: anEvent</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="postCopy">postCopy
	
	super postCopy.
	self properties notNil 
		ifTrue: 
			[self properties: self properties copy].
	self relations notNil 
		ifTrue: 
			[self relations: self relations copy]</body>

<body package="PV-DM-Support" selector="addRelation:">addRelation: anEventRelation 
	
	anEventRelation childId ifNotNil: 
		[:myChildId | self relations at: myChildId put: anEventRelation]</body>

<body package="PV-DM-Support" selector="addChild:">addChild: anEvent 
	
	self addRelation: 
		(PvEventRelation 
			parent: self
			child: anEvent)</body>

<body package="PV-DM-Support" selector="removeRelation:">removeRelation: anEventRelation 
	
	anEventRelation childId ifNotNil: 
		[:myChildId | 
		self relations 
			removeKey: myChildId
			ifAbsent: []]</body>

<body package="PV-DM-Support" selector="postDomainCopy">postDomainCopy
	
	super postDomainCopy.
	self properties ifNotNil: 
		[:original | 
		self properties: (original copyEmpty: original size).
		original keysAndValuesDo: [:key :value | self properties at: key put: value copy]].
	self relations ifNotNil: 
		[:original | 
		self relations: (original copyEmpty: original size).
		original keysAndValuesDo: [:key :value | self relations at: key put: value copy]]</body>

<body package="PV-DM-Support" selector="postInsertUpdateIn:">postInsertUpdateIn: aPvModel 
	
	self eventType: 
		(aPvModel eventManager eventTypes 
			detect: [:value | value id == self eventTypeId]
			ifNone: [nil])</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="relations:">relations: anObject 
	
	relations := anObject.
	relations whileMutableDo: [relations owner: self]</body>

<body package="PV-DM-Support" selector="relations">relations
	^relations</body>

<body package="PV-DM-Support" selector="relationsDo:">relationsDo: aBlock 
	
	self relations keysAndValuesDo: [:childId :relation | aBlock value: relation]</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>accessing properties</category>

<body package="PV-DM-Support" selector="removeProperty:ifAbsent:">removeProperty: aProperty ifAbsent: absentBlock 
	
	self hasProperties 
		ifTrue: 
			[self properties 
				removeKey: aProperty attributeId
				ifAbsent: absentBlock]</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>immutable</category>

<body package="PV-DM-Support" selector="setChildrenImmutable">setChildrenImmutable

	self properties beImmutable.
	self relations beImmutable.</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="prepareForCommitUsing:">prepareForCommitUsing: anNgModelInterface 
	
	super prepareForCommitUsing: anNgModelInterface.
	self 
		smeePropertyAt: self class nameProperty
		put: self name</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>hasChildren</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>children:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>children</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>relationFrom:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEvent</class-id> <selector>childrenDo:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvEvent class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventHistory' put: self historyTableName asString.
	namedReplacements at: 'elementHistory' put: PvElement historyTableName asString.
	namedReplacements at: 'subelementHistory' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 'ev.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addToNowDateConditionTo: namedReplacements
			using: parametersDictionary;
		addCollectorClauseNamed: 'eCollectorClause'
			to: namedReplacements
			prefix: 'e'
			using: parametersDictionary;
		addCollectorClauseNamed: 'edCollectorClause'
			to: namedReplacements
			prefix: 'e1'
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString
	
	^'
Select /*+ PUSH_SUBQ ORDERED USE_NL(se ev) INDEX(ev ID_EVDH_4_2) */
       %columnList 
  From ( Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(e s) */
                s.Idx_Ind
           From %elementHistory e,
                %subelementHistory s
          Where %eCollectorClause
             s.Idx_Host = e.Idx_Ind
            And e.Dte_Date %toNowDateCondition
            And e.Dte_Date = ( Select Max(e1.Dte_Date)
                                 From %elementHistory e1
                                Where e1.Idx_Ind = e.Idx_Ind
                                  And %edCollectorClause
                                  e1.Dte_Date %toNowDateCondition )
            And s.Dte_Date %toNowDateCondition
            And s.Dte_Date = ( Select Max(s1.Dte_Date)
                                 From %subelementHistory s1
                                Where s1.Idx_Ind = s.Idx_Ind
                                  And s1.Dte_Date %toNowDateCondition )
            And e.Str_Action In %actionList
            And s.Str_Action In %actionList ) se,
       %eventHistory ev
 Where ev.Idx_Resource = se.Idx_Ind
   And ev.Dte_Date %resyncDateCondition
   And ev.Dte_Date = ( Select Max(ev1.Dte_Date)
                         From %eventHistory ev1
                        Where ev1.Idx_Ind = ev.Idx_Ind
                          And ev1.Idx_Resource = ev.Idx_Resource
                          And ev1.Dte_Date %resyncDateCondition )
   And ev.Str_Action In %actionList;
'</body>
</methods>

<methods>
<class-id>PROVISO.PvEvent class</class-id> <category>properties</category>

<body package="PV-DM-Support" selector="nameProperty">nameProperty

	^'Name'</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarTimeInterval</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="intersectsWith:">intersectsWith: aPvCalendarInterval
	" Return true if aPvCalendarInterval intersects with me "

	^(aPvCalendarInterval start between: self start and: self stop) or:
		[(aPvCalendarInterval stop between: self start and: self stop) or: 
			[(self start between: aPvCalendarInterval start and: aPvCalendarInterval stop) or:
				[self stop between: aPvCalendarInterval start and: aPvCalendarInterval stop]]]</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarTimeInterval</class-id> <category>set operations</category>

<body package="PV-DM-Support" selector="merge:">merge: aPvCalendarInterval 
	" Return aPvCalendarInterval that overlaps both me and aPvCalendarInterval "
	
	^PvCalendarTimeInterval 
		start: (self start min: aPvCalendarInterval start)
		stop: (self stop max: aPvCalendarInterval stop)</body>

<body package="PV-DM-Support" selector="intersect:">intersect: aPvCalendarInterval 
	" Return true if aPvCalendarInterval intersects with me 
		(PvCalendarTimeInterval start: 5 stop: 100)
			intersect: (PvCalendarTimeInterval start: 50 stop: 150)
	"
	
	^(self intersectsWith: aPvCalendarInterval) 
		ifTrue: 
			[PvCalendarTimeInterval 
				start: (self start max: aPvCalendarInterval start)
				stop: (self stop min: aPvCalendarInterval stop)]</body>

<body package="PV-DM-Support" selector="union:">union: aPvCalendarInterval 
	" Return aPvCalendarInterval that is a set union of both me and aPvCalendarInterval "
	
	^PvCalendarTimeInterval 
		start: (self start min: aPvCalendarInterval start)
		stop: (self stop max: aPvCalendarInterval stop)</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarTimeInterval class</class-id> <category>instance creation</category>

<body package="PV-DM-Support" selector="from:to:">from: startSecs to: endSecs 
	
	^self 
		start: startSecs
		stop: endSecs + 1
		inSegment: true</body>

<body package="PV-DM-Support" selector="start:end:">start: startSecs end: endSecs 
	
	^self 
		start: startSecs
		stop: endSecs + 1
		inSegment: true</body>
</methods>


<methods>
<class-id>PROVISO.PvDomainProxy</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="dereference">dereference
	"Turn the receiver into the real domain object...ensure that we don't screw up caches by taking a shallow copy of the object retrieved from the repository."
	
	| rep newMe jp myPvModel |
	myPvModel := self pvModel.
	(rep := myPvModel repository) ifNil: [^nil error: 'missing repository binding'].
	rep critical: 
		[jp := self journalPosition.
		newMe := (rep atJournalPosition: jp) shallowCopy.
		newMe journalPosition: jp].
	newMe flags: self flags.
	newMe element: self element.
	self become: newMe.
	"The following call will initialize any reified relationships."
	newMe postInsertUpdateIn: myPvModel</body>
</methods>


<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="bindVariableSelectStatementForLabelForMetricId:subelementId:between:and:">bindVariableSelectStatementForLabelForMetricId: metricId 
	subelementId: subelementId
	between: beginTimestamp
	and: endTimestamp
	"self bindVariableSelectStatementForLabelForMetricId: 1234 subelementId: 4567 between: 5000 and: 1000"

	| bindVariableArray |

	bindVariableArray := Array new: 4.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.
	bindVariableArray at: 3 put: beginTimestamp.
	bindVariableArray at: 4 put: endTimestamp.

	^ 'SELECT distinct ts1.int_label
         FROM ts_desc ts1
         WHERE ts1.idx_metric = :1 and ts1.idx_resource = :2 
           AND ts1.DTE_DATE = ( SELECT MAX(ts2.DTE_DATE)
                                FROM ts_desc ts2
                               WHERE ts1.idx_ind=ts2.idx_ind
                                 AND ts2.DTE_DATE between :3 and :4 )'
		-&gt; bindVariableArray</body>
</methods>

<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand class</class-id> <category>instance creation</category>

<body package="PV-DM-Support" selector="fromTimeSeries:">fromTimeSeries: aTimeSeries

	| inst |
	inst := self new
		msid: aTimeSeries msid;
		metricId: aTimeSeries metricId;
		resourceId: aTimeSeries resourceId; 
		resyncHistoricalDate: ([aTimeSeries timestamp] on: Error do: [:ex | nil]);
		resyncAction: #I;
		streamLabelId: aTimeSeries streamLabel;
		isExplicitAsNumber: aTimeSeries isExplicit;
		requestId: aTimeSeries requestId.
	inst versionDate: inst timestamp.
	^inst</body>
</methods>


<class>
<name>AbstractCalendarSegmentStrategy</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>segment </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Calendars</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.AbstractCalendarSegmentStrategy</class-id>
<body>I represent polymorphic behavior of my segment.

Instance Variables:
	segment	&lt;PvCalendarSegment&gt;	My calendar segment

</body>
</comment>

<methods>
<class-id>PROVISO.AbstractCalendarSegmentStrategy</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isSupportedByDatachannel">isSupportedByDatachannel

	^true</body>

<body package="PV-DM-Support" selector="coversCompletePeriod">coversCompletePeriod
	" Answer true if the segment is periodic and completely covers its main period "

	^false</body>
</methods>

<methods>
<class-id>PROVISO.AbstractCalendarSegmentStrategy</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="durationOfPeriodForTimestamp:">durationOfPeriodForTimestamp: aPvTimestampOrNumber
	" Answer duration of period for period containing aPvTimestamp using definition of aCalendarSegment "

	^(self stopOfPeriodForTimestamp: aPvTimestampOrNumber) -
		(self startOfPeriodForTimestamp: aPvTimestampOrNumber)</body>

<body package="PV-DM-Support" selector="segment">segment
	^segment</body>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	self subclassResponsibility</body>

<body package="PV-DM-Support" selector="labelForCalendarSegment">labelForCalendarSegment
	" Answer descriptive name CalendarSegment will use to print itself. Return my class name without 'Trait' "

	^self class name</body>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	self subclassResponsibility</body>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	self subclassResponsibility</body>
</methods>

<methods>
<class-id>PROVISO.AbstractCalendarSegmentStrategy</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestampOrNumber do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	self subclassResponsibility</body>

<body package="PV-DM-Support" selector="asIntervalForTimestamp:">asIntervalForTimestamp: dayTimestamp
	" Answer daily interval for the current timestamp "

	| periodInterval |
	periodInterval := PvCalendarTimeInterval start: dayTimestamp dayStartSeconds stop: dayTimestamp dayStopSeconds.
	self segment 
		intervalsForTimestamp: dayTimestamp		" Force seed timestamp into the preceding period "
		do: 
			[:interval | |effectiveInterval|
			effectiveInterval := interval intersect: periodInterval.	
			(effectiveInterval isNil or: [effectiveInterval isEmpty]) 
				ifFalse: [^effectiveInterval]].
	^nil</body>
</methods>

<methods>
<class-id>PROVISO.AbstractCalendarSegmentStrategy</class-id> <category>private</category>

<body package="PV-DM-Support" selector="intervalsForCalendarPeriodForTimestamp:from:to:do:">intervalsForCalendarPeriodForTimestamp: aPvTimestamp
	from: start
	to: stop
	do: aBlock
	" Week/Month range is encoded as a single interval defined by fromDay/fromTime to toDay/toTime.
	start and stop arguments are interval boundary offsets from the start of the period. The period is determined by 
	the period type (week or month) containing aPvTimestamp.
 	Evaluate aBlock for this interval. If stop &lt;= start, the interval ends in the next period (intervals protrudes
	into the future) "
	
	| periodStart effectiveStop |
	periodStart := self startOfPeriodForTimestamp: aPvTimestamp.
	" Check if the interval protrudes out of the current period (period containing aPvTimestamp). 
	If it does, adjust stop extending it into the next interval "
	effectiveStop := start &gt;= stop 
		ifTrue: [stop + (self durationOfPeriodForTimestamp: (PvTimestamp fromSeconds: periodStart))]
		ifFalse: [stop].
	aBlock 
		value: 
			(PvCalendarTimeInterval 
				start: periodStart + start
				stop: periodStart + effectiveStop
				inSegment: true)</body>

<body package="PV-DM-Support" selector="dailyIntervalStartingAt:do:">dailyIntervalStartingAt: dayStart do: aBlock 
	" Evaluate aBlock for daily interval based on me and start of the day.
	For example, if I am weekly 8-5, aBlock will be evaluated with the following arguments:
		- dayStart
		- from (08:00)
		- to (17:00
	if toTime &lt;= fromTime, the interval ends in the next day  
	"
	
	| from to |
	from := self segment fromTimeSeconds.
	to := self segment toTimeSeconds.
	" If to &lt;= from (i.e. 8 to 2), to is assumed to be in the next day (interval protrudes out of the current day) "
	to &lt;= from 
		ifTrue: [to := to + Date secondsInDay].
	aBlock 
		value: 
			(PvCalendarTimeInterval 
				start: dayStart + from
				stop: dayStart + to
				inSegment: true)</body>

<body package="PV-DM-Support" selector="segment:">segment: anObject
	segment := anObject</body>

<body package="PV-DM-Support" selector="dailyIntervalsForTimestamp:periodIndices:do:">dailyIntervalsForTimestamp: aPvTimestamp periodIndices: indices do: aBlock 
	" Evaluate aBlock for daily intervals based on me, aPvTimestamp and the set of indices.
	I and aPvTimestamp determine a time range ('period') containing that timestamp. For example, if I am
	a weekly interval (i.e. weekdays 8 to 5), my period is week containing the timestamp.
	Once the perio is known, indices collection represents days relative to the start of the week for which 
	aBlock should be evaluated. Each index is 0-based offset of the day in the period.
	For example, if I am weekly 8-5, the indices will be #(1 2 3 4 5), which means Mon-Fri. For each
	of these aBlock will be evaluated with the following arguments:
		- start of the day
		- from (08:00)
		- to (17:00 "
	
	| periodStart |
	" Determine period "
	periodStart := aPvTimestamp dayStartSeconds - 
						((self class dayIndexFromDate: aPvTimestamp asDate) * Date secondsInDay).
	indices do: 
		[:ix | 
		self 
			dailyIntervalStartingAt: periodStart + (ix * Date secondsInDay)
			do: aBlock]</body>
</methods>


<methods>
<class-id>PROVISO.AbstractCalendarSegmentStrategy class</class-id> <category>instance creation</category>

<body package="PV-DM-Support" selector="newFor:">newFor: aPvCalendarSegment

	^self new
		segment: aPvCalendarSegment;
		yourself</body>
</methods>

<methods>
<class-id>PROVISO.AbstractCalendarSegmentStrategy class</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="dayIndexFromDate:">dayIndexFromDate: dayDate
	"The weekly indices from the database run Sun through Sat and index 0-6.
	The weekly indices from Date run Mon through Sun and index 1-7.  
	We need to ge the weekday index from Date and rotate it to Sun-Sat and remove one so,
		Date		Database
		Mon 1		Mon 1
		Tue  2		Tue  2
		Wed  3		Wed  3
		Thu  4		Thu  4
		Fri    5		Fri    5
		Sat   6		Sat  6
		Sun  7		Sun  0 "

	^dayDate weekdayIndex \\ 7.</body>
</methods>


<class>
<name>PvAbstractPlanBuildCommand</name>
<environment>PROVISO</environment>
<super>PROVISO.PvPersistentObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>resyncHistoricalDate resyncAction versionDate pvModel </inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			Smee.*
			</imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvAbstractPlanBuildCommand</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isSameAs:">isSameAs: anotherCommand 
	
	^self resyncHistoricalDate = anotherCommand resyncHistoricalDate and: 
		[self resyncAction = anotherCommand resyncAction and: 
			[self versionDate = anotherCommand versionDate]]</body>
</methods>

<methods>
<class-id>PROVISO.PvAbstractPlanBuildCommand</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="pvModel:">pvModel: anObject
	pvModel := anObject</body>

<body package="PV-DM-Support" selector="pvModel">pvModel
	^pvModel</body>
</methods>


<methods>
<class-id>PROVISO.PvEventAttrType class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventAttributeTypeHistory' put: self historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allColumnsForSelectWithPrefix: 'evad.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ PUSH_SUBQ */
       %columnList 
  From %eventAttributeTypeHistory evad
 Where evad.Dte_Date %resyncDateCondition
   And evad.Dte_Date = (Select Max(evad1.Dte_Date)
                          From %eventAttributeTypeHistory evad1
                         Where evad1.Idx_Ind = evad.Idx_Ind
                           And evad1.Dte_Date %resyncDateCondition )
   And evad.Str_Action In %actionList;
'</body>
</methods>


<methods>
<class-id>PROVISO.PvThresholdDefinition class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementForFormulaId:">selectStatementForFormulaId: formulaId

	^'select idx_metric from ', self tableName, ' where idx_metric = ', formulaId printString</body>
</methods>


<methods>
<class-id>PROVISO.PvEventType class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ PUSH_SUBQ */
       %columnList 
  From %eventTypeHistory evt
 Where evt.Dte_Date %resyncDateCondition
   And evt.Dte_Date = (Select Max(evt1.Dte_Date)
                         From %eventTypeHistory evt1
                        Where evt1.Idx_Ind = evt.Idx_Ind
                          And evt1.Dte_Date %resyncDateCondition )
   And evt.Str_Action In %actionList;
'</body>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventTypeHistory' put: self historyTableName asString.
	namedReplacements at: 'columnList' put: (self allColumnsForSelectWithPrefix: 'evt.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarSegment class</class-id> <category>database constants</category>

<body package="PV-DM-Support" selector="periodDay">periodDay
	" Despite the name, it includes a number of calendar segments whose effective period is one week "

	^1</body>

<body package="PV-DM-Support" selector="periodComplementAbsoluteRange_1">periodComplementAbsoluteRange_1
	" Main period: oneTimeOnly (4) "

	^1</body>

<body package="PV-DM-Support" selector="dayIndexThursday">dayIndexThursday

	^4</body>

<body package="PV-DM-Support" selector="dayIndexFriday">dayIndexFriday

	^5</body>

<body package="PV-DM-Support" selector="periodComplementRangeInWeek">periodComplementRangeInWeek
	" Main period: week (2). 
	Period repeats for specified range in week "

	^2</body>

<body package="PV-DM-Support" selector="periodComplementWeekend">periodComplementWeekend
	" Period that repeats every day for weekend days "

	^3</body>

<body package="PV-DM-Support" selector="periodWeek">periodWeek

	^2</body>

<body package="PV-DM-Support" selector="periodComplementEveryDay">periodComplementEveryDay
	" Period that repeats every day "

	^1</body>

<body package="PV-DM-Support" selector="periodComplementEncodedRangeInMonth">periodComplementEncodedRangeInMonth
	" Main period: month(3). 
	Period repeats for specified encoded range in month "

	^2</body>

<body package="PV-DM-Support" selector="dayIndexSaturday">dayIndexSaturday

	^6</body>

<body package="PV-DM-Support" selector="periodComplementEnumeratedDaysInWeek">periodComplementEnumeratedDaysInWeek
	" Main period: week (2). 
	Period repeats for enumerated days in week "

	^1</body>

<body package="PV-DM-Support" selector="dayIndexTuesday">dayIndexTuesday

	^2</body>

<body package="PV-DM-Support" selector="periodComplementAbsoluteRange_2">periodComplementAbsoluteRange_2
	" Main period: oneTimeOnly (4) "

	^2</body>

<body package="PV-DM-Support" selector="dayIndexSunday">dayIndexSunday

	^0</body>

<body package="PV-DM-Support" selector="periodMonth">periodMonth

	^3</body>

<body package="PV-DM-Support" selector="dayIndexWednesday">dayIndexWednesday

	^3</body>

<body package="PV-DM-Support" selector="oneTimeOnly">oneTimeOnly

	^4</body>

<body package="PV-DM-Support" selector="periodComplementWeekday">periodComplementWeekday
	" Period that repeats every day for weekday days "

	^2</body>

<body package="PV-DM-Support" selector="dayIndexMonday">dayIndexMonday

	^1</body>

<body package="PV-DM-Support" selector="periodComplementRangeInMonth">periodComplementRangeInMonth
	" Main period: month(3). 
	Period repeats for specified range in month "

	^1</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarSegment class</class-id> <category>dispatching</category>

<body package="PV-DM-Support" selector="strategyClassFor:">strategyClassFor: aCalendarSegment
	" This class facilitates polymorphic behavior. It answer class of segment's trait (a proper subclass pv CalendarSegmentTrait)
	based on the segment's definition "

		(Case select: aCalendarSegment period)
		case: self periodDay
			do: 
				[(Case select: aCalendarSegment periodComplement)
					case: self periodComplementEveryDay
						do: [^EveryDayCalendarSegment];
					case: self periodComplementWeekday
						do: [^WeekdayCalendarSegment];
					case: self periodComplementWeekend
						do: [^WeekendCalendarSegment];
					elseDo: [^UnsupportedCalendarSegment]];
		case: self periodWeek
			do: 
				[(Case select: aCalendarSegment periodComplement)
					case: self periodComplementEnumeratedDaysInWeek
						do: [^EnumeratedDaysInWeekCalendarSegment];
					case: self periodComplementRangeInWeek
						do: [^RangeInInWeekCalendarSegment];
					elseDo: [^UnsupportedCalendarSegment]];
		case: self periodMonth
			do: 
				[(Case select: aCalendarSegment periodComplement)
					case: self periodComplementRangeInMonth
						do: [^RangeInInMonthCalendarSegment];
					case: self periodComplementEncodedRangeInMonth
						do: [^EncodedRangeInInMonthCalendarSegment];
					elseDo: [^UnsupportedCalendarSegment]];
		case: self oneTimeOnly
			do: 
				[(Case select: aCalendarSegment periodComplement)
					case: self periodComplementAbsoluteRange_1
						do: [^AbsoluteDateCalendarSegment];
					case: self periodComplementAbsoluteRange_2
						do: [^AbsoluteDateCalendarSegment];
					elseDo: [^UnsupportedCalendarSegment]];
		elseDo: [^UnsupportedCalendarSegment]</body>

<body package="PV-DM-Support" selector="strategyFor:">strategyFor: aPvCalendarSegment
	" Answer an instance of proper trait for aPvCalendarSegment "

	^(self strategyClassFor: aPvCalendarSegment)
		newFor: aPvCalendarSegment</body>
</methods>


<methods>
<class-id>PROVISO.PvInputBuildCommand class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementForAllForMsid:between:and:">selectStatementForAllForMsid: operator between: startSeconds and: endSeconds 
	"self selectAllForMsid: 210098240 between: 1211218765 and: 1214870399"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements   |
	realStartSeconds := startSeconds.
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.').
	operator notNil
		ifTrue: [
			namedReplacements 
				at: 'OPERATORCLAUSE'
				put: 't1.idx_ts_operator = ', operator asString].

	endSeconds == Infinity positive
		ifTrue: [namedReplacements at: 'PRIMARYDATECONDITION' put: ' &gt;= ' , startSeconds asString , ' ']
		ifFalse: [
			startSeconds &gt; 0 
				ifTrue: [
					namedReplacements at: 'PRIMARYDATECONDITION' put: 
						' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
				ifFalse: [namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt;= ' , endSeconds asString , ' ']].

	^'SELECT 
		%COLUMNLIST 
	FROM  %TABLE t1
	WHERE %OPERATORCLAUSE
		AND t1.dte_date %PRIMARYDATECONDITION ' namedBindWithArguments: namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvBaseSubelement class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="getSubelementChangesForId:from:to:do:">getSubelementChangesForId: resourceId from: start to: end do: aMonadicBlock

	| query bindVars effectiveStart effectiveEnd |

	effectiveStart := start max: 0.
	effectiveEnd := end == Infinity positive
					ifTrue: [PvTimestamp nowAsSeconds]
					ifFalse: [end].
	start = 0
		ifTrue: 
			[query := PvCmeSubelement selectStatementForLastSubelementChangeBefore.
			bindVars := Array with: resourceId with: effectiveEnd]
		ifFalse: 
			[query := PvCmeSubelement selectStatementForAllSubelementChangesInRange.
			bindVars := Array with: resourceId with: effectiveStart with: effectiveEnd]
.
	self dbSession 
		readObjectsOfClass: PvCmeSubelement
		with: query
		bindVars: bindVars
		into: aMonadicBlock</body>

<body package="PV-DM-Support" selector="selectStatementForAllSubelementChangesInRange">selectStatementForAllSubelementChangesInRange
	"self selectStatementForAllSubelementChangesInRange"
	"This statement retrieves last subelement at or before specified time"
	
	| namedReplacements |
	namedReplacements := 
		('TABLE' -&gt;self historyTableName asString),
		('COLUMNLIST' -&gt; (self allHistoricalColumnsForSelectWithPrefix: 'se.')).
	^'Select 
		%COLUMNLIST 
	From   %TABLE se
	Where se.idx_ind = :1
		And se.Dte_Date Between :2 And :3
' namedBindWithArguments: namedReplacements.</body>

<body package="PV-DM-Support" selector="selectStatementForLastSubelementChangeBefore">selectStatementForLastSubelementChangeBefore
	"self selectStatementForLastSubelementBefore"
	"This statement retrieves last subelement at or before specified time"
	
	| namedReplacements |
	namedReplacements := 
		('TABLE' -&gt;self historyTableName asString),
		('COLUMNLIST' -&gt; (self allHistoricalColumnsForSelectWithPrefix: 'se.')).
	^'Select /*+ PUSH_SUBQ */
		%COLUMNLIST 
	  From   %TABLE se
 Where se.idx_ind = :1
   And se.dte_date = (select max(dte_date) From SE_DESC_HIST se1 Where se1.Idx_Ind = se.Idx_Ind And se1.Dte_Date &lt;= :2 )
   And se.Str_Action In (''I'',''U'')
' namedBindWithArguments: namedReplacements.</body>
</methods>


<class>
<name>PVDatabaseDomainHelper</name>
<environment>PROVISO</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PVDatabaseDomainHelper</class-id> <category>parameters</category>

<body package="PV-DM-Support" selector="addToNowDateConditionTo:using:">addToNowDateConditionTo: namedReplacements using: parametersDictionary 
	
	| endSeconds |
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	namedReplacements at: 'toNowDateCondition' put: ' &lt;= ' , endSeconds asString , ' '</body>

<body package="PV-DM-Support" selector="addResyncDateConditionTo:using:">addResyncDateConditionTo: namedReplacements using: parametersDictionary 
	
	| endSeconds startSeconds |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	namedReplacements 
		at: 'resyncDateCondition'
		put: 
			(startSeconds &gt; 0 
				ifTrue: [' BETWEEN ' , startSeconds asString , ' AND ' , endSeconds asString , ' ']
				ifFalse: [' &lt;= ' , endSeconds asString , ' '])</body>

<body package="PV-DM-Support" selector="addCollectorClauseNamed:to:prefix:using:">addCollectorClauseNamed: name
	to: namedReplacements
	prefix: prefix
	using: parametersDictionary
	
	| collectors |
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [#()].
	namedReplacements 
		at: name
		put: 
			(collectors isEmpty 
				ifTrue: ['']
				ifFalse: 
					[prefix , '.Int_Collector In ' , collectors asParameterListString , ' And '])</body>

<body package="PV-DM-Support" selector="addActionListTo:using:">addActionListTo: namedReplacements using: parametersDictionary 
	
	| startSeconds |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	namedReplacements 
		at: 'actionList'
		put: 
			(startSeconds &gt; 0 
				ifTrue: [#('I' 'U' 'D')]
				ifFalse: [#('I' 'U')]) asParameterListString</body>
</methods>


<methods>
<class-id>PROVISO.PvDomainObject</class-id> <category>persistence</category>

<body package="PV-DM-Support" selector="proxifyIn:">proxifyIn: aPvModel 
	"Turn the receiver into a proxy (if possible)."
	
	| myPosition repos |
	repos := aPvModel repository.
	repos ifNil: [^self].
	repos critical: 
		[myPosition := self journalPosition.
		(self id isNil or: [myPosition isNil]) 
			ifTrue: 
				["The receiver cannot be proxified because it doesn't have enough information to retrieve the domain object from the repository.  Just answer the receiver."^self].
		self become: 
			(self 
				asProxyIn: aPvModel
				position: myPosition)]</body>
</methods>


<methods>
<class-id>PROVISO.PvFormula</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isOperatorNumericFormula">isOperatorNumericFormula

	^self isOperatorFormula and: [self isFloat]</body>

<body package="PV-DM-Support" selector="isOperatorFormula">isOperatorFormula

	^self hasFormulaPrototype</body>

<body package="PV-DM-Support" selector="dependsOnFormula:">dependsOnFormula: aPvFormula 
 
	^self formulaPrototype 
		ifNil: [false]
		ifNotNil: 
			[:f | 
			self isSmee and: 
				[f arguments notNil and: 
					[f arguments anySatisfy: 
						[:eachArg | 
						eachArg pathFormulas notNil and: 
							[eachArg pathFormulas anySatisfy: 
								[:eachAssoc | 
								eachAssoc value notNil and: 
									[eachAssoc value == aPvFormula or: [eachAssoc value dependsOnFormula: aPvFormula]]]]]]]]</body>

<body package="PV-DM-Support" selector="isOperatorProperty">isOperatorProperty

	^self isOperatorFormula and: [self isString]</body>
</methods>

<methods>
<class-id>PROVISO.PvFormula</class-id> <category>xml parsing/generation</category>

<body package="PV-DM-Support" selector="createSmeePrototypeIn:">createSmeePrototypeIn: aPvModel

	self isSmee ifFalse: [^nil].
	(self sourceText isNil or: [self sourceText isEmpty]) ifTrue: [^nil].
	self formulaPrototype: 
		[[ | timestamp frml doc |
		timestamp := self resyncHistoricalDate ifNil: [self date].
		doc := aPvModel formulaManager formulaDocumentFor: self timestamp: timestamp.
		frml := aPvModel formulaManager 
			getFormulaNamed: self fullName 
			inDocument: doc 
			timestamp: timestamp.
		frml ifNil: 
			[self error: 'Unable to locate formula named "', self fullName asString, 
				'" in document "', doc asString, '"']
			ifNotNil: [frml formulaPrototype id: self id].
		frml formulaPrototype]
				on: FrmlDocRegistry missingFormula
				do: [ :ex | ex resume]].
	^formulaPrototype</body>
</methods>

<methods>
<class-id>PROVISO.PvFormula</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="hasCompiledFormulaPrototype">hasCompiledFormulaPrototype

	^formulaPrototype notNil and: [formulaPrototype isBlock not]</body>

<body package="PV-DM-Support" selector="addSpecificFormula:">addSpecificFormula: aFormula

	self specificFormulas ifNil: [self specificFormulas: Set new].
	self specificFormulas add: aFormula</body>

<body package="PV-DM-Support" selector="hasFormulaPrototype">hasFormulaPrototype

	^formulaPrototype notNil</body>

<body package="PV-DM-Support" selector="resetSpecificFormulas">resetSpecificFormulas

	self specificFormulas: nil</body>
</methods>

<methods>
<class-id>PROVISO.PvFormula</class-id> <category>converting</category>

<body package="PV-DM-Support" selector="coerceToTheRightRecordType:">coerceToTheRightRecordType: aTuple 
	
	^self isSparseTimeSeries 
		ifTrue: [aTuple asSparseMetricRecord]
		ifFalse: [aTuple asPeriodicMetricRecord]</body>
</methods>


<methods>
<class-id>PROVISO.PvEventProperty class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventPropertyHistory' put: self historyTableName asString.
	namedReplacements at: 'eventHistory' put: PvEvent historyTableName asString.
	namedReplacements at: 'elementHistory' put: PvElement historyTableName asString.
	namedReplacements at: 'subelementHistory' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 'evav.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addToNowDateConditionTo: namedReplacements
			using: parametersDictionary;
		addCollectorClauseNamed: 'eCollectorClause'
			to: namedReplacements
			prefix: 'e'
			using: parametersDictionary;
		addCollectorClauseNamed: 'edCollectorClause'
			to: namedReplacements
			prefix: 'e1'
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ ORDERED PUSH_SUBQ USE_NL(ev1 evav) */
       %columnList 
  From (Select /*+ NO_MERGE PUSH_SUBQ ORDERED USE_NL(se ev) INDEX(ev ID_EVDH_4_2) */
               ev.Idx_Ind
          From ( Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(e s) */
                        s.Idx_Ind
                   From %elementHistory e,
                        %subelementHistory s
                  Where %eCollectorClause
                    s.Idx_Host = e.Idx_Ind
                    And e.Dte_Date %toNowDateCondition
                    And e.Dte_Date = ( Select Max(Dte_Date)
                                         From %elementHistory e1
                                        Where e1.Idx_Ind = e.Idx_Ind
                                          And %edCollectorClause
                                          e1.Dte_Date %toNowDateCondition )
                    And s.Dte_Date %toNowDateCondition
                    And s.Dte_Date = ( Select Max(Dte_Date)
                                         From %subelementHistory s1
                                        Where s1.Idx_Ind = s.Idx_Ind
                                          And s1.Dte_Date %toNowDateCondition )
                    And e.Str_Action In %actionList
                    And s.Str_Action In %actionList ) se,
               %eventHistory ev
         Where ev.Idx_Resource = se.Idx_Ind
           And ev.Dte_Date  %toNowDateCondition
           And ev.Dte_Date = (Select Max(ev1.Dte_Date)
                                From %eventHistory ev1
                               Where ev1.Idx_Ind = ev.Idx_Ind
                                 And ev1.Idx_Resource = ev.Idx_Resource
                                 And ev1.Dte_Date %toNowDateCondition )
           And ev.Str_Action In %actionList) ev1,
       %eventPropertyHistory evav
 Where evav.Idx_Event = ev1.Idx_Ind
   And evav.Dte_Date %resyncDateCondition
   And evav.Dte_Date = ( Select Max(evav1.Dte_Date)
                           From %eventPropertyHistory evav1
                          Where evav1.Idx_Event = evav.Idx_Event
                            And evav1.Idx_Attribute = evav.Idx_Attribute
                            And evav1.Dte_Date %resyncDateCondition )
   And evav.Str_Action In %actionList;
'</body>
</methods>


<methods>
<class-id>PROVISO.PvEventRelation class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="isHistorical">isHistorical

	^ true</body>

<body package="PV-DM-Support" selector="historyTableName">historyTableName

	^'event_event_desc_hist'</body>

<body package="PV-DM-Support" selector="selectStatementTemplateString">selectStatementTemplateString

	^'
Select /*+ ORDERED PUSH_SUBQ USE_NL(ev1 eed) */
       %columnList
  From (Select /*+ NO_MERGE PUSH_SUBQ ORDERED USE_NL(se ev) INDEX(ev ID_EVDH_4_2) */
               ev.Idx_Ind
          From (Select /*+ ORDERED NO_MERGE PUSH_SUBQ USE_NL(e s) */
                        s.Idx_Ind
                   From %elementHistory e,
                        %subelementHistory s
                  Where %eCollectorClause
                    s.Idx_Host = e.Idx_Ind
                    And e.Dte_Date %toNowDateCondition
                    And e.Dte_Date = ( Select Max(Dte_Date)
                                         From %elementHistory e1
                                        Where e1.Idx_Ind = e.Idx_Ind
                                          And %edCollectorClause
                                          e1.Dte_Date %toNowDateCondition )
                    And s.Dte_Date %toNowDateCondition
                    And s.Dte_Date = ( Select Max(Dte_Date)
                                         From %subelementHistory s1
                                        Where s1.Idx_Ind = s.Idx_Ind
                                          And s1.Dte_Date %toNowDateCondition )
                    And e.Str_Action In %actionList
                    And s.Str_Action In %actionList ) se,
               %eventHistory ev
         Where ev.Idx_Resource = se.Idx_Ind
           And ev.Dte_Date  %toNowDateCondition
           And ev.Dte_Date = (Select Max(ev1.Dte_Date)
                                From %eventHistory ev1
                               Where ev1.Idx_Ind = ev.Idx_Ind
                                 And ev1.Idx_Resource = ev.Idx_Resource
                                 And ev1.Dte_Date %toNowDateCondition )
           And ev.Str_Action In %actionList) ev1,
       %eventRelationHistory eed
 Where eed.Idx_Parent_Event = ev1.Idx_Ind
   And eed.Dte_Date %resyncDateCondition
   And eed.Dte_Date = ( Select Max(eed1.Dte_Date)
                         From %eventRelationHistory eed1
                         Where eed1.Idx_Parent_Event = eed.Idx_Parent_Event
                           And eed1.Idx_Child_Event = eed.Idx_Child_Event
                           And eed1.Dte_Date %resyncDateCondition )
'</body>

<body package="PV-DM-Support" selector="selectStatementWithParameters:">selectStatementWithParameters: parametersDictionary 
	
	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'eventRelationHistory' put: self historyTableName asString.
	namedReplacements at: 'eventHistory' put: PvEvent historyTableName asString.
	namedReplacements at: 'elementHistory' put: PvElement historyTableName asString.
	namedReplacements at: 'subelementHistory' put: 
		PvSubelement historyTableName asString.
	namedReplacements at: 'columnList' put: 
		(self allHistoricalColumnsForSelectWithPrefix: 'eed.').
	PVDatabaseDomainHelper new
		addResyncDateConditionTo: namedReplacements
			using: parametersDictionary;
		addToNowDateConditionTo: namedReplacements
			using: parametersDictionary;
		addCollectorClauseNamed: 'eCollectorClause'
			to: namedReplacements
			prefix: 'e'
			using: parametersDictionary;
		addCollectorClauseNamed: 'edCollectorClause'
			to: namedReplacements
			prefix: 'e1'
			using: parametersDictionary;
		addActionListTo: namedReplacements
			using: parametersDictionary.
	^self selectStatementTemplateString trimBlanks namedBindWithArguments: 
		namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>As yet unclassified</category>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:segment:">startOfPeriodForTimestamp: aPvTimestampOrNumber segment: aCalendarSegment
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment "

	^aCalendarSegment startOfPeriodForTimestamp: aPvTimestampOrNumber</body>

<body package="PV-DM-Support" selector="intervalsFrom:to:do:">intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock
	" Evaluate the block with all intervals that intersect time interval from aTsNumberStart to aTsNumberStop exclusive. 
	aMonadicBlock is evaluated with an instance of PvCalendarTimeInterval. "

	| startTime boundaries subInt |
	startTime := self calendar segments inject: aTsNumberStart into: [:minTs :eachSegment | 
					minTs min: (self startOfPeriodForTimestamp: aTsNumberStart segment: eachSegment)].
	boundaries := PvCalendarTimeInterval start: aTsNumberStart stop: aTsNumberStop.
	" This may go back and forth in time, so reset myself before and after "
	self reset.
	[[startTime &lt;= aTsNumberStop] 
		whileTrue:
			[self intervalForTimestamp: startTime - 1.
			startTime := self horizonStop + 1].
	self intervals do: [:eachInterval |
		(boundaries intersectsWith: eachInterval)
			ifTrue: 
				[subInt := boundaries intersect: eachInterval.
				subInt inSegment: eachInterval inSegment.
				subInt isEmpty 
					ifFalse: [aMonadicBlock value: subInt]]]] 
		ensure:
			[self reset]</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptCalendarSegmentEveryDayInterval:">acceptCalendarSegmentEveryDayInterval: aSegment 
	" Build calentar intervals for the period defined by the argument calendar segment and timestamp.
	Determine time interval from this segment containing timestamp. Add both period boundary segment (full day or maybe two days) and 
	the specific interval to this calendar interface.
	This calendar segment spans one day and it repeats every day "
	
	| base from to |
	base := timestamp dayStartSeconds.
	self addSegmentBoundaryFrom: base to: self timestamp dayStopSeconds.
	" If high boundary is less or equal to low bounday, prpagate it one day to the future
	(i.e. (00:00 - 00:00 really means 00 through the start of the next day "
	from := base + aSegment fromTimeSeconds.
	to := base + aSegment toTimeSeconds.
	to &lt;= from 
		ifTrue: [to := to + 86400].
	self 
		addIntervalFrom: from
		to: to</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentWeekdayInterval:">acceptCalendarSegmentWeekdayInterval: aSegment
	" Build calentar intervals for the period defined by the argument calendar segment and timestamp.
	Determine time interval from this segment containing timestamp. Add both period boundary segment (full day or maybe two days) and 
	the specific interval to this calendar interface "

	| base dayStart offset from to |
	base := self timestamp weekStartSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	self addSegmentBoundaryFrom: base to: self timestamp weekStopSeconds.
	aSegment weekdayIndices do: [:ix | |dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		from := dayStart + aSegment fromTimeSeconds.
		to := dayStart + aSegment toTimeSeconds.
		to &lt;= from 
			ifTrue: 
				[to := to + 86400 "24 * 3600"].
		self 
			addIntervalFrom: from
			to: to
	]</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentWeekendInterval:">acceptCalendarSegmentWeekendInterval: aSegment
	" Build calentar intervals for the period defined by the argument calendar segment and timestamp.
	Determine time interval from this segment containing timestamp. Add both period boundary segment (full day or maybe two days) and 
	the specific interval to this calendar interface "

	| base dayStart offset from to |
	base := self timestamp weekStartSeconds.
	self addSegmentBoundaryFrom: base to: self timestamp weekStopSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	aSegment weekendIndices do: [:ix | |dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").
		from := dayStart + aSegment fromTimeSeconds.
		to := dayStart + aSegment toTimeSeconds.
		to &lt;= from 
			ifTrue: 
				[to := to + 86400 "24 * 3600"].
		self addIntervalFrom: from to: to
	]</body>

<body package="PV-DM-Support" selector="acceptCalendarSegmentEnumeratedWeekInterval:">acceptCalendarSegmentEnumeratedWeekInterval: aSegment 
	" Build calentar intervals for the period defined by the argument calendar segment and timestamp.
	Determine time interval from this segment containing timestamp. Add both period boundary segment (full day or maybe two days) and 
	the specific interval to this calendar interface
	This calendar segment spans one week and it repeats every day for which there is an index specified in this segment. 
	from&lt;-&gt;to specification may implicitly add another day if to &lt;= from (i.e. 17:00 &lt;-&gt; 00:00) "
	
	| base offset from to |
	base := self timestamp weekStartSeconds.
	offset := PvTimestamp weekStartSunday ifTrue: [0] ifFalse: [-1].
	self 
		addSegmentBoundaryFrom: base
		to: self timestamp weekStopSeconds.
	aSegment weekEnumerationIndices do: [:ix | |dayStart dayIx|
		dayIx := ix + offset.
		dayIx &lt; 0 ifTrue: [dayIx := dayIx + 7].
		dayStart := base + (dayIx  * 86400 "24 * 3600").

		from := dayStart + aSegment fromTimeSeconds.
		to := dayStart + aSegment toTimeSeconds.
		to &lt;= from 
			ifTrue: 
				[to := to + 86400 "24 * 3600"].
		self 
			addIntervalFrom: from
			to: to]</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>initialize-release</category>

<body package="PV-DM-Support" selector="initialize">initialize

	super initialize.
	intervals := SortedCollection new: 8.
	segmentBoundaries := SortedCollection new: 8.
	lastInterval := nil</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarIntervalInterface</class-id> <category>api</category>

<body package="PV-DM-Support" selector="intervalForTimestamp:">intervalForTimestamp: aSeconds 
	" It is possible that end of an implicitly built period and the start of explicitly ('in') period overlap. This should really be fixed
	in the build code to prevent this prom happening. In the meantime first search for explicitly built interval, then for an 
	implicit one "
	| result |
	((result := self lastInterval) notNil and: [result includes: aSeconds]) 
		ifTrue: [^result].
	^(self extendHorizonToInclude: aSeconds) ifNotNil: 
		[result := 
			self intervals 
				detect: [:each | (each includes: aSeconds) and: [each inSegment]]
				ifNone: 
					[self intervals 
						detect: [:each | each includes: aSeconds]
						ifNone: [^nil]].
		self lastInterval: result.
		result]</body>

<body package="PV-DM-Support" selector="reset">reset

	self initialize</body>
</methods>


<methods>
<class-id>PROVISO.PvTimeSeriesBuildCommand</class-id> <category>printing</category>

<body package="PV-DM-Support" selector="formula">formula 
	
	^self pvModel ifNotNil: [self pvModel formulaWithId: self metricId]</body>

<body package="PV-DM-Support" selector="printResourceOn:">printResourceOn: aStream 
	
	self resource 
		ifNil: 
			[aStream
				nextPutAll: 'resourceId: ';
				print: self metricId]
		ifNotNil: [:pvSe | pvSe printNameOn: aStream]</body>

<body package="PV-DM-Support" selector="printFormulaOn:">printFormulaOn: aStream 
	
	self formula 
		ifNil: 
			[aStream
				nextPutAll: 'metricId: ';
				print: self metricId]
		ifNotNil: [:pvFormula | pvFormula printNameOn: aStream]</body>

<body package="PV-DM-Support" selector="printContentsOn:">printContentsOn: aStream 
	
	aStream
		nextPutAll: self resyncAction asString;
		nextPutAll: ': '.
	self printFormulaOn: aStream.
	aStream space.
	self printResourceOn: aStream.
	aStream space.
	aStream
		nextPutAll: 'msid: ';
		print: self msid;
		nextPutAll: ' streamLabelId: ';
		print: self streamLabelId;
		nextPutAll: ' ts: ';
		nextPutAll: self timestamp pvOpportunisticPrintString;
		nextPutAll: ' version: ';
		nextPutAll: self versionDate pvOpportunisticPrintString</body>

<body package="PV-DM-Support" selector="resource">resource 
	
	^self pvModel ifNotNil: [self pvModel subelementWithId: self resourceId]</body>

<body package="PV-DM-Support" selector="printOn:">printOn: aStream 
	
	aStream
		nextPutAll: self class name;
		nextPutAll: ' ('.
	self printContentsOn: aStream.
	aStream nextPut: $)</body>
</methods>


<class>
<name>UnsupportedCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractCalendarSegmentStrategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.UnsupportedCalendarSegment</class-id>
<body>I represent calendar segment which is currently not supported by Datachannel
</body>
</comment>

<methods>
<class-id>PROVISO.UnsupportedCalendarSegment</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isSupportedByDatachannel">isSupportedByDatachannel

	^false</body>
</methods>

<methods>
<class-id>PROVISO.UnsupportedCalendarSegment</class-id> <category>As yet unclassified</category>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^nil</body>
</methods>

<methods>
<class-id>PROVISO.UnsupportedCalendarSegment</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestamp
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^nil</body>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^nil</body>
</methods>

<methods>
<class-id>PROVISO.UnsupportedCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestampOrNumber do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" Do nothing here "</body>

<body package="PV-DM-Support" selector="asIntervalForTimestamp:">asIntervalForTimestamp: dayTimestamp
	" Answer daily interval for the current timestamp "

	^nil</body>
</methods>


<class>
<name>PvCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>period periodComplement comment fromDay toDay fromTime toTime weekEnumeration calendarId calendar strategy </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Calendars</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvCalendarSegment</class-id> <category>printing</category>

<body package="PV-DM-Support" selector="printOn:">printOn: aStream

	aStream
		nextPutAll: self strategy 	labelForCalendarSegment;
		nextPutAll: ' (calendar: ';
		print: self calendarId;
		nextPutAll: ',  ';
		print: self period;
		nextPutAll: ':';
		print: self periodComplement;
		nextPutAll: '  &lt;';
		print: self fromDay;
		nextPutAll: ': ';
		print: self toDay;
		nextPutAll: '&gt;  &lt;';
		print: self fromTime;
		nextPutAll: ': ';
		print: self toTime;
		nextPutAll: '&gt;)'</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarSegment</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="strategy">strategy
	" If traits is not set, set it lazily "
	
	strategy ifNil: [strategy := self class strategyFor: self].
	^strategy</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarSegment</class-id> <category>dispatching</category>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	| pvTs |
	pvTs := self coerceToPvTimestamp: aPvTimestampOrNumber.
	^self strategy stopOfPeriodForTimestamp: pvTs</body>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	| pvTs |
	pvTs := self coerceToPvTimestamp: aPvTimestampOrNumber.
	^self strategy endOfPeriodForTimestamp: pvTs</body>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestampOrNumber do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a triadic block. When it is evaluated, it is passed start of period and period offsets to the start and stop of the interval "

	| pvTs |
	pvTs := self coerceToPvTimestamp: aPvTimestampOrNumber.
	self strategy intervalsForTimestamp: pvTs do: aBlock</body>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	| pvTs |
	pvTs := self coerceToPvTimestamp: aPvTimestampOrNumber.
	^self strategy startOfPeriodForTimestamp: pvTs</body>

<body package="PV-DM-Support" selector="durationOfPeriodForTimestamp:">durationOfPeriodForTimestamp: aPvTimestampOrNumber
	" Answer duration of period for period containing aPvTimestamp using definition of aCalendarSegment "

	| pvTs |
	pvTs := self coerceToPvTimestamp: aPvTimestampOrNumber.
	^self strategy durationOfPeriodForTimestamp: pvTs</body>
</methods>

<methods>
<class-id>PROVISO.PvCalendarSegment</class-id> <category>dispatching-private</category>

<body package="PV-DM-Support" selector="coerceToPvTimestamp:">coerceToPvTimestamp: aPvTimestampOrNumber 
	
	| pvTs |
	pvTs := 
		aPvTimestampOrNumber isInteger 
			ifTrue: [PvTimestamp fromSeconds: aPvTimestampOrNumber]
			ifFalse: [aPvTimestampOrNumber].
	^pvTs</body>
</methods>


<methods>
<class-id>PROVISO.PvInputBuildCommand</class-id> <category>printing</category>

<body package="PV-DM-Support" selector="printOn:">printOn: aStream

	aStream
		nextPutAll: self class name;
		nextPutAll: ' (';
		nextPutAll: self resyncAction asString;
		nextPutAll: ': ';
		nextPutAll: 'operatorTimeSeriesMsid: ';
		print: self operatorTimeSeriesMsid;
		nextPutAll: ' operatorTimeSeriesLabel: ';
		print: self operatorTimeSeriesLabel;
		nextPutAll: ' inputTimeSeriesMsid: ';
		print: self inputTimeSeriesMsid;
		nextPutAll: ' currentResourceId: ';
		print: self currentResourceId;
		nextPutAll: ' sequenceNumber: ';
		print: self sequenceNumber;
		nextPutAll: ' ts: ';
		nextPutAll: self timestamp pvOpportunisticPrintString;
		nextPutAll: ' version: ';
		nextPutAll: self versionDate pvOpportunisticPrintString</body>
</methods>

<methods>
<class-id>PROVISO.PvInputBuildCommand</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="isSameAs:">isSameAs: anotherCommand 
	
	^(super isSameAs: anotherCommand) and: 
		[self operatorTimeSeriesMsid = anotherCommand operatorTimeSeriesMsid and: 
			[self inputTimeSeriesMsid = anotherCommand inputTimeSeriesMsid and: 
				[self operatorTimeSeriesLabel = anotherCommand operatorTimeSeriesLabel and: 
					[self sequenceNumber = anotherCommand sequenceNumber and: 
						[self currentResourceId = anotherCommand currentResourceId]]]]]</body>
</methods>


<class>
<name>MonthlyCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractCalendarSegmentStrategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.MonthlyCalendarSegment</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestamp
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^aPvTimestamp monthStartSeconds</body>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestamp
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^aPvTimestamp monthStopSeconds</body>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestamp
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^aPvTimestamp monthEndSeconds</body>
</methods>


<class>
<name>WeeklyCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractCalendarSegmentStrategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.WeeklyCalendarSegment</class-id>
<body>My subclasses have main period of one week. They build intervals withing the main period</body>
</comment>

<methods>
<class-id>PROVISO.WeeklyCalendarSegment</class-id> <category>private</category>

<body package="PV-DM-Support" selector="weekdayIndices">weekdayIndices
	" self new weekdayIndices "

	^(
		Array
			with: 
				PvCalendarSegment dayIndexMonday
			with: 
				PvCalendarSegment dayIndexTuesday
			with: 
				PvCalendarSegment dayIndexWednesday
			with: 
				PvCalendarSegment dayIndexThursday
			with: 
				PvCalendarSegment dayIndexFriday
	)</body>

<body package="PV-DM-Support" selector="weekendIndices">weekendIndices
	" self new weekendIndices "

	^(
		Array
			with: 
				PvCalendarSegment dayIndexSunday
			with: 
				PvCalendarSegment dayIndexSaturday
	)</body>
</methods>

<methods>
<class-id>PROVISO.WeeklyCalendarSegment</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestamp
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
"	^aPvTimestamp weekStopSeconds"
	^(self startOfPeriodForTimestamp: aPvTimestamp) + (Date secondsInDay * 7)</body>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestamp
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
"	^aPvTimestamp weekEndSeconds"
	^(self stopOfPeriodForTimestamp: aPvTimestamp) - 1</body>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestamp
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment. Wor weekly segments start of the week is the start of Sunday.
	This, it does NOT depend on the value of weekStartSunday "
	
"	^aPvTimestamp weekStartSeconds"
	^aPvTimestamp dayStartSeconds - 
		((self class dayIndexFromDate: aPvTimestamp asDate) * Date secondsInDay).</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendar</class-id> <category>tuple storage compatibility</category>

<body package="PV-DM-Support" selector="hasFormulaPrototype">hasFormulaPrototype

	^false</body>

<body package="PV-DM-Support" selector="hasCompiledFormulaPrototype">hasCompiledFormulaPrototype

	^false</body>
</methods>


<class>
<name>AbsoluteDateCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractCalendarSegmentStrategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.AbsoluteDateCalendarSegment</class-id>
<body>I represent a once-only (non-repeating interval defined by its start and end. 

	Start if comprised from date (fromDate) and time (fromTime)
	Stop if comprised from date (toDate) and time (toTime)


</body>
</comment>

<methods>
<class-id>PROVISO.AbsoluteDateCalendarSegment</class-id> <category>As yet unclassified</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestampOrNumber do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "
	
	| start stop |
	start := 
		(PvTimestamp 
			fromDate: (Date readFrom: self segment fromDay readStream)
			andTime: (Time readFrom: self segment fromTime readStream)) asSeconds.
	stop := 
		(PvTimestamp 
			fromDate: (Date readFrom: self segment toDay readStream)
			andTime: (Time readFrom: self segment toTime readStream)) asSeconds.
	aBlock value: 
		(PvCalendarTimeInterval 
			start: start
			stop: stop
			inSegment: true)</body>
</methods>

<methods>
<class-id>PROVISO.AbsoluteDateCalendarSegment</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestampOrNumber 
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	" Here we equate period to the interval "
	^(PvTimestamp 
		fromDate: (Date readFrom: self segment toDay readStream)
		andTime: (Time readFrom: self segment toTime readStream)) asSeconds</body>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestamp
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	self stopOfPeriodForTimestamp: aPvTimestamp - 1</body>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestamp 
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	" Here we equate period to the interval "
	^(PvTimestamp 
			fromDate: (Date readFrom: self segment fromDay readStream)
			andTime: (Time readFrom: self segment fromTime readStream)) asSeconds</body>
</methods>


<methods>
<class-id>PROVISO.PvEventProperty</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="postInsertUpdateIn:">postInsertUpdateIn: aPvModel 
	
	(self pvModel eventPropertyManager eventAttrTypes 
		at: self attributeId
		ifAbsent: [nil]) ifNotNil: 
			[:type | 
			self attrType ifNil: [self attrType: type].
			self name ifNil: [self name: type name]]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventProperty</class-id> <selector>setNameFromType:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvTimezone</class-id> <category>private</category>

<body package="PV-DM-Support" selector="resyncUpdateFrom:">resyncUpdateFrom: aPvDomainObject
	"Update the receiver's instance variables from the given object. This code is specific to PvTimezone class."

	self class == aPvDomainObject class
		ifFalse: [^self].

	name := aPvDomainObject name.
	resyncAction := aPvDomainObject resyncAction.
	id := aPvDomainObject id.
	flags := aPvDomainObject flags.
	date := aPvDomainObject date.
	offset := aPvDomainObject offset.
	comment := aPvDomainObject comment.
	status := aPvDomainObject status.
	
	date ifNotNil: 
		[(self dates includes: date)
			ifFalse: [self dates add: date].
		self offsets at: date put: offset].</body>
</methods>


<class>
<name>DailyCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractCalendarSegmentStrategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.DailyCalendarSegment</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="endOfPeriodForTimestamp:">endOfPeriodForTimestamp: aPvTimestamp
	" Answer end of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^aPvTimestamp dayEndSeconds</body>

<body package="PV-DM-Support" selector="startOfPeriodForTimestamp:">startOfPeriodForTimestamp: aPvTimestamp
	" Answer start of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^aPvTimestamp dayStartSeconds</body>

<body package="PV-DM-Support" selector="stopOfPeriodForTimestamp:">stopOfPeriodForTimestamp: aPvTimestamp
	" Answer stop of period for period containing aPvTimestamp using definition of aCalendarSegment "
	
	^aPvTimestamp dayStopSeconds</body>
</methods>


<methods>
<class-id>PROVISO.PvEventRelation</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="parent:">parent: anObject 
	
	parent := anObject.
	anObject ifNotNil: [:myParent | parentId := myParent id]</body>

<body package="PV-DM-Support" selector="parent">parent
	^parent</body>

<body package="PV-DM-Support" selector="child:">child: anObject
	child := anObject.
	anObject ifNotNil: [:myChild | childId := myChild id].</body>

<body package="PV-DM-Support" selector="child">child
	^child</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelation</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="postInsertUpdateIn:">postInsertUpdateIn: aPvModel 
	
	self child: 
		(aPvModel eventManager 
			itemWithId: self childId
			ifAbsent: [nil]).
	self parent: 
		(aPvModel eventManager 
			itemWithId: self parentId
			ifAbsent: [nil]).</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaVisitor</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptFormula:">acceptFormula: aPvFormula 
	
	self pushFormula: aPvFormula.
	[(aPvFormula isOperatorFormulaOrProperty and: [aPvFormula formulaClass isNil]) 
		ifTrue: 
			[PvFormulaCompileNotification 
				signalWith: aPvFormula
				text: 'Missing formula prototype -- probably syntax error'].
	aPvFormula isSpecificToGenericConversion 
		ifTrue: 
			[(self pvModel formulaWithId: aPvFormula genericId) 
				ifNotNil: [:genericFormula | genericFormula addSpecificFormula: aPvFormula]].
	super acceptFormula: aPvFormula] 
		ensure: [self popFormula]</body>
</methods>


<class>
<name>RangeInInMonthCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.MonthlyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.RangeInInMonthCalendarSegment</class-id>
<body>I represent a repeating interval which repeats every month. Start and end is defined by day indexes (from/toDay provide day indexes. 

The interval is from (fromDay index, fromTime) to  (toDay index, toTime)</body>
</comment>

<methods>
<class-id>PROVISO.RangeInInMonthCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" Week/Month range is encoded as a single interval defined by fromDay/fromTime to toDay/toTime.
	Evaluate block for this interval. If stop &lt;= start, the interval ends in the next period (intervals protrudes
	into the future). In this case we also evaluate the block with a symmetric interval that protrudes INTO 
	the current period from the previous one "
	
	self 
		intervalsForCalendarPeriodForTimestamp: aPvTimestamp
		from: ( self segment fromDayNumber - 1) * Date secondsInDay + self segment fromTimeSeconds
		to: (self segment toDayNumber - 1) * Date secondsInDay + self segment toTimeSeconds
		do: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.RangeInInMonthCalendarSegment</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="coversCompletePeriod">coversCompletePeriod
	" Answer true if the segment is periodic and completely covers its main period "

	^self segment fromDay = self segment toDay and: [self segment fromTime = self segment toTime]</body>
</methods>


<class>
<name>EnumeratedDaysInWeekCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.WeeklyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.EnumeratedDaysInWeekCalendarSegment</class-id>
<body>I represent a set of intervals repeating every week. I define weekEnumeration field which is like a bit mask for days on which interval occurs. In each of the days defined by weekEnumeration interval is fromTime to toTime.

Week enumeration is a sequence of 0 and 1. First digit corresponds to Sunday, next one to Monday and so on.
For example, the following weekEnumeration mask
	0 1 1 0 0 0 0
Corresponds to Monday and Tuesday.

I am a generalization of both weekday and weekend segments. The following masks model Weekday and Weekend segments respectively

	0 1 1 1 1 1 0
	1 0 0 0 0 0 1
</body>
</comment>

<methods>
<class-id>PROVISO.EnumeratedDaysInWeekCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" Weekly enumerated ranges are a sequence of intervals defined by fromDay/fromTime relative to the start of day 
	for all days of week for which enumeration is not zero "
	
	self 
		dailyIntervalsForTimestamp: aPvTimestamp
		periodIndices: self weekEnumerationIndices
		do: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.EnumeratedDaysInWeekCalendarSegment</class-id> <category>private</category>

<body package="PV-DM-Support" selector="weekEnumerationIndices">weekEnumerationIndices

	| indices weekString |
	indices := OrderedCollection new.
	weekString := self segment weekEnumeration reject: [:each | each isSeparator].
	weekString with: (0 to: weekString size -1) do: [:eachChar :eachIndex |
		(eachChar digitValue == 1)
			ifTrue: [indices add: eachIndex]].
	^ indices</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaLinker</class-id> <category>api</category>

<body package="PV-DM-Support" selector="link">link
	self class allSmeeFormulasIn: self pvModel do: [:each | each resetFormulaConnections].
	self pvModel formulaManager itemsDo: [:formula | formula resetSpecificFormulas].
	self visit: self pvModel formulaManager</body>
</methods>


<class>
<name>PvFormulaHeartbeatDisconnector</name>
<environment>PROVISO</environment>
<super>PROVISO.PvFormulaVisitor</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>NGUBA-ModelInterface</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvFormulaHeartbeatDisconnector</class-id> <category>visitor-callbacks</category>

<body package="PV-DM-Support" selector="acceptFormula:">acceptFormula: aPvFormula 
	"Overidden to NOT call formulaClass and force a compile.  When RCM is doing disconnectAllHeartbeatSources we don't want to compile anything"
	
	self pushFormula: aPvFormula.
	[(aPvFormula hasFormulaPrototype and: [aPvFormula hasCompiledFormulaPrototype])
		ifTrue: [self visit: aPvFormula formulaPrototype].
	self acceptObject: aPvFormula] 
		ensure: [self popFormula]</body>
</methods>


<class>
<name>RangeInInWeekCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.WeeklyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.RangeInInWeekCalendarSegment</class-id>
<body>I represent a repeating interval which repeats every week. Start and end is defined by day indexes (from/toDay provide day indexes. 

The interval is from (fromDay index, fromTime) to  (toDay index, toTime)</body>
</comment>

<methods>
<class-id>PROVISO.RangeInInWeekCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" Week/Month range is encoded as a single interval defined by fromDay/fromTime to toDay/toTime.
	Evaluate block for this interval. If stop &lt;= start, the interval ends in the next period (intervals protrudes into the future). "
	
	| startDayIndex stopDayIndex |
	startDayIndex := self segment fromDayNumber.	" Number from 0-6 (Sun-Sat), "
	stopDayIndex := self segment toDayNumber.		" Number from 0-6 (Sun-Sat), "
	" Delegate to the common code for range intervals "
	self 
		intervalsForCalendarPeriodForTimestamp: aPvTimestamp
		from: startDayIndex * Date secondsInDay + self segment fromTimeSeconds
		to: stopDayIndex * Date secondsInDay + self segment toTimeSeconds
		do: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.RangeInInWeekCalendarSegment</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="coversCompletePeriod">coversCompletePeriod
	" Answer true if the segment is periodic and completely covers its main period "

	^self segment fromDay = self segment toDay and: [self segment fromTime = self segment toTime]</body>
</methods>


<class>
<name>EveryDayCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.DailyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.EveryDayCalendarSegment</class-id>
<body>I represent a simple repeating interval which repeats every day between fromTime and toTime</body>
</comment>

<methods>
<class-id>PROVISO.EveryDayCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" This calendar segment spans one day and it repeats every day "
	
	self 
		dailyIntervalStartingAt: (self startOfPeriodForTimestamp: aPvTimestamp)
		do: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.EveryDayCalendarSegment</class-id> <category>testing</category>

<body package="PV-DM-Support" selector="coversCompletePeriod">coversCompletePeriod
	" Answer true if the segment is periodic and completely covers its main period "

	^self segment fromTime = self segment toTime</body>
</methods>


<class>
<name>WeekendCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.WeeklyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.WeekendCalendarSegment</class-id>
<body>I represent a set of intervals repeating every week. Within each week I define intervals that occur every weekend day (Saturady and Sunday) from fromTime to toTime</body>
</comment>

<methods>
<class-id>PROVISO.WeekendCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" Weekly enumerated ranges are a sequence of intervals defined by fromDay/fromTime relative to the start of day 
	for all days of week for which enumeration is not zero "
	
	self 
		dailyIntervalsForTimestamp: aPvTimestamp
		periodIndices: self weekendIndices
		do: aBlock</body>
</methods>


<class>
<name>EncodedRangeInInMonthCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.MonthlyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.EncodedRangeInInMonthCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	|currentDate to from fromDate toDate |
	currentDate := aPvTimestamp asDate.
	fromDate := self dateForMonthEncoding: self segment fromDay forDate: currentDate.
	toDate := self dateForMonthEncoding: self segment toDay forDate: currentDate.
	from := (PvTimestamp fromDate: fromDate andTime: (Time readFrom: self segment fromTime readStream)) asSeconds.
	to := (PvTimestamp fromDate: toDate andTime:  (Time readFrom: self segment toTime readStream)) asSeconds.

	(from isNil or: [ to isNil ])
		ifTrue: [^self].
	" If to &lt;= from (i.e. 8 to 2), to is assumed to be in the next month (interval protrudes out of the current day) "
	to &lt;= from 
		ifTrue: [to := to + (aPvTimestamp monthEndSeconds - aPvTimestamp monthStartSeconds)].
	aBlock 
		value: 
			(PvCalendarTimeInterval 
				start: from
				stop: to
				inSegment: true)</body>
</methods>

<methods>
<class-id>PROVISO.EncodedRangeInInMonthCalendarSegment</class-id> <category>private</category>

<body package="PV-DM-Support" selector="dateForWeekOfMonthEncoding:dayOfWeekEncoding:forDate:">dateForWeekOfMonthEncoding: weekOfMonthChar dayOfWeekEncoding: dayOfWeekIndex forDate: aDate

	| selector |
	selector := self encodedWeekDayOfWeekDictionary at: weekOfMonthChar ifAbsent: [nil].
	(selector = nil)
		ifTrue: [^nil].
	^ self perform: selector withArguments: (Array with: dayOfWeekIndex with: aDate).</body>

<body package="PV-DM-Support" selector="computeSecondWeekWithDayOfWeekEncoding:forDate:">computeSecondWeekWithDayOfWeekEncoding:dayOfWeekIndex forDate: aDate

	^ (self computeFirstWeekWithDayOfWeekEncoding: dayOfWeekIndex forDate: aDate) addDays: 7</body>

<body package="PV-DM-Support" selector="dateForMonthEncoding:forDate:">dateForMonthEncoding: encodedDayOfMonth forDate: aDate

	| firstCode secondCode |
	(encodedDayOfMonth size ~= 2)
		ifTrue: [^nil].
	firstCode := encodedDayOfMonth first asUppercase.
	secondCode := encodedDayOfMonth last asUppercase.
	^ (secondCode = $D)
		ifTrue: [	| days |
			(firstCode asUppercase = $L)
				ifTrue: [days :=  (aDate firstDayOfMonth - 1) + aDate daysInMonth]
				ifFalse: [days := (aDate firstDayOfMonth - 1) + firstCode digitValue].
			Date newDay: days year: aDate year.]
		ifFalse: [self dateForWeekOfMonthEncoding: firstCode dayOfWeekEncoding: secondCode digitValue forDate: aDate].</body>

<body package="PV-DM-Support" selector="computeThirdWeekWithDayOfWeekEncoding:forDate:">computeThirdWeekWithDayOfWeekEncoding:dayOfWeekIndex forDate: aDate

	^ (self computeFirstWeekWithDayOfWeekEncoding: dayOfWeekIndex forDate: aDate) addDays: 14</body>

<body package="PV-DM-Support" selector="encodedWeekDayOfWeekDictionary">encodedWeekDayOfWeekDictionary

	^##( Dictionary new
		at: $1 put: #computeFirstWeekWithDayOfWeekEncoding:forDate:;
		at: $2 put: #computeSecondWeekWithDayOfWeekEncoding:forDate:;
		at: $3 put: #computeThirdWeekWithDayOfWeekEncoding:forDate:;
		at: $4 put: #computeFourthWeekWithDayOfWeekEncoding:forDate:;
		at: $5 put: #computeFifthWeekWithDayOfWeekEncoding:forDate:;
		at: $L put: #computeLastWeekWithDayOfWeekEncoding:forDate:;
		yourself )</body>

<body package="PV-DM-Support" selector="computeLastWeekWithDayOfWeekEncoding:forDate:">computeLastWeekWithDayOfWeekEncoding:dayOfWeekIndex forDate: aDate

	| nextMonthDate |
	nextMonthDate := Date newDay: 1 monthNumber: (aDate monthIndex +1 )  year: aDate year .
	^ (self computeFirstWeekWithDayOfWeekEncoding:dayOfWeekIndex forDate: nextMonthDate) subtractDays: 7 .</body>

<body package="PV-DM-Support" selector="computeFifthWeekWithDayOfWeekEncoding:forDate:">computeFifthWeekWithDayOfWeekEncoding:dayOfWeekIndex forDate: aDate

	^ (self computeFirstWeekWithDayOfWeekEncoding: dayOfWeekIndex forDate: aDate) addDays: 28</body>

<body package="PV-DM-Support" selector="computeFirstWeekWithDayOfWeekEncoding:forDate:">computeFirstWeekWithDayOfWeekEncoding: dayOfWeekIndex forDate: aDate

	| offsetFromStartOfMonth firstDayIndexOfMonth |
	firstDayIndexOfMonth := self class dayIndexFromDate: (Date newDay: (aDate firstDayOfMonth) year: aDate year).
	offsetFromStartOfMonth := ((7 - firstDayIndexOfMonth) + dayOfWeekIndex) \\ 7.
	^ Date newDay: (aDate firstDayOfMonth + offsetFromStartOfMonth) year: aDate year.</body>

<body package="PV-DM-Support" selector="computeFourthWeekWithDayOfWeekEncoding:forDate:">computeFourthWeekWithDayOfWeekEncoding:dayOfWeekIndex forDate: aDate

	^ (self computeFirstWeekWithDayOfWeekEncoding: dayOfWeekIndex forDate: aDate) addDays: 21</body>
</methods>


<class>
<name>WeekdayCalendarSegment</name>
<environment>PROVISO</environment>
<super>PROVISO.WeeklyCalendarSegment</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<comment>
<class-id>Root.Smalltalk.PROVISO.WeekdayCalendarSegment</class-id>
<body>I represent a set of intervals repeating every week. Within each week I define intervals that occur every weekday day (Monday through Friday) from fromTime to toTime</body>
</comment>

<methods>
<class-id>PROVISO.WeekdayCalendarSegment</class-id> <category>intervals</category>

<body package="PV-DM-Support" selector="intervalsForTimestamp:do:">intervalsForTimestamp: aPvTimestamp do: aBlock 
	" Evaluate aBlock for each time interval this segment represents. aBlock is a mondic block. When it is evaluated, it is passed an instance of PvCalendarTimeInterval representing the interval  "

	" Weekly enumerated ranges are a sequence of intervals defined by fromDay/fromTime relative to the start of day 
	for all days of week for which enumeration is not zero "
	
	self 
		dailyIntervalsForTimestamp: aPvTimestamp
		periodIndices: self weekdayIndices
		do: aBlock</body>
</methods>



<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>sql statements</category>

<body package="PV-DM-Managers" selector="sqlStatementFor:instanceClass:">sqlStatementFor: sql instanceClass: aClass 
	^self dbSession sqlStatement: sql forClass: aClass</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="resyncUpdate:from:">resyncUpdate: realObject from: anObject 
	
	self 
		onUpdateItem: realObject
		from: anObject.
	(realObject name ~= anObject name and: [self storesByName]) 
		ifTrue: 
			[self protect: 
				[itemsByName 
					removeKey: anObject name
					ifAbsent: []].
			realObject resyncUpdateFrom: anObject.
			realObject name ifNotNil: 
				[:name | self protect: [itemsByName at: name put: realObject]]]
		ifFalse: [realObject resyncUpdateFrom: anObject].
	realObject postInsertUpdateIn: self pvModel.
	^realObject</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>database queries - private</category>

<body package="PV-DM-Managers" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
	
	| params |
	params := 
		self 
			createParameters: collectors
			between: startSeconds
			and: endSeconds.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParameters: params)
		instanceClass: self itemClass) do: [:each | self resyncFrom: each]</body>
</methods>

<methods>
<class-id>PROVISO.PvDomainObjectManager</class-id> <category>private</category>

<body package="PV-DM-Managers" selector="createParameters:between:and:">createParameters: collectors between: startSeconds and: endSeconds 
	
	| params |
	params := 
		Dictionary new
			at: #collectors put: collectors;
			at: #startSeconds put: startSeconds;
			at: #endSeconds put: endSeconds;
			yourself.
	^params</body>
</methods>


<methods>
<class-id>PROVISO.PvModelResyncAgent</class-id> <category>initialize - release</category>

<body package="PV-DM-Managers" selector="initialize">initialize

	super initialize.
	self removedObjects: (PvDictionary newSizedFor: 1000).
	bufferActions := true.
	lastStartSeconds := lastEndSeconds := 0.
	self resyncActions: OrderedCollection new; testResyncActions: OrderedCollection new.
	self updatedProperties: OrderedCollection new.</body>
</methods>

<methods>
<class-id>PROVISO.PvModelResyncAgent</class-id> <category>resync actions</category>

<body package="PV-DM-Managers" selector="updatedProperty:">updatedProperty: property

	updatedProperties ifNotNil: [updatedProperties add: property]</body>
</methods>


<class>
<name>PvModel</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>objects</indexed-type>
<inst-vars>elementManager subelementManager formulaManager requestManager thresholdManager propertyManager calendarManager eventManager eventPropertyManager dataViewApplicationManager idManager idManagerRU collectorsByChannel resyncAgent groupCount loadStatsCollector debugCounters dataloadManager profilesManager snmpConfigurationManager schemaMap relationManager repository idManagerEvent eventRelationManager </inst-vars>
<class-inst-vars>soleInstance </class-inst-vars>
<imports></imports>
<category>PV-DM-Model</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>dm adding</category>

<body package="PV-DM-Managers" selector="addEvent:">addEvent: anEvent

	self eventManager addEvent: anEvent</body>
</methods>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="allDomainManagerSelectors">allDomainManagerSelectors

	^#(elementManager 	subelementManager formulaManager requestManager thresholdManager calendarManager propertyManager snmpConfigurationManager relationManager profilesManager eventManager eventPropertyManager eventRelationManager)</body>

<body package="PV-DM-Managers" selector="eventRelationManager:">eventRelationManager: anObject
	eventRelationManager := anObject</body>

<body package="PV-DM-Managers" selector="idManagerEvent">idManagerEvent
	idManagerEvent ifNil: [self initializeIdManagerEvent].
	^idManagerEvent</body>

<body package="PV-DM-Managers" selector="eventRelationManager">eventRelationManager
	^eventRelationManager</body>
</methods>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-DM-Managers" selector="initIdManager">initIdManager
	
	idManager := 
		PvIdManager new
			setBlockSize: 100;
			yourself.
	idManagerRU := 
		PvIdManager new
			setBlockSize: 100;
			makeRU;
			yourself.</body>

<body package="PV-DM-Managers" selector="initializeInMemory">initializeInMemory

	self dbSession
		doSelect: false;
		doNonSelect: false.
	self initOfflineIdManager.

	formulaManager := PvFormulaManager newInMemoryFor: self.
	elementManager := PvElementManager newInMemoryFor: self.
	subelementManager := PvSubelementManager newInMemoryFor: self.
	eventManager := PvEventManager newInMemoryFor: self.
	eventPropertyManager := PvEventPropertyManager newInMemory.
	eventRelationManager := PvEventRelationManager newInMemoryFor: self.
	requestManager := PvRequestManager newInMemory.
	thresholdManager := PvThresholdManager newInMemory.
	calendarManager := PvCalendarManager newInMemory.
	propertyManager := PvPropertyManager newInMemory.
	relationManager := PvRelationManager new.
	dataloadManager := PvDataloadManager newInMemory.
	profilesManager := PvProfilesManager newInMemory.
	snmpConfigurationManager := PvSnmpConfigurationManager newInMemory.

	self makeAllDomainManagersReferToMe.

	collectorsByChannel := Dictionary new.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self).</body>

<body package="PV-DM-Managers" selector="initialize">initialize
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvElementManager new.
	subelementManager := PvSubelementManager new.
	eventManager := PvEventManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvPropertyManager new.
	eventPropertyManager := PvEventPropertyManager new.
	eventRelationManager := PvEventRelationManager new.
	relationManager := PvRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	repository := nil.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self).
	self initCollectorsByChannel.
	self loadStatsCollector: false</body>

<body package="PV-DM-Managers" selector="initializeIdManagerEvent">initializeIdManagerEvent
	
	idManagerEvent := 
		PvIdManager new
			setBlockSize: 100;
			makeEvent;
			yourself</body>
</methods>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>dm loading/resyncing</category>

<body package="PV-DM-Managers" selector="allManagerSelectors">allManagerSelectors

	^#(elementManager subelementManager formulaManager propertyManager calendarManager thresholdManager requestManager snmpConfigurationManager eventManager eventPropertyManager eventRelationManager).</body>
</methods>


<methods>
<class-id>PROVISO.PvEventPropertyManager</class-id> <category>database queries - private</category>

<body package="PV-DM-Managers" selector="loadEventAttrTypesWith:">loadEventAttrTypesWith: params 
	
	self dbSession 
		readObjectsOfClass: PvEventAttrType
		with: (PvEventAttrType selectStatementWithParameters: params)
		into: [:each | eventAttrTypes at: each id put: each]</body>

<body package="PV-DM-Managers" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := self createParameters: collectors between: startSeconds and: endSeconds.
	self loadEventAttrTypesWith: params.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParameters: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each].</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventPropertyManager</class-id> <selector>loadEventAttrTypes</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvThresholdManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="doesExistThresholdsForFormulaId:">doesExistThresholdsForFormulaId: formulaId

	^(self sqlStatementFor: (PvThresholdDefinition selectStatementForFormulaId: formulaId)) contents notEmpty</body>
</methods>


<class>
<name>PvEventManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObjectManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>eventTypes </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvEventManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="relinkNameFor:">relinkNameFor: anEvent 
	
	anEvent properties do: 
		[:eachProperty | 
		(self pvModel 
			eventAttrTypeWithId: eachProperty attributeId
			ifAbsent: [nil]) ifNotNil: 
				[:type | eachProperty name ifNil: [eachProperty name: type name]]].
	anEvent name ifNil: 
		[anEvent name: 
			(anEvent 
				propertyAt: PvEvent nameProperty
				ifAbsent: [])].
	^anEvent name ifNotNil: [:name | itemsByName at: name put: anEvent]</body>
</methods>

<methods>
<class-id>PROVISO.PvEventManager</class-id> <category>initializing</category>

<body package="PV-DM-Managers" selector="initialize">initialize
	
	super initialize.
	eventTypes := Dictionary new.</body>
</methods>

<methods>
<class-id>PROVISO.PvEventManager</class-id> <category>database queries</category>

<body package="PV-DM-Managers" selector="dbResync:between:and:">dbResync: collectors between: startSeconds and: endSeconds 
	
	| params |
	params := 
		self 
			createParameters: collectors
			between: startSeconds
			and: endSeconds.
	self loadEventTypesWith: params.
	super 
		dbResync: collectors
		between: startSeconds
		and: endSeconds.</body>

<body package="PV-DM-Managers" selector="dbResyncGlobalBetween:and:">dbResyncGlobalBetween: startSeconds and: endSeconds 
	
	| params |
	params := 
		self 
			createParameters: #()
			between: startSeconds
			and: endSeconds.
	self loadEventTypesWith: params</body>

<body package="PV-DM-Managers" selector="loadEventTypesWith:">loadEventTypesWith: params 
	
	self dbSession 
		readObjectsOfClass: PvEventType
		with: (PvEventType selectStatementWithParameters: params)
		into: [:each | eventTypes at: each name put: each]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>relateParent:to:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>eventRelations</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>loadEventTypes</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvEventManager</class-id> <selector>loadEventRelations</selector>
</remove-selector>

<class>
<name>PvEventRelationManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObjectManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvEventRelationManager</class-id> <category>testing</category>

<body package="PV-DM-Managers" selector="storesByName">storesByName

	^ false</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelationManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="itemWithId:ifAbsent:">itemWithId: aNumber ifAbsent: absentBlock

	^PvException generic raiseErrorString: 'You cannot retrieve relations by id'</body>

<body package="PV-DM-Managers" selector="itemClass">itemClass

	^PvEventRelation</body>

<body package="PV-DM-Managers" selector="itemNamed:ifAbsent:">itemNamed: aString ifAbsent: absentBlock

	^PvException generic raiseErrorString: 'Relations do not have names'</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelationManager</class-id> <category>adding/removing</category>

<body package="PV-DM-Managers" selector="addItem:">addItem: anEventRelation 
	
	(anEventRelation parent isNil or: [anEventRelation child isNil]) 
		ifTrue: [^self].
	anEventRelation parent addRelation: anEventRelation</body>

<body package="PV-DM-Managers" selector="removeItem:">removeItem: anEventRelation

	anEventRelation parent ifNotNil: [:myParent | myParent removeRelation: anEventRelation]</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelationManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="resyncDeleteFrom:">resyncDeleteFrom: aRelation

	self removeItem: aRelation</body>

<body package="PV-DM-Managers" selector="resyncInsertFrom:">resyncInsertFrom: aRelation

	self resyncUpdateFrom: aRelation</body>

<body package="PV-DM-Managers" selector="resyncUpdateFrom:">resyncUpdateFrom: aRelation 
	
	aRelation postInsertUpdateIn: self pvModel.
	self addItem: aRelation</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelationManager</class-id> <category>visiting</category>

<body package="PV-DM-Managers" selector="acceptVisit:">acceptVisit: aVisitor

	"do nothing. Relation stored in Events"</body>
</methods>

<methods>
<class-id>PROVISO.PvEventRelationManager</class-id> <category>initializing</category>

<body package="PV-DM-Managers" selector="initializeInMemoryFor:">initializeInMemoryFor: aModel

	super initializeInMemory.
	self pvModel: aModel.</body>

<body package="PV-DM-Managers" selector="newDictionaryForExpectedItemsCount">newDictionaryForExpectedItemsCount
	"needed for itemsByName and itemsById. Not used here"
	^nil</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarManager</class-id> <category>database queries</category>

<body package="PV-DM-Managers" selector="dbResyncGlobalBetween:and:">dbResyncGlobalBetween: startSeconds and: endSeconds

	self dbResyncItems: #() between: startSeconds and: endSeconds.
	self dbResyncTimezonesBetween: startSeconds and: endSeconds.
	self dbResyncSegmentsBetween: startSeconds and: endSeconds.
	self dbResyncGroupTimezoneCalendarRelationshipsBetween: startSeconds and: endSeconds.</body>

<body package="PV-DM-Managers" selector="dbResync:between:and:">dbResync: collectors between: startSeconds and: endSeconds

	super dbResync: collectors between: startSeconds and: endSeconds.
	self dbResyncTimezonesBetween: startSeconds and: endSeconds.
	self dbResyncSegmentsBetween: startSeconds and: endSeconds.</body>
</methods>


<methods>
<class-id>PROVISO.PvGroupableDomainObjectManager</class-id> <category>resync support</category>

<body package="PV-DM-Managers" selector="resyncUpdateGroupItemRelationshipBetween:and:">resyncUpdateGroupItemRelationshipBetween: parentKey and: childKey 
	
	| parent child |
	parent := self 
		groupWithId: parentKey
		ifAbsent: [^self].
	child := self 
		itemWithId: childKey
		ifAbsent: [^self].

	(child hasParents and: [child parents includes: parent])
		ifFalse: [
			self onUpdateRelationshipOfChildItem: child toParent: parent.
			parent addChild: child.
			child addParent: parent].</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="formulasWithGenericId:do:">formulasWithGenericId: aGenericId do: aBlock 
	
	self itemsDo: 
		[:formula | 
		(formula isSpecificToGenericConversion and: [formula genericId = aGenericId]) 
			ifTrue: [aBlock value: formula]]</body>
</methods>



<methods>
<class-id>PROVISO.PvFmCommandLog</class-id> <category>private-actions</category>

<body package="PV-FM-Core" selector="doCopyFromAnyOf:to:copySelector:retryLimit:">doCopyFromAnyOf: sourceURIs to: destURI copySelector: copySelector retryLimit: retryLimit
	"&lt;Boolean&gt; Attempt to copy any one of the given source URIs to the given destURI"

	| retryCount retryLimitNumber decodedSrcURIs isZeroLength |
	retryLimitNumber := retryLimit asNumber.
	retryCount := 1.
	[retryCount &lt;= retryLimitNumber] whileTrue:
		[isZeroLength := false.
		 (decodedSrcURIs := self decodeURIList: sourceURIs) do:
			[ :ea | 
			(((self doCopyFrom: ea to: destURI copySelector: copySelector) ~~ false) and:
				[self checkFileSizeOf: ea and: destURI ifError: [false] ifUnsupported: [true] ifZeroLength: [isZeroLength := true. false]])
					ifTrue: [^true]].
		(self timeFacade delayForMilliseconds: 200) wait.
		retryCount := retryCount + 1].
	"if file stayed zero length for 5 retries then it must be zero length, let it go"
	isZeroLength ifTrue: [^true].
	"We've tried all sourceURIs up to a retryLimit number of times, checking file sizes and we still can't acquire the resource...log the failure and raise an exception."
	self logRetryLimitExceeded: decodedSrcURIs.
	self error: 'failed to complete #copyFromAnyOf:to:copySelector:retryLimit: command'.
	^false</body>

<body package="PV-FM-Core" selector="checkFileSizeOf:and:ifError:ifUnsupported:ifZeroLength:">checkFileSizeOf: srcURIOrString
	and: destURIOrString
	ifError: errorBlock
	ifUnsupported: unsupportedBlock
	ifZeroLength: zeroLengthBlock
	"&lt;Boolean&gt; Answer whether the file sizes of both URIs match"
	
	| destFileSize srcFileSize |
	destFileSize := 
		self 
			getFileFizeOf: destURIOrString
			ifError: [^errorBlock value]
			ifUnsupported: [^unsupportedBlock value].
	srcFileSize := 
		self 
			getFileFizeOf: srcURIOrString
			ifError: [^errorBlock value]
			ifUnsupported: [^unsupportedBlock value].
	^srcFileSize = destFileSize 
		ifTrue: 
			[srcFileSize isZero 
				ifTrue: [^zeroLengthBlock value].
			true]
		ifFalse: 
			[self 
				logMismatchedFileSizes: srcURIOrString asURI -&gt; srcFileSize
				and: destURIOrString asURI -&gt; destFileSize.
			false]</body>

<body package="PV-FM-Core" selector="getFileFizeOf:ifError:ifUnsupported:">getFileFizeOf: aURIOrString ifError: errorBlock ifUnsupported: unsupportedBlock
	"&lt;Boolean&gt; Answer whether the file size is zero"

	| fileSize uri |
	uri := aURIOrString asURI.
	uri canDetermineFileSize ifFalse: [^unsupportedBlock value].
	
	[fileSize := uri fileSize]
		on: self errorsToHandle
		do: 
			[ :ex |
			self logUnableToRetrieveFileSize: uri asURI.
			^errorBlock value].
	^fileSize</body>
</methods>

<methods>
<class-id>PROVISO.PvFmCommandLog</class-id> <category>logging</category>

<body package="PV-FM-Core" selector="logMove:to:">logMove: sourceURI to: destURI 
	
	self system 
		logDebugFour: #MOVE_URI
		template: 'Moved &lt;1s&gt; to: &lt;2s&gt;'
		arguments: 
			[(Array 
				with: sourceURI asURI asStringWithObfuscatedPassword
				with: destURI asURI asStringWithObfuscatedPassword)]</body>

<body package="PV-FM-Core" selector="logDelete:">logDelete: uri
	self system 
		logDebugFour: #DELETE_URI
		template: 'Deleted &lt;1s&gt;'
		arguments: [(Array with: uri asURI asStringWithObfuscatedPassword)]</body>

<body package="PV-FM-Core" selector="logStopCopy:to:elapsed:">logStopCopy: sourceURI to: destURI elapsed: seconds 
	
	self system 
		logDebugFour: #STOP_COPY
		template: 'Copied: &lt;1s&gt; to &lt;2s&gt; in &lt;3p&gt; seconds'
		arguments: 
			[(Array 
				with: sourceURI asURI asStringWithObfuscatedPassword
				with: destURI asURI asStringWithObfuscatedPassword
				with: seconds)]</body>

<body package="PV-FM-Core" selector="logStartCopy:to:">logStartCopy: sourceURI to: destURI 
	
	self system 
		logDebugFour: #START_COPY
		template: 'Start copying &lt;1s&gt; to: &lt;2s&gt;'
		arguments: 
			[(Array 
				with: sourceURI asURI asStringWithObfuscatedPassword
				with: destURI asURI asStringWithObfuscatedPassword)]</body>

<body package="PV-FM-Core" selector="logLink:to:">logLink: sourceURI to: destURI 
	
	self system 
		logDebugFour: #LINK_URI
		template: 'Linked &lt;1s&gt; to: &lt;2s&gt;'
		arguments: 
			[(Array 
				with: sourceURI asURI asStringWithObfuscatedPassword
				with: destURI asURI asStringWithObfuscatedPassword)]</body>
</methods>



<class>
<name>TupleSubscription</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>name firstUnseen firstNeeded streamFactory containerFactory filters sourceNode destinationNode </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-Tuple Storage Engine</category>
<attributes>
<package>PV-Tuple Storage Engine</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>logging</category>

<body package="PV-Tuple Storage Engine" selector="logFirstUnseenShouldAlwaysBeGreatherThanFirstNeeded:whenSettingFirstNeeded:firstUnseen:">logFirstUnseenShouldAlwaysBeGreatherThanFirstNeeded: proposedFirstNeeded whenSettingFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen

	&lt;comment: 'Attempted to set firstNeeded to a value greater than firstUnseen.  firstUnseen should always be greater than or equal to firstNeeded.  ' 
	probableCause: 'A CME is not behaving correctly' 
	suggestedAction: 'Contact your Proviso system administrator'&gt;

	self system 
		logWarning: #INVALID_POSITION
		messageId: #DC11012
		text: '[' , self sourceNodeName asString, '] -&gt; [', self name asString , '] Adjusting firstUnseen equal to firstNeeded ', proposedFirstNeeded asString , ' because firstUnseen should always be greater than or equal to firstNeeded.  Valid positions are ', self sourceStream validPositionsString , '. - ', (self descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen)</body>

<body package="PV-Tuple Storage Engine" selector="logAttemptedToSetFirstUnseenToInvalidPos:insteadSettingTo:whenSettingFirstNeeded:firstUnseen:">logAttemptedToSetFirstUnseenToInvalidPos: invalidPosition insteadSettingTo: validPosition whenSettingFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen

	&lt;comment: 'The first unseen pointer must be set to a position in the source stream that is between the first and last positions that have values. This error is an indication that a CME may not be behaving properly.' 
	probableCause: 'A CME is not behaving correctly' 
	suggestedAction: 'Contact your Proviso system administrator'&gt;
	
	self system 
		logWarning: #INVALID_POSITION
		messageId: #DC11014
		text: 
			'[' , self sourceNodeName asString, '] -&gt; [', self name asString , '] Attempt to set the firstUnseen to an invalid position ' , invalidPosition asString , 
				'.  Valid positions are ',self sourceStream validPositionsString , '.  Instead setting it to ' , validPosition asString, ' - ', (self descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen)</body>

<body package="PV-Tuple Storage Engine" selector="descriptionOfChangesToFirstNeeded:firstUnseen:">descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen 

	| changingStream |
	changingStream := String new writeStream.
	self firstNeeded = aFirstNeeded 
		ifFalse: 
			[changingStream nextPutAll: 
				' when changing firstNeeded from: ' , self firstNeeded asString , ' to: ' , 
					aFirstNeeded asString].
	self firstUnseen = aFirstUnseen 
		ifFalse: 
			[changingStream isEmpty 
				ifTrue: [changingStream nextPutAll: ' when ']
				ifFalse: [changingStream nextPutAll: ' and '].
			changingStream nextPutAll: 
				'changing firstUnseen from: ' , self firstUnseen asString , ' to: ' , 
					aFirstUnseen asString].
	^changingStream contents</body>

<body package="PV-Tuple Storage Engine" selector="logAttemptedToSetFirstNeededToInvalidPos:insteadSettingTo:whenSettingFirstNeeded:firstUnseen:">logAttemptedToSetFirstNeededToInvalidPos: invalidPosition
	insteadSettingTo: validPosition
	whenSettingFirstNeeded: aFirstNeeded
	firstUnseen: aFirstUnseen
	&lt;comment: 'The first needed pointer must be set to a position in the source stream that is between the first and last positions that have values. This error is an indication that a CME may not be behaving properly.' 
	probableCause: 'A CME is not behaving correctly' 
	suggestedAction: 'Contact your Proviso system administrator'&gt;
	
	self system 
		logWarning: #INVALID_POSITION
		messageId: #DC11010
		text: 
			'[' , self sourceNodeName asString, '] -&gt; [', self name asString , '] Attempt to set the firstNeeded to an invalid position ' , invalidPosition asString , 
				'.  Valid positions are ',self sourceStream validPositionsString , '.  Instead setting it to ' , validPosition asString, ' - ', (self descriptionOfChangesToFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen)</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>private</category>

<body package="PV-Tuple Storage Engine" selector="noCheckFirstUnseen:">noCheckFirstUnseen: aPosition

	self firstUnseen = aPosition
		ifTrue: [^self].

	self repository ifNotNil:
		[ :rep |
		rep at: (self name asString, ':firstUnseen') put: aPosition asString].
	self basicFirstUnseen: aPosition</body>

<body package="PV-Tuple Storage Engine" selector="critical:">critical: aBlock

	^self sourceNode critical: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="setFirstNeeded:firstUnseen:">setFirstNeeded: aFirstNeeded firstUnseen: aFirstUnseen

	self critical:
		[| proposedFirstNeeded proposedFirstUnseen |
		proposedFirstNeeded := aFirstNeeded.
		proposedFirstUnseen := aFirstUnseen.

		"If outside the valid range then make it the first valid position"
		(self isValidPosition: proposedFirstNeeded)
			ifFalse: 
				[| firstPos |
				firstPos := self sourceStream firstPosition.
				self 
					logAttemptedToSetFirstNeededToInvalidPos: proposedFirstNeeded 
					insteadSettingTo: firstPos 
					whenSettingFirstNeeded: aFirstNeeded 
					firstUnseen: aFirstUnseen.
				proposedFirstNeeded := firstPos].

		"If outside the valid range then make proposedFistUnseen = proposedFirstNeeded"
		(self isValidPosition: proposedFirstUnseen)
			ifFalse: 
				[self 
					logAttemptedToSetFirstUnseenToInvalidPos: proposedFirstUnseen 
					insteadSettingTo: proposedFirstNeeded 
					whenSettingFirstNeeded: aFirstNeeded 
					firstUnseen: aFirstUnseen.
				proposedFirstUnseen := proposedFirstNeeded].

		"If proposedFistUnseen &lt; proposedFirstNeeded then make proposedFistUnseen = proposedFirstNeeded
			because firstUnseen should not be less than firstNeeded"
		(self sourceStream isPosition: proposedFirstUnseen lessThan: proposedFirstNeeded)
			ifTrue: 
				[self 
					logFirstUnseenShouldAlwaysBeGreatherThanFirstNeeded: proposedFirstNeeded 
					whenSettingFirstNeeded: aFirstNeeded 
					firstUnseen: aFirstUnseen.
				proposedFirstUnseen := proposedFirstNeeded].
		self noCheckFirstNeeded: proposedFirstNeeded.
		self noCheckFirstUnseen: proposedFirstUnseen].</body>

<body package="PV-Tuple Storage Engine" selector="firstUnseen:">firstUnseen: aPosition

	self setFirstNeeded: self firstNeeded firstUnseen: aPosition.</body>

<body package="PV-Tuple Storage Engine" selector="firstNeeded:">firstNeeded: aPosition

	self setFirstNeeded: aPosition firstUnseen: self firstUnseen.
	self sourceNode scheduleLangoliering.</body>

<body package="PV-Tuple Storage Engine" selector="noCheckFirstNeeded:">noCheckFirstNeeded: aPosition

	self firstNeeded = aPosition
		ifTrue: [^self].

	self repository ifNotNil:
		[ :rep |
		rep at: (self name asString, ':firstNeeded') put: aPosition asString].
	self basicFirstNeeded: aPosition.
	(self sourceStream containerAt: aPosition) ifNotNil:
		[ :container |
		self filters do: [ :filter | filter advancePast: container timestamp]].</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>initialize-release</category>

<body package="PV-Tuple Storage Engine" selector="initialize">initialize
	"Initialize a newly created instance. This method must answer the receiver."

	filters := OrderedCollection new add: (WhiteListTupleFilter for: self); yourself.
	streamFactory := [WriteStream on: Array new].
	containerFactory := [ :strm | TupleArray withAll: strm contents].</body>
</methods>

<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>notification</category>

<body package="PV-Tuple Storage Engine" selector="acceptTuples:from:position:">acceptTuples: aTupleContainer from: aTupleContainerStream position: aPosition

	| tmp answer |
	self critical:
		[[self ensureDestinationNodeConnection.
		tmp := self getClient.
		tmp ifNil: [^false].
		answer := tmp isRemote
			ifTrue: [tmp acceptTuplesFromURIs: aTupleContainer uriList from: aTupleContainerStream name position: aPosition]
			ifFalse: [tmp acceptTuples: aTupleContainer from: aTupleContainerStream name position: aPosition].
		answer
			ifTrue: 
				[self logSuccessfulDelivery: aTupleContainer from: aTupleContainerStream position: aPosition]
			ifFalse: 
				[aTupleContainer validate
					ifTrue: 
						[self 
							logFailedDelivery: aTupleContainer 
							from: aTupleContainerStream 
							reason: 'subscriber rejected push']
					ifFalse: 
						["RA503455 MFTE sending bad containers
						I put this code in to pretend that the send was OK and return true 
						when the container we tried to send is invalid (files don't exist).
						Log a msg and move to the next one to send.. maybe we just had a ref 
						to a file that we were unable to write when we received it.. not sure 
						why this happens.  When it does happen, MFTE tries to keep sending a file 
						that doesn't exist and assuming the CME is rejecting it...  not good- Monty"
						answer := true.
						self 
							logFailedDelivery: aTupleContainer 
							from: aTupleContainerStream 
							reason: 'invalid container - will skip and try the next one.'	].
				aTupleContainer releaseExternalResources].
		^answer]
				on: Error 
				do: 
					[ :ex | 
					self logFailedDelivery: aTupleContainer from: aTupleContainerStream reason: ex description.
					aTupleContainer releaseExternalResources.
					^false]]</body>

<body package="PV-Tuple Storage Engine" selector="acceptTuples">acceptTuples

	| ts |
	self critical:
		["Before sending.. attempt to set both firstNeeded &amp; firstUnseen to make sure they are set to valid positions"
		self setFirstNeeded: self firstNeeded firstUnseen: self firstUnseen.

		self sourceStream enumerateStartingAt: self firstUnseen do:
			[ :aTupleContainer :aPosition |
			ts := aTupleContainer timestamp.
			self filters do: [ :filter | filter resyncTo: ts].
			(self  
				acceptTuples: (self filterTuples: aTupleContainer) 
				from: self sourceStream 
				position: aPosition) 
					ifTrue: [self setFirstNeeded: self firstNeeded firstUnseen: (self sourceStream nextPositionAfter: aPosition)]
					ifFalse: [^self]]].</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logFatalSettingFirstUnseenTo:insteadOf:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logInvalidFirstUnseenSetting:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logInvalidFirstNeededSetting:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logCannotAdjustFirstNeededBackward:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logFatalSettingFirstNeededTo:insteadOf:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logCannotAdjustFirstUnseenBeforeFirstNeeded:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.TupleSubscription</class-id> <selector>logCannotAdjustFirstNeededBeyondFirstUnseen:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvFteTupleInjectorProcess</class-id> <category>xlog</category>

<body package="PV-Tuple Storage Engine" selector="notifyPlanBuilderOfContainerArrival:">notifyPlanBuilderOfContainerArrival: container

	| timeGranularity hasCrossedIntoPeriod sequenceNum notificationTime currentSequenceNum containerTimestamp lct |
	"If the collector just crossed a period then notify the plan builder so he can gen a new plan"
	self testMode ifTrue: [^self].
	lct := self lastCallTime.
	containerTimestamp := container timestamp.
	timeGranularity := self tupleStorageClient timeGranularity.

	"Make sure we don't go backward and make sure we've crossed a period boundary"
	hasCrossedIntoPeriod := 
		lct isNil or: 
			[containerTimestamp &gt; lct and:
			[(lct // timeGranularity) ~= (containerTimestamp // timeGranularity)]].
	hasCrossedIntoPeriod
		ifTrue:
			["Notify the plan builder that this collector has just crossed a period boundary"
			notificationTime := ((containerTimestamp // timeGranularity) * timeGranularity).
			self logPlanBuilderNotification: notificationTime.
			[sequenceNum :=
				(PvDSTFacade getObjectNamed: PvApplication planBuilderFacilityName)
					updateProgressFor: self tupleStorageClient name 
					to: notificationTime.
			sequenceNum ifNil: [self error: 'my advancement was ignored so signal an error and try again']]
						on: Error
						do: [ :ex | (Delay forSeconds: 30) wait. ex retry].
			self logPlanBuilderNotified: sequenceNum.
			"Sit in a loop until the next plan is generated"
			[[currentSequenceNum := 
				(PvDSTFacade getObjectNamed: PvApplication planBuilderFacilityName) getPlanSequenceNumber.
			sequenceNum &lt; currentSequenceNum] 
				on: Error 
				do: [ :ex | false]] 
					whileFalse: [(Delay forSeconds: 2) wait].

			"Update the lastCallTime so we don't call the plan builder again until we cross the next end of period"
			self lastCallTime: containerTimestamp.
			self logPlanBuilderFinished: currentSequenceNum].</body>
</methods>


<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - unioned</category>

<body package="PV-Tuple Storage Engine" selector="getDbPositionForType:on:">getDbPositionForType: tupleType on: labels

	| stream timestamps |
	labels isEmpty
		ifTrue: [^nil].

	stream := (WriteStream on: (String new: 100))
		nextPutAll: 'select 
  max(s.dte_last_load_date) as startOfLastLoadedPeriod
from chnl_table_set_type t, chnl_table_load_status s 
where t.idx_ind = s.IDX_TABLE_SET_TYPE and t.str_name = ';
		nextPutAll: tupleType printString;
		nextPutAll: ' and s.idx_subchnl in (';
		yourself.

	labels
		do: [:each | stream print: each]
		separatedBy: [stream nextPutAll: ', '].

	stream nextPutAll:  ')'.

	timestamps := (self dbSession execute: stream contents) collect: [:each | each first].
	timestamps := timestamps reject: [:each | each isNil].
	^timestamps isEmpty
		ifTrue: [nil]
		ifFalse: [
			timestamps
				inject: timestamps first
				into: [:sum :each | sum max: each]].</body>

<body package="PV-Tuple Storage Engine" selector="getDbPositionOn:">getDbPositionOn: labels

	| sparseTimestamp periodicTimestamp loadedLabels |
	loadedLabels := labels collect: [:each |
		(each between: 1000 and: 1999)
			ifTrue: [each - 1000]
			ifFalse: [each]].
	sparseTimestamp := self getDbPositionForType: 'SNRW' on: loadedLabels.
	periodicTimestamp := self getDbPositionForType: 'NRAW' on: loadedLabels.

	"We add 3599 to the timestamp, since the DB column we're reading is start of period..."
	sparseTimestamp isNil
		ifTrue: [^periodicTimestamp].
	periodicTimestamp isNil
		ifTrue: [^sparseTimestamp].
	^(sparseTimestamp min: periodicTimestamp) + 3599</body>

<body package="PV-Tuple Storage Engine" selector="getTuplesForMid:rid:from:to:adjTime:count:dbSession:">getTuplesForMid: mid rid: rid from: startTime to: stopTime adjTime: adjTime count: count dbSession: dbSession
	"&lt;ReadStream&gt; Get all the tuples from tuples storage and the database for the given mid/rid.  Order by tuple timestamp (startTime may be greater than stopTime to indicate reverse order).  The startTime and endTime can be infinite to formulate a query that gets all tuples. The count is used to optimize the database queries, but does not restrict the number of tuples that can be in the resulting read stream (do not read more than count tuples from the resulting read stream, the results may not be accurate)."

	^self
		getTuplesForMid: mid
		rid: rid 
		from: startTime 
		to: stopTime 
		adjTime: adjTime 
		count: count 
		dbSession: dbSession 
		passing: #()</body>

<body package="PV-Tuple Storage Engine" selector="getTuplesForMid:rid:from:to:adjTime:count:dbSession:passing:">getTuplesForMid: mid rid: rid from: startTime to: stopTime adjTime: adjTime count: count dbSession: dbSession passing: recompActions
	"&lt;ReadStream&gt; Get all the tuples from tuples storage and the database for the given mid/rid.  Order by tuple timestamp (startTime may be greater than stopTime to indicate reverse order).  The startTime and endTime can be infinite to formulate a query that gets all tuples. The count is used to optimize the database queries, but does not restrict the number of tuples that can be in the resulting read stream (do not read more than count tuples from the resulting read stream, the results may not be accurate)."

	| labels transitionTime tupleStreams start stop adjustmentStart adjustmentStop dbStart dbStop mergeSort direction needTuplesFromTS formula isSparse |

	formula := self currentApplication server pvModel formulaWithId: mid.
	(formula notNil and: [formula isProperty])
		ifTrue: [^#() readStream].

	start := startTime ifNil: [Infinity negative].
	stop := stopTime ifNil: [Infinity positive].
	direction := self directionFrom: startTime to: stopTime ifIndeterminate: [^#() readStream].

	"Determine the earliest time for which TSE has tuples for the given mid/rid"
	labels := self planAccessor labelsForMetricId: mid subelementId: rid between: startTime and: stopTime.
	transitionTime := self getDbPositionOn: labels.
	transitionTime isNil
		ifTrue: [transitionTime := start].

	"If the latest DB time is before the stop time, we need to talk to the CME(s) as well."
	needTuplesFromTS := start &lt;= stop
		ifTrue: [transitionTime &lt; stop]
		ifFalse: [transitionTime &lt; start].

	"Now figure out the time ranges for the DB ajustment and tuple queries"
	needTuplesFromTS
		ifTrue: [
			start &lt;= stop
				ifTrue: [
					adjustmentStart := transitionTime + 1 max: start.
					adjustmentStop := stop.
					dbStart := start.
					"If the DB is way behind, we don't want to get anything from it..."
					dbStop := transitionTime max: start]
				ifFalse: [
					adjustmentStart := start.
					adjustmentStop := transitionTime - 1 max: stop.
					dbStart := transitionTime.
					dbStop := stop]]
		ifFalse: [
			dbStart := start.
			dbStop := stop].

	tupleStreams := OrderedCollection new.

	"1) First, lets go after the adjusted tuples from the database...do this first because we want the adjustments to shadow other results (if there are no tuples in tuple storage, no need to do this)."
	isSparse := formula isNil or: [formula isPeriodicTimeSeries not].
		
	needTuplesFromTS 
		ifTrue: [
"			isSparse
				ifTrue:
					["tupleStreams add: (self 
						dbGetAdjustedSparseTuplesForMid: mid 
						rid: rid 
						from: adjustmentStart 
						to: adjustmentStop 
						adjTime: adjTime 
						count: count 
						dbSession: dbSession)"]".
			"For now, we don't need the following because we don't support adjustments to periodic metrics"
			"tupleStreams add:
				(self dbGetAdjustedTuplesForMid: mid rid: rid from: adjustmentStart to: adjustmentStop adjTime: adjTime count: count dbSession: dbSession."].

	"2) Next go after tuples outside the Tuple Storage window in the DB"
"	isSparse
		ifTrue:
			["tupleStreams add: (self 
				dbGetSparseTuplesForMid: mid 
				rid: rid 
				from: dbStart
				to: dbStop
				adjTime: adjTime 
				count: count 
				dbSession: dbSession)."]."
	isSparse
		ifFalse:
			[tupleStreams add: (self
				dbGetTuplesForMid: mid
				rid: rid 
				from: dbStart 
				to: dbStop 
				adjTime: adjTime 
				count: count 
				dbSession: dbSession)].

	"3) Finally, get the tuples from tuple storage (if there aren't any tuples in tuple storage, skip this)"
	needTuplesFromTS 
		ifTrue: [
			tupleStreams add: (self 
				tsGetTuplesForMid: mid 
				rid: rid 
				from: adjustmentStart 
				to: adjustmentStop
				on: labels
				passing: recompActions)]
		ifFalse: [
			self 
				tsGetTuplesForMid: nil 
				rid: nil 
				from: nil 
				to: nil
				on: labels
				passing: recompActions].

	direction &gt;= 0
		ifTrue: [mergeSort := MergeSortStream forTuplesOnAll: tupleStreams]
		ifFalse: [mergeSort := MergeSortStream forReverseTuplesOnAll: tupleStreams].
	^DeduplicatingStream 
		on: mergeSort
		comparisonBlock: [ :a :b | a timestamp = b timestamp]</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - for recomp</category>

<body package="PV-Tuple Storage Engine" selector="getTimestampsOf:metricId:resourceId:after:adjTime:">getTimestampsOf: aNumber
	metricId: aMetricId
	resourceId: aResourceId
	after: aTsNumber
	adjTime: adjTime
	"&lt;Number|nil&gt; Answer timestamp of Nth tuple with a given (mid, rid) after aTsnumber, and all the ones in between. If N is 0, just answer a collection with aTsNumber.  If there aren't enough tuples in the history, answer nil (designed to be called over CORBA)"
	
	| strm tupleCount tuple results |
	aNumber = 0 ifTrue: [^Array with: aTsNumber].
	tupleCount := 0.
	[strm := 
		self 
			getTuplesForMid: aMetricId
			rid: aResourceId
			from: aTsNumber
			to: Infinity positive
			adjTime: (self decodeInfinity: adjTime)
			count: aNumber
			dbSession: self dbSession.
	results := OrderedCollection new.
	[strm atEnd] 
		whileFalse: 
			[tuple := strm next.
			results add: tuple timestamp.
			tupleCount := tupleCount + 1.
			tupleCount = aNumber 
				ifTrue: [^results]]] 
					ensure: [strm ifNotNil: [strm close]].
	^nil</body>

<body package="PV-Tuple Storage Engine" selector="getMetricsForMid:rid:between:and:adjTime:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber adjTime: adjTime
	"&lt;Array&gt; Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	^self getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber adjTime: adjTime passing: #()</body>

<body package="PV-Tuple Storage Engine" selector="getMetricsForMid:rid:between:and:adjTime:passing:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber adjTime: adjTime passing: recompActions
	"&lt;Array&gt; Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	| strm |
	[strm := self
		getTuplesForMid: metricId
		rid: resourceId
		from: (self decodeInfinity: startTsNumber)
		to: (self decodeInfinity: endTsNumber)
		adjTime: (self decodeInfinity: adjTime)
		count: Infinity positive
		dbSession: self dbSession
		passing: recompActions.
	^strm upToEnd]
		ensure: [strm ifNotNil: [strm close]]</body>

<body package="PV-Tuple Storage Engine" selector="getTimestampsOf:metricId:resourceId:before:adjTime:">getTimestampsOf: aNumber
	metricId: aMetricId
	resourceId: aResourceId
	before: aTsNumber
	adjTime: adjTime
	"&lt;Number|nil&gt; Answer timestamp of Nth tuple with a given (mid, rid) before aTsnumber, and all the ones in between. If N is 0, just answer a collection with aTsNumber.  If there aren't enough tuples in the history, answer nil (designed to be called over CORBA)"
	
	| strm tupleCount tuple results |
	aNumber = 0 ifTrue: [^Array with: aTsNumber].
	tupleCount := 0.
	[strm := 
		self 
			getTuplesForMid: aMetricId
			rid: aResourceId
			from: aTsNumber
			to: Infinity negative
			adjTime: (self decodeInfinity: adjTime)
			count: aNumber
			dbSession: self dbSession.
	results := OrderedCollection new.
	[strm atEnd] 
		whileFalse: 
			[tuple := strm next.
			results add: tuple timestamp.
			tupleCount := tupleCount + 1.
			tupleCount = aNumber 
				ifTrue: [^results]]] 
					ensure: [strm ifNotNil: [strm close]].
	^nil</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - tuple storage</category>

<body package="PV-Tuple Storage Engine" selector="tsGetTuplesForMid:rid:from:to:on:passing:">tsGetTuplesForMid: mid rid: rid from: startTime to: endTime on: labels passing: recompActions

	| agents results |
	(mid isNil and: [recompActions isEmpty])
		ifTrue: [^self].
	agents := labels collect: [ :label | label -&gt; (self lookupNode: label ifAbsent: [nil])].
	agents := agents select: [ :ea | ea value notNil].
	results := OrderedCollection new.
	agents do:
		[ :assn |
		| agent label |
		agent := assn value.
		label := assn key.
		agent isRemote
			ifTrue: [
				| value |
				value := self
					handleRemoteQueryForMid: mid
					rid: rid 
					from: startTime 
					to: endTime 
					on: label 
					for: agent 
					passing: recompActions.
				value notNil ifTrue: [results add: value]]
			ifFalse: [results add: (agent getTuplesForMid: mid rid: rid from: startTime to: endTime)]].
	^mid isNil
		ifTrue: [self]
		ifFalse: [
			(self directionFrom: startTime to: endTime) &gt;= 0
				ifTrue: [MergeSortStream forTuplesOnAll: results]
				ifFalse: [MergeSortStream forReverseTuplesOnAll: results]]</body>

<body package="PV-Tuple Storage Engine" selector="handleRemoteQueryForMid:rid:from:to:on:for:passing:">handleRemoteQueryForMid: mid rid: rid from: startTime to: endTime on: label for: agent passing: recompActions

	| cmePair result elapsed appName |
	cmePair := CMETimeSeries new getApplicationForOperatorLabel: label.
	appName := (cmePair ifNotNil: [cmePair key]) asString.
	self logRemoteQuery: label agent: appName mid: mid rid: rid from: startTime to: endTime.
	result := #().
	cmePair value isNil
		ifFalse: [
			| cmeApplication |
			cmeApplication := cmePair value.
			[
				elapsed := Time millisecondsToRun: [
				result := cmeApplication server streamLabelOperator 
						perform: #protectedHandleRecomputationRecords:whileGettingTuplesForMid:rid:from:to:
						withArguments: (Array with: recompActions with: mid with: rid with: startTime with: endTime)
						timeoutMilliseconds: 300000 "5 min"
						onTimeout: 
							[self logTimedOutOnRemoteQuery: label agent: appName mid: mid rid: rid from: startTime to: endTime.
							self error: 'timed out on promise'] ].
				elapsed &gt;= 100 
					ifTrue: 
						[self system 
							logDebugThree: #REMOTE_TUPLE_QUERY_PERF
							messageId: nil
							template: ##('Retrieved &lt;8s&gt; tuples in &lt;7s&gt; ms: label &lt;1s:label&gt; (&lt;2s:app name&gt;), mid: &lt;3s:mid&gt;, rid: &lt;4s:rid&gt;, start: &lt;5s:start&gt;, end: &lt;6s:end&gt;' asLogTemplate)
							arguments: {label asString. appName. mid asString. rid asString. startTime asString. endTime asString. elapsed asString. result size asString}]
					ifFalse:
						[self system 
							logDebugFour: #REMOTE_TUPLE_QUERY_PERF
							messageId: nil
							template: ##('Retrieved &lt;8s&gt; tuples in &lt;7s&gt; ms: label &lt;1s:label&gt; (&lt;2s:app name&gt;), mid: &lt;3s:mid&gt;, rid: &lt;4s:rid&gt;, start: &lt;5s:start&gt;, end: &lt;6s:end&gt;' asLogTemplate)
							arguments: [{label asString. appName. mid asString. rid asString. startTime pvOpportunisticPrintString. endTime pvOpportunisticPrintString. elapsed asString. result size asString}]]
				"remoteStream finalizeAction: #destroy"]
			on: Error 
			do: [ :ex | 
				self logRemoteQueryFailed: ex label: label.
				ex pass]].

	^result readStream</body>

<body package="PV-Tuple Storage Engine" selector="tsGetTuplesForMid:rid:from:to:">tsGetTuplesForMid: mid rid: rid from: startTime to: endTime

	| labels |
	labels := self planAccessor labelsForMetricId: mid subelementId: rid between: startTime and: endTime.
	^self
		tsGetTuplesForMid: mid 
		rid: rid 
		from: startTime 
		to: endTime 
		on: labels 
		passing: #()</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>tuple queries - database</category>

<body package="PV-Tuple Storage Engine" selector="dbGetSparseTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetSparseTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession

	| adjClause elapsed result |
	elapsed := Time millisecondsToRun: [
	adjClause := 'and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date'.
	adjTime &gt; 0
		ifTrue: 
			[(adjTime == Infinity positive)
				ifTrue: [adjClause := adjClause, ')']
				ifFalse: [adjClause := adjClause, ' and t2.dte_adj_date &lt;= :3)']]
		ifFalse: 
			[adjClause := 'and dte_adj_date = 0'].

	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: 4 do:
		[ :rangeClause :orderClause :vars | | sql |
		"We do the following because apparently Oracle applies the rownum clause before it sorts the results (ARG!)."
		vars 
			at: 1 put: mid;
			at: 2 put: rid;
			at: 3 put: adjTime.
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value, idx_event
				from MTRC00_SNRW_000_FULL t1 
				where 
					idx_metric = :1
					and idx_resource = :2
					', rangeClause, '
					 and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date)
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
"
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvSparseMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					eventId: (row at: 5);
					yourself]].
	^#() readStream"
	result := (dbSession 
			sqlStatement: sql
			forClass: nil
			bindVariableObject: vars) 
				collect: [:row |
					PvSparseMetricRecord0406 new
						metricId: (row at: 1);
						resourceId: (row at: 2);
						date: (row at: 3);
						value: (row at: 4);
						eventId: (row at: 5);
						yourself]].
	].
	self logQueryPerf: 'dbGetSnrwTuples' forMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count retrieved: result in: elapsed.
	^result readStream</body>

<body package="PV-Tuple Storage Engine" selector="dbGetAdjustedSparseTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetAdjustedSparseTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession

	| adjClause elapsed result |
	adjTime &gt; 0
		ifTrue: 
			[(adjTime == Infinity positive)
				ifTrue: [adjClause := '']
				ifFalse: [adjClause := 'and t2.dte_adj_date &lt;= :3']]
		ifFalse: 
			["This query is only interested in the sparse metrics...if adjTime &lt;= 0, nothing will be returned from the DB query anyway, so don't bother"
			^#() readStream].
	elapsed := Time millisecondsToRun: [
	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: (adjClause isEmpty ifTrue: [3] ifFalse: [4]) do:
		[ :rangeClause :orderClause :vars | | sql |
		vars 
			at: 1 put: mid;
			at: 2 put: rid.
		adjClause isEmpty ifFalse: [vars at: 3 put: adjTime].
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value, idx_event
				from MTRC00_SNRW_000_FULL t1 
				where 
					idx_metric = :1 
					and idx_resource = :2 ',
					rangeClause,
					' and dte_adj_date &lt;&gt; 0
					and dte_adj_date = 
						(select max(dte_adj_date) 
							from MTRC00_SNRW_000_FULL t2 
							where 
								t1.idx_metric = t2.idx_metric and
								t1.idx_resource = t2.idx_resource and
								t1.dte_date = t2.dte_date ', adjClause,') 
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
"
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvSparseMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					eventId: ((row at: 5) ifNil: [0]);
					yourself]].
	^#() readStream"
		result := (dbSession 
			sqlStatement: sql
			forClass: nil
			bindVariableObject: vars) 
				collect: [:row |
					PvSparseMetricRecord0406 new
						metricId: (row at: 1);
						resourceId: (row at: 2);
						date: (row at: 3);
						value: (row at: 4);
						eventId: ((row at: 5) ifNil: [0]);
						yourself].].
	].
	self logQueryPerf: 'dbGetAdjustmentTuples' forMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count retrieved: result in: elapsed.
	^result readStream</body>

<body package="PV-Tuple Storage Engine" selector="dbGetTuplesForMid:rid:from:to:adjTime:count:dbSession:">dbGetTuplesForMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count dbSession: dbSession
	"Note: adjTime is ignored because we don't currently support adjustments to periodic metrics"
	| elapsed result |
	elapsed := Time millisecondsToRun: [
	PvDatabaseSession rangeClauseWithAnd: 'dte_date' from: startTime to: endTime bindVarIndex: 3 do:
		[ :rangeClause :orderClause :vars | | sql |
		vars 
			at: 1 put: mid;
			at: 2 put: rid.
		sql := 
			'select idx_metric, idx_resource, dte_date, dbl_value
				from MTRC00_NRAW_000_FULL t1 
				where 
					idx_metric = :1 
					and idx_resource = :2
					', rangeClause, '
				order by ', orderClause.
		(count notNil and: [count ~~ Infinity positive]) ifTrue:
			[sql := 'select * from (', sql, ') where rownum &lt;= ', count asString].
		result := (dbSession 
			sqlStatement: sql
			forClass: nil
			bindVariableObject: vars) 
				collect: [:row |
					PvMetricRecord0406 new
						metricId: (row at: 1);
						resourceId: (row at: 2);
						date: (row at: 3);
						value: (row at: 4);
						pollId: (row at: 3) \\ 3600;
						yourself]].
	].
	self logQueryPerf: 'dbGetNrawTuples' forMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count retrieved: result in: elapsed.
	^result readStream
"
		^MaterializeStream 
			on: (dbSession answerFor: sql bindVars: vars) 
			materializeCallback:
				[ :strm | | row |
				row := strm next.
				PvMetricRecord0406 new
					metricId: (row at: 1);
					resourceId: (row at: 2);
					date: (row at: 3);
					value: (row at: 4);
					pollId: (row at: 3) \\ 3600;
					yourself]
	^#() readStream"</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorage</class-id> <category>logging</category>

<body package="PV-Tuple Storage Engine" selector="logRemoteQuery:agent:mid:rid:from:to:">logRemoteQuery: label agent: appName mid: mid rid: rid from: startTime to: endTime

	self system 
		logDebugFour: #REMOTE_TUPLE_QUERY
		messageId: nil
		template: ##('Sending tuple query for label &lt;1s:label&gt; to remote process &lt;2s:app name&gt;(mid: &lt;3s:mid&gt;, rid: &lt;4s:rid&gt;, start: &lt;5s:start&gt;, end: &lt;6s:end&gt;)' asLogTemplate)
		arguments: [{label asString. appName. mid asString. rid asString. startTime asString. endTime asString}]</body>

<body package="PV-Tuple Storage Engine" selector="logTimedOutOnRemoteQuery:agent:mid:rid:from:to:">logTimedOutOnRemoteQuery: label agent: appName mid: mid rid: rid from: startTime to: endTime

	self system 
		logInfo: #REMOTE_TUPLE_QUERY
		messageId: #DC10006
		template: ##('Timed Out during tuple query for label &lt;1s:label&gt; to remote process &lt;2s:app name&gt;(mid: &lt;3s:mid&gt;, rid: &lt;4s:rid&gt;, start: &lt;5s:start&gt;, end: &lt;6s:end&gt;)' asLogTemplate)
		arguments: [{label asString. appName. mid asString. rid asString. startTime asString. endTime asString}]</body>

<body package="PV-Tuple Storage Engine" selector="logQueryPerf:forMid:rid:from:to:adjTime:count:retrieved:in:">logQueryPerf: explanation forMid: mid rid: rid from: startTime to: endTime adjTime: adjTime count: count retrieved: retrieved in: seconds
	
	| messageStream |
	seconds &gt;= 100
		ifTrue: [
	messageStream := 
		String new writeStream
			nextPutAll: 'Retrieved: ';
			print: retrieved size;
			nextPutAll: ' tuples in: ';
			print: seconds;
			nextPutAll: ' ms for ', explanation, ' for mid: ';
			print: mid;
			nextPutAll: ' rid: ';
			print: rid;
			nextPutAll: ' start: ';
			nextPutAll: startTime pvOpportunisticPrintString;
			nextPutAll: ' end: ';
			nextPutAll: endTime pvOpportunisticPrintString;
"
			nextPutAll: ' adj time: ';
			nextPutAll: adjTime pvOpportunisticPrintString;
"
			nextPutAll: ' count: ';
			print: count;
			yourself.

	self system 
		logDebugThree: #RECOMP_QUERY_PERF
		text: messageStream contents]</body>
</methods>


<methods>
<class-id>PROVISO.PlanBasedSubscriptionAgent</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="createOutput:at:">createOutput: nodeName at: utcSeconds

	^self owner 
		getOutput: nodeName
		ifAbsent:
			[ | subscription |
			subscription := self owner createOutput: nodeName.
			(self owner dataStream positionForTime: utcSeconds)
				ifNotNil:
					[ :position |
					subscription setFirstNeeded: position firstUnseen: position].
			subscription].</body>
</methods>


<class>
<name>TupleStorageNode</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>owner name currentDataTime client inputs outputs dataStream repository fileInterface subscriptionAgents </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-Tuple Storage Engine</category>
<attributes>
<package>PV-Tuple Storage Engine</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.TupleStorageNode</class-id> <category>queries - base</category>

<body package="PV-Tuple Storage Engine" selector="remoteGetTuplesForMid:rid:from:to:">remoteGetTuplesForMid: mid rid: rid from: startTime to: stopTime

	| messageStream time tuples | 
	time := Time millisecondsToRun: 
		[tuples := (self getTuplesForMid: mid rid: rid from: startTime to: stopTime) upToEnd].

	messageStream := 
		String new writeStream
			nextPutAll: 'TS query for mid: ';
			print: mid;
			nextPutAll: ' rid: ';
			print: rid;
			nextPutAll: ' start: ';
			print: startTime;
			nextPutAll: ' end: ';
			print: stopTime;
			nextPutAll: ' took: ';
			print: time;
			nextPutAll: ' ms';
			yourself.
	self system 
		logInfo: #REMOTE_TUPLE_QUERY
		text: messageStream contents.

	^tuples</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorageNode</class-id> <category>initialize-release</category>

<body package="PV-Tuple Storage Engine" selector="initialize">initialize

	outputs := Dictionary new.
	inputs := Dictionary new.
	dataStream := 
		TupleContainerStream new
			owner: self;
			yourself.
	currentDataTime := nil.
	subscriptionAgents := OrderedCollection new.</body>
</methods>

<methods>
<class-id>PROVISO.TupleStorageNode</class-id> <category>private</category>

<body package="PV-Tuple Storage Engine" selector="critical:">critical: aBlock

	^self dataStream critical: aBlock</body>
</methods>



<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>updating</category>

<body package="PV CML-Framework" selector="onAddTuple:">onAddTuple: aTuple
	"do nothing"</body>

<body package="PV CML-Framework" selector="runCalculationMethod">runCalculationMethod
	
	[| result resultRecord |

	self timeSeries ifNotNil: [:ts | ts shouldFire ifFalse: [^self]].

	xxxPrivateFormulaResult := nil.
	[((result := self calculate) notNil and: [result ~~ self]) 
		ifTrue: 
			[result := 
				self class outputType == self class numberType 
					ifTrue: [result value asNumber]
					ifFalse: [result value asString].
			xxxPrivateFormulaResult := result]] 
				on: Error
				do: [:err | ^self logCalculationError: err].

	xxxPrivateFormulaResult isNil 
		ifFalse: 
			[[resultRecord := self buildResultMetricRecord] 
				on: Error
				do: [:err | ^self logBuildResultMetricRecordError: err].
			self owner isEnabled
				ifTrue: [self owner onAddTuple: resultRecord]]] 
				ensure: [self resetInputState]</body>

<body package="PV CML-Framework" selector="shouldDeduplicateOnAddTuple:">shouldDeduplicateOnAddTuple: aTuple

	^false</body>
</methods>

<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>accessing</category>

<body package="PV CML-Framework" selector="lastTuple">lastTuple
	" For compatibility with ES formulas "

	^nil</body>

<body package="PV CML-Framework" selector="lastTuple:">lastTuple: aTuple
	"ignore"</body>
</methods>

<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula</class-id> <category>mutating</category>

<body package="PV CML-Framework" selector="recompileWithFormula:">recompileWithFormula: aFormula

	" Do nothing here "</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulas.PvCflFormula class</class-id> <category>accessing</category>

<body package="PV CML-Framework" selector="lastTuple:">lastTuple: aTuple
	"ignore"</body>
</methods>



<methods>
<class-id>PROVISO.Input</class-id> <category>updating</category>

<body package="PV-ES-Formulas" selector="update:with:">update: aSymbol with: anObject

	aSymbol == #addTuple 
		ifTrue: [^self handleTuple: anObject value position: anObject key].
	aSymbol == #addEphemeralTuple 
		ifTrue: [^self handleEphemeralTuple: anObject value position: anObject key].
	aSymbol == #shiftPositions 
		ifTrue: [^self shiftPositionsBy: anObject].
	aSymbol == #removePosition 
		ifTrue: [^self removeAtPosition: anObject].
	aSymbol == #insertPosition 
		ifTrue: [^self insertAtPosition: anObject].
	aSymbol == #disconnected 
		ifTrue: [^self clearReferences].
	aSymbol == #logPointerState
		ifTrue: [^self logPointerState].
	super update: aSymbol with: anObject</body>
</methods>

<methods>
<class-id>PROVISO.Input</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="getCalendarTransitionsBetween:and:">getCalendarTransitionsBetween: start and: end 

	^self timeSeries formula isLocalizedSchedule
		ifTrue: [self timeSeries formula getCalendarTransitionsBetween: start and: end ]
		ifFalse: [OrderedCollection new]</body>

<body package="PV-ES-Formulas" selector="getCalendarPeriodEnd">getCalendarPeriodEnd

	^self timeSeries formula isLocalizedSchedule
		ifTrue: [self timeSeries formula end]
		ifFalse: [nil]</body>

<body package="PV-ES-Formulas" selector="getCalendarTransitionAtOrBefore:">getCalendarTransitionAtOrBefore: time 

	"Use the last tuple if it exists"
	self stLastTuple ifNotNil: 
		[:last | 
		last timestamp &lt;= time 
			ifTrue: 
				[^PvCalendarTimeInterval
					start: last timestamp
					stop: nil
					inSegment: last value smeeToBoolean]].

	"If it doesn't exist then go to the calendar input and compute what it would have been"
	^self timeSeries formula isLocalizedSchedule
		ifTrue: [self timeSeries formula getCalendarTransitionAtOrBefore: time]
		ifFalse: [nil]</body>

<body package="PV-ES-Formulas" selector="getCalendarPeriodDuration">getCalendarPeriodDuration

	^self timeSeries formula isLocalizedSchedule
		ifTrue: [self timeSeries formula duration]
		ifFalse: [nil]</body>

<body package="PV-ES-Formulas" selector="getCalendarPeriodStart">getCalendarPeriodStart

	^self timeSeries formula isLocalizedSchedule
		ifTrue: [self timeSeries formula start]
		ifFalse: [nil]</body>
</methods>

<methods>
<class-id>PROVISO.Input</class-id> <category>push interface</category>

<body package="PV-ES-Formulas" selector="removeAllExceptNumberOfRecentTuples:">removeAllExceptNumberOfRecentTuples: aNumber 
	
	self timeSeries hasBufferedTuples 
		ifFalse: 
			[self firstNeededTupleId: nil.
			^self firstUnseenTupleId: 1.].

	self firstNeededTupleId ifNotNil: 
		[:first | self firstNeededTupleId: (first max: self firstUnseenTupleId - aNumber)]</body>
</methods>

<methods>
<class-id>PROVISO.Input</class-id> <category>formula window interface</category>

<body package="PV-ES-Formulas" selector="releaseTuplesBefore:plus:">releaseTuplesBefore: aTsNumber plus: aCount 
	
	| positionOfTuplesInTheRange posOfProtectedTuples |
	self timeSeries hasBufferedTuples 
		ifFalse: 
			[self firstNeededTupleId: nil.
			^self firstUnseenTupleId: 1.].

	"find the earliest position of tuples in the range"
	positionOfTuplesInTheRange := 
		((self timeSeries firstTuplePositionAtOrAfter: aTsNumber)
			ifNil: [self firstUnseenTupleId]).

	"make position be aCount less than the lowest position in the range"
	posOfProtectedTuples := positionOfTuplesInTheRange - aCount max: 1.

	"if the pos of protected tuples is is the same as first unseen.. then there are no tuples we care about"
	posOfProtectedTuples = self firstUnseenTupleId
		ifTrue: [posOfProtectedTuples := nil].
	
	self firstNeededTupleId: posOfProtectedTuples</body>

<body package="PV-ES-Formulas" selector="setFirstNeededAndFirstUnseenFromBufferedTuples">setFirstNeededAndFirstUnseenFromBufferedTuples
	"firstNeededTupleId is nil, so set both it and firstUnseenTupleId from the time series."

	self timeSeries bufferedTuples isEmpty
		ifTrue: 
			[firstNeededTupleId := nil.
			firstUnseenTupleId := 1]
		ifFalse: [
			firstNeededTupleId := 1.
			firstUnseenTupleId := self timeSeries bufferedTuples size + 1].</body>
</methods>

<methods>
<class-id>PROVISO.Input</class-id> <category>private</category>

<body package="PV-ES-Formulas" selector="shiftPositionsBy:">shiftPositionsBy: aNumber

	firstNeededTupleId ifNotNil: [
		"move first unseen back aNumber"
		firstUnseenTupleId := (firstUnseenTupleId - aNumber) max: 1.

		"move first needed back aNumber"
		firstNeededTupleId := firstNeededTupleId - aNumber.
		"If we moved back below the front of the collection then:
			if there are no tuples then set first needed to nil.  
			if there are any tuples then set first needed to 1"
		firstNeededTupleId &lt;= 0
			ifTrue: [
				firstUnseenTupleId = 1
					ifTrue: [firstNeededTupleId := nil]
					ifFalse: [firstNeededTupleId := 1]].
		].</body>
</methods>

<methods>
<class-id>PROVISO.Input</class-id> <category>logging</category>

<body package="PV-ES-Formulas" selector="logPointerState">logPointerState

	self system
		logDebugTwo: #INPUT_STATE
		text: self owner printString, ' - firstNeeded: ', self firstNeededTupleId asString, ' firstUnseen: ', self firstUnseenTupleId asString</body>
</methods>


<methods>
<class-id>PROVISO.FormulaWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator lastTuple 
		ifNil: 
			[aFormulaOperator timeSeries ifNotNil: 
				[:ts | 
				self 
					doEmitTuple: aTuple
					formulaOperator: aFormulaOperator
					timeSeries: ts]]
		ifNotNil: 
			[:last | 
			aTuple timestamp &lt; last timestamp 
				ifTrue: [nil]
				ifFalse: 
					[((shouldDeduplicate or: [aTuple timestamp = last timestamp]) and: 
						[last value = aTuple value]) 
							ifTrue: [aFormulaOperator deduplicateTuple: aTuple]
							ifFalse: 
								[aFormulaOperator timeSeries ifNotNil: 
									[:ts | 
									self 
										doEmitTuple: aTuple
										formulaOperator: aFormulaOperator
										timeSeries: ts]]]]</body>

<body package="PV-ES-Formulas" selector="periodDurationForFormulaOperator:">periodDurationForFormulaOperator: aFormulaOperator

	self subclassResponsibility</body>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		aFormulaOperator lastTuple: aTuple.
		ts onAddTuple: aTuple.</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	^false</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator</body>

<body package="PV-ES-Formulas" selector="periodEndForFormulaOperator:">periodEndForFormulaOperator: aFormulaOperator

	self subclassResponsibility</body>
</methods>

<methods>
<class-id>PROVISO.FormulaWindow</class-id> <category>recomputations support</category>

<body package="PV-ES-Formulas" selector="reduceInputMetrics:using:and:">reduceInputMetrics: metricsForInput using: originalResults and: queryInterface
	"Answer a new collection that contains metrics for an input to the given window, following the rules of the window."

	| metrics metricsSet |
	metrics := OrderedCollection new.
	"We use metricsSet here because lookup on identity sets is hugely faster than in ordered collections..."
	metricsSet := IdentitySet new.
	originalResults do: [:eachTuple |
		| inputsForTuple |
		inputsForTuple := self chooseInputMetricsFrom: metricsForInput at: eachTuple timestamp using: queryInterface.
		inputsForTuple do: [:each |
			(metricsSet includes: each)
				ifFalse: [
					metricsSet add: each.
					metrics add: each]]].

	^metrics</body>

<body package="PV-ES-Formulas" selector="insertAtPosition:forInput:for:">insertAtPosition: intPos forInput: anInput for: anOperator 
	" Handle tuple insertion at position intPos. Each input maintains two pointers into its time series that define a range
	of tuples this input currently 'buffers'. If the insertions happens in the past relative to this range, the inserted tuple
	may or may not be  not be included in the range. The behavior depends on the nature of the window and is implemented
	in subclasses. If the tuple is to be included in the range, firstNeededTupleId becomes intPos and firstUnseenTupleId 
	increments to account for the inserted tuple in the past. 
	If the tuple is not to be included in the range, both pointers will increment to account for the inserted tuple in the past. 
	This 'tuple in the past' case corresponds to a condition when intPos &lt;= firstNeededTupleId.
	If the new tuple's date falls between oldest and newest tuples in input's range, the new tuple is included in the 
	input's range. In this case only the firstUnseenTupleId increments to account for the inserted tuple.
	This case corresponds to a condition when firstNeededTupleId &lt; intPos &lt;= firstUnseenTupleId.
	If the new tuple's date is newer than any tuple in the range, we always include it in the range. This is based on the following considerations:
	- Recomp records are always processed after their referencedate is older than the newest data processed by that CME,
	so they can't be ahead of computations that are yet to happen. This means referenceDate can't be outside of the current 
	formula's period for periodic formulas and it can't be ahead of tuples eventful formulas are yet to see. This means if we
	see a recomp tuple in the future relative to the current range, it represents a legitimate recomp insert in the current 
	computation. So we always include it in the current range even if it means extending the range "

	" The code below only deals with the effects of tuple insertion on firstUnseenTupleId (insertion in present and future).
	See subclasses for the logic to deal with firstNeededTupleId (insertion in the past) "
	anInput firstNeededTupleId
		ifNil: [anInput firstUnseenTupleId: 1]
		ifNotNil: 
			[anInput firstUnseenTupleId &gt;= intPos 
				ifTrue: [anInput firstUnseenTupleId: anInput firstUnseenTupleId + 1]
				ifFalse: [anInput firstUnseenTupleId: intPos]]</body>
</methods>


<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>testing</category>

<body package="PV-ES-Formulas" selector="isGenericFormula">isGenericFormula

	^false</body>
</methods>

<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>converting</category>

<body package="PV-ES-Formulas" selector="coerceToTheRightRecordType:">coerceToTheRightRecordType: aTuple
	"To make compatible with formulas"

	^aTuple</body>
</methods>

<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>initialize-release</category>

<body package="PV-ES-Formulas" selector="initialize">initialize

	super initialize.</body>
</methods>

<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="getCalendarTransitionAtOrBefore:">getCalendarTransitionAtOrBefore: time

	| interval |
	self intervals reset.
	interval := self intervalForTimestamp: time.
	self intervals reset.
	^interval</body>

<body package="PV-ES-Formulas" selector="getCalendarTransitionsBetween:and:">getCalendarTransitionsBetween: startTime and: endTime

	| transitions |
	transitions := OrderedCollection new.
	self 
		intervalsFrom: startTime
		to: endTime + 1
		do: 
			[:interval | 
			transitions add: interval].
	^transitions</body>
</methods>

<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>tuple storage compatibility</category>

<body package="PV-ES-Formulas" selector="hasFormulaPrototype">hasFormulaPrototype

	^false</body>

<body package="PV-ES-Formulas" selector="hasCompiledFormulaPrototype">hasCompiledFormulaPrototype

	^false</body>
</methods>

<methods>
<class-id>PROVISO.LocalizedSchedule</class-id> <category>heartbeat source api</category>

<body package="PV-ES-Formulas" selector="intervalsFrom:to:do:">intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock
	" Evaluate the block with all intervals that intersect time interval from aTsNumberStart to aTsNumberStop exclusive. 
	aMonadicBlock is evaluated with an instance of PvCalendarTimeInterval. "

	self intervals intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock</body>
</methods>


<methods>
<class-id>PROVISO.AbstractOperatorInput</class-id> <category>smee interface</category>

<body package="PV-ES-Formulas" selector="smeeGetCalendarTransitionsBetween:and:">smeeGetCalendarTransitionsBetween: start and: end
	&lt;prototypeFunctionNamed: #getCalendarTransitions 
		length: 2 
		args: 'startTime endTime' 
		selector: #smeeGetCalendarTransitionsBetween:and: 
		comment: 'Compute an array of tuples representing a calendar input''s transitions within the range'&gt;
	
	^Smee.SmeeArray smeeNewWithAll: (
		(self getCalendarTransitionsBetween: start smeeToInteger and: end smeeToInteger) collect: 
			[:eachInterval | 
			Smee.SmeeObject new 
				at: #timestamp put: eachInterval start;
				at: #value put: eachInterval inSegment;
				yourself ])</body>

<body package="PV-ES-Formulas" selector="smeeGetCalendarStartOfPeriod">smeeGetCalendarStartOfPeriod
	&lt;prototypeFunctionNamed: #getCalendarStartOfPeriod comment: 'Return start of the current period for the input calendar'&gt;

	^self getCalendarPeriodStart</body>

<body package="PV-ES-Formulas" selector="smeeGetCalendarPeriodDuration">smeeGetCalendarPeriodDuration
	&lt;prototypeFunctionNamed: #getCalendarPeriodDuration comment: 'Return duration of the current period for the calendar input'&gt;

	^self getCalendarPeriodDuration</body>

<body package="PV-ES-Formulas" selector="smeeGetCalendarEndOfPeriod">smeeGetCalendarEndOfPeriod
	&lt;prototypeFunctionNamed: #getCalendarEndOfPeriod comment: 'Return end of the current period for the input calendar'&gt;

	^self getCalendarPeriodEnd</body>

<body package="PV-ES-Formulas" selector="getCalendarPeriodStart">getCalendarPeriodStart

	^nil</body>

<body package="PV-ES-Formulas" selector="getCalendarPeriodDuration">getCalendarPeriodDuration

	^nil</body>

<body package="PV-ES-Formulas" selector="getCalendarPeriodEnd">getCalendarPeriodEnd

	^nil</body>

<body package="PV-ES-Formulas" selector="smeeGetCalendarTransitionAtOrBefore:">smeeGetCalendarTransitionAtOrBefore: time
	&lt;prototypeFunctionNamed: #getCalendarTransitionAtOrBefore 
		length: 1
		args: 'time' 
		selector: #smeeGetCalendarTransitionAtOrBefore: 
		comment: 'Get the most recent calendar transition with a time that is at or before some time'&gt;
	
	| interval |
	interval := self getCalendarTransitionAtOrBefore: time smeeToInteger.
	^interval ifNotNil: 
		[Smee.SmeeObject new 
			at: #timestamp put: interval start;
			at: #value put: interval inSegment;
			yourself ]</body>
</methods>

<methods>
<class-id>PROVISO.AbstractOperatorInput</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="getCalendarTransitionsBetween:and:">getCalendarTransitionsBetween: start and: end 

	^OrderedCollection new</body>

<body package="PV-ES-Formulas" selector="getCalendarTransitionAtOrBefore:">getCalendarTransitionAtOrBefore: time

	^nil</body>
</methods>


<methods>
<class-id>PROVISO.Formula</class-id> <category>smee interface</category>

<body package="PV-ES-Formulas" selector="smeePeriodDuration">smeePeriodDuration
	&lt;instanceFunctionNamed: #periodDuration comment: 'Return current period duration'&gt;

	^nil</body>

<body package="PV-ES-Formulas" selector="smeeEndOfPeriod">smeeEndOfPeriod
	&lt;instanceFunctionNamed: #endOfPeriod comment: 'End of operator''s period'&gt;
	^nil</body>
</methods>

<methods>
<class-id>PROVISO.Formula</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="id:">id: anObject
	id := anObject</body>

<body package="PV-ES-Formulas" selector="id">id
	^id</body>
</methods>


<methods>
<class-id>PROVISO.TimeSeries class</class-id> <category>database support</category>

<body package="PV-ES-Formulas" selector="bindVariableSelectStatementForCurrentLabelForMetricId:subelementId:">bindVariableSelectStatementForCurrentLabelForMetricId: metricId subelementId: subelementId
	"self bindVariableSelectStatementForCurrentLabelForMetricId: 1234 subelementId: 4567"

	| bindVariableArray |

	bindVariableArray := Array new: 2.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.

	^'SELECT distinct ts.int_label
		FROM ts_desc ts
		WHERE 
			ts.idx_metric = :1 
			and ts.idx_resource = :2 
			and ts.str_action = ''I'' 
			and ts.int_version_date = 
				(SELECT MAX(ts2.int_version_date)
					FROM ts_desc ts2
					WHERE 
						ts2.idx_metric = :1 
						AND ts2.idx_resource = :2)'
    				-&gt; bindVariableArray</body>

<body package="PV-ES-Formulas" selector="bindVariableSelectStatementForLabelForMetricId:subelementId:between:and:">bindVariableSelectStatementForLabelForMetricId: metricId 
	subelementId: subelementId
	between: beginTimestamp
	and: endTimestamp
	"self bindVariableSelectStatementForLabelForMetricId: 1234 subelementId: 4567 between: 5000 and: 1000"

	| bindVariableArray dateClause begin end subquery |
	begin := beginTimestamp ifNil: [Infinity negative].
	end := endTimestamp ifNil: [Infinity positive].
	(((begin == Infinity negative) or: [begin == Infinity positive]) and: [begin == end])
		ifTrue: [^nil].
	end &lt; begin ifTrue: [^nil].

	bindVariableArray := Array new: 4.
	bindVariableArray at: 1 put: metricId.
	bindVariableArray at: 2 put: subelementId.
	bindVariableArray at: 3 put: begin.
	bindVariableArray at: 4 put: end.

	subquery := 
		'OR ts.int_version_date = 
			(SELECT MAX(ts2.int_version_date)
				FROM ts_desc ts2
				WHERE 
					ts2.idx_metric = :1 
					AND ts2.idx_resource = :2
					AND ts2.dte_date &lt; :3)'.
	((begin ~~ Infinity negative) and: [end ~~ Infinity positive]) 
		ifTrue:
			[dateClause := 'and (ts.dte_date between :3 and :4 ', subquery, ')']
		ifFalse:
			[((begin == Infinity negative) and: [end == Infinity positive])
				ifTrue:
					[dateClause := ''.
					bindVariableArray := bindVariableArray copyFrom: 1 to: 2]
				ifFalse:
					[(begin == Infinity negative) ifTrue: 
						[dateClause := 'and ts.dte_date &lt;= :3'.
						bindVariableArray at: 3 put: endTimestamp].
					(end == Infinity positive) ifTrue: 
						[dateClause := 'and (ts.dte_date &gt;= :3 ', subquery, ')'].
					bindVariableArray := bindVariableArray allButLast]].

	^('SELECT distinct ts.int_label
		FROM ts_desc ts
		WHERE 
			ts.idx_metric = :1 
			and ts.idx_resource = :2 
			and ts.str_action = ''I''', dateClause)
    				-&gt; bindVariableArray</body>
</methods>


<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>smee interface</category>

<body package="PV-ES-Formulas" selector="smeePeriodDuration">smeePeriodDuration
	&lt;prototypeFunctionNamed: #periodDuration comment: 'Return current period duration'&gt;

	^self periodDuration</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:">shouldDeduplicateOnAddTuple: aTuple

	^self window shouldDeduplicateOnAddTuple: aTuple formulaOperator: self</body>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate 
	&lt;prototypeFunctionNamed: #emitTuple length: 1 args: 'tuple' selector: #emitTuple:
	comment: 'Emits new tuple'&gt;
	
	^self window 
		emitTuple: aTuple
		shouldDeduplicate: shouldDeduplicate
		formulaOperator: self</body>

<body package="PV-ES-Formulas" selector="smeeEndOfPeriod">smeeEndOfPeriod
	&lt;prototypeFunctionNamed: #endOfPeriod comment: 'Return end of the current period for the operator'&gt;

	^self periodEnd</body>

<body package="PV-ES-Formulas" selector="onAddTuple:">onAddTuple: aTuple

	self window onAddTuple: aTuple formulaOperator: self</body>
</methods>

<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>updating</category>

<body package="PV-ES-Formulas" selector="update:with:">update: aSymbol with: anObject

	aSymbol == #addEndOfPeriod 
		ifTrue: 
			[[^self window 
				onEndOfPeriod: anObject
				for: self]
					on: Error
					do: [:ex | 
						self system 
							logWarning: #ERROR
							messageId: #DC12347
							text: 'Error in FormulaOperator&gt;&gt;update:with: as a result of responding to #addEndOfPeriod notification.'.
						PvWalkbackWriter new dumpWalkbackForException: ex.
						^self]].
	aSymbol == #addStartOfPeriod 
		ifTrue: 
			[[^self window 
				onStartOfPeriod: anObject
				for: self]
					on: Error
					do: [:ex | 
						self system 
							logWarning: #ERROR
							messageId: #DC12348
							text: 'Error in FormulaOperator&gt;&gt;update:with: as a result of responding to #addStartOfPeriod notification.'.
						PvWalkbackWriter new dumpWalkbackForException: ex.
						^self]].
	aSymbol == #addCalendarPeriodNotification 
		ifTrue: [^anObject handleForOperator: self].
	aSymbol == #addIntermediateHeartbeat 
		ifTrue: 
			[^self window 
				onCalculateIntermediate: anObject
				for: self].
	aSymbol == #prepareForUpdate 
		ifTrue: [^anObject prepareToUpdateTimeSeries: self timeSeries].
	aSymbol == #establishImplicitPeriod 
		ifTrue: [self periodStart ifNil: [self periodStart: anObject]].

	super 
		update: aSymbol
		with: anObject</body>
</methods>

<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="periodEnd">periodEnd
	^self window ifNil: [nil] ifNotNil: [:window | window periodEndForFormulaOperator: self]</body>

<body package="PV-ES-Formulas" selector="periodDuration">periodDuration
	^self window ifNil: [nil] ifNotNil: [:window | window periodDurationForFormulaOperator: self]</body>
</methods>

<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>windowing api</category>

<body package="PV-ES-Formulas" selector="evaluate:withTuple:">evaluate: sel withTuple: aTuple 
	|temp|

	self timeSeries ifNotNil: [:ts | ts shouldFire ifFalse: [^nil]].

	^self environment do: 
		[[temp := self 
			invokeSmeeCallback: sel
			withArguments: (Array with: aTuple)
			ifAbsent: [nil]] 
				on: Error
				do: 
					[:err | 
					FormulaCalculationError 
						raiseRequestWith: self formula-&gt;sel 
						errorString: 'Calc error in ', sel, '(), formula ', self formula printString, ' mid: ', self metricId printString ,' rid: ', self resourceId printString, ', error: ', err description.
					(self inputs conform: [:eachInput | eachInput notNil])
						ifTrue: 
							[self 
								logWarnFailedCalculate: self formula printString
								selector: sel
								msg: err description  , ' for mid: ', self metricId printString ,' rid: ', self resourceId printString]
						ifFalse: 
							[| missingArgs |
							missingArgs := OrderedCollection new: self formula arguments size.
							self formula arguments keysAndValuesDo:  
								[:eachIx :eachArg | (self inputs at: eachIx) ifNil: [missingArgs add: eachArg]].
							self 
								logWarnFailedCalculate: self formula printString
								selector: sel
								msg: 'Formula is missing input(s) for arguments: ', missingArgs asArray printString , ' for mid: ', self metricId printString ,' rid: ', self resourceId printString].
					nil]]</body>
</methods>

<methods>
<class-id>PROVISO.FormulaOperator</class-id> <category>mutating</category>

<body package="PV-ES-Formulas" selector="removeSmeePropertiesForObsoleteFormulaInputs">removeSmeePropertiesForObsoleteFormulaInputs
	" If a formula loses some inputs, Smee propeties that make those inputs accessible in Smee
	should also be removed. I.e. formula inputs change from 
		a1, a2, a3
	to 
		a2, a5
	This means we should remove Smee properties a1 and a3 "

	| obsoleteSmeeInputProperties |
	obsoleteSmeeInputProperties := OrderedCollection new.
	self enumerablePropertiesDo: 
		[:eachModifier | 
		((eachModifier value isKindOf: AbstractInput) and: [(self inputs includes: eachModifier value) not])
			ifTrue: [obsoleteSmeeInputProperties add: eachModifier]].
	
	obsoleteSmeeInputProperties do: [:eachModifier |
		self smeeDelete: eachModifier key].</body>

<body package="PV-ES-Formulas" selector="recompileWithFormula:">recompileWithFormula: aFormula 
	" Replace the prototype with the new formula and reshape the inputs "
	
	| oldInputs newInputs obsoleteInputs |
	oldInputs := self inputs.
	newInputs := Array new: aFormula arguments size.
	" Get all the inputs that are preserved between in the new version of the formula and put them in proper place at the new inputs array"
	aFormula arguments keysAndValuesDo: 
		[:ix :eachArgument | 
		| oldInput |
		oldInput := 
			oldInputs 
				detect: [:eachInput | eachInput notNil and: [eachInput sequenceNumber = eachArgument id]]
				ifNone: [nil].
		oldInput ifNotNil: [newInputs at: ix put: oldInput]].

	" These inputs should have been deleted in an orderly fashion, so their presence may be an indication of some problem in the logic "
	obsoleteInputs := 
		oldInputs reject: 
			[:eachInput | 
			eachInput isNil 
				or: [aFormula arguments anySatisfy: [:eachArgument | eachInput sequenceNumber = eachArgument id]]].
	obsoleteInputs do: 
		[:eachInput | 
		self system 
			logDebugOne: #DISCONNECT_OBSOLETE_INPUT
			messageId: nil
			text: 
				'Removing input because of formula change. Time series ' , 
					self id printString , ', input: ' , eachInput printString.
		eachInput disconnect].
	self smeePrototype: aFormula.
	self inputs: newInputs.
	self removeSmeePropertiesForObsoleteFormulaInputs</body>
</methods>


<methods>
<class-id>PROVISO.TupleSource</class-id> <category>testing</category>

<body package="PV-ES-Formulas" selector="hasAnyClients">hasAnyClients

	^self dependents notEmpty</body>
</methods>


<methods>
<class-id>PROVISO.FormulaSet class</class-id> <category>instance creation</category>

<body package="PV-ES-Formulas" selector="installFromFile:infoOn:">installFromFile: aFilename infoOn: aStrm 

	| fileSet dbSet deltas model argMapInsert highWatermark |
	highWatermark := self timeFacade nowAsSeconds.
	(self 
		validateFromFile: aFilename
		infoOn: aStrm) 
			ifFalse: [^nil].
	PROVISO.UBA.Environment new do: 
		[model := 
			PvModel new
				initializeForCme;
				initIdManager;
				yourself.
		"Resync up to 1 day to avoid any issues with local timezone settings"
		model 
			resyncDomainManagers: #(formulaManager calendarManager)
			collectors: nil
			between: 0
			and: self timeFacade now asUTCSeconds + 8640.
		fileSet := self loadFromFile: aFilename.
		fileSet do: [:ea | ea resyncHistoricalDate: Infinity positive].
		dbSet := 
			self 
				formulasForDoc: fileSet documentName
				inModel: model.
		deltas := fileSet asMutationsOf: dbSet.
		"TODO: only store the document if there has been a change in the text of the document...also, need to be able to handle document include statements."
		model formulaManager 
			storeDocument: aFilename
			named: fileSet documentName.
		"The following code needs to be retained and will be utilized in the future, for now, the plumbing is not in place to support it -spair/apikovsky"
		"argMapInsert := (String new: 1024) streamContentsDo: [:stream |
					stream nextPutAll: 'insert into FRML_ARG (idx_ind, str_arg_path, dte_date) values ('; cr.
					(model formulaManager argumentMap associations 
						select: [:eachAssoc | eachAssoc value key &gt;= highWatermark])
							do: [:eachAssoc |
								stream
									print: eachAssoc value value; nextPut: $,; space;
									nextPutAll: eachAssoc key; nextPut: $,; space;
									print: eachAssoc value key]
							separatedBy: [stream  nextPut: $,; cr].
					stream cr; nextPutAll: ')'.
				].
				self dbSession executeNonSelect: argMapInsert."
		aStrm nextPutAll: 'Deleted Formulas:'.
		(deltas at: #deletes) isEmpty 
			ifTrue: [aStrm nextPutAll: ' (none)'].
		aStrm cr.
		(deltas at: #deletes) do: 
			[:formulaName | 
			aStrm
				nextPutAll: '   ';
				nextPutAll: formulaName;
				cr.
			(dbSet formulaNamed: formulaName) dbDelete].
		aStrm nextPutAll: 'Inserted Formulas:'.
		(deltas at: #inserts) isEmpty 
			ifTrue: [aStrm nextPutAll: ' (none)'].
		aStrm cr.
		(deltas at: #inserts) do: 
			[:formulaName | 
			| formula |
			aStrm
				nextPutAll: '   ';
				nextPutAll: formulaName;
				cr.
			formula := fileSet formulaNamed: formulaName.
			model formulaManager 
				dbAddFormula: formula
				named: formulaName
				withSeparator: $~.
			model formulaManager 
				associateFormula: formula
				withDocument: fileSet documentName].
		aStrm nextPutAll: 'Updated Formulas:'.
		(deltas at: #updates) addAll: (deltas at: #unchanged).
		"update all formulas, even the unchanged ones"
		(deltas at: #updates) isEmpty 
			ifTrue: [aStrm nextPutAll: ' (none)'].
		aStrm cr.
		(deltas at: #updates) do: 
			[:formulaName | 
			| formula |
			aStrm
				nextPutAll: '   ';
				nextPutAll: formulaName;
				cr.
			formula := fileSet formulaNamed: formulaName.
			formula id: (dbSet formulaNamed: formulaName) id.
			(dbSet formulaNamed: formulaName) group ifNotNil: [:grp | formula group: grp].
			formula dbUpdate]].

	self installDummyFormulasForCalendarsIn: model infoOn: aStrm</body>

<body package="PV-ES-Formulas" selector="validateFromFile:infoOn:">validateFromFile: aFilename infoOn: aStrm

	| fileSet dbSet deltas model failures insertOrUpdate |
	insertOrUpdate := 
		[ :formulaName | | formula frmlProto newId |
		formula := fileSet formulaNamed: formulaName.
		[formula id: (dbSet formulaNamed: formulaName) id] on: Error do: [ :ex | ].
		frmlProto := formula formulaPrototype.
		newId := 0.
		model formulaManager
			addFormula: formula
			named: formulaName
			withSeparator: $~
			idCallback:
				[[newId := newId + 1.
				(model formulaManager itemWithId: newId) isNil and: [(model formulaManager groupWithId: newId) isNil]] whileFalse.
				newId]
			insertCallback: [ :obj |].
		formula formulaPrototype: frmlProto].

	aStrm cr; nextPutAll: 'Validating Formulas'; cr; flush.

	"turn off dbinsert/update"
	self dbSession doNonSelect: false.
	
	PROVISO.UBA.Environment new do:
		[model := 
			PvModel new 
				initializeForCme; 
				initIdManager;
				yourself.
		"Resync up to 1 day to avoid any issues with local timezone settings"
		model
			resyncDomainManagers: #(formulaManager calendarManager requestManager)
			collectors: nil
			between: 0
			and: (self timeFacade now asUTCSeconds + 86400).

	"Catch basic compile errors in the file"
		[fileSet := self loadFromFile: aFilename]
			on: Error
			do: 
				[:ex | 
				aStrm nextPutAll: 'Validation failed while compiling formula file! Problem found:'.
				aStrm cr; nextPutAll: ex description.
				aStrm cr.
				^false].

		dbSet := self formulasForDoc: fileSet documentName inModel: model.
		deltas := fileSet asMutationsOf: dbSet.

		(deltas at: #deletes) do: 
			[ :formulaName | 
			(model formulaNamed: formulaName) ifNotNil: [:formula |
			model requestManager allItems do: [:request |
				| error |
				error := (request formula notNil and: [request formula id = formula id]) 
					or: [request formulaIndex = formula id
						or: [request genericFormula notNil and: [request genericFormula id = formula id]]].
				error
					ifTrue: [
						aStrm nextPutAll: 'Validation failed: formula ', formulaName.
						aStrm nextPutAll: ' referenced by request with id: ', request id printString.
						aStrm cr.
						^false]].

			(model thresholdManager doesExistThresholdsForFormulaId: formula id)
				ifTrue: [
					aStrm nextPutAll: 'Validation failed: formula ', formulaName.
					aStrm nextPutAll: ' referenced by threshold(s)'.
					aStrm cr.
					^false].

			model formulaManager removeItemWithId: formula id ifAbsent: []]].

		(deltas at: #inserts) do: insertOrUpdate.
		(deltas at: #updates) addAll: (deltas at: #unchanged). "update all formulas, even the unchanged ones"
		(deltas at: #updates) do: insertOrUpdate].

	failures := OrderedCollection new.
	"explicitly call linker"
	[PvFormulaLinker linkPvModelAndAssignArgumentIds: model]
		on: PvFormulaCompileNotification
		do: [:ex | 
			failures add: ex.
			ex resume].

	fileSet formulas keysAndValuesDo: 
		[:eachFname :eachPvFormula | | window calName |
		window := eachPvFormula formulaPrototype window.
		window isCalendarBased ifTrue:
			[calName := eachPvFormula formulaPrototype window calendarName.
			model calendarManager
				itemNamed: (LocalizedSchedule calendarNameFrom: calName) 
				ifPresent: 
					[:cal |
					cal isSuitableForCalendarWindow ifFalse:
						[failures add:
							(GeneralError new
								owner: self;
								description: 'Calendar ', calName, ' in formula ', eachFname, ' is not suitable for period definition (hint: check segment''s str_to_time)';
								yourself)]]
				ifAbsent: 
					[failures add:
						(GeneralError new
							owner: self;
							description: 'Calendar referenced by ', calName, ' in formula ', eachFname, ' is not presently defined';
							yourself)]]].

	"turn on insert/update"
	self dbSession doNonSelect: true.

	failures isEmpty
		ifTrue: [aStrm nextPutAll: 'Validation Succeeded, Loading formulas'; cr]
		ifFalse:
			[aStrm nextPutAll: 'Validation Failed! Problems found:'.
			failures do: [:ex | aStrm cr; nextPutAll: ex description].
			aStrm cr].

	^failures isEmpty</body>
</methods>


<methods>
<class-id>PROVISO.MetricInTimeSeries</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="action">action

	^(self record respondsTo: #action)
		ifTrue: [self record action]
		ifFalse: [nil]</body>

<body package="PV-ES-Formulas" selector="resource">resource

	^self timeSeries
		ifNotNil: [:ts | ts id resource]</body>

<body package="PV-ES-Formulas" selector="formula">formula

	^self timeSeries
		ifNotNil: [:ts | ts id formula]</body>
</methods>


<methods>
<class-id>PROVISO.AbstractHeartbeatSource</class-id> <category>actions</category>

<body package="PV-ES-Formulas" selector="intervalsFrom:to:do:">intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock
	" Evaluate the block with all intervals that intersect time interval from aTsNumberStart to aTsNumberStop exclusive. 
	aMonadicBlock is evaluated with an instance of PvCalendarTimeInterval. "

	self policy intervalsFrom: aTsNumberStart to: aTsNumberStop do: aMonadicBlock</body>

<body package="PV-ES-Formulas" selector="establishImplicitPeriodForClientsForHour:">establishImplicitPeriodForClientsForHour: aTsNumber 
	
	self clients do: 
		[:eachBroker | 
		eachBroker
			update: #establishImplicitPeriod
				with: self startOfPeriod].</body>

<body package="PV-ES-Formulas" selector="prepareForHour:">prepareForHour: aTimestamp 
	" Langolier all old calendar intervals, but, to be on the cautious side, lag by 2 hours "

	self policy langolierAllBefore: aTimestamp-7200 .
	self hasPeriodDefined
		ifFalse: [self establishImplicitStartOfPeriodFor: aTimestamp]</body>
</methods>

<methods>
<class-id>PROVISO.AbstractHeartbeatSource</class-id> <category>testing</category>

<body package="PV-ES-Formulas" selector="isStartOfNextPeriod:">isStartOfNextPeriod: aNumber

	^self policy isStartOfNextPeriod: aNumber</body>
</methods>


<methods>
<class-id>PROVISO.NullWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="periodEndForFormulaOperator:">periodEndForFormulaOperator: aFormulaOperator

	^self count</body>

<body package="PV-ES-Formulas" selector="periodDurationForFormulaOperator:">periodDurationForFormulaOperator: aFormulaOperator

	^self count</body>
</methods>

<methods>
<class-id>PROVISO.NullWindow</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="count">count
	^self duration</body>
</methods>


<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>builder protocol</category>

<body package="PV-ES-Formulas" selector="disconnect">disconnect

	self removeSpecificToGenericDependency.

	self beImplicit; shouldStore: false.
	super disconnect.</body>

<body package="PV-ES-Formulas" selector="removeSpecificToGenericDependency">removeSpecificToGenericDependency
	"I might be the generic.  If any specific ts point to me because i am generic, then remove me from that dependents collection"
	
	self tupleRepository 
		specificTimeseriesFor: self
		do: [:each | each removeDependent: self]</body>
</methods>

<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>shouldFire flag</category>

<body package="PV-ES-Formulas" selector="shouldFire:">shouldFire: aBool
	"Ignore"</body>

<body package="PV-ES-Formulas" selector="shouldFire">shouldFire

	^true</body>
</methods>

<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="dependentComputationsDo:">dependentComputationsDo: aBlock 

	self dependents do:
		[:dependent | 
		((dependent isKindOf: FormulaOperator) or: 
			[(dependent isKindOf: PROVISO.PvFormulas.PvCflFormula) or:
				[dependent isKindOf: TimeSeries]])
					ifTrue: [aBlock value: dependent]]</body>
</methods>


<methods>
<class-id>PROVISO.HeartbeatWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="periodDurationForFormulaOperator:">periodDurationForFormulaOperator: aFormulaOperator

	| heartbeatSource |
	heartbeatSource := aFormulaOperator tupleRepository getHeartbeatSourceAt: self periodDefinition.
	^heartbeatSource periodDuration</body>

<body package="PV-ES-Formulas" selector="periodEndForFormulaOperator:">periodEndForFormulaOperator: aFormulaOperator

	| heartbeatSource |
	heartbeatSource := aFormulaOperator tupleRepository getHeartbeatSourceAt: self periodDefinition.
	^heartbeatSource endOfPeriod</body>
</methods>

<methods>
<class-id>PROVISO.HeartbeatWindow</class-id> <category>recomputations support</category>

<body package="PV-ES-Formulas" selector="insertAtPosition:forInput:for:">insertAtPosition: intPos forInput: anInput for: anOperator 
	" For period windows a tuple may have to be included in the range if it is in the past.
	We check if the new tuple falls into the current period and, if it does, we extend the range into the past "
	
	anOperator periodStart ifNil: 
		[^self system
			logDebugTwo: #TIMESERIES_STATE
			text: 'No periodStart set so ignoring tuple insertion ', anInput owner printString].

	anInput setFirstNeededAndFirstUnseenFromBufferedTuples.
	anInput releaseTuplesBefore: anOperator periodStart plus: self count</body>
</methods>


<methods>
<class-id>PROVISO.TupleWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator timeSeries ifNotNil: 
		[:ts | 
		self 
			doEmitTuple: aTuple
			formulaOperator: aFormulaOperator
			timeSeries: ts]</body>

<body package="PV-ES-Formulas" selector="periodDurationForFormulaOperator:">periodDurationForFormulaOperator: aFormulaOperator

	^self count</body>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		ts onBufferTuple: aTuple</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	| last |

	"If we don't have a lastTuple then we should produce a value"
	(last := formulaOperator lastTuple) ifNil: [^false].

	"There should never be a new tuple for an earlier timestamp (moving back in time)"
	aTuple timestamp &lt; last timestamp
		ifTrue: [^true].

	"There should never be 2 tuples for the same timestamp"
	(aTuple timestamp = last timestamp and: [last value = aTuple value])
		ifTrue: [^true].

	"Real deduplication - where previous value is the same as this value"
	(formulaOperator shouldDeduplicate and: [last value = aTuple value])
		ifTrue: [^true].

	^false</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator

	aFormulaOperator lastTuple: aTuple</body>

<body package="PV-ES-Formulas" selector="periodEndForFormulaOperator:">periodEndForFormulaOperator: aFormulaOperator

	^self count</body>
</methods>

<methods>
<class-id>PROVISO.TupleWindow</class-id> <category>recomputations support</category>

<body package="PV-ES-Formulas" selector="insertAtPosition:forInput:for:">insertAtPosition: intPos forInput: anInput for: anOperator 
	" For tuple windows the a tuple may have to be included in the range if it is in the past.
	Since there is no period, we always extend the range into the past. Then, 
	after updating the range, we make sure the input buffers no more tuples than it needs. 
	This also takes care of removing recomp records we included in the past if they really shouldn't be there "

	anInput setFirstNeededAndFirstUnseenFromBufferedTuples.
	anInput removeAllExceptNumberOfRecentTuples: self count</body>

<body package="PV-ES-Formulas" selector="reduceInputMetrics:using:and:">reduceInputMetrics: metricsForInput using: originalResults and: queryInterface
	"Answer a new collection that contains metrics for an input to the given window, following the rules of the window."

	^metricsForInput</body>
</methods>


<methods>
<class-id>PROVISO.CMEWindow</class-id> <category>operator api</category>

<body package="PV-ES-Formulas" selector="doEmitTuple:formulaOperator:timeSeries:">doEmitTuple: aTuple formulaOperator: aFormulaOperator timeSeries: ts

		aFormulaOperator lastTuple: aTuple.
		ts onAddTuple: aTuple.</body>

<body package="PV-ES-Formulas" selector="onAddTuple:formulaOperator:">onAddTuple: aTuple formulaOperator: aFormulaOperator</body>

<body package="PV-ES-Formulas" selector="emitTuple:shouldDeduplicate:formulaOperator:">emitTuple: aTuple shouldDeduplicate: shouldDeduplicate formulaOperator: aFormulaOperator
	
	^aFormulaOperator lastTuple 
		ifNil: 
			[aFormulaOperator timeSeries ifNotNil: 
				[:ts | 
				self 
					doEmitTuple: aTuple
					formulaOperator: aFormulaOperator
					timeSeries: ts]]
		ifNotNil: 
			[:last | 
			aTuple timestamp &lt; last timestamp 
				ifTrue: [nil]
				ifFalse: 
					[((shouldDeduplicate or: [aTuple timestamp = last timestamp]) and: 
						[last value = aTuple value]) 
							ifTrue: [aFormulaOperator deduplicateTuple: aTuple]
							ifFalse: 
								[aFormulaOperator timeSeries ifNotNil: 
									[:ts | 
									self 
										doEmitTuple: aTuple
										formulaOperator: aFormulaOperator
										timeSeries: ts]]]]</body>

<body package="PV-ES-Formulas" selector="shouldDeduplicateOnAddTuple:formulaOperator:">shouldDeduplicateOnAddTuple: aTuple formulaOperator: formulaOperator

	^false</body>
</methods>



<methods>
<class-id>PROVISO.AbstractCmeMetadataHandler</class-id> <category>processing (pre-hourly)</category>

<body package="PV-CME-Core" selector="buildAndPrepareTrees">buildAndPrepareTrees
	
	| startTime stopTime enumerator |
	self buildStartOfPeriodCache.
	startTime := self timeFacade now asSeconds.
	self system extendedStatus: 'Setup data for ' , self currentHour printString.
	enumerator := self createTreeBuilder.
	enumerator
		initializeFromCme: self;
		build.
	self updatePropertyFormulasWithInputs: self pvModel resyncAgent updatedProperties.
	self pvModel resyncAgent finalizeResync.
	self hasReadRecoveryFiles
		ifFalse: 
			[PvCmeRecoveryTreeBuilder executeForCmeEngine: self.
			self loadOperatorState.
			self hasReadRecoveryFiles: true].
	self createTreePruner
		initializeFromCme: self owner;
		execute.
	self resetRaBucketsForStartOfPeriod.
	self resetGaBucketsForStartOfPeriod.
	stopTime := self timeFacade now asSeconds.
	self stats 
		timingFor: #preHourlyTreeBuildSeconds
		is: stopTime - startTime</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeRecoveryTreeBuilder</class-id> <category>api</category>

<body package="PV-CME-Core" selector="execute">execute
	
	| time |
	self logAboutToRebuild.
	time := Time millisecondsToRun: [self doRebuildAggregateTrees].
	self logRebuildDoneIn: time.</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeModelResyncAgent</class-id> <category>private</category>

<body package="PV-CME-Core" selector="disconnectHeartbeatSourcesForFormula:">disconnectHeartbeatSourcesForFormula: realObject 
	
	realObject hasFormulaPrototype ifTrue: 
		[self cmeEngine ifNotNil: 
			[:engine | realObject formulaPrototype disconnectFromHeartbeatSourcesIn: engine tupleRepository]]</body>
</methods>


<methods>
<class-id>PROVISO.FormulaInstallerApplication</class-id> <category>hooks</category>

<body package="PV-CME-Core" selector="hookStart">hookStart

	| out result |
	out := OS.Stdout.
	super hookStart.
	self dbSession connect.
	self dbSession isConnected ifFalse: 
		[out nextPutAll: 'Unable to establish DB connection, exiting.'; cr.
		^self stopImmediate].
	self dbSession begin.
	result := [
		self formulaDocuments
			do: [ :doc |
				OS.Stdout 
					nextPutAll: 'Processing ';
					nextPutAll: (doc asFilename asString);
					cr.
				FormulaSet 
					installFromFile: doc asFilename 
					infoOn: out]
			separatedBy: [OS.Stdout cr].
		true]
	on: Error do: [:signal |
		self logError: signal description.
		OS.Stdout 
			nextPutAll: 'Error: ';
			nextPutAll: signal description;
			cr.
		signal return: false].

	result
		ifTrue: [self dbSession commit]
		ifFalse: [self dbSession rollback].
	self stopImmediate.</body>
</methods>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>testing</category>

<body package="PV-CME-Core" selector="recordIsDuplicate:">recordIsDuplicate: metricRecord 
	" Answer true if a record with the same timestamp, or one in the same hour and with the same poll id
	is already in the buffer "
	
	| newPollId newDate newHour record |
	self formula isSparseTimeSeries 
		ifTrue: [^false].
	(self bufferedTuples isNil or: [self bufferedTuples isEmpty]) 
		ifTrue: [^false].
	newPollId := metricRecord pollId.
	newDate := metricRecord date.
	newHour := newDate truncateTo: 3600.
	record := 
		self bufferedTuples recordAtInsertionUsing: 
			[:eachRecord | | eachHour |
			newHour &gt; (eachHour := eachRecord date truncateTo: 3600) or: 
				[newHour = eachHour and: 
					[metricRecord date = eachRecord date or: 
						[newPollId &gt; eachRecord pollId]]]].
	^record notNil and:
		[newDate = record date or: 
			[newPollId = record pollId and: [newHour = (record date truncateTo: 3600)]]]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initBufferedTuples">initBufferedTuples

	bufferedTuples := PvRawBucketSortedCollection sortBlock: [:a :b | a date &lt;= b date]</body>

<body package="PV-CME-Core" selector="initialize">initialize

	super initialize.
	self
		shouldFire: true;
		periodsPerHour: 0;
		metricRecordsCount: 0;
		duplicateRecordCount: 0;
		droppedRecordCount: 0.</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>recomputations</category>

<body package="PV-CME-Core" selector="insertOrUpdateTupleWith:">insertOrUpdateTupleWith: aRecompRecord 
	" Perform insert/update for the given recomp action "
	" Either insert the record, or update the current one if exists "
	| rec ix |
	rec := self formula metricRecordClass new initializeFrom: aRecompRecord.
	"We need to update the date, since it is copied from the date field instead of the reference date field..."
	rec date: aRecompRecord referenceDate.
	(self bufferedTuples 
		detect: [:eachRec | eachRec date = aRecompRecord referenceDate]
		ifNone: [nil]) 
			ifNil: 
				[" No record with this date -- insert "
				" Add it this way because bufferedTuples is a SortedCollection "
				rec := PvRecomputedRecordWrapper new
						recomputed: rec;
						yourself.
				self bufferedTuples add: rec.
				" Now find it and signal insertion to all dependents "
				ix := self bufferedTuples indexOf: rec.
				self 
					changed: #insertPosition
					with: ix]
			ifNotNil: 
				[:orig | 
				" Record exists -- just update value, no futher actions "
				self bufferedTuples replaceAll: orig with: 
					(orig asRecomputedRecordWrapperWith: rec)].

	"set lastTuple based on the actual last tuple in my bufferedTuples,
	The goal here is to keep the operator's lastTuple in sync with the 
	actual last tuple because he uses it to decide it he should deduplicate or not"
	self lastTuple ifNotNil: 
		[:realLastTuple |
		self owner ifNotNil: [:op | op lastTuple: realLastTuple].
		self tupleRepository 
			specificTimeseriesFor: self 
			do: 
				[:specificTs | 
				specificTs owner ifNotNil: [:op | op lastTuple: realLastTuple]]].</body>

<body package="PV-CME-Core" selector="handleRecomputationRecord:">handleRecomputationRecord: aRecompRecord
"
	self system
		logDebugTwo: #TIMESERIES_STATE_BEGIN
		text: self printString.
	self logStateOfBufferedTuplesAndDependentInputs.
"	
	self bufferedTuples isNil
		ifTrue: [self initBufferedTuples].

	aRecompRecord isActionDelete
		ifTrue: [self deleteTupleWith: aRecompRecord]
		ifFalse: [self insertOrUpdateTupleWith: aRecompRecord].
"
	self system
		logDebugTwo: #TIMESERIES_STATE_APPLIED
		text: 'Applied recomp tuple: ', aRecompRecord printString.
	self logStateOfBufferedTuplesAndDependentInputs.
	self system
		logDebugTwo: #TIMESERIES_STATE_END
		text: self printString.
"</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>flags</category>

<body package="PV-CME-Core" selector="shouldFireFlagMask">shouldFireFlagMask

	^2r00010000</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>shouldFire flag</category>

<body package="PV-CME-Core" selector="shouldFire:">shouldFire: aBool

	aBool
		ifTrue: [self setShouldFireFlag]
		ifFalse: [self clearShouldFireFlag]</body>

<body package="PV-CME-Core" selector="setShouldFireFlag">setShouldFireFlag

	flags := flags maskSet: self shouldFireFlagMask</body>

<body package="PV-CME-Core" selector="clearShouldFireFlag">clearShouldFireFlag

	flags := flags maskClear: self shouldFireFlagMask</body>

<body package="PV-CME-Core" selector="shouldFire">shouldFire

	^(flags bitAnd: self shouldFireFlagMask) ~= 0</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>updating</category>

<body package="PV-CME-Core" selector="coerceInputRecordToTheRightRecordType:">coerceInputRecordToTheRightRecordType: aTuple

	^self formula coerceToTheRightRecordType: aTuple</body>

<body package="PV-CME-Core" selector="onAddTuple:">onAddTuple: aTuple 
	" New tuple is produced by the owner of this time series. 
	Store the tuple in the tupleRepository and distribute it to the local clients "

	"Ask the operator if this tuple should be deduplicated"	
	self operator ifNotNil: 
		[:aFormulaOperator | 
		(aFormulaOperator shouldDeduplicateOnAddTuple: aTuple) 
			ifTrue: [^aFormulaOperator deduplicateTuple: aTuple] 
			ifFalse: [aFormulaOperator onAddTuple: aTuple]].

	self tupleRepository 
		addTupleNoUpdate: aTuple
		forTimeSeries: self.
	self tupleRepository 
		changed: #onMetric
		with: aTuple.
	self onUpdateTuple: aTuple</body>

<body package="PV-CME-Core" selector="onUpdateTuple:">onUpdateTuple: anObject 
	" New tuple has arrived (produced either locally or ermotely). Distribute it to the local clients "
	
	| pos rec |
	(self validateTuple: anObject) 
		ifTrue: 
			[rec := self coerceInputRecordToTheRightRecordType: anObject.
			pos := self storeTuple: rec.
			self 
				changed: #addTuple
				with: rec
				with: pos]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="flagSpecs">flagSpecs

	^super flagSpecs, #(#(shouldFire shouldFireFlagMask))</body>

<body package="PV-CME-Core" selector="firstTuple">firstTuple
	
	^self hasBufferedTuples 
		ifTrue: [self bufferedTuples first]
		ifFalse: [nil]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>clients interaction</category>

<body package="PV-CME-Core" selector="lastScavengeableTuplePositionEarlierThan:">lastScavengeableTuplePositionEarlierThan: aNumber 
	
	| pos |
	pos := 
		self clients 
			inject: nil
			into: 
				[:lastPos :eachClient | 
				eachClient firstNeededTupleId 
					ifNil: [lastPos]
					ifNotNil: 
						[:num | 
						lastPos 
							ifNil: [num - 1]
							ifNotNil: [num - 1 min: lastPos]]].
	(pos notNil and: [self shouldStore]) 
		ifTrue: 
			[[pos &gt; 0 and: [(self bufferedTuples at: pos) timestamp &gt;= aNumber]] 
				whileTrue: [pos := pos - 1]]
		ifFalse: 
			[(self isPeriodicTimeSeries or: [pos isNil]) 
				ifTrue: 
					[pos := self bufferedTuples size.
					[pos &gt; 0 and: [(self bufferedTuples at: pos) timestamp &gt;= aNumber]] 
						whileTrue: [pos := pos - 1]]].
	^pos max: 0</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>private</category>

<body package="PV-CME-Core" selector="storeTuple:">storeTuple: aTuple 
	
	^self isProperty
		ifTrue: 
			[self subelement propertyValueAtFormula: self formula put: aTuple.
			nil]
		ifFalse:
			[self bufferedTuples ifNil: [self initBufferedTuples].
			self bufferedTuples add: aTuple.
			self metricRecordsCount: self metricRecordsCount + 1.
			^self bufferedTuples size]</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>user interface</category>

<body package="PV-CME-Core" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc coll1 |
	details := OrderedCollection new.
 	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	self tupleRepository ifNotNil: [:rep | |specificNode|
		rep 
			specificTimeseriesFor: self 
			do: [:eachSpecificTs |
				specificNode := ObjectLabel key: 'Specific: ', eachSpecificTs pvTreeViewLabelString value: eachSpecificTs.
				details add: specificNode]
	].
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self bufferedTuples ifNil: [#()].
	coll isEmpty
		ifTrue: 
			[self owner 
				ifNotNil: 
					[:operator | 
					operator lastTuple 
						ifNotNil: [:tuple | details add: (ObjectLabel key: 'Last record: ', tuple printString)]].
		]
		ifFalse: 
			[coll1 := OrderedCollection new: coll size.
			coll reverseDo: [:eachRec | 
				coll1 add: (ObjectLabel key: eachRec shortDigest value: eachRec)].
			details add: 
				((HierarchicalObjectWrapper 
					key: 'Records: '
					value: coll1)
					inspectorChildren: coll1;
					emphasis: #(veryDarkGray);
					icon: ListIconLibrary collection16x16;
					yourself)].
	" Add reference to the remote original time series if we are not local"
	self isLocalStreamLabel
		ifFalse: 
			[[liveTsAssoc := self getMyTimeSeries.
			details add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			(moreDetails
				add: (ObjectLabel key: 'Label: ' , obj printString value: obj);
				yourself) asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for (', self pvTreeViewLabelString, '...', ')' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			emphasis: #(veryDarkGray italic);
			yourself).
	^details asArray</body>
</methods>

<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>logging</category>

<body package="PV-CME-Core" selector="logStateOfBufferedTuplesAndDependentInputs">logStateOfBufferedTuplesAndDependentInputs

	self system
		logDebugTwo: #TIMESERIES_STATE
		text: self printString, ' - bufferedTuples size= ', self bufferedTuples size asString.

	self bufferedTuples ifNotNil: 
		[:buff | 
		buff doWithIndex: 
			[:e :i | 
			self system
				logDebugTwo: #TIMESERIES_STATE
				text: (i asString, ':', e printString)]].

	self changed: #logPointerState</body>
</methods>


<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>private</category>

<body package="PV-CME-Core" selector="postBuildActionForTimeSeries:">postBuildActionForTimeSeries: eachTs 
	
	" If a give raw bucket is new, or its subelement had some recent change (i.e. its group membership changed
	directly or indirectly), we need to rebuild its RA buckets. Prior to rebuilding RA buckets we reset flags for all 
	existing buckets so we can scavenge obsolete ones at the end "

	(eachTs formula isSpecificToGenericConversion not and: 
		[eachTs formula isLocalizedSchedule not and: 
			[eachTs isNew or: [(self resyncAgent dirtySubelements includes: eachTs resource) or: [self resyncAgent fullTreeBuildFlag]]]]) 
				ifTrue: 
					[self 
						buildRaBucketsFromRequest: eachTs request
						timeSeries: eachTs]</body>
</methods>

<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>building buckets</category>

<body package="PV-CME-Core" selector="buildForRequest:id:explicit:">buildForRequest: aRequest id: aTSid explicit: aBoolean 

	| ts tsgen request explicit returnSpecific specificId genericId |
	(specificId := self getActualIdForRequest: aRequest id: aTSid) ifNil: [^nil].
	ts := nil.
	tsgen := nil.
	returnSpecific := true.
	request := aRequest.
	explicit := aBoolean.
	(specificId = aTSid and: [specificId formula isGenericFormula])
		ifTrue: [self specificIdAndRequestForGenericTimeSeriesId: specificId
				do: 
					[:myId :myReq |
					genericId := specificId.
					specificId := myId.
					request := myReq.
					explicit := true.
					returnSpecific := false]].
	
	[ts := self
				buildOperatorForRequest: request
				id: specificId
				explicit: explicit.
	tsgen := specificId formula isSpecificToGenericConversion
				ifTrue: [self
						buildForGenericFormulaForRequest: request
						timeSeries: ts
						explicit: explicit]
				ifFalse: [ts].
	specificId formula isLocalizedSchedule
		ifTrue: [(self getHeartbeatSourceAt: specificId formula name)
				subscribe: ts]
		ifFalse: [aRequest currentResource notNil
				ifTrue: [self buildRaBucketsForTimeSeries: tsgen contextResource: request currentResource]
				ifFalse: [nil]]]
		on: Error
		do: 
			[:ex | 
			self
				logBuildErrorForRequest: request
				id: aTSid
				reason: ex.
			(self system debugFlags 
				at: #DEBUG_WALKBACK_ON_BUILD_ERROR
				ifAbsent: [true]) 
					ifTrue: [PvWalkbackWriter new dumpWalkbackForException: ex]].
	^returnSpecific
		ifTrue: [ts ifNil: [self tupleRepository at: specificId]]
		ifFalse:[tsgen ifNil: [self tupleRepository at: genericId]]</body>

<body package="PV-CME-Core" selector="specificIdAndRequestForGenericTimeSeriesId:do:">specificIdAndRequestForGenericTimeSeriesId: genId do: aBlock

	| specificRequests specificRequest specificId |
	genId formula isGenericFormula ifFalse: [^nil].
	specificRequests := nil.
	genId resource metricRequestsDo: 
		[:req | 
			(genId formula specificFormulas anySatisfy: [:eachFormula | eachFormula isSnmpFormula not and: [eachFormula = req formula]])
				ifTrue: 
					[specificRequests ifNil: [specificRequests := IdentitySet new].
					specificRequests add: req]].
	specificRequests ifNil: 
		["self logNoRequestsForSpecificFormulaForGenericTimeSeries: genId."
		^nil].

	specificRequests size &gt; 1 
		ifTrue: [self logTooManySpecificFormulaRequests: specificRequests forGenericTimeSeries: genId].

	(specificRequest := specificRequests anyOne) currentResource: genId resource.
	specificId := MetricSeriesIdentifier metric: specificRequest formula resource: genId resource.
	aBlock value: specificId value: specificRequest</body>
</methods>

<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>testing</category>

<body package="PV-CME-Core" selector="shouldAssignIdsToTimeSeries">shouldAssignIdsToTimeSeries
	" Builders that create new computations answer true; 
	builders that reconstruct computations from some external representation answer false "
	self subclassResponsibility</body>

<body package="PV-CME-Core" selector="isExecutingPlan">isExecutingPlan
	" Only builders that actually execute the plan activate heartbeat sources "

	self subclassResponsibility</body>
</methods>

<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>building</category>

<body package="PV-CME-Core" selector="build">build
	
	self logAboutToBuild: self resources size.
	self fullTreeBuildFlag ifTrue: [self disconnectAllHeartbeatSources].
	PvFormulaLinker linkPvModel: self pvModel.
	self clearBuckets.
	self tupleRepository shouldAutoAssignIdsToTimeSeries: 
		self shouldAssignIdsToTimeSeries.
	self buildResourceBuckets.
	self postBuildResourceBuckets.
	self buildgroupBuckets</body>
</methods>

<methods>
<class-id>PROVISO.CmeESTreeBuilder</class-id> <category>logging</category>

<body package="PV-CME-Core" selector="logTooManySpecificFormulaRequests:forGenericTimeSeries:">logTooManySpecificFormulaRequests: aCollOfReqs forGenericTimeSeries: aTimeSeries

	self system
		logWarning: #TOO_MANY_SPECIFIC_FORMULA_REQUESTS
		messageId: #DC10012
		text: 'There are too many specific formula requests for ' , aTimeSeries printString , ' ' , aCollOfReqs asArray printString , '.  This is a misconfiguration that can cause loss of data and excessive plan churn'.</body>

<body package="PV-CME-Core" selector="logNoRequestsForSpecificFormulaForGenericTimeSeries:">logNoRequestsForSpecificFormulaForGenericTimeSeries: aTimeSeries 
	
	self system
		logWarning: #NO_SPECIFIC_FORMULA_REQUEST
		messageId: #DC10011
		text: 'There is no specific formula request for timeseries: ' , aTimeSeries printString</body>
</methods>


<class>
<name>TupleRepository</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>dependents owner tupleStorageClient metricTimeSeries msidToTimeSeriesMap raData gaData heartbeatHandlers timeSeriesClass buffer heartbeatBuffer shouldAutoAssignIdsToTimeSeries noSenseOfTimeYet </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>My Classes</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>private</category>

<body package="PV-CME-Core" selector="injectBufferedTuplesIntoComputationsUntilAllDone">injectBufferedTuplesIntoComputationsUntilAllDone

	| formulasInBuffer inputFormulaIds tupleToTsList |	
	
	tupleToTsList := OrderedCollection new: heartbeatBuffer size.
	[heartbeatBuffer isEmpty]
		whileFalse:
			["build up a list of all formulas in the buffer"
			formulasInBuffer := Set new: 200.
			heartbeatBuffer do: [:array | formulasInBuffer add: array last formula].

			"find the formulaIds that do not depend on any other formulas in the buffer"
			inputFormulaIds := Set new: 200.
			formulasInBuffer do: 
				[:each | 
				(formulasInBuffer noneSatisfy: [:each2 | each dependsOnFormula: each2])
					ifTrue: [inputFormulaIds add: each id]].
		
			"build up a list of all timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList fastEmpty.
			heartbeatBuffer keysAndValuesDo: 
				[:midRidArray :tupleToTsArray | 
				(inputFormulaIds includes: midRidArray first)
					ifTrue: [tupleToTsList add: tupleToTsArray]].
	
			"remove the timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				heartbeatBuffer 
					removeMid: tupleToTsArray second metricId 
					rid: tupleToTsArray second resourceId 
					ifAbsent: []].
	
			"do onAddTuple: for each timeseries where the formula does not depend on any other formulas in the buffer.
			For tupleWindow type formulas this can result in more things being added to heartbeatBuffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				tupleToTsArray last onAddTuple: tupleToTsArray first]]</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="shouldAutoAssignIdsToTimeSeries">shouldAutoAssignIdsToTimeSeries
	^shouldAutoAssignIdsToTimeSeries</body>

<body package="PV-CME-Core" selector="noSenseOfTimeYet">noSenseOfTimeYet
	^noSenseOfTimeYet</body>

<body package="PV-CME-Core" selector="noSenseOfTimeYet:">noSenseOfTimeYet: anObject
	noSenseOfTimeYet := anObject</body>

<body package="PV-CME-Core" selector="shouldAutoAssignIdsToTimeSeries:">shouldAutoAssignIdsToTimeSeries: anObject
	shouldAutoAssignIdsToTimeSeries := anObject</body>

<body package="PV-CME-Core" selector="specificTimeseriesFor:do:">specificTimeseriesFor: aTimeSeries do: aBlock 
	
	aTimeSeries formula isSpecificToGenericConversion 
		ifFalse: 
			[self pvModel formulaManager 
				formulasWithGenericId: aTimeSeries metricId
				do: 
					[:formula | 
					(self metricTimeSeries 
						atMid: formula id
						rid: aTimeSeries resourceId) ifNotNil: [:specificTs | aBlock value: specificTs]]]</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>accessing trees</category>

<body package="PV-CME-Core" selector="rawBucketsKeysAndValuesDo:">rawBucketsKeysAndValuesDo: aBlock

	self rawData keysAndValuesDo: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>api</category>

<body package="PV-CME-Core" selector="onHeartbeat:">onHeartbeat: aHeartbeat 
	" Sort by evaluation order. aCollection is collection of heartbeat sources to fire now.
	Each heartbeat source has a list of subscribers, which are either heartbeat brokers,
	brokering heartbeat notifications for a specific formula (normal or intermediate heartbeats)
	or a time series. This method arranges these in the proper evaluation order. The order is as follows:
	1. All time series should evaluate before heartbeats
	2. Within time series formula that is a direct or indirect argument of another formula should be 
		evaluated before that formula
	3. Within heartbeats, heartbeats for a formula that is a direct or indirect argument of another formula 
		should be evaluated before heartbeats for that formula
	4. If both intermediate and normal heartbeats are to fire, only normal heartbeats should fire "

	self noSenseOfTimeYet 
		ifTrue: [self prepareForHour: aHeartbeat timestamp + 1].
	self changed: #onHeartbeat with: aHeartbeat.
"
	(self heartbeatHandlers notEmpty 
		and: [self heartbeatHandlers first shouldHandleHeartbeatAt: aHeartbeat timestamp])
			ifTrue: [self handleHeartbeat: aHeartbeat forAll: self heartbeatHandlers]
"
	self handleHeartbeat: aHeartbeat forAll: self heartbeatHandlers</body>

<body package="PV-CME-Core" selector="addHeartbeatBufferedTuple:for:">addHeartbeatBufferedTuple: aMetricRecord for: cmeTimeSeries

	heartbeatBuffer
		atMid: cmeTimeSeries metricId
		rid: cmeTimeSeries resourceId
		put: (Array with: aMetricRecord with: cmeTimeSeries).</body>

<body package="PV-CME-Core" selector="prepareForHour:">prepareForHour: aNumber 
	
	self heartbeatHandlers do: 
		[:each | 
		each
			prepareForHour: aNumber;
			establishImplicitPeriodForClientsForHour: aNumber].
	self noSenseOfTimeYet: false</body>

<body package="PV-CME-Core" selector="registerTimeSeries:">registerTimeSeries: eachTSid 
	" Creates new time series that will be managed by this node "

	| ts |

	^metricTimeSeries 
		at: eachTSid
		ifAbsentPut: 
			[eachTSid msid isNil
				ifTrue: 
					[self shouldAutoAssignIdsToTimeSeries
						ifTrue: 
							[eachTSid msid: self pvModel getNextRUId]].
			ts := 
				self timeSeriesClass new
					id: eachTSid;
					tupleRepository: self;
					beNew;
					yourself.
			self 
				changed: #addTimeSeries
				with: ts.
			ts]</body>

<body package="PV-CME-Core" selector="handleHeartbeat:forAll:">handleHeartbeat: aHeartbeat forAll: sources 
	" Sort by evaluation order. aCollection is collection of heartbeat sources to fire now.
	Each heartbeat source has a list of subscribers, which are either heartbeat brokers,
	brokering heartbeat notifications for a specific formula (normal or intermediate heartbeats)
	or a time series. This method arranges these in the proper evaluation order. The order is as follows:
	1. All time series should evaluate before heartbeats
	2. Within time series formula that is a direct or indirect argument of another formula should be 
		evaluated before that formula
	3. Within heartbeats, heartbeats for a formula that is a direct or indirect argument of another formula 
		should be evaluated before heartbeats for that formula
	4. If both intermediate and normal heartbeats are to fire, only normal heartbeats should fire "
	
	| heartbeatSourceToBrokerList startHb formulasInBuffer inputFormulas inputFormulaIds tupleToTsList heartbeatBrokersToTrigger fullHeartbeatSourceToBrokerList |	

	"build up a list of all heartbeatSources-&gt;heartbeatBrokers that should be triggered now"
	heartbeatSourceToBrokerList := OrderedCollection new.
	sources do: [:eachSource |
		eachSource 
			clientsAtEndOfPeriodFor: aHeartbeat timestamp 
			do: [:eachBroker | 
				heartbeatSourceToBrokerList add: eachSource -&gt; eachBroker]].
	fullHeartbeatSourceToBrokerList := heartbeatSourceToBrokerList copy.

	tupleToTsList := OrderedCollection new: heartbeatBuffer size.
	"Keep doing this loop until we have processed all heartbeatSources-&gt;heartbeatBrokers AND there is nothing left in the buffer"
	[heartbeatBuffer isEmpty not or: [heartbeatSourceToBrokerList notEmpty]]
		whileTrue:
			["build up a list of all formulas in the buffer"
			formulasInBuffer := Set new: 200.
			heartbeatBuffer do: [:array | formulasInBuffer add: array last formula].
			heartbeatSourceToBrokerList copy do: 
				[:eachAssoc | | formula | 
				formula := self pvModel formulaOrLocalizedScheduleWithId: eachAssoc value formula id. 
				formula isNil
					ifTrue: [heartbeatSourceToBrokerList remove: eachAssoc]
					ifFalse: [formulasInBuffer add:  formula]].

			"find the formulaIds that do not depend on any other formulas in the buffer"
			inputFormulas := Set new: 200.
			formulasInBuffer do: 
				[:each | 
				(formulasInBuffer noneSatisfy: [:each2 | each dependsOnFormula: each2])
					ifTrue: [inputFormulas add: each]].
	
			"get heartbeatsources to trigger and trigger them"
			heartbeatBrokersToTrigger := heartbeatSourceToBrokerList select: [:eachAssoc | inputFormulas includes: (self pvModel formulaOrLocalizedScheduleWithId: eachAssoc value formula id)].
			heartbeatBrokersToTrigger do: 
				[:eachAssoc | 
				eachAssoc key update: #addEndOfPeriod for: eachAssoc value with: aHeartbeat].
			heartbeatSourceToBrokerList removeAll: heartbeatBrokersToTrigger.
		
			"build up a list of all timeseries where the formula does not depend on any other formulas in the buffer"
			inputFormulaIds := inputFormulas collect: [:e | e id].
			tupleToTsList fastEmpty.
			heartbeatBuffer keysAndValuesDo: 
				[:midRidArray :tupleToTsArray | 
				(inputFormulaIds includes: midRidArray first)
					ifTrue: [tupleToTsList add: tupleToTsArray]].
	
			"remove the timeseries where the formula does not depend on any other formulas in the buffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				heartbeatBuffer 
					removeMid: tupleToTsArray second metricId 
					rid: tupleToTsArray second resourceId 
					ifAbsent: []].
	
			"do onAddTuple: for each timeseries where the formula does not depend on any other formulas in the buffer.
			For tupleWindow type formulas this can result in more things being added to heartbeatBuffer"
			tupleToTsList do: 
				[:tupleToTsArray | 
				tupleToTsArray last onAddTuple: tupleToTsArray first]].

	" Finally, send start of period notifications to all subscribers. 
	Start of period does not require a particular ordering since no tuples are generated at 
	start of period. Therefore it can be done at the heartbeat source level. 
	Each source will then propagate it to its clients "
	startHb := PvStreamHeartbeat timestamp: aHeartbeat timestamp + 1.
	fullHeartbeatSourceToBrokerList do: [:eachAssoc | 
		eachAssoc key 
			update: #addStartOfPeriod
			for: eachAssoc value
			with: startHb].</body>

<body package="PV-CME-Core" selector="onMetric:">onMetric: aMetricRecord 
	
	aMetricRecord isHeartbeat
		ifTrue: [self onHeartbeat: aMetricRecord]
		ifFalse:
			[self changed: #onMetric with: aMetricRecord.
			self noSenseOfTimeYet 
				ifTrue: [self prepareForHour: aMetricRecord timestamp].
			self notifySubscribers: aMetricRecord]</body>
</methods>

<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize
	
	metricTimeSeries := PvMidRidBTree new.
	metricTimeSeries label: 'Metric Data'.
	msidToTimeSeriesMap := LHSet new.
	raData := PvMidGidRidBTree new.
	gaData := PvMidGidBTree new.
	self noSenseOfTimeYet: true.
	self shouldAutoAssignIdsToTimeSeries: false.		" Builders will always set this variable "
	self buffer: (OrderedCollection new: 128).
	self resetHeartbeatHeandlers.
	self resetHeartbeatBuffer</body>
</methods>


<class>
<name>CmlSerializer</name>
<environment>PROVISO</environment>
<super>PROVISO.SimpleSerializer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>currentTupleSource operatorCount timeSeriesCount tupleCount tupleRepository skipTupleSourceFlagsOnRead </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.CmlSerializer</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize

	super initialize.
	timeSeriesCount := 0.
	operatorCount := 0.
	tupleCount := 0.
	skipTupleSourceFlagsOnRead := true.</body>
</methods>

<methods>
<class-id>PROVISO.CmlSerializer</class-id> <category>reading</category>

<body package="PV-CME-Core" selector="readHeartbeatSource:">readHeartbeatSource: aHeartbeatSource

	| periodStart duration source |
	periodStart := self read.
	duration := self read.

	source := self tupleRepository heartbeatHandlerAt: aHeartbeatSource id ifAbsent: [^nil].
"mkam commented out for RA503363
because state restore was messing up localizedSchedules even
thought resync had changed the cal from month to day"
	"source start: periodStart length: duration."
	^source</body>

<body package="PV-CME-Core" selector="readCalendarSource:">readCalendarSource: aHeartbeatSource 
	
	| source |
	source := self readHeartbeatSource: aHeartbeatSource.
"mkam commented out for RA503363
because state restore was messing up localizedSchedules even
thought resync had changed the cal from month to day"
	"source ifNotNil: 
		[source policy
			intervalForTimestamp: source endOfPeriod;
			intervalForTimestamp: source startOfPeriod]"</body>

<body package="PV-CME-Core" selector="readTupleSource:">readTupleSource: aTupleSource

	timeSeriesCount := timeSeriesCount + 1.
	[currentTupleSource := aTupleSource.
	skipTupleSourceFlagsOnRead
		ifTrue: [self read]
		ifFalse: [	aTupleSource flags: self read].
	"We only write the owner if it is a formula operator, otherwise, we write a nil, so only set the owner if it's not nil"
	self read ifNotNil: [ :obj | aTupleSource owner: obj].
	^aTupleSource]
			ensure: [currentTupleSource := nil]</body>
</methods>


<methods>
<class-id>PROVISO.CmeSmeeFormulaBuildHelper</class-id> <category>private</category>

<body package="PV-CME-Core" selector="bindInputsForRequest:operator:formula:">bindInputsForRequest: aRequest operator: operator formula: aFormula 
	" Build operator inputs. Each input is specified as a path with potentially multiple segments. 
	Each segment is a formula name or a calendar reference. All intermediate segments should refer
	to a relation-typed formula; the leaf segment should refer to a float, string or property formula.
	For all intermediate segments we have to build intermediate nodes in case the topology in the middle 
	changes. For the leaf segment we build an instace of Input for specified formula and the resource we
	navigate to from the current operator via relation formula segments
	"
	
	| oldInputs oldIntermediates newInputs |
	oldInputs := operator inputs ifNil: [self class emptySet].
	newInputs := (Array new: aFormula arguments size).
	oldIntermediates := operator intermediateNodes copy.
	operator intermediateNodes: Set new.

	aFormula arguments keysAndValuesDo: 
		[:ix :eachArgument | | oldInput newInput|
		oldInput := oldInputs detect: [:each | each notNil and: [each sequenceNumber = eachArgument id]] ifNone: [nil].
		newInput := nil.
		self builder 
			convertInputPath: eachArgument pathFormulas
			startingFrom: 1
			toIdsForResouce: operator resource
			do: 
				[:eachTSid :leaf |
				"formula can be nil if the formula was removed from the system but still remains in some other formula's pathFormulas"
				eachTSid formula ifNotNil:
					[leaf 
						ifTrue: 
							[eachTSid resource isActive
								ifTrue: 
									[newInput := 
										self 
											buildInputForRequest: aRequest
											operator: operator
											input: oldInput
											newInput: newInput
											id: eachTSid.
									newInput ifNotNil: [newInput sequenceNumber: eachArgument id]]
								ifFalse: 
									[" This could happen if the subelement is inactive, or it has no element or element's collector is wrong "
									self system 
										logWarning: #MISSING_INPUT_INACTIVE
										messageId: #DC10008
										text: 'Skipped building input for ', eachTSid printString, ' because subelement is inactive.  This could happen if the subelement is inactive, or it has no element or elements collector is wrong']]
						ifFalse: 
							[self builder 
								buildIntermediateTimeSeriesForOperator: operator
								id: eachTSid]]].

		"make the newInputs at this argument be the newInputs we just created"
		newInputs at: ix put: newInput].

		"disconnect old inputs that are no longer needed because formula changed"
		oldInputs do: 
			[:oInputs | 
			oInputs ifNotNil: 
				[oInputs do: 
					[:oldInput | 
					(self hasInput: oldInput in: newInputs) 
						ifFalse:
							[self builder changed: #aboutToDeleteInput with: oldInput.
							oldInput disconnect]]]].
	
	oldIntermediates 
		ifNotNil: 
			[oldIntermediates do: 
				[:eachInput | 
				(operator includesIntermediate: eachInput) 
					ifFalse: [operator removeIntermediate: eachInput]]].

	"set the operator's inputs to be the newInputs (the ones we just created or reused)"
	operator inputs: newInputs.
	aFormula arguments 
		with: operator inputs
			do: 
				[:arg :input | 
				operator 
					smeeAt: arg name
					put: input].
	operator removeSmeePropertiesForObsoleteFormulaInputs</body>
</methods>


<class>
<name>PvSleModelTestResyncAgent</name>
<environment>PROVISO</environment>
<super>PROVISO.PvSleModelResyncAgent</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-Core</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSleModelTestResyncAgent</class-id> <category>private</category>

<body package="PV-CME-Core" selector="doResyncDomainManagers:collectors:between:and:">doResyncDomainManagers: endSeconds
	collectors: collectors
	between: domainManagerSelectors
	and: startSeconds</body>
</methods>

<methods>
<class-id>PROVISO.PvSleModelTestResyncAgent</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="addResyncAction:">addResyncAction: anObject

	self addTestResyncAction: anObject</body>
</methods>


<methods>
<class-id>PROVISO.PvPlanBasedPropertyManager</class-id> <category>resync support</category>

<body package="PV-CME-Core" selector="resyncInsertFrom:">resyncInsertFrom: aProperty 
	
	self addItem: aProperty.</body>
</methods>

<methods>
<class-id>PROVISO.PvPlanBasedPropertyManager</class-id> <category>As yet unclassified</category>

<body package="PV-CME-Core" selector="resyncUpdateFrom:">resyncUpdateFrom: aProperty 
	
	self addItem: aProperty.</body>
</methods>


<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>near real-time support</category>

<body package="PV-CME-Core" selector="getBaselineHistoryRecordsBetween:and:forMid:gid:rid:">getBaselineHistoryRecordsBetween: beginSeconds and: endSeconds forMid: mid gid: gid rid: rid

	| results raBucket |
	self currentHour isNil ifTrue: [^#()].
	(self hasNoDataBetween: beginSeconds and: endSeconds) ifTrue: [^#()].

	results := OrderedCollection new.
	raBucket := self raData atMid: mid gid: gid rid: rid ifAbsent: [nil].
	raBucket notNil
		ifTrue: [
			((raBucket baselineHistory isNil not) and: [ raBucket baselineHistory date between: beginSeconds and: endSeconds])
				ifTrue: [ results add: raBucket baselineHistory ].
			(((raBucket previousHourBaselineHistory isNil not) and: [ raBucket previousHourBaselineHistory date between: beginSeconds and: endSeconds])
					and: [ ((raBucket baselineHistory) = ( raBucket previousHourBaselineHistory)) not ] )
				ifTrue: [ results add: raBucket previousHourBaselineHistory ] ].

	^results</body>

<body package="PV-CME-Core" selector="hasNoDataBetween:and:">hasNoDataBetween: beginSeconds and: endSeconds
	"Return if the given time range is outside of the current hour and the last hour."

	| startOfHour endOfHour startOfLastHour |
	startOfHour := self currentHour asSeconds.
	endOfHour := startOfHour + 3600.
	startOfLastHour := startOfHour - 3600.

	^ (endSeconds &lt;= startOfLastHour) | (beginSeconds &gt;= endOfHour)</body>

<body package="PV-CME-Core" selector="getMetricRecordsBetween:and:forMetricId:andResourceId:">getMetricRecordsBetween: beginSeconds  and: endSeconds forMetricId: mid andResourceId: rid

	| results rawBucket |
	self currentHour isNil ifTrue: [^#()].
	(self hasNoDataBetween: beginSeconds and: endSeconds) ifTrue: [^#()].

	results := OrderedCollection new.
	rawBucket := self rawData atMid: mid rid: rid ifAbsent: [nil].
	rawBucket notNil
		ifTrue: [
			rawBucket metricRecordsBetween: beginSeconds and: endSeconds do: [:eachRecord | 
				results add: eachRecord asMetricRecord]].
	^results</body>
</methods>

<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>processing</category>

<body package="PV-CME-Core" selector="acquireTupleContainer:">acquireTupleContainer: aTupleContainer 
	
	| acquired |
	^self critical: 
		[aTupleContainer validate
			ifFalse: 
				[self system 
					logWarning: #BAD_CONTAINER 
					messageId: #DC12354 
					text: 'Bad container: ', aTupleContainer printString.
				^nil].
		self transactionDo: 
			[:txn | 
			acquired := aTupleContainer acquireIn: txn.
			acquired ifNotNil:
				[self fileInterface addAdditionalConsumedSpace: aTupleContainer fileSize.
				self currentContainers add: acquired.
				self saveCurrentTupleContainersIn: txn]].
		acquired]</body>
</methods>

<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>processing (recomputations)</category>

<body package="PV-CME-Core" selector="localCopyOf:">localCopyOf: aRecompAction

	| record |
	(aRecompAction classObject name == #RecomputationAction)
		ifFalse: [^aRecompAction].

	record := PvRecomputationRecord0407 new
		metricId: aRecompAction metricId;
		resourceId: aRecompAction resourceId;
		referenceDate: aRecompAction timestamp;
		value: (Double readFromString: aRecompAction valueString);
		yourself.

	aRecompAction isUpdate
		ifTrue: [record beActionUpdate].

	aRecompAction isInsert
		ifTrue: [record beActionInsert].

	aRecompAction isDelete
		ifTrue: [record beActionDelete].

	^record</body>

<body package="PV-CME-Core" selector="debugLogIncomingRcmTuples:">debugLogIncomingRcmTuples: aCollection

	aCollection isEmpty
		ifTrue: [^self].

	self system
		logDebugFour: 'RCM_TUPLES' 
		text: ['Received ', aCollection size printString, ' tuple(s) from RCM.'].

	self system
		logDebugFour: 'RCM_TUPLES' 
		text: ['First Tuple: ', aCollection first printString].</body>

<body package="PV-CME-Core" selector="protectedHandleRecomputationRecords:whileGettingTuplesForMid:rid:from:to:">protectedHandleRecomputationRecords: recompActions whileGettingTuplesForMid: mid rid: rid from: startTime to: endTime

	| answer tsRecords nrtRecords nrtStart tsScopeStart timeSeries tupleStorageNode |
	[
		"RCM will retry in 60 seconds if we throw an error because we are not ready"
		(self metadataHandler isNil or: [self metadataHandler hasReadRecoveryFiles not])
			ifTrue: [self error: 'Not ready yet to repond to queries.  I am still starting up and have not restored state yet'].

		tsRecords := #().
		nrtRecords := #().
		mid notNil
			ifTrue: [
				"First, see if we have any NRT records"
				timeSeries := self tupleRepository atMid: mid rid: rid ifAbsent: [^OrderedCollection new].
				timeSeries shouldStore
					ifFalse: [^OrderedCollection new].
				nrtRecords := self getNearRealTimeRecordsForMid: mid rid: rid from: startTime to: endTime.
				nrtStart := self startOfPeriod - 3600.		" We guarantee to keep tuples for this and the previous hour "
				tsScopeStart := timeSeries firstTuple 		" But the time series may keep more tuples, which may extend its scope "
							ifNil: [nrtStart]
							ifNotNil: [:tuple | tuple timestamp min: nrtStart].
				(startTime &lt; tsScopeStart)
					ifTrue: [
						tupleStorageNode := self tupleStorage lookupNode: self collectorNumber ifAbsent: [nil].
						tsRecords := tupleStorageNode isNil
							ifTrue: [#()]
							ifFalse: [
								| records |
								self logStartingTSQueryForMid: mid rid: rid from: startTime to: endTime.
								records := tupleStorageNode
									perform: #remoteGetTuplesForMid:rid:from:to:
									withArguments: (Array with: mid with: rid with: startTime with: endTime)
									timeoutMilliseconds: 300000 "5 min"
									onTimeout: 
										[self logTimedOutDuringTSQueryForMid: mid rid: rid from: startTime to: endTime.
										self error: 'timed out on promise'].
								self logFinishedTSQueryForMid: mid rid: rid from: startTime to: endTime count: records size.
								records]]].
		self debugLogIncomingRcmTuples: recompActions.
		recompActions do: [:each | self handleRecomputationRecord: (self localCopyOf: each)]
			] valueUninterruptably.

	answer := OrderedCollection new.
	answer addAll: tsRecords.
	answer addAll: nrtRecords.

	^answer</body>

<body package="PV-CME-Core" selector="getNearRealTimeRecordsForMid:rid:from:to:">getNearRealTimeRecordsForMid: mid rid: rid from: startTime to: endTime
	"Queries from TupleStorage may have startTime &gt; endTime, so we'll check for that here..."

	| start end |
	startTime &gt; endTime
		ifTrue: [
			start := endTime.
			end := startTime]
		ifFalse: [
			start := startTime.
			end := endTime].

	^self getMetricRecordsBetween: start and: end forMetricId: mid andResourceId: rid</body>
</methods>

<methods>
<class-id>PROVISO.StreamLabelProcessor</class-id> <category>logging</category>

<body package="PV-CME-Core" selector="logStartingTSQueryForMid:rid:from:to:">logStartingTSQueryForMid: mid rid: rid from: startTime to: endTime 
	
	| messageStream |
	self system 
		logDebugFour: #REMOTE_TUPLE_QUERY
		text: 
			[messageStream := 
				String new writeStream
					nextPutAll: 'Starting TS query for mid: ';
					print: mid;
					nextPutAll: ' rid: ';
					print: rid;
					nextPutAll: ' start: ';
					print: startTime;
					nextPutAll: ' end: ';
					print: endTime;
					yourself.
			messageStream contents]</body>

<body package="PV-CME-Core" selector="logTimedOutDuringTSQueryForMid:rid:from:to:">logTimedOutDuringTSQueryForMid: mid rid: rid from: startTime to: endTime
	
	| messageStream |
	messageStream := 
		String new writeStream
			nextPutAll: 'Timed Out during TS query for mid: ';
			print: mid;
			nextPutAll: ' rid: ';
			print: rid;
			nextPutAll: ' start: ';
			print: startTime;
			nextPutAll: ' end: ';
			print: endTime;
			yourself.
	self system 
		logWarning: #REMOTE_TUPLE_QUERY
		messageId: #DC10005
		text: messageStream contents</body>

<body package="PV-CME-Core" selector="logFinishedTSQueryForMid:rid:from:to:count:">logFinishedTSQueryForMid: mid rid: rid from: startTime to: endTime count: count 
	
	| messageStream |
	self system 
		logDebugThree: #REMOTE_TUPLE_QUERY
		text: 
			[messageStream := 
				String new writeStream
					nextPutAll: 'Finished TS query for mid: ';
					print: mid;
					nextPutAll: ' rid: ';
					print: rid;
					nextPutAll: ' start: ';
					nextPutAll: startTime pvOpportunisticPrintString;
					nextPutAll: ' end: ';
					nextPutAll: endTime pvOpportunisticPrintString;
					nextPutAll: ' count: ';
					print: count;
					yourself.
			messageStream contents]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.StreamLabelProcessor</class-id> <selector>hasDataBetween:and:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvRawBucketSortedCollection</class-id> <category>comparing</category>

<body package="PV-CME-Core" selector="indexForInsertionUsing:">indexForInsertionUsing: aMonadicBlock
	| t2 t3 t4 rec |
	t3 := 1.
	t4 := self size.
	
	[t2 := t4 + t3 // 2.
	t3 &gt; t4]
		whileFalse: [
			rec := self at: t2.
			(aMonadicBlock value: rec)
				ifTrue: [t3 := t2 + 1]
				ifFalse: [t4 := t2 - 1]].
	^t3</body>

<body package="PV-CME-Core" selector="recordAtInsertionUsing:">recordAtInsertionUsing: aMonadicBlock

	| ix |
	ix := self indexForInsertionUsing: aMonadicBlock.
	^ix &lt;= self size
		ifTrue: [self at: ix]
		ifFalse: [self last]</body>
</methods>

<methods>
<class-id>PROVISO.PvRawBucketSortedCollection</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="at:put:">at: index put: value
	"Store the argument value in the indexable field of the receiver indicated by
	 index. Fail if the index is not an Integer or is out of bounds. Fail if the
	 value is not of the right type for this kind of collection. Answer the
	 value that was stored."

	^self privateAt: index + firstIndex - 1 put: value</body>
</methods>


<methods>
<class-id>PROVISO.PvInputAndTimeSeriesBuildCommand</class-id> <category>printing</category>

<body package="PV-CME-Core" selector="printContentsOn:">printContentsOn: aStream 
	
	aStream
		print: self ownerTimeSeriesMsid;
		nextPut: $[;
		print: self operatorId;
		nextPut: $,;
		print: self ownerTimeSeriesLabel;
		nextPut: $];
		nextPutAll: '&lt;-&gt;';
		print: self inputTimeSeriesMsid;
		nextPut: $[;
		print: self inputId;
		nextPut: $,;
		print: self inputTimeSeriesLabel;
		nextPut: $]</body>
</methods>

<methods>
<class-id>PROVISO.PvInputAndTimeSeriesBuildCommand</class-id> <category>building</category>

<body package="PV-CME-Core" selector="buildTimeSeriesForMsid:metricId:resourceId:label:requestId:isExplicit:withBuilder:">buildTimeSeriesForMsid: msid
	metricId: metricId
	resourceId: resourceId
	label: label
	requestId: requestId
	isExplicit: isExplicit
	withBuilder: aPlanBuilder

	" Build time series and everything necessary for the specified time series. If some required domain
	object (formula, subelement, request) are missing, build inactive stuibs for these "

	| id metric ts resource request |
	resource := aPlanBuilder pvModel subelementManager getOrCreateNewInactiveItemWithId: resourceId.
	metric := (aPlanBuilder pvModel formulaOrLocalizedScheduleWithId: metricId) ifNil: 
		[aPlanBuilder pvModel formulaManager getOrCreateNewInactiveItemWithId: metricId].
	id := MetricSeriesIdentifier msid: msid metric: metric resource: resource.
	request := aPlanBuilder pvModel requestManager getOrCreateNewInactiveItemWithId: requestId.
	ts := 
		aPlanBuilder 
			buildOperatorForRequest: request
			id: id
			explicit: isExplicit.
	ts streamLabel: label.
	id formula isSpecificToGenericConversion 
		ifTrue: 
			[aPlanBuilder 
				buildForGenericFormulaForRequest: request
				timeSeries: ts
				explicit: isExplicit].
	id formula isLocalizedSchedule 
		ifTrue: [(aPlanBuilder getHeartbeatSourceAt: id formula name) subscribe: ts].
	aPlanBuilder tupleRepository atMsid: id msid put: ts.
	^ts</body>

<body package="PV-CME-Core" selector="addOrUpdatePlanDataWithBuilder:">addOrUpdatePlanDataWithBuilder: aTreeBuilder 
	
	| operatorTs inputTs |
	operatorTs := 
		self 
			buildTimeSeriesForMsid: self ownerTimeSeriesMsid
			metricId: self ownerMetricId
			resourceId: self ownerResourceId
			label: self ownerTimeSeriesLabel
			requestId: self ownerRequestId
			isExplicit: (aTreeBuilder isMyLabel: self ownerTimeSeriesLabel)
			withBuilder: aTreeBuilder.
	operatorTs shouldFire: (aTreeBuilder isMyLabel: self ownerTimeSeriesLabel).
	inputTs := 
		self 
			buildTimeSeriesForMsid: self inputTimeSeriesMsid
			metricId: self inputMetricId
			resourceId: self inputResourceId
			label: self inputTimeSeriesLabel
			requestId: self inputRequestId
			isExplicit: (aTreeBuilder isMyLabel: self inputTimeSeriesLabel)
			withBuilder: aTreeBuilder.
	inputTs shouldFire: (aTreeBuilder isMyLabel: self inputTimeSeriesLabel).
	operatorTs formula formulaPrototype ifNotNil: 
		[:formula | | contextResource |
		contextResource := self contextResourceId isNil
			ifTrue: [nil]
			ifFalse: [aTreeBuilder pvModel subelementManager getOrCreateNewInactiveItemWithId: self contextResourceId].
		formula 
			addOrUpdateInputForTs: operatorTs
			inputTs: inputTs
			sequenceNumber: self sequenceNumber
			versionDate: self versionDate
			currentResource: contextResource
			withBuilder: aTreeBuilder]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvInputAndTimeSeriesBuildCommand</class-id> <selector>printOn:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvRecomputedRecordWrapper</class-id> <category>converting</category>

<body package="PV-CME-Core" selector="asMetricRecord">asMetricRecord

	^self recomputed</body>
</methods>


<class>
<name>AbstractPlanGeneratingTreeBuilder</name>
<environment>PROVISO</environment>
<super>PROVISO.CmeESTreeBuilder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.AbstractPlanGeneratingTreeBuilder</class-id> <category>testing</category>

<body package="PV-CME-Core" selector="isExecutingPlan">isExecutingPlan
	" Only builders that actually execute the plan activate heartbeat sources "

	^false</body>

<body package="PV-CME-Core" selector="shouldAssignIdsToTimeSeries">shouldAssignIdsToTimeSeries
	" Builders that create new computations answer true; 
	builders that reconstruct computations from some external source answer false "

	" My subclasses generate plan, so I answer true "
	^true</body>
</methods>


<methods>
<class-id>PROVISO.AbstractPlanBasedTreeBuilder</class-id> <category>As yet unclassified</category>

<body package="PV-CME-Core" selector="shouldAssignIdsToTimeSeries">shouldAssignIdsToTimeSeries
	" Builders that create new computations answer true; 
	builders that reconstruct computations from some external representation answer false "

	" My subclasses reconstruct plan, so I answer false "
	^false</body>

<body package="PV-CME-Core" selector="deleteTimeSeriesForMsid:mid:rid:">deleteTimeSeriesForMsid: anMsid mid: metricId rid: resourceId 

	" Remove stuff looking up only by msid "

	" First, by msid "
	self tupleRepository atMsid: anMsid 
		ifPresent: [:presentTimeSeries |
			(presentTimeSeries metricId ~= metricId or: [presentTimeSeries resourceId ~= resourceId])
				ifTrue: 
					[self system logWarning: #TIME_SERIES_ID_CHANGE
						messageId: #DC100901
						template: 'Time series being deleted: &lt;1p&gt; is registered under msid &lt;2p&gt; as mid=&lt;3p&gt;, rid=&lt;4p&gt;'
						arguments: (Array with: presentTimeSeries id with: anMsid with: metricId with: resourceId)].
			self tupleRepository removeMsid: presentTimeSeries msid.
			presentTimeSeries disconnect]
		ifAbsent: [].</body>
</methods>

<methods>
<class-id>PROVISO.AbstractPlanBasedTreeBuilder</class-id> <category>testing</category>

<body package="PV-CME-Core" selector="isExecutingPlan">isExecutingPlan
	" Only builders that actually execute the plan activate heartbeat sources "

	^true</body>
</methods>


<class>
<name>MockRequestEnumerator</name>
<environment>PROVISO</environment>
<super>PROVISO.CmeESTreeBuilder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>requests matchBlock prunerClass </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>testing</category>

<body package="PV-CME-Core" selector="shouldAssignIdsToTimeSeries">shouldAssignIdsToTimeSeries
	" Builders that create new computations answer true; 
	builders that reconstruct computations from some external source answer false "

	" My subclasses generate plan, so I answer true "
	^true</body>

<body package="PV-CME-Core" selector="isExecutingPlan">isExecutingPlan
	" Only builders that actually execute the plan activate heartbeat sources "

	^true</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>initialize-release</category>

<body package="PV-CME-Core" selector="initialize">initialize
	
	super initialize.
	requests := OrderedCollection new.
	self beForAssociations.
	prunerClass := CmeESTreePruner</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="emulateCmeTreeBulder">emulateCmeTreeBulder
	
	self matchBlock: 
		[:arr :bucket | 
		self fullTreeBuildFlag or: 
			[self pvModel resyncAgent dirtySubelements anySatisfy: 
				[:eachSe | eachSe id = arr last]]]</body>

<body package="PV-CME-Core" selector="associations:">associations: aCollection 
	
	self pvModel requestManager
		initialize; 
		relink.
	self requests: (aCollection collect: [:assoc | self newRequestForFormula: assoc key resource: assoc value])</body>

<body package="PV-CME-Core" selector="formulas">formulas 
	
	^IdentitySet new addAll: (self requests collect: [:each | each formula])</body>

<body package="PV-CME-Core" selector="beForAssociations">beForAssociations
	
	matchBlock := 
		[:arr :node | 
		self requests noneSatisfy: 
			[:eachRequest | eachRequest formula id = arr first and: [eachRequest target id = arr last]]]</body>

<body package="PV-CME-Core" selector="resources">resources

	^IdentitySet new
		addAll: (self requests collect: [:each | each target]); 
		yourself</body>

<body package="PV-CME-Core" selector="beForIncrementalTreeBuild">beForIncrementalTreeBuild

	self matchBlock: [:arr :bucket | 
		self pvModel resyncAgent dirtySubelements anySatisfy: [:eachSe | eachSe id = arr last]].</body>

<body package="PV-CME-Core" selector="requests:">requests: aCollection

	requests := aCollection</body>

<body package="PV-CME-Core" selector="requests">requests

	^requests</body>

<body package="PV-CME-Core" selector="replaceAssociationsWith:">replaceAssociationsWith: aCollection

	self associations: aCollection</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>building</category>

<body package="PV-CME-Core" selector="build">build

	PvFormulaLinker linkFormulas: (self requests collect: [:e | e formula]) inPvModel: self pvModel.
	super build</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>private</category>

<body package="PV-CME-Core" selector="newRequestForFormula:resource:">newRequestForFormula: aFormula resource: aSubelement

	| request |
	request := 
		PvRequest new
			id: self pvModel getNextId; 
			targetType: 'alias'; 
			target: aSubelement; 
			targetIndex: aSubelement id; 
			period: 900; 
			status: 'active'; 
			storageState: 'always'; 
			origin: 'Smalltalk'; 
			formulaIndex: aFormula id; 
			formula: aFormula; 
			yourself.
	self pvModel requestManager addItem: request.
	^request</body>
</methods>

<methods>
<class-id>PROVISO.MockRequestEnumerator</class-id> <category>enumerating</category>

<body package="PV-CME-Core" selector="do:">do: aBlock 

	self requests do: 
		[:request | 
		aBlock 
			value: request
			value: request target]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associateTimeSeries:withRequest:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associationsToIgnore:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>timeSeriesToRequests:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>newRequestForFormula:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associationsToIgnore</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>associations</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRequestEnumerator</class-id> <selector>timeSeriesToRequests</selector>
</remove-selector>

<methods>
<class-id>PROVISO.SlePlanBasedBuilder</class-id> <category>private</category>

<body package="PV-CME-Core" selector="buildRaBuckets">buildRaBuckets
	
	| time |	
	self shouldBuildRaAndGaBuckets: true.
	self system 
		logDebugTwo: #CME_PLAN_STEP 
		text: 'Building RA buckets'. 
	time := 
		Time millisecondsToRun: 
			[self rawData do: 
				[:timeSeries | | hasContextChanged |
				"Determine all the contexts in which you need to rebuild this time series's RAs in.
				This might include timeSeries resource or any of its context resources if they are dirty "
				hasContextChanged := timeSeries isNew or: [self resyncAgent fullTreeBuildFlag].
				hasContextChanged 
					ifFalse: 
						[timeSeries contextResourcesDo: 
							[:eachResource | 
							(self resyncAgent dirtySubelements includes: eachResource) 
								ifTrue: [hasContextChanged := true]]].
				"If any of our contexts have changed then unmark all ras for this timeseries and rebuild 
				them for each contextResource &amp; the timeSeries resource"
				hasContextChanged
					ifTrue:
						[timeSeries prepareDependentRaRecordsForUpdate.
						timeSeries contextResourcesDo: 
							[:eachResource | 
							self
								buildRaBucketsForTimeSeries: timeSeries
								contextResource: eachResource]]]].
	self shouldBuildRaAndGaBuckets: false.
	self system
		logDebugTwo: #CME_PLAN_STAT 
		text: 'Finished building RA buckets in ', (time // 1000) printString, ' seconds'.</body>

<body package="PV-CME-Core" selector="buildResourceBuckets">buildResourceBuckets
	" Since we are building the tree ebfore we have resources, we cannot build RA/GA buckets
	until after we completed loading all the resources. Therefore we disable building RA/GA buckets initially "
	
	| metadataTime1 buildTime1 metadataTime2 buildTime2 |

	"Mark all ts as old so that we know what is new"
	self rawData do: [:timeSeries | timeSeries beOld].

	self shouldBuildRaAndGaBuckets: false.
	self resyncAgent resync: 
		[self resyncAgent markCurrentObjects.		" This is how we will know which resources are new "
		metadataTime1 := 
			Time millisecondsToRun: [self resyncGlobalMetadata].
		buildTime1 := Time millisecondsToRun: 
			[self recompileTimeSeriesForFormulaChanges.
			self buildExternalTimeSeries.
			self buildTimeSeriesAndInputs.
			self processTimeSeriesDeletes].
		metadataTime2 := Time millisecondsToRun: 
			[" Populate resource id temp table which will drive resynching of all resource-related data "
			self populateTempTable.
			" Now resync all the interesting resource details "
			self resyncAgent 
				resyncFromResourcesDomainManagers: 
						#(elementManager subelementManager propertyManager thresholdManager relationManager)
					between: self metadataStartSeconds
					and: self metadataEndSeconds;
				lastStartSeconds: self metadataStartSeconds;
				lastEndSeconds: self metadataEndSeconds]].
	buildTime2 := Time millisecondsToRun: [self buildRaBuckets].
	self stats
		timingFor: #preHourlyLoadMetadataSeconds
		is: (metadataTime1 + metadataTime2) // 1000.
	self stats
		timingFor: #preHourlyTreeBuildSeconds
		is: (buildTime1 + buildTime2) // 1000.</body>

<body package="PV-CME-Core" selector="populateTempTable">populateTempTable
	
	| rows row insertStatement numberInserted totalInserted time rowStream chunkOfRows |
	self system 
		logDebugTwo: #CME_PLAN_STEP
		text: 'Writing resource temp table for ' , 
			self pvModel subelementManager itemCount printString , ' subelements'.
	totalInserted := 0.
	time := 
		Time millisecondsToRun: 
			[self dbSession execute: 'truncate table ' , self subelementTempTableName.
			rows := OrderedCollection new: self pvModel subelementManager itemCount.
			self pvModel subelementManager itemsDo: 
				[:eachSe | 
				row := Array with: eachSe id with: (eachSe isNew ifTrue: ['S'] ifFalse: ['R']).
				rows add: row].
			rowStream := rows readStream.
			chunkOfRows := OrderedCollection new: 10000.
			[rowStream atEnd] whileFalse:
				[chunkOfRows add: rowStream next.
				(chunkOfRows size = 10000 or: [rowStream atEnd])
					ifTrue: 
						[insertStatement := PvDbBulkStatement new: chunkOfRows size.
						numberInserted := 
							insertStatement 
								do: 'insert into gtt_se_resync (idx_resource,str_type) values(:id,:type)'
								onSession: self dbSession
								forRows: chunkOfRows
								withAspects: #(id type).
						chunkOfRows := chunkOfRows fastEmpty.
						totalInserted := totalInserted + numberInserted.
						self dbSession commit]]].
			
	totalInserted ~= self pvModel subelementManager itemCount 
		ifTrue: 
			[PvException generic raiseErrorString: 
				'Number of rows inserted to GTT_SE_RESYNC (' , totalInserted printString , 
					') not equal to the total number of subelements (' , 
						self pvModel subelementManager itemCount printString , ')'].

	self system 
		logDebugTwo: #CME_PLAN_STAT
		text: 
			'Inserted ' , self pvModel subelementManager itemCount printString , 
				' subelements into GTT_SE_RESYNC in ' , (time // 1000) printString , ' seconds'</body>

<body package="PV-CME-Core" selector="buildgroupBuckets">buildgroupBuckets
	
	self shouldBuildRaAndGaBuckets: true.
	super buildgroupBuckets.
	self shouldBuildRaAndGaBuckets: false.</body>

<body package="PV-CME-Core" selector="recompileTimeSeriesForFormulaChanges">recompileTimeSeriesForFormulaChanges
	"by default everything is marked and we only clear things when we know they need to go away"
	
	| formulasToReshape |
	self pvFlag: #TODO.
	" What to do if a formula changes from Smee to Smalltalk or vice versa "
	formulasToReshape := 
		self resyncAgent updatedFormulas select: 
			[:eachPvFormula | eachPvFormula isOperatorFormula and: [eachPvFormula isSmeeFormula]].

	formulasToReshape notEmpty 
		ifTrue: 
			[self rawBucketsDo: 
				[:eachTs | 
				(eachTs owner notNil and: [formulasToReshape includes: eachTs formula]) 
					ifTrue: [eachTs owner recompileWithFormula: eachTs formula formulaPrototype]]]</body>
</methods>

<methods>
<class-id>PROVISO.SlePlanBasedBuilder</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="planStartSeconds">planStartSeconds
	" Plan time to resync "

	^self startSeconds</body>

<body package="PV-CME-Core" selector="planEndSeconds">planEndSeconds
	" Plan time to resync "

	^self endSeconds</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.SlePlanBasedBuilder</class-id> <selector>clearBuckets</selector>
</remove-selector>

<class>
<name>RequestToResourceEnumerator</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractPlanGeneratingTreeBuilder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>requests </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<class>
<name>ResourceToRequestEnumerator</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractPlanGeneratingTreeBuilder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>resources filter resourceIds </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>


<methods>
<class-id>PROVISO.PblPlanFromDatabaseBuilder</class-id> <category>private</category>

<body package="PV-DC-Plan-Builder" selector="buildResourceBuckets">buildResourceBuckets
	
	|  tsCount inputCount tsWalkbacksWritten inputWalkbacksWritten |

	tsCount := 0.
	tsWalkbacksWritten := 0.
	PlanAccessor new 
		planVersionsPast: self lastLoadedPlanVersion
		timeSeriesDo: 
			[:eachRow | 
			[self buildTimeSeriesFromDbRow: eachRow.
			tsCount := tsCount + 1] 
				on: Error
				do: 	
					[:ex | 
					self logErrorBuildTsErrorFrom: eachRow reason: ex.
					tsWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							tsWalkbacksWritten := tsWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , tsCount asString , ' time series from db'.

"Load inputs"
	inputCount := 0.
	inputWalkbacksWritten := 0.
	PlanAccessor new 
		planVersionsPast: self lastLoadedPlanVersion
		inputsDo: 
			[:eachRow | 
			[self buildInputFromDbRow: eachRow.
			inputCount := inputCount + 1] 
				on: Error
				do: 
					[:ex | 
					self logErrorBuildInputErrorFrom: eachRow reason: ex.
					inputWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							inputWalkbacksWritten := inputWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , inputCount asString , ' inputs from db'.

	"Actually assign each ts it's label"
	self rawData do: 
		[:ts | 
		ts streamLabel assignToTimeSeries: ts]</body>
</methods>

<methods>
<class-id>PROVISO.PblPlanFromDatabaseBuilder</class-id> <category>testing</category>

<body package="PV-DC-Plan-Builder" selector="isExecutingPlan">isExecutingPlan
	" Only builders that actually execute the plan activate heartbeat sources "

	^false</body>
</methods>


<methods>
<class-id>PROVISO.PlanBuilderTimeSeries</class-id> <category>user interface</category>

<body package="PV-DC-Plan-Builder" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc |
	details := OrderedCollection new.
	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	self tupleRepository ifNotNil: [:rep | |specificNode|
		rep 
			specificTimeseriesFor: self 
			do: [:eachSpecificTs |
				specificNode := ObjectLabel key: 'Specific: ', eachSpecificTs pvTreeViewLabelString value: eachSpecificTs.
				details add: specificNode]
	].
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			[liveTsAssoc := self getMyTimeSeries.
			moreDetails add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly.
			moreDetails add: (ObjectLabel key: 'Label: ' , obj printString value: obj).
			moreDetails asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for ', self printString, '...' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			yourself).

	^details asArray</body>
</methods>


<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>hook</category>

<body package="PV-DC-Plan-Builder" selector="hookPreRun">hookPreRun
	
	self logMemoryPolicy.
	self logMemoryStats.

	"what happens if current hr is nil"
	"self currentHour: PvTimestamp now."

	self pvModel
		initializeForPlanBuilder;
		initIdManager.
	self pvModel resyncAgent server: self.

	self replayAllPendingTransactions.

	self restoreStateFromDisk.
	self deleteFailedBuildState.
	self planAndMetadataDumperLoader: (PblPlanAndMetadataDumperLoader forHighestVersionPlanBuilder: self).
	self planAndMetadataDumperLoader versionDirectory exists
		ifTrue: 
			[self planAndMetadataDumperLoader
				restoreCollectorState;
				restoreOperatorState].
	self loadLabelDefinitionsFromDatabase.
	self setTimeInPlanForCollectorLabels.

	"Resync and build the plan but do NOT save it because it already exists in the db"
	PlanAccessor new hasInitialPlanInDatabase 
		ifTrue: 
			[self updateMetadata: true.
			self loadPlan]
		ifFalse:
			[self logInitCollectorTimesFromDb.
			PlanAccessor new collectorTimesInDbDo: 
				[:col :timestamp | 
				(PlanBuilder isValidCollectorLabelId: col)
					ifTrue: [self updateProgressFor: col to: timestamp]]].</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>api TSE</category>

<body package="PV-DC-Plan-Builder" selector="updateProgressFor:to:">updateProgressFor: collNum to: seconds 
	"This method should be called by TupleStorage or a collector itself to tell the plan 
	builder that this collector (id) has moved forward in time.
	Return nil if the advancement was ignored"
	
	| timestamp |
	timestamp := PvTimestamp fromSeconds: seconds.
	self logReceivedAdvanceCollectorRequest: 
		'Received notification from tuple storage that collector ' , 
		collNum printString , ' has advanced to ' , timestamp printString.

	(PlanBuilder isValidCollectorLabelId: collNum)
		ifFalse: 
			[self logReceivedAdvanceCollectorRequest: 
				'Ignoring collector advancement for ' , collNum printString , 
				' advancing to ' , timestamp printString , ' because invalid collector number'.
			^nil].
	seconds &gt; self timeFacade nowAsSeconds 
		ifTrue: 
			[self logReceivedAdvanceCollectorRequest: 
				'Ignoring collector advancement for ' , collNum printString , 
				' advancing to ' , timestamp printString , ' because collectors cannot advance into the future'.
			^nil].

	self advanceMutex critical: 
		[self advanceCollectorRequests add: collNum -&gt; seconds.
		self saveAdvanceCollectorRequestsState.

		"Always give back the greater of the  2"
		^self versionBeingBuilt ifNil: [self versionLastBuilt]]</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>state save/restore</category>

<body package="PV-DC-Plan-Builder" selector="upgradeStateFromKilaToLulu">upgradeStateFromKilaToLulu
	
	| dl stateDir |
	self fileInterface stateDirectory copyDirectoryTo: 
		(self fileInterface subsystemDirectory construct: 'backupOfStateBeforeUpgrade').
	self
		restoreState;
		saveAdvanceCollectorRequestsState;
		saveStateLabelChangeHistory;
		saveVersionBeingBuilt: self versionBeingBuilt
			advanceCollectorRequests: 
				(self advancingCollectorLabels asArray collect: 
					[:e | 
					e id -&gt; e collectorTimeNow]);
		saveStateVersionLastBuilt.
	self advancingCollectorLabels do: [:e | e collectorTimeNow: e collectorTimeInPlan].
	(dl := 
		PblPlanAndMetadataDumperLoader 
			forVersion: self versionLastBuilt
			planBuilder: self)
		makeVersionDirectory;
		saveOperatorState;
		saveCollectorState.
	stateDir := self fileInterface stateDirectory.
	dl planAndMetadataFilenames do: [:each | self fileInterface moveFilename: stateDir , each tail toFilename: each].
	(stateDir , 'planVersion.state') exists 
		ifTrue: [(self fileInterface stateDirectory construct: 'planVersion.state') delete].
	self planBuilderStateFilename delete</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>plan building</category>

<body package="PV-DC-Plan-Builder" selector="handleBuiltGenericTimeSeries:for:">handleBuiltGenericTimeSeries: genericTs for: specificTs 
	"A ts for a generic formula should have the same label as the specific formula's ts"	

	| cNum labelToAssign specificLabels | 
	cNum := self getCollectorNumberForTimeSeries: genericTs.
	labelToAssign :=
		(cNum isNil or: [cNum = 0])
			ifTrue: [self operatorLabelZero]
			ifFalse: [self collectorLabelForId: cNum].

	specificLabels := Set new.
	genericTs formula specificFormulas do: 
		[:specificFormula | 
		(self atMid: specificFormula id rid: genericTs resourceId) ifNotNil: 
			[:ts | specificLabels add: ts streamLabel]].
	specificLabels size = 1
		ifTrue: [labelToAssign := specificLabels anyOne]
		ifFalse: 
			[specificLabels size &gt; 1 
				ifTrue: [self logMultipleSpecific: specificLabels toGeneric: genericTs]].

	self 
		changeLabelForTimeSeries: genericTs 
		to: labelToAssign</body>

<body package="PV-DC-Plan-Builder" selector="buildPlan:">buildPlan: aBlock 
	"PlanBuilderApplication new startWithCommandLine: 'vm image -a PBL -name PBL -f ../conf/dc.cfg '  "
	
	| hadChanges dl |
	self versionBeingBuilt
		ifNil: [self setAdvancementsForVersionBeingBuilt].
	
	hadChanges := false.
	dl := PblPlanAndMetadataDumperLoader forVersion: self versionBeingBuilt planBuilder: self.
	self initiateCollectorAdvancement.
	self logAboutToUpdatePlan.
	self advancingCollectorLabels isEmpty 
		ifTrue: [self logNoMeaningfulAdvancements]
		ifFalse: 
			[aBlock 
				ifNil: 
					[self updateMetadata: false.
					self buildAndPruneTrees.
					self saveLabelRelationshipsToDatabase.
					hadChanges := self planSaver hasChanges.
					self savePlanToDatabase]
				ifNotNil: 
					[aBlock value.
					hadChanges := self planSaver hasChanges]].
	self completeCollectorAdvancement.
	
	"Save in the main state dir"
	self saveStateLabelChangeHistory.

	"Save all these files in the versionBeingBuilt directory"
	dl
		makeVersionDirectory;
		saveCollectorState;
		saveOperatorState;
		dumpCachedPlanAndMetadata;
		recordPlanRowsInserted: hadChanges.

	"Once we do this it is comitted.  If we don't do this then when PBL 
	restarts we will wipe out the plan and state from disk for the version 
	being built and start over"
	self resetAdvancementsForVersionBeingBuilt.

	"Now that it is committed, go delete big state files from previous versions 
	and make sure we only keep around the most recent N versions of state"
	dl deletePlanAndMetadataFromDiskForAllPreviousVersions.</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>logging</category>

<body package="PV-DC-Plan-Builder" selector="logNoMeaningfulAdvancements">logNoMeaningfulAdvancements

	self system 
		logInfo: #NO_MEANINGFUL_ADVANCEMENTS
		messageId: nil
		text: 'There were no meaningful collector advancements.  Skipping metadata resync, tree build, db save'.</body>

<body package="PV-DC-Plan-Builder" selector="logSavePlanError">logSavePlanError
	&lt;comment: 'Stopping plan builder because plan save to db failed' 
	probableCause: 'Could be duplicate rows, database error, Smalltalk exception, or something else'
	suggestedAction: 'Restart the plan builder'&gt;

	self system 
		logWarning: #PLAN_SAVE_ERROR
		messageId: #DC10009
		text: 'Stopping plan builder because plan save to db failed'.</body>

<body package="PV-DC-Plan-Builder" selector="logMultipleSpecific:toGeneric:">logMultipleSpecific: specificLabels toGeneric: aTimeSeries

	| specificFormulas |
	specificFormulas := (aTimeSeries specificFormulas collect: [:e | e nameString]) asArray.
	self system
		logWarning: #MULTIPLE_SPECIFIC_TO_GENERIC
		messageId: #DC10010
		text: 'There are multiple specific formulas: ', specificFormulas printString ,' for this generic formula: ' , aTimeSeries id printString , '. These specific formulas are for the same resource and reside in different labels ', specificLabels asArray printString.</body>
</methods>


<methods>
<class-id>PROVISO.PlanAccessor</class-id> <category>pbl support</category>

<body package="PV-DC-Plan-Builder" selector="collectorTimesInPlan:do:">collectorTimesInPlan: collectorNums do: aBlock 

	collectorNums do: 
			[:cNum | | time |
			time := 0.
			[time := (self dbSession
						executeSelect: 'select max(dte_date) from ts_desc where int_label = ' 
								, cNum printString) first first] 
					on: Error
					do: [:err | ].
			time ifNil: [time := 0].
			time := 0 max: time.
			aBlock value: cNum value: time]</body>
</methods>


<methods>
<class-id>PROVISO.PblPlanFromDiskBuilder</class-id> <category>As yet unclassified</category>

<body package="PV-DC-Plan-Builder" selector="buildResourceBuckets">buildResourceBuckets

	| tsCount inputCount tsWalkbacksWritten inputWalkbacksWritten |
	

"Load timeSeries"
	tsCount := 0.
	tsWalkbacksWritten := 0.
	self planBuilder planAndMetadataDumperLoader 
		timeSeriesDo: 
			[:eachRow | 
			[self buildTimeSeriesFromDbRow: eachRow.
			tsCount := tsCount + 1] 
				on: Error
				do: 	
					[:ex | 
					self logErrorBuildTsErrorFrom: eachRow reason: ex.
					tsWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							tsWalkbacksWritten := tsWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , tsCount asString , ' time series from disk'.

"Load inputs"
	inputCount := 0.
	inputWalkbacksWritten := 0.
	self planBuilder planAndMetadataDumperLoader 
		inputsDo: 
			[:eachRow | 
			[self buildInputFromDbRow: eachRow.
			inputCount := inputCount + 1] 
				on: Error
				do: 
					[:ex | 
					self logErrorBuildInputErrorFrom: eachRow reason: ex.
					inputWalkbacksWritten &gt; 2 
						ifFalse: 
							[PvWalkbackWriter new dumpWalkbackForException: ex.
							inputWalkbacksWritten := inputWalkbacksWritten + 1]]].
	self system logDebugTwo: #PLAN_STAT text: 'Loaded ' , inputCount asString , ' inputs from disk'.

	"Actually assign each ts it's label"
	self rawData do: 
		[:ts | 
		ts streamLabel assignToTimeSeries: ts]</body>
</methods>



<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PlanAccessor</class-id> <selector>forLabelNameAndTSCountDo:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.LoadBalancer</class-id> <category>external accessing</category>

<body package="PV-DC-Load-Balancer" selector="cmeInformationForLabel:">cmeInformationForLabel: aLabel

	| tempImage tempAppSpec tempCmeInfo labelNumber |
	labelNumber := aLabel asInteger.
	tempCmeInfo := CmeInformation new.
	tempCmeInfo addMessage: Character cr asString.
	tempImage := self imageForLabel: labelNumber.
	tempImage
		ifNil: [ tempCmeInfo reportNoImageForLabel: labelNumber printString ]
		ifNotNil: [ tempAppSpec := self channelManager applicationSpecNamed: tempImage name.
				tempAppSpec
					ifNil: [ tempCmeInfo reportNoAppSpec ]
					ifNotNil: [ tempCmeInfo imageName: tempAppSpec name.
								tempCmeInfo running: (self channelManager isApplicationSpecRunning: tempAppSpec).
								tempCmeInfo reportCmeImageRunning: tempCmeInfo running]].
	^tempCmeInfo.</body>
</methods>

<methods>
<class-id>PROVISO.LoadBalancer</class-id> <category>sleMovePrivate</category>

<body package="PV-DC-Load-Balancer" selector="cmeWithSleLabel:">cmeWithSleLabel: sleLabelName
	"Return a DST proxy for the CME with the given SLE."

	| labelNumber cmeImage |
	labelNumber := sleLabelName asInteger.
	cmeImage := self imageForLabel: labelNumber.
	^cmeImage isNil
		ifTrue: [nil]
		ifFalse: [(PvDSTFacade getObjectNamed: cmeImage name) server].</body>
</methods>



<methods>
<class-id>PROVISO.PvHourlyLoaderFileMonitor</class-id> <category>private</category>

<body package="PV-LDR" selector="deleteMalformedInputFiles:">deleteMalformedInputFiles: loaderDataFilesToDelete 
	
	| loadSet cls |
	loaderDataFilesToDelete do: 
		[:eachDataFile | 
		| source dest |
		source := eachDataFile asFilename.
		dest := self fileInterface fileInDoneDirectoryForFilename: eachDataFile asFilename.
		self logMoveMalformedFile: source toDone: dest.
		" Make sure we record time progression on this subchannel/data type "
		cls := self loader class loadSetClassByDataType 
					at: eachDataFile dataType
					ifAbsent: [PvException generic raiseErrorString: 'No load set for data type!'].
		loadSet := cls new.
		loadSet
			loader: self loader;
			timestamp: (PvTimestamp fromString: eachDataFile filename directory tail);
			dataType: eachDataFile dataType;
			aggSet: eachDataFile aggSet;
			allFiles: (OrderedCollection with: eachDataFile);
			filesToMerge: (OrderedCollection with: eachDataFile).
		loadSet registerLoad.
		self fileInterface 
			moveFilename: source
			toFilename: dest]</body>
</methods>



<methods>
<class-id>PROVISO.RecomputationAction</class-id> <category>action</category>

<body package="PV-DC-Recomputations" selector="applyTo:">applyTo: aCollection
	"Apply the receiver to the given collection of metric records."

	self isDelete
		ifTrue: [ | toRemove |
			toRemove := aCollection 
				detect: [:each | each metricId = self metricId 
					and: [each resourceId = self resourceId 
						and: [each timestamp = self timestamp
							and: [each value = self value]]]]
				ifNone: [^self].
			aCollection remove: toRemove ifAbsent: [].
			^self].

	"Check for an already existing tuple first..."
	aCollection do: [:each |
		(self appliesTo: each)
			ifTrue: [
				each value: self value.
				^self]].
	"We didn't find it, so just do an insert..."
	aCollection add: (RecomputationMetricRecordWrapper on: self asMetricRecord).
	^self</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationAction</class-id> <category>converting</category>

<body package="PV-DC-Recomputations" selector="asMetricRecord">asMetricRecord
	"Answer the receiver converted to a metric record."

	^PvMetricRecord currentSparseMetricRecordClass new
		metricId: self metricId;
		resourceId: self resourceId;
		timestamp: self timestamp;
		value: self value;
		yourself</body>

<body package="PV-DC-Recomputations" selector="asRecomputationRecord">asRecomputationRecord

"	record := (PvRecomputationRecord0407
		metricId: self metricId
		resourceId: self resourceId
		date: self timestamp 
		value: self value)	
			referenceDate: 
			beActionDelete;
			yourself"</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationAction</class-id> <category>accessing</category>

<body package="PV-DC-Recomputations" selector="pollId">pollId
	" default implementation for the pollId, is simply the timestamp of the measure within the current hour"
	
	^self date \\ 3600</body>

<body package="PV-DC-Recomputations" selector="valueString">valueString

	^self value printString</body>
</methods>


<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>initialize-release</category>

<body package="PV-DC-Recomputations" selector="resetTupleRepositoryFor:">resetTupleRepositoryFor: aRecomputationEngine

	aRecomputationEngine tupleRepository initialize.</body>
</methods>

<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>queries-scope</category>

<body package="PV-DC-Recomputations" selector="getTimestampOf:metricId:resourceId:after:ifAbsent:">getTimestampOf: aNumber
	metricId: aMetricId
	resourceId: aResourceId
	after: aTsNumber
	ifAbsent: absentBlock
	" Answer timestamp of Nth typle with a giver (mid, rid) after aTsnumber. If N is 0, just answer aTsNumber.
	If there aren't enough tuples in the history, evaluate absentBlock "
	
	| coll |
	^aNumber = 0 
		ifTrue: [aTsNumber]
		ifFalse: 
			[coll := 
				(self metricsHistory select: 
					[:eachMetric | 
					eachMetric metricId = aMetricId 
						and: [eachMetric resourceId = aResourceId]
						and: [eachMetric timestamp &gt; aTsNumber]]) asSortedCollection: 
							[:x :y | x timestamp &lt; y timestamp].
			coll size &gt;= aNumber 
				ifTrue: [(coll at: aNumber) timestamp]
				ifFalse: [absentBlock value]]</body>

<body package="PV-DC-Recomputations" selector="getTimestampOf:metricId:resourceId:before:ifAbsent:">getTimestampOf: aNumber
	metricId: aMetricId
	resourceId: aResourceId
	before: aTsNumber
	ifAbsent: absentBlock
	" Answer timestamp of Nth typle with a giver (mid, rid) before aTsnumber. If N is 0, just answe aTsNumber.
	If there aren't enough tuples in the history, evaluate absentBlock "
	
	| coll |
	^aNumber = 0 
		ifTrue: [aTsNumber]
		ifFalse: 
			[coll := 
				(self metricsHistory select: 
					[:eachMetric | 
					eachMetric metricId = aMetricId 
						and: [eachMetric resourceId = aResourceId]
						and: [eachMetric timestamp &lt;= aTsNumber]]) asSortedCollection: 
							[:x :y | x timestamp &gt; y timestamp].
			coll size &gt;= aNumber 
				ifTrue: [(coll at: aNumber) timestamp]
				ifFalse: [absentBlock value]]</body>
</methods>

<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>tuple cache</category>

<body package="PV-DC-Recomputations" selector="initializeTupleCache">initializeTupleCache</body>

<body package="PV-DC-Recomputations" selector="cacheTuples:">cacheTuples: aCollection</body>
</methods>

<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>populating</category>

<body package="PV-DC-Recomputations" selector="addOrReplaceMetric:">addOrReplaceMetric: aMetricRecord
	
	| existing |
	existing := self metricsHistory 
		detect: 
			[:eachMetric | 
			eachMetric metricId = aMetricRecord metricId and:
				[eachMetric resourceId = aMetricRecord resourceId and:
					[eachMetric timestamp = aMetricRecord timestamp]]]
		ifNone: [nil].
	existing 
		ifNil: [self metricsHistory add: aMetricRecord]
		ifNotNil: [existing value: aMetricRecord value].</body>
</methods>

<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>queries</category>

<body package="PV-DC-Recomputations" selector="getMetricsForMid:rid:between:and:passing:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber passing: recompActions

	^metricsHistory select: [:each |
		each metricId = metricId
			and: [each resourceId = resourceId]
			and: [each timestamp between: startTsNumber and: endTsNumber]]</body>
</methods>

<methods>
<class-id>PROVISO.MockRecomputationQueryInterface</class-id> <category>private</category>

<body package="PV-DC-Recomputations" selector="resyncSubelementWith:">resyncSubelementWith: tsBuildCommand</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.MockRecomputationQueryInterface</class-id> <selector>resyncSubelementWithId:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.RecompTupleInjectionInterface</class-id> <category>tuple storage api</category>

<body package="PV-DC-Recomputations" selector="acceptTuples:from:position:">acceptTuples: aTupleContainer from: aLabel position: aPosition 
	
	aTupleContainer
		label: aLabel;
		position: aPosition.
	self system 
		logInfo: #RECEIVED_TUPLES
		text: 'Received ' , aTupleContainer printString.
	self configureAdaptorsForAllInputLabels.
	(self testMode or: 
		[self fileInterface isFlowControlStateFull not and: 
			[self owner unprocessedTupleContainers size &lt;= 1 or: 
				[self fileInterface haveSpaceForAcquiringTuples and: 
					[self hasEnoughForwardBufferingCapacityFor: aTupleContainer]]]]) 
						ifFalse: [^false].

	aTupleContainer isForRecomputations
		ifFalse: [
			aTupleContainer isHeartbeat
				ifFalse: [
					self system 
						logDebugFour: #NON_RECOMP_TUPLES
						text: ['Received non-recomp tuple container: ' , aTupleContainer printString]].
			self transactionDo: [:txn | 
				aTupleContainer releaseIn: txn.
				"self owner updateLastContainerTimestamp: aTupleContainer timestamp in: txn"].
			^true].


	^(self owner acquireTupleContainer: aTupleContainer) 
		ifNil: [false]
		ifNotNil: 
			[:acquired | 
			self agentQueue nextPut: acquired.
			true]</body>
</methods>

<methods>
<class-id>PROVISO.RecompTupleInjectionInterface</class-id> <category>initialize-release</category>

<body package="PV-DC-Recomputations" selector="initialize">initialize
	
	super initialize.
	self agentQueue: (SharedPriorityQueue sortBlock: [:container1 :container2 | 
		container1 isForRecomputations 
			ifTrue: [
				container2 isForRecomputations 
					ifTrue: [container1 timestamp &lt; container2 timestamp]
					ifFalse: [true]]
				ifFalse: [
					container2 isForRecomputations 
						ifTrue: [false]
						ifFalse: [container1 timestamp &lt; container2 timestamp]]])</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationMetricRecordWrapper</class-id> <category>replay</category>

<body package="PV-DC-Recomputations" selector="replayFor:on:">replayFor: aPlanBasedBuilder on: aTupleRepository 
	"Apply the receiver's record to the tuple repository during a recompute..."
	
	aTupleRepository prepareForHour: self timestamp.
	aTupleRepository onMetric: self record</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationMetadataChangeWrapper</class-id> <category>testing</category>

<body package="PV-DC-Recomputations" selector="isSameAs:">isSameAs: anotherWrapper

	^self record isSameAs: anotherWrapper record</body>
</methods>


<methods>
<class-id>PROVISO.RecompCommandLog</class-id> <category>private-actions</category>

<body package="PV-DC-Recomputations" selector="doRecomputeAll:saveResultsTo:saveActionsTo:originLabel:">doRecomputeAll: aTupleContainerFilename saveResultsTo: aPath saveActionsTo: anotherPath originLabel: originLabel

	| tuples resultPair tupleContainer elapsed |
	Processor yield.
	tupleContainer := (BOFFileContainer fromFilename: aTupleContainerFilename asURI asFilename)
		label: self server outputLabel;
		yourself.

	tuples := OrderedCollection new.
	tupleContainer do: [:each |
		tuples add: each.
		self server changed: #aboutToProcessRecompTuple with: each].
	self server stats incrementMetricRecordsInBy: tuples size.
	self server recompEngine resetTupleRepository.
	elapsed := Time millisecondsToRun: [
		resultPair := self server recompEngine recomputeAll: tuples originLabel: originLabel asNumber.
	].
	self system 
		logDebugTwo: #RECOMP_ALL_PERF
		text: 'Processed ', aTupleContainerFilename asURI asFilename tail asString, 'with ', tuples size asString, ' actions in ', elapsed asString, 'ms'.
	self fileInterface
		saveRecompTuples: resultPair first to: aPath asURI asFilename;
		saveRecompTuples: resultPair last to: anotherPath asURI asFilename.</body>
</methods>


<class>
<name>RecomputationQueryInterface</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractRecomputationQueryInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>tupleStorage tupleCache </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DC-Recomputations</category>
<attributes>
<package>PV-DC-Recomputations</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>private</category>

<body package="PV-DC-Recomputations" selector="resyncPropertiesFor:resource:atOrBefore:">resyncPropertiesFor: formula resource: subelement atOrBefore: aTsNumber

	self dbSession
		readObjectsOfClass: PvProperty
		with: 
'SELECT /*+ PUSH_SUBQ */
  t1.DTE_DATE "date", t1.IDX_METRIC "metricId", t1.IDX_RESOURCE "resourceId", t1.STR_HIST_ACTION "resyncAction", t1.STR_VALUE "value" 
  from prop_desc_hist t1
  where t1.idx_metric = :1 
  and t1.idx_resource = :2 
  and t1.dte_hist_date &lt;= :3
  and t1.dte_hist_date = 
      (select max(dte_hist_date) 
          from prop_desc_hist t2 
          where t2.idx_metric = t1.idx_metric 
            and t2.idx_resource = t1.idx_resource 
            and t2.dte_hist_date &lt;= :3)'
		bindVars: 
			(Array with: formula id with: subelement id with: aTsNumber)
		into: [:each |
			each formula: formula.
			subelement addProperty: each.
			self pvModel propertyManager resyncFrom: each].
	self pvModel resyncAgent commitResync.</body>

<body package="PV-DC-Recomputations" selector="resyncSubelementWith:">resyncSubelementWith: tsBuildCommand

	PvCmeSubelement
		getSubelementChangesForId: tsBuildCommand resourceId 
		from: 0 
		to: tsBuildCommand resyncHistoricalDate
		do: [:each | self pvModel subelementManager resyncFrom: each].
	self pvModel resyncAgent commitResync.</body>

<body package="PV-DC-Recomputations" selector="applyAdjustments:to:">applyAdjustments: adjustments to: tuples
	"Apply the given set of adjustments to the given collection of tuples. Answer the new collection of tuples."

	adjustments do: [:eachAdjustment |
		eachAdjustment asRecomputationAction applyTo: tuples].

	"Since applying the recomp actions builds recomp wrappers, we need to strip those out..."
	^tuples collect: [:each |
		(each isKindOf: RecomputationWrapper)
			ifTrue: [each record]
			ifFalse: [each]].</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>queries-scope</category>

<body package="PV-DC-Recomputations" selector="getFirstAvailable:metricsForMid:rid:before:">getFirstAvailable: aNumber metricsForMid: aMetricId rid: aResourceId before: startTsNumber
	"&lt;OrderedCollection&gt; Answer collection of first N (tuples with a given (mid, rid) before startTsnumber. If N is 0, answer empty collection. "

	^(self 
		queryTupleStorageWith: #getFirstAvailable:metricsForMid:rid:before: 
		arguments: 
			(Array 
				with: aNumber 
				with: aMetricId
				with: aResourceId
				with: startTsNumber))

"NOTE - if Recomputation ever uses this method, this method has to be updated to take 'tupleCache' into account..."</body>

<body package="PV-DC-Recomputations" selector="getAvailableMetricsForMid:rid:from:to:count:">getAvailableMetricsForMid: aMetricId rid: aResourceId from: startTsNumber to: stopTsNumber count: aNumber
	"&lt;OrderedCollection&gt; Answer collection tuples with a given (mid, rid) between startTsnumber and stopTsNumber plus aNumber of tuples beyond. "

	^(self 
		queryTupleStorageWith: #getAvailableMetricsForMid:rid:from:to:count: 
		arguments: 
			(Array 
				with: aMetricId
				with: aResourceId
				with: startTsNumber
				with: stopTsNumber
				with: aNumber))

"NOTE - if Recomputation ever uses this method, this method has to be updated to take 'tupleCache' into account..."</body>

<body package="PV-DC-Recomputations" selector="getTimestampOf:metricId:resourceId:before:ifAbsent:">getTimestampOf: aNumber
	metricId: aMetricId
	resourceId: aResourceId
	before: aTsNumber
	ifAbsent: absentBlock
	" Answer timestamp of Nth typle with a giver (mid, rid) before aTsnumber. If N is 0, just answe aTsNumber.
	If there aren't enough tuples in the history, evaluate absentBlock "

	| timestamps cachedTimestamps mergedSet count |
	timestamps := (self 
		queryTupleStorageWith: #getTimestampsOf:metricId:resourceId:before:adjTime:
		arguments: 
			(Array 
				with: aNumber 
				with: aMetricId
				with: aResourceId
				with: aTsNumber
				with: '+infinity')) ifNil: [#()].

	cachedTimestamps := (self cachedMetricsForMid: aMetricId rid: aResourceId between: 0 and: aTsNumber)
		collect: [:each | each timestamp].

	(timestamps isEmpty and: [cachedTimestamps isEmpty])
		ifTrue: [^absentBlock value].

	"Special case - we didn't find anything in the first query, so return the first cached value."
	(timestamps size = 1 and: [timestamps first = aTsNumber and: [cachedTimestamps notEmpty]])
		ifTrue: [^cachedTimestamps last].

	mergedSet := MergeSortStream
		onAll: (Array 
			with: (ReadStream on: timestamps)
			with: (ReadStream on: cachedTimestamps))
		sortBlock: [:a :b | a &gt; b].

	count := 0.
	[mergedSet atEnd] whileFalse: [
		| timestamp |
		timestamp := mergedSet next.
		count := count + 1.
		count = aNumber
			ifTrue: [^timestamp]].

	^aTsNumber</body>

<body package="PV-DC-Recomputations" selector="getTimestampOf:metricId:resourceId:after:ifAbsent:">getTimestampOf: aNumber
	metricId: aMetricId
	resourceId: aResourceId
	after: aTsNumber
	ifAbsent: absentBlock
	" Answer timestamp of Nth typle with a giver (mid, rid) after aTsnumber. If N is 0, just answe aTsNumber.
	If there aren't enough tuples in the history, evaluate absentBlock "

	| timestamps cachedTimestamps mergedSet count |
	timestamps := (self 
		queryTupleStorageWith: #getTimestampsOf:metricId:resourceId:after:adjTime:
		arguments: 
			(Array 
				with: aNumber 
				with: aMetricId
				with: aResourceId
				with: aTsNumber
				with: '+infinity')) ifNil: [#()].

	cachedTimestamps := (self cachedMetricsForMid: aMetricId rid: aResourceId between: aTsNumber and: Infinity positive)
		collect: [:each | each timestamp].

	(timestamps isEmpty and: [cachedTimestamps isEmpty])
		ifTrue: [^absentBlock value].

	"Special case - we didn't find anything in the first query, so return the first cached value."
	(timestamps size = 1 and: [timestamps first = aTsNumber and: [cachedTimestamps notEmpty]])
		ifTrue: [^cachedTimestamps first].

	mergedSet := MergeSortStream
		onAll: (Array 
			with: (ReadStream on: timestamps)
			with: (ReadStream on: cachedTimestamps))
		sortBlock: [:a :b | a &lt;= b].

	count := 0.
	[mergedSet atEnd] whileFalse: [
		| timestamp |
		timestamp := mergedSet next.
		count := count + 1.
		count = aNumber
			ifTrue: [^timestamp]].

	^aTsNumber</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>tuple cache</category>

<body package="PV-DC-Recomputations" selector="cachedMetricsForMid:rid:between:and:">cachedMetricsForMid: mid rid: rid between: startTimestamp and: endTimestamp
	"Private - Return a collection of tuples from the receiver's cache, that meet the given criteria.
	Note that there is no ordering implied between startTimestamp and endTimestamp, and either
	one can be +/- infinity."

	| tuples start end |
	tuples := tupleCache atMid: mid rid: rid ifAbsent: [^#()].
	startTimestamp &lt;= endTimestamp
		ifTrue: [
			start := startTimestamp.
			end := endTimestamp]
		ifFalse: [
			start := endTimestamp.
			end := startTimestamp].
	^(tuples select: [:each | each timestamp between: start and: end]) asSortedCollection</body>

<body package="PV-DC-Recomputations" selector="cacheTuples:">cacheTuples: aCollection

	aCollection do: [:each |
		| midRidTuples |
		midRidTuples := tupleCache
			atMid: each metricId 
			rid: each resourceId ifAbsentPut: [Set new].
		"We don't want to cache the same tuple twice..."
		midRidTuples add: each].</body>

<body package="PV-DC-Recomputations" selector="initializeTupleCache">initializeTupleCache

	tupleCache := PvMidRidBTree new.</body>

<body package="PV-DC-Recomputations" selector="cacheTuple:">cacheTuple: aTuple

	self cacheTuples: (Array with: aTuple)</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>initialize-release</category>

<body package="PV-DC-Recomputations" selector="initialize">initialize

	super initialize.
	self initializeTupleCache.</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationQueryInterface</class-id> <category>queries</category>

<body package="PV-DC-Recomputations" selector="getMetricsForMid:rid:between:and:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber 
	"Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."
	
	^self getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber passing: #()</body>

<body package="PV-DC-Recomputations" selector="isDuplicate:">isDuplicate: aRecompRecord

	| sql results duplicateOnDb |
	sql := 'select count(*) from MTRC00_SNRW_000_FULL where idx_metric = %1 and idx_resource = %2 and dte_date = %3 and dte_adj_date = %4 and idx_event = %5' bindWithArguments: { aRecompRecord metricId asString . aRecompRecord resourceId asString . aRecompRecord referenceDate asString . aRecompRecord date asString . aRecompRecord eventId asString }.
	results := self dbSession executeSelect: sql.
	duplicateOnDb := results isEmpty
		ifTrue: [false]
		ifFalse: [results first first &gt; 0].
	duplicateOnDb
		ifTrue: [^true].

	^((tupleCache atMid: aRecompRecord metricId rid: aRecompRecord resourceId ifAbsent: [^false])
		detect: [:each |
			(each isActionUpdate | each isActionInsert) and: [
				each referenceDate = aRecompRecord referenceDate and: [
					each date = aRecompRecord date and: [
						each eventId = aRecompRecord eventId]]]]
		ifNone: [nil]) notNil</body>

<body package="PV-DC-Recomputations" selector="getLastTimeSeriesWithId:atOrBefore:">getLastTimeSeriesWithId: anMsid atOrBefore: aTsNumber 

	| all |
	all := OrderedCollection new.
	self dbSession
		readObjectsOfClass: PvTimeSeriesBuildCommand
		with: (PvTimeSeriesBuildCommand selectStatementForLastMsid: anMsid atOrBefore: aTsNumber)
		into: [:each | 
			each pvModel: self pvModel.
			all add: each].

	^self 
		getMostRecentEntryFrom: all
		atOrBefore: aTsNumber</body>

<body package="PV-DC-Recomputations" selector="getMetricsForMid:rid:between:and:passing:">getMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber passing: passingTuples
	"Ask tuple storage for the set of metric records in the given timeframe, with the given mid/rid."

	| tuples cachedTuples |
	tuples := self 
		queryTupleStorageWith: #getMetricsForMid:rid:between:and:adjTime:passing:
		arguments: 
			(Array 
				with: metricId
				with: resourceId
				with: (self encodeInfinity: startTsNumber)
				with: (self encodeInfinity: endTsNumber)
				with: '+infinity'
				with: passingTuples).
	cachedTuples := self cachedMetricsForMid: metricId rid: resourceId between: startTsNumber and: endTsNumber.
	^self applyAdjustments: cachedTuples to: tuples asOrderedCollection.</body>

<body package="PV-DC-Recomputations" selector="getAllInputsForTimeSeriesWithId:between:and:">getAllInputsForTimeSeriesWithId: anMsid between: scopeStartTimestamp and: scopeEndTimestamp
	" Answer all latest inputs for the given time series between the two timestamps.
	We scan the whole history looking for all inputs for this time series , then group by each input's msid."
	
	| inputs |
	inputs := OrderedCollection new.
	self dbSession
		readObjectsOfClass: PvInputBuildCommand
		with: (PvInputBuildCommand selectStatementForAllForMsid: anMsid between: scopeStartTimestamp and: scopeEndTimestamp)
		into: [:each | inputs add: each].

	^inputs</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.RecomputationQueryInterface</class-id> <selector>resyncSubelementWithId:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.RecomputationQueryInterface</class-id> <selector>selectStatementForPropertyForMid:rid:atOrBefore:</selector>
</remove-selector>

<class>
<name>RecomputationEngine</name>
<environment>PROVISO</environment>
<super>PROVISO.AbstractPlanBasedTreeBuilder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>queryInterface recomputationActions deltas scopeStartTimestamp scopeEndTimestamp originalInputs changedInputs mergedInputs nonInputMetadataChanges metadataChanges inputsByTime originalMetricsByTime updatedMetricsByTime originalResults updatedResults changeManager currentTimeSeries periodStartTimestamp periodEndTimestamp genericId </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DC-Recomputations</category>
<attributes>
<package>PV-DC-Recomputations</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>printing</category>

<body package="PV-DC-Recomputations" selector="printStringForResourceId:">printStringForResourceId: resourceId 
	
	^(String new: 128) streamContentsDo: 
		[:stream | 
		self 
			printResourceFor: resourceId
			on: stream]</body>

<body package="PV-DC-Recomputations" selector="printResourceFor:on:">printResourceFor: aResourceId on: aStream 

	(self pvModel subelementWithId: aResourceId) 
		ifNil: 
			[aStream
				nextPutAll: 'resourceId: ';
				print: aResourceId]
		ifNotNil: [:pvSe | pvSe printNameOn: aStream]</body>

<body package="PV-DC-Recomputations" selector="printStringForMetricId:">printStringForMetricId: metricId 
	
	^(String new: 128) streamContentsDo: 
		[:stream | 
		self 
			printFormulaFor: metricId
			on: stream]</body>

<body package="PV-DC-Recomputations" selector="printFormulaFor:on:">printFormulaFor: aMetricId on: aStream 
	
	(self pvModel formulaWithId: aMetricId) 
		ifNil: 
			[aStream
				nextPutAll: 'metricId: ';
				print: aMetricId]
		ifNotNil: [:pvFormula | pvFormula printNameOn: aStream]</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>accessing</category>

<body package="PV-DC-Recomputations" selector="updatedResults:">updatedResults: anObject
	updatedResults := anObject</body>

<body package="PV-DC-Recomputations" selector="updatedResults">updatedResults
	^updatedResults</body>

<body package="PV-DC-Recomputations" selector="outputLabel">outputLabel

	^(testMode isNil or: [testMode])
		ifTrue: [499]
		ifFalse: [self owner outputLabel].</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>building</category>

<body package="PV-DC-Recomputations" selector="buildTimeSeriesFromCommand:">buildTimeSeriesFromCommand: command
	"Note - command must be an instance of PvTimeSeriesBuildCommand."
	
	| id action formula subelement |
	formula := self pvModel formulaOrLocalizedScheduleWithId: command metricId.
	formula isNil ifTrue: [
		self logMissingFormulaFromCommand: command.
		^self].
	formula formulaPrototype ifNotNil: [:formulaPrototype |
		formulaPrototype
			deduplicate: false;
			deduplicateIntermediate: false].
	subelement := self pvModel 
		subelementWithId: command resourceId 
		ifAbsent: 
			[self queryInterface resyncSubelementWith: command.
			self pvModel subelementWithId: command resourceId ].
	"There is a case when a SE gets deleted, PBL doesn't remove the time series until the start of the next hour. If we try and do recomp in that time interval, we can end up with nil instead of a valid SE. In this case, we can just ignore the time series..."
	subelement isNil
		ifTrue: [^self].

	formula isProperty
		ifTrue: [self queryInterface resyncPropertiesFor: formula resource: subelement atOrBefore: scopeStartTimestamp].

	id := (MetricSeriesIdentifier 
		metric: formula
		resource: (self pvModel subelementManager itemWithId: command resourceId))
			msid: command msid;
			yourself.
	action := command resyncAction.
	" This is to cover test case scenarios where the actions comes as a symbol "
	((action isSymbol and: [action = #D]) or: [action = 'D']) 
		ifTrue: [self deleteTimeSeriesForId: id]
		ifFalse: ["add the timeseries if it isn't already there"
			self 
				addOrUpdateTimeSeriesForId: id
				fromCommand: command]</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>As yet unclassified</category>

<body package="PV-DC-Recomputations" selector="recompile:withFormula:">recompile: anOperator withFormula: aFormula 
	" Assume aTimeSeries is a Smee formula-based time series.
	Replace the prototype with the new formula and reshape the inputs "
	
	| oldInputs newInputs obsoleteInputs |
	oldInputs := anOperator inputs.
	newInputs := Array new: aFormula arguments size.
	" Get all the inputs that are preserved between in the new version of the formula and put them in proper place at the new inputs array"
	aFormula arguments keysAndValuesDo: 
		[:ix :eachArgument | 
		| oldInput |
		oldInput := 
			oldInputs 
				detect: [:eachInput | eachInput notNil and: [eachInput sequenceNumber = eachArgument id]]
				ifNone: [nil].
		oldInput ifNotNil: [newInputs at: ix put: oldInput]].

	" These inputs should have been deleted in an orderly fashion, so their presence may be an indication of some problem in the logic "
	obsoleteInputs := 
		oldInputs reject: 
			[:eachInput | 
			eachInput isNil 
				or: [aFormula arguments anySatisfy: [:eachArgument | eachInput sequenceNumber = eachArgument id]]].
	obsoleteInputs do: 
		[:eachInput | 
		self system 
			logWarning: #DISCONNECT_OBSOLETE_INPUT
			messageId: nil
			text: 
				'Disconnecting obsolete input on formula reshape. Time series ' , 
					anOperator printString , ', input: ' , eachInput printString.
		eachInput disconnect].
	anOperator smeePrototype: aFormula.
	anOperator inputs: newInputs</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>private</category>

<body package="PV-DC-Recomputations" selector="updateFormula:from:for:">updateFormula: originalFormula from: updatedFormula for: aTimeSeries
	"Update the given original formula with the information from the updated one. Note that for formulas, we have to handle both the formula iteself as well as the formula prototype."

	| documentSource formulaSet latestFormula time |

	time := Time millisecondsToRun: [
	[self pvModel formulaManager resyncFrom: updatedFormula] 
		on: Error 
		do: [:ex | 
			" The current scheme is crazy and no matter which order you try to do it, it produces an error
			The formula a) needs to be in formula manager
				b) has groups loaded and
				c) has to have the doc loaded
			This would at least accomplish adding it to formula manager, then grouping can succeed
			"
		nil].

	queryInterface resyncFormulaRelationshipsFor: updatedFormula id.
	self pvModel formulaManager buildNameIndex.
	documentSource := updatedFormula sourceText.

	documentSource isNil 
		ifTrue: [^self].

	formulaSet := self pvModel formulaManager documentRegistry
		getFormulaSet: documentSource
		timestamp: updatedFormula resyncHistoricalDate
		ifMissing: [^self].
	
	self pvModel formulaManager resyncFrom: updatedFormula.
	self pvModel resyncAgent commitResync.

	latestFormula := self pvModel formulaManager itemWithId: updatedFormula id.
	self
		doUpdateForComplexFormula: latestFormula
		withDoc: formulaSet
		at: latestFormula timestamp
		on: aTimeSeries].

	self system
		logDebugThree: #RECOMP_RESYNC_FORMULA_PERF
		text: 'Resynched formula ', latestFormula nameString, ' in ', time printString, ' ms'.</body>

<body package="PV-DC-Recomputations" selector="generateHeartbeatsFor:addResultsTo:">generateHeartbeatsFor: aTimeInterval addResultsTo: buffer 
	
	| punctuations |

	aTimeInterval isEmpty
		ifTrue: [^self].
	punctuations := self timePunctuationsForInterval: aTimeInterval.
	punctuations do: 
		[:eachTs | 
		self 
			generateHeartbeatAt: eachTs
			addResultsTo: buffer]</body>

<body package="PV-DC-Recomputations" selector="timePunctuationsForInterval:">timePunctuationsForInterval: anInterval 
	" Answer sorted collection of timestamps corresponding to times when a heartbeat needs to be issued. Heartbeats 'punctuate' otherwise contiguous flow of time, hence the name.
	Time boundaries from anInterval start to anInterval stop EXCLUSIVE.
	We collect timestamps of starts and ends of periods of all heartbeat handlers in the tuple repository (ignore ones that don't have any clients to not waste any time. " 
	
	| punctuations |
	punctuations := Set new.
	self tupleRepository heartbeatHandlers do: 
		[:eachHbSource | 
		eachHbSource hasAnyClients 
			ifTrue: 
				[eachHbSource 
					intervalsFrom: anInterval start
					to: anInterval stop
					do: 
						[:interval | 
						interval isEmpty 
							ifFalse: 
								[(Array 
									with: interval start - 1
									with: interval start
									with: interval end
									with: interval end + 1) do: 
										[:eachTs | 
										(anInterval includes: eachTs) 
											ifTrue: [punctuations add: eachTs]]]]]].
	^punctuations asSortedCollection.</body>

<body package="PV-DC-Recomputations" selector="reduceInputMetrics:for:">reduceInputMetrics: metricsForInput for: formulaWindow
	"Answer a new collection that contains metrics for an input to the given window, following the rules of the window."

	^formulaWindow reduceInputMetrics: metricsForInput using: originalResults and: queryInterface</body>

<body package="PV-DC-Recomputations" selector="removeAlreadyDone:from:">removeAlreadyDone: tuplesDone from: tuples
	"Return a new collection of tuples, derived from the given collection of tuples, removing those that we have already processed (and updating the given collection of tuples done with those we haven't)."

	| results |
	results := OrderedCollection new.
	tuples do: [:each |
		| found |
		found := tuplesDone
			detect: [:eachDone |
				each metricId = eachDone metricId 
					and: [each resourceId = eachDone resourceId
					and: [each referenceDate = eachDone referenceDate
					and: [(each value - eachDone value) abs &lt; 0.001]]]]
			ifNone: [nil].
		found isNil
			ifTrue: [
				results add: each.
				tuplesDone add: each]
			ifFalse: [
				self system
					logDebugTwo: #ALREADY_DONE
					text: 'Tuple already done: ', each printString]].

	^results</body>

<body package="PV-DC-Recomputations" selector="disconnectAllHeartbeatSources">disconnectAllHeartbeatSources
	"This is all we have to do here..."

	PvFormulaHeartbeatDisconnector 
		allSmeeFormulasIn: self pvModel
		do: [:eachFormula | eachFormula resetHeartbeatHandlers].</body>

<body package="PV-DC-Recomputations" selector="compressTupleSets:">compressTupleSets: aCollection
	"Compress (which means bring together any sets of tuples that share the same mid/rid) in the given collection of tuple sets. Maintain ordering of the tuple sets."

	| results byIndex tupleOrder |
"
	self system
		logDebugFour: #COMPRESS
		text: ['Starting to compress ', aCollection size printString, ' tuple sets...'].
"
	byIndex := Dictionary new.
	tupleOrder := OrderedCollection new.
	aCollection do: [:eachTupleSet |
		| key |
		key := Array with: eachTupleSet first metricId with: eachTupleSet first resourceId.
		(byIndex at: key ifAbsentPut: [SortedCollection sortBlock: [:a :b | a referenceDate &lt;= b referenceDate]])
			addAll: eachTupleSet.
		tupleOrder add: key].

	results := OrderedCollection new.
	tupleOrder do: [:eachKey |
		| tupleSet |
		tupleSet := byIndex at: eachKey ifAbsent: [nil].
		tupleSet isNil
			ifFalse: [
				byIndex removeKey: eachKey.
				results add: tupleSet asOrderedCollection]].

	self system
		logDebugFour: #COMPRESS_PERF
		text: ['Compressed ', aCollection size printString, ' tuple sets into ', results size printString].

	^results</body>

<body package="PV-DC-Recomputations" selector="deduplicate:">deduplicate: aCollection
	"Answer a new collection that contains the contents of the given collection, with all duplicates removed."

	| byIndex results ordered |
	self system
		logDebugFour: #DEDUPLICATE
		text: ['Starting to deduplicate ', aCollection size printString, ' tuples...'].

	byIndex := Dictionary new.
	aCollection reverseDo: [:each |
		| currentSet |
		currentSet := byIndex
			at: (Array with: each metricId with: each resourceId)
			ifAbsentPut: [Array with: Set new with: OrderedCollection new].
		(currentSet first includes: each referenceDate)
			ifFalse: [
				currentSet first add: each referenceDate.
				currentSet last add: each]].

	results := OrderedCollection new.
	ordered := byIndex keys asSortedCollection: [:a :b |
		a first = b first
			ifTrue: [a last &lt;= b last]
			ifFalse: [a first &lt; b first]].
	ordered do: [:eachKey |
		| local pair |
		pair := byIndex at: eachKey.
		local := pair last asSortedCollection: [:a :b | a referenceDate &lt;= b referenceDate].
		results addAll: local asOrderedCollection].

	self system
		logDebugThree: #DEDUPLICATE
		text: ['Deduplicated ', aCollection size printString, ' tuples into ', results size printString].

	^results</body>

<body package="PV-DC-Recomputations" selector="replayAction:addResultsTo:">replayAction: aRecompAction addResultsTo: buffer

	aRecompAction replayFor: self on: self tupleRepository.
	self tupleRepository buffer notEmpty
		ifTrue:
			[buffer addAll: self tupleRepository buffer.
			self tupleRepository initializeBuffer].</body>

<body package="PV-DC-Recomputations" selector="deltaBetween:and:on:">deltaBetween: oneSet and: anUpdatedResults on: aTimeSeries
	"Answer a collection of recomputation records that represent the changes that occurred between the orginal results and the updated ones."

	| delta firstSet secondSet firstValidTimestamp |
	delta := OrderedCollection new.
	"First, find deletes and updates..."
	genericId isNil
		ifTrue: [
			firstSet := oneSet select: [:each | each metricId = aTimeSeries metricId].
			secondSet := anUpdatedResults select: [:each | each metricId = aTimeSeries metricId]]
		ifFalse: [
			firstSet := oneSet select: [:each | each metricId = genericId].
			secondSet := anUpdatedResults select: [:each | each metricId = genericId]].
	firstSet do: [:eachRecord |
		| matchingRecord |
		matchingRecord := secondSet
			detect: [:each |
				each metricId = eachRecord metricId 
					and: [each resourceId = eachRecord resourceId
					and: [each timestamp = eachRecord timestamp]]]
			ifNone: [nil].
		matchingRecord isNil
			ifTrue: ["delta add: (self deleteRecomputeRecordFor: eachRecord)"]
			ifFalse: [matchingRecord value = eachRecord value
				ifFalse: [delta add: (self updateRecomputeRecordFor: matchingRecord)]]].

	"Now, find inserts..."
	secondSet do: [:eachRecord |
		firstSet
			detect: [:each |
				each metricId = eachRecord metricId 
					and: [each resourceId = eachRecord resourceId
					and: [each timestamp = eachRecord timestamp]]]
			ifNone: [delta add: (self insertRecomputeRecordFor: eachRecord)]].

	" Drop all results that are older than the first recomp action "
	firstValidTimestamp := recomputationActions inject: Infinity positive into: [:ts :rec | ts min: rec timestamp].
	^((delta reject: [:eachRec | eachRec timestamp &lt; firstValidTimestamp]) 
		" Return results in timestamp order "
		asSortedCollection: [:x : y | x timestamp &lt; y timestamp]) asOrderedCollection.</body>

<body package="PV-DC-Recomputations" selector="computeRangeOfHeartbeatsFor:between:and:">computeRangeOfHeartbeatsFor: metricEvents between: startTimestamp and: endTimestamp

	| timeRange |
	(startTimestamp == Infinity positive or: [startTimestamp == Infinity negative or: [endTimestamp == Infinity positive or: [endTimestamp == Infinity negative]]])
		ifTrue: [timeRange := self computeComplexHeartbeatsFor: metricEvents between: startTimestamp and: endTimestamp]
		ifFalse: [
			| maxTimestamp |
			maxTimestamp := endTimestamp min: (metricEvents isEmpty ifTrue: [endTimestamp] ifFalse: [metricEvents last timestamp]).
			maxTimestamp := maxTimestamp max: (originalResults isEmpty ifTrue: [maxTimestamp] ifFalse: [originalResults last timestamp]).
			timeRange := PvCalendarTimeInterval from: (metricEvents isEmpty ifTrue: [startTimestamp] ifFalse: [metricEvents first timestamp max: startTimestamp]) - 1 to: maxTimestamp].
	^timeRange</body>

<body package="PV-DC-Recomputations" selector="postprocessRecomputationOutputs:timeRange:">postprocessRecomputationOutputs: aCollectionOfTuples timeRange: timeRange
	"Clean up the results and return outputs sorted by timestamp. "

	| newBuffer metricId buffer |

	metricId := genericId isNil
		ifTrue: [currentTimeSeries metricId]
		ifFalse: [genericId].

	"We are really only interested in the results from the current time series. Drop everything else."
	buffer := aCollectionOfTuples select: [:each | 
					(each metricId = metricId and: [each resourceId = currentTimeSeries resourceId]) and: 
						[each timestamp between: timeRange start and: timeRange end]].

	"Now we need to remove any possible timestamp-based duplicates that come up."
	" APIK: do we still need that? It would seem if this code is EVER doing anything, it would produce indeterminate results.
	We have a scheme to eliminate dups in the course of processing, so there should never be dups "
	newBuffer := Dictionary new.
	buffer do: [:each |
		newBuffer at: each timestamp put: each].

	" Return the results as ordered collection by timestamp "
	^(newBuffer values asSortedCollection: [:x :y | x timestamp &lt; y timestamp]) asOrderedCollection</body>

<body package="PV-DC-Recomputations" selector="earliestValidOutputTimestamp">earliestValidOutputTimestamp
	" Answer earliest timestamp for updated outputs "

	^recomputationActions inject: Infinity positive into: [:ts :rec | ts min: rec timestamp].</body>

<body package="PV-DC-Recomputations" selector="computeComplexHeartbeatsFor:between:and:">computeComplexHeartbeatsFor: metricEvents between: startTimestamp and: endTimestamp

	| heartbeatStart heartbeatEnd |
	heartbeatStart := startTimestamp &lt;= 0
		ifTrue: [metricEvents first timestamp]
		ifFalse: [startTimestamp].

	heartbeatEnd := endTimestamp == Infinity positive
		ifTrue: [metricEvents last timestamp + 1]
		ifFalse: [
			| maxTimestamp |
			maxTimestamp := endTimestamp min: (metricEvents isEmpty ifTrue: [endTimestamp] ifFalse: [metricEvents last timestamp]).
			maxTimestamp max: (originalResults isEmpty ifTrue: [maxTimestamp] ifFalse: [originalResults last timestamp])].

	^ PvCalendarTimeInterval from: (heartbeatStart - 1 max: self earliestValidOutputTimestamp)  to: heartbeatEnd</body>

<body package="PV-DC-Recomputations" selector="doUpdateForComplexFormula:withDoc:at:on:">doUpdateForComplexFormula: aPvFormula withDoc: formulaSet at: timestamp on: timeSeries
	"Simulate a resync which includes a change of the PvFormula as refleced in the documentSource"

	| newFormula |
	self pvModel resyncAgent finalizeResync.
	newFormula := aPvFormula runCopy.
	newFormula
		resyncAction: #U;
		date: timestamp.

	"load the formula document with the same timestamp so that the lookup works properly"
	self pvModel formulaManager documentRegistry 
		registerFormulaSet: formulaSet 
		withTimestamp: timestamp.

	self pvModel formulaManager resyncFrom: newFormula.
	self pvModel resyncAgent commitResync.
	newFormula := self pvModel formulaManager itemWithId: newFormula id.
	queryInterface resyncFormulaArgumentsFor: newFormula.
	self pvModel resyncAgent commitResync.

	"We need to remove the heartbeat handler dependent for the old formula, since adding the time series will
		add a new dependency with the new version of the formula..."
	tupleRepository heartbeatHandlers do: [:each |
		each dependents asArray do: [:eachBroker |
			((eachBroker isKindOf: CMETimeSeries) and: [eachBroker formula isKindOf: LocalizedSchedule]) 
				ifFalse: 
					[eachBroker owner ~~ newFormula formulaPrototype
						ifTrue: [each removeDependent: eachBroker]]]].

	" If the current formula changes, we need to re-shape it. We have to do this before we rebuild the rest because 
	code assumes time series inputs are consistent with formula arguments " 
	currentTimeSeries metricId = aPvFormula id
		ifTrue: 
			[self tupleRepository 
				atMsid: timeSeries msid 
				ifPresent: [:ts | 
					ts operator 
						ifNotNil: [:operator | operator recompileWithFormula:  aPvFormula formulaPrototype]]
				ifAbsent: []].
	self buildTimeSeriesFromCommand: timeSeries.</body>

<body package="PV-DC-Recomputations" selector="generateHeartbeatAt:addResultsTo:">generateHeartbeatAt: aTsNumber addResultsTo: buffer 
	
	self 
		replayAction: 
			(RecomputationMetricRecordWrapper on: (PvStreamHeartbeat timestamp: aTsNumber))
		addResultsTo: buffer</body>

<body package="PV-DC-Recomputations" selector="doReplayFrom:and:and:">doReplayFrom: changes and: metricEvents and: heartbeatsRange
	"Run the replay algorithm on the given metric &amp; metadata records. Answer ordered collection of outputs this replay produces "

	| mergeStream buffer lastTimestamp actionsByTimestamp |

 	"We can use a merge sort stream directly, with the default sort block, since the elements are wrappers which know how to sort themselves correctly."
	mergeStream := MergeSortStream
		onAll: (Array
			with: (ReadStream on: changes)
			with: (ReadStream on: metricEvents)).

	actionsByTimestamp := PvDictionary new: metricEvents size + changes size.
	mergeStream do: [:eachAction |
		(actionsByTimestamp at: eachAction timestamp ifAbsentPut: [OrderedCollection new]) add: eachAction].

	buffer := OrderedCollection new.
	lastTimestamp := heartbeatsRange start - 1.
	actionsByTimestamp keys asSortedCollection do: [:eachTs | | eachColl intervalForIntermediateHeartbeats|
		intervalForIntermediateHeartbeats := PvCalendarTimeInterval from: lastTimestamp + 1 to: eachTs - 1.
		self generateHeartbeatsFor: intervalForIntermediateHeartbeats addResultsTo: buffer.
		eachColl := actionsByTimestamp at: eachTs.
		eachColl do: [:currentAction |
			self replayAction: currentAction addResultsTo: buffer].
			eachTs &gt;= heartbeatsRange start
				ifTrue: [self generateHeartbeatAt: eachTs addResultsTo: buffer].
		lastTimestamp := eachTs max: lastTimestamp.
	].
	self 
		generateHeartbeatsFor: 
			(PvCalendarTimeInterval from: lastTimestamp + 1 to: heartbeatsRange stop)
 		addResultsTo: buffer.

	^buffer</body>

<body package="PV-DC-Recomputations" selector="replayFrom:and:on:between:and:">replayFrom: changes and: metricEvents on: aTupleRepository between: startTimestamp and: endTimestamp
	"Run the replay algorithm on the given metric &amp; metadata records."

	| outputs timeRange |

	timeRange := self computeRangeOfHeartbeatsFor: metricEvents
			between: startTimestamp
			and: endTimestamp.

	outputs := self doReplayFrom: changes and: metricEvents and: timeRange.

	^self postprocessRecomputationOutputs: outputs timeRange: timeRange</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>recomputation</category>

<body package="PV-DC-Recomputations" selector="computeDatabaseNonInputMetadataChangesFor:">computeDatabaseNonInputMetadataChangesFor: aTimeSeries 
	"This method needs to figure out what metadata has changed for the given time series, in the scope of the receiver.
	Non-input metadata changes can include formula definition changes, and subelement changes."
	
	| metricId formula resourceId elapsed |
	self logComputingDatabaseNonInputMetadataFor: aTimeSeries.
	nonInputMetadataChanges := OrderedCollection new.
	metricId := aTimeSeries metricId.
	formula := pvModel formulaManager itemWithId: metricId.
	elapsed := Time millisecondsToRun: [
	self dbSession 
		readObjectsOfClass: PvFormula
		with: 
			(PvFormula selectStatementWithParameters: 
				#startSeconds -&gt; scopeStartTimestamp , (#endSeconds -&gt; scopeEndTimestamp) , 
					(#id -&gt; metricId))
		into: 
			[:each | 
			nonInputMetadataChanges add: 
				(RecomputationDbChangeWrapper 
					on: 
						(self 
							buildUpdateBlockForFormula: formula
							from: each)
					from: each timestamp
					to: scopeEndTimestamp)]].
	elapsed &gt;= 100 
		ifTrue:
			[self system 
				logDebugThree: #RECOMP_DB_QUERY_PERF
				text: 'Getting formula with metricId: ', (self printStringForMetricId: metricId) , ' took ', elapsed printString, ' ms']
		ifFalse:
			[self system 
				logDebugFour: #RECOMP_DB_QUERY_PERF
				text: ['Getting formula with metricId: ', (self printStringForMetricId: metricId) , ' took ', elapsed printString, ' ms']].

	resourceId := aTimeSeries resourceId.
	elapsed := Time millisecondsToRun: [
		PvCmeSubelement
			getSubelementChangesForId: resourceId 
			from: scopeStartTimestamp 
			to: scopeEndTimestamp
			do: [:each | 
			nonInputMetadataChanges add: 
				(RecomputationDbChangeWrapper 
					on: (self buildUpdateBlockForSubelement: each)
					from: each timestamp
					to: scopeEndTimestamp)]].
	elapsed &gt;= 100 
		ifTrue: 
			[self system 
				logDebugThree: #RECOMP_DB_QUERY_PERF
				text: 'Getting resource with resourceId: ', (self printStringForResourceId: resourceId) , ' took ', elapsed printString, ' ms']
		ifFalse:
			[self system 
				logDebugFour: #RECOMP_DB_QUERY_PERF
				text: ['Getting resource with resourceId: ', (self printStringForResourceId: resourceId) , ' took ', elapsed printString, ' ms']].</body>

<body package="PV-DC-Recomputations" selector="recomputeAll:originLabel:">recomputeAll: aCollection originLabel: originLabel
	"Run recomputation using the given collection of recomputation actions. This may be a mixed set,
	(based on mid/rid) so we have to group them, and run each set seperately."

	| byIndex recomputationRecords pendingTupleSetsQueue allResults label tuplesDone inputs |
	byIndex := Dictionary new.
	recomputationRecords := self removeNonRecomputationRecordsFrom: aCollection.
	recomputationRecords do: [:each |
		(byIndex 
			at: (Array with: each metricId with: each resourceId)
			ifAbsentPut: [OrderedCollection new]) add: each].

	self system
		logDebugTwo: #RECOMP_ALL
		text: byIndex size printString, ' tuple groups to process'.

	"Note that pendingTupleSetsQueue is a collection of collections..."
	pendingTupleSetsQueue := OrderedCollection withAll: byIndex values.
	allResults := OrderedCollection new.
	tuplesDone := OrderedCollection new.
	self queryInterface initializeTupleCache.
	label := originLabel.
	[pendingTupleSetsQueue isEmpty] whileFalse: [
		| tuples resultPair resultTuples |
		pendingTupleSetsQueue := self compressTupleSets: pendingTupleSetsQueue.
		self system
			logDebugFour: #RECOMP_TUPLES
			text: ['Pending queue size: ', pendingTupleSetsQueue size printString].
		tuples := pendingTupleSetsQueue removeFirst.
		tuples := self removeAlreadyDone: tuplesDone from: tuples.
		tuples notEmpty
			ifTrue: [
				resultPair := self privateRecomputeAll: tuples originLabel: label.
				"This cycle's input is last cycle's output, so we're mostly caching duplicates here, except for the first time through..."
				self queryInterface cacheTuples: tuples.
				label := self outputLabel.
				resultTuples := resultPair first.
				resultTuples notEmpty
					ifTrue: [
						self queryInterface cacheTuples: resultTuples.
						allResults addAll: resultTuples.
						byIndex := Dictionary new.
						resultTuples do: [:each |
							(byIndex 
								at: (Array with: each metricId with: each resourceId)
								ifAbsentPut: [OrderedCollection new]) add: each].
						pendingTupleSetsQueue addAllFirst: byIndex values.
						self system
							logDebugThree: #RECOMP_TUPLES
							text: ['Added ', byIndex size printString, ' result set(s) to pending queue, new queue size: ', pendingTupleSetsQueue size printString]]]].

	self system
		logDebugFour: #RECOMP_ALL
		text: 'Done #recomputeAll...'.

	allResults := self deduplicate: allResults.
	inputs := aCollection asSortedCollection: [:a :b |
		a metricId = b metricId
			ifTrue: [
				a resourceId = b resourceId
					ifTrue: [a referenceDate &lt;= b referenceDate]
					ifFalse: [a resourceId &lt; b resourceId]]
			ifFalse: [a metricId &lt; b metricId]].

	^Array with: allResults with: inputs</body>

<body package="PV-DC-Recomputations" selector="gatherOriginalResultsFor:passing:">gatherOriginalResultsFor: aTimeSeries passing: recompActions
	"Retrieve the original metrics produced by the formula assocaited with the given time series, during the time periond in question."

	| metricId |
	self logComputingOriginalResultsFor: aTimeSeries.
	metricId := genericId isNil
		ifTrue: [aTimeSeries metricId]
		ifFalse: [genericId].

	originalResults := queryInterface
		getMetricsForMid: metricId
		rid: aTimeSeries resourceId
		between: scopeStartTimestamp
		and: scopeEndTimestamp
		passing: recompActions.</body>

<body package="PV-DC-Recomputations" selector="gatherMetricsFor:">gatherMetricsFor: aTimeSeries
	"Collect the set of metrics that were originally produced on all the inputs. Also, produce an updated list of metrics after applying the receiver's recomputation action to the original set."

	| metrics window |
	self logComputingInputDataFor: aTimeSeries.
	metrics := OrderedCollection new.
	window := queryInterface getWindowFor: aTimeSeries.
	inputsByTime do: [:eachTimeSeriesWrapper |
		| metricsForInput |
		metricsForInput := queryInterface
			getMetricsForMid: eachTimeSeriesWrapper metricId
			rid: eachTimeSeriesWrapper resourceId
			between: eachTimeSeriesWrapper startTimestamp
			and: eachTimeSeriesWrapper endTimestamp.
		metricsForInput := self reduceInputMetrics: metricsForInput for: window.
		metrics add: metricsForInput].
	originalMetricsByTime := metrics
		inject: SortedCollection new
		into: [:sum :each |
			sum addAll: (each collect: [:eachSub | RecomputationMetricRecordWrapper on: eachSub]); yourself].
	updatedMetricsByTime := (originalMetricsByTime collect: [:each | each copy]) asSortedCollection.
	recomputationActions do: [:each | each applyTo: updatedMetricsByTime].

	self pvModel calendarManager resetLocalizedSchedules.

"	second := OrderedCollection new: updatedMetricsByTime size.
	updatedMetricsByTime do: [:each |
		| found |
		found := second
			detect: [:eachOther |
				each metricId = eachOther metricId
					and: [each resourceId = eachOther resourceId
					and: [each timestamp = eachOther timestamp]]]
			ifNone: [nil].
		found
			ifNil: [second add: each]
			ifNotNil: [:f | self halt]]."</body>

<body package="PV-DC-Recomputations" selector="computeMetadataChangesFor:">computeMetadataChangesFor: aTimeSeries
	"Determine the initial metadata setup for the given time series. That includes inputs, and the time series for those inputs. Also keep track of the time series separately, we use those to gather metric records."

	self logComputingTimeSeriesFor: aTimeSeries.
	metadataChanges := SortedCollection
		with: (RecomputationAddTimeSeriesWrapper on: aTimeSeries from: scopeStartTimestamp to: scopeEndTimestamp).
	inputsByTime := OrderedCollection new.
	mergedInputs do: [:eachInputWrapper |
		| timeSeriesWrapper ts elapsed |
		elapsed := Time millisecondsToRun: [ 
		ts := queryInterface
				getLastTimeSeriesWithId: eachInputWrapper record inputTimeSeriesMsid
				atOrBefore: eachInputWrapper record timestamp].
		elapsed &gt;= 100
			ifTrue: 
				[self system 
					logDebugThree: #RECOMP_DB_TS_QUERY_PERF
					text: ['Getting timeseries with msid: ', eachInputWrapper record inputTimeSeriesMsid printString , ' took ', elapsed printString, ' ms']]
			ifFalse: 
				[self system 
					logDebugFour: #RECOMP_DB_TS_QUERY_PERF
					text: ['Getting timeseries with msid: ', eachInputWrapper record inputTimeSeriesMsid printString , ' took ', elapsed printString, ' ms']].
		timeSeriesWrapper := RecomputationAddTimeSeriesWrapper
			on: ts
			from: scopeStartTimestamp
			to: scopeEndTimestamp.
		inputsByTime add: timeSeriesWrapper.
		metadataChanges
			add: timeSeriesWrapper;
			addAll: 
				(self 
					computeMetadataChangeForMetricId: timeSeriesWrapper metricId 
					resourceId: timeSeriesWrapper resourceId 
					between: scopeStartTimestamp 
					and: timeSeriesWrapper timestamp);
			add: eachInputWrapper].</body>

<body package="PV-DC-Recomputations" selector="resetTupleRepository">resetTupleRepository

	self queryInterface resetTupleRepositoryFor: self.
	self disconnectAllHeartbeatSources.</body>

<body package="PV-DC-Recomputations" selector="computeInputsFor:">computeInputsFor: aTimeSeries
	"Determine what the inputs were to the formula the given time series represents."

	| wrapper toDelete |
	self logComputingInputsFor: aTimeSeries.
	originalInputs := queryInterface 
		getLastInputsForTimeSeriesWithId: aTimeSeries msid 
		atOrBefore: scopeStartTimestamp.

	changedInputs := queryInterface
		getAllInputsForTimeSeriesWithId: aTimeSeries msid 
		between: scopeStartTimestamp
		and: scopeEndTimestamp.

	mergedInputs := SortedCollection sortBlock: [:a :b | 
		(a record resyncHistoricalDate &lt; b record resyncHistoricalDate) or: 
			[(a record resyncHistoricalDate = b record resyncHistoricalDate and: [a record inputTimeSeriesMsid &lt; b record inputTimeSeriesMsid])
				or: [a record resyncHistoricalDate = b record resyncHistoricalDate and: [a record inputTimeSeriesMsid = b record inputTimeSeriesMsid and: [(a record versionDate isNil or: [b record versionDate isNil]) or: [a record versionDate &lt; b record versionDate]]]]]].

	originalInputs do: [:each |
		wrapper := RecomputationAddInputWrapper
				on: each
				from: scopeStartTimestamp
				to: scopeEndTimestamp.
		mergedInputs add: wrapper].

	changedInputs do: [:each |
		wrapper := RecomputationAddInputWrapper
			on: each
			from: each timestamp
			to: scopeEndTimestamp.
		" Weed out plain dups here -- the queries above overlap by one second "
		(mergedInputs anySatisfy: [:eachInputWrapper | eachInputWrapper isSameAs: wrapper])
			ifFalse: [mergedInputs add: wrapper]].

	" Deal with input moves, etc "
	toDelete := OrderedCollection new.
	mergedInputs fold: [:prev :next |
		" Multiple simultaneous changes? "
		(prev record operatorTimeSeriesMsid = next record operatorTimeSeriesMsid
			and: [prev record inputTimeSeriesMsid = next record inputTimeSeriesMsid and: 
				[prev record resyncHistoricalDate = next record resyncHistoricalDate]])
			ifTrue: 
				[prev record versionDate = next record versionDate
					ifTrue: 
						[" Simultaneous change in the plan -- same version, must be time series move "
						prev record isActionDelete 
							ifTrue: [toDelete add: prev]
							ifFalse: 
								[next record isActionDelete 
									ifTrue: [toDelete add: next]]]
					ifFalse: [
						" next action is older version, leave just the last one "
						toDelete add: prev]
			].
		next
	].
	mergedInputs removeAll: toDelete.</body>

<body package="PV-DC-Recomputations" selector="privateRecomputeAll:originLabel:">privateRecomputeAll: aCollection originLabel: originLabel
	"Run recomputation using the given recomputation action."

	| actions elapsed |
	actions := self removeDuplicateRecordsFrom: aCollection using: originLabel.
"	self system extendedStatus: 'Running Recomputation, processing ', actions size printString, ' records'."

	actions doWithIndex: [:each :index |
		self system
			logDebugThree: #RECOMP_RECORD
			text: ['Processing recomp record: ', each printString, ' - ', index printString, ' of ', actions size printString]].

	recomputationActions := self convertRecomputationActions: actions.
	recomputationActions isEmpty
		ifTrue: [^#(() ())].
	recomputationActions := recomputationActions asSortedCollection: [:a :b | a timestamp &lt;= b timestamp].

	deltas := OrderedCollection new.
	self affectedTimeSeriesDo: [:eachTimeSeries |
		elapsed := Time millisecondsToRun: [
		self computeScopeFor: eachTimeSeries.
		scopeStartTimestamp notNil
			ifTrue: [
				self
					computeGenericFor: eachTimeSeries;
					computeInputsFor: eachTimeSeries;
					computeMetadataChangesFor: eachTimeSeries;
					computeNonInputMetadataChangesFor: eachTimeSeries;
					gatherOriginalResultsFor: eachTimeSeries passing: actions;
					gatherMetricsFor: eachTimeSeries;
					runReplayFor: eachTimeSeries]].
		self system
			logDebugThree: #RECOMP_PERF
			text: ['Processing took: ', elapsed printString, ' ms for timeseries: ', eachTimeSeries printString.]].

	self switchDeltasUsing: aCollection.
"	self system extendedStatus: 'Done Recomputation'."
	^Array with: deltas with: aCollection</body>

<body package="PV-DC-Recomputations" selector="runReplayFor:">runReplayFor: aTimeSeries
	"We have built up a collection of metadata changes and metrics. Replay them, grab the new results, and compute the deltas betwen what we had before and what we have now."

	| elapsed newDeltas |
	self system
		logDebugFour: #RECOMP_REPLAY
		text: [('Replaying for mid: %1 with %2 tuples and %3 metadata changes'
			bindWith: (self printStringForMetricId: aTimeSeries metricId)
			with: updatedMetricsByTime size printString
			with: metadataChanges size printString )].

	currentTimeSeries := aTimeSeries.
	updatedMetricsByTime notEmpty
		ifTrue: [
			elapsed := Time millisecondsToRun: [
			updatedResults := self
				replayFrom: metadataChanges
				and: updatedMetricsByTime
				on: tupleRepository
				between: periodStartTimestamp
				and: periodEndTimestamp.
			genericId isNil
				ifFalse: [updatedResults do: [:each | each metricId: genericId]].
			].
			newDeltas := self deltaBetween: originalResults and: updatedResults on: aTimeSeries.
			newDeltas do: [:eachRec | self changed: #recompDelta with: eachRec].
			self system
				logDebugThree: #RECOMP_REPLAY_PERF
				text: [('Replayed in %4 ms for mid: %1. Produced %2 results, %3 differences '
					bindWith: (self printStringForMetricId: aTimeSeries metricId)
					with: updatedResults size printString
					with: newDeltas size printString 
					with: elapsed printString)].
			deltas addAll: newDeltas].</body>

<body package="PV-DC-Recomputations" selector="switchDeltasUsing:">switchDeltasUsing: aCollection
	"We need to switch the dates &amp; referenceDates for all the deltas."

	| timestamp eventId |
	self system
		logDebugThree: #RECOMP_OUTPUT
		text: ['Produced ', deltas size printString, ' records'].

	timestamp := aCollection first timestamp.
	eventId := aCollection first eventId.
	"We're using 'date' as the 'referenceDate' of the new tuples..."
	deltas do: [:each |
		each
			referenceDate: each date;
			date: timestamp;
			eventId: eventId.
		self system
			logDebugFour: #RECOMP_OUTPUT
			text: ['Produced: ', each printString]].</body>

<body package="PV-DC-Recomputations" selector="computeGenericFor:">computeGenericFor: aTimeSeries
	"Find out if the formula for the given time series has a genercId."

	| formula |
	self logComputingGenericsFor: aTimeSeries.
	formula := self pvModel formulaManager itemWithId: aTimeSeries metricId.
	genericId := formula isSpecificToGenericConversion
		ifTrue: [formula genericId]
		ifFalse: [nil].</body>

<body package="PV-DC-Recomputations" selector="computeScopeFor:">computeScopeFor: aTimeSeries
	"Determine the scope of the receiver's operation, which involves finding the period of the formula the given time series represents, and then finding the boundaries of that period."

	| startScope endScope |
	self logComputingScopeFor: aTimeSeries.
	"Note - We have to do these in reverse order, because part of doing the scope calculation is to resync the formula itself into the model,
	and we need to end up with the original one in the model at the start time, not what was there at the end time..."
	endScope := queryInterface
		getScopeFor: aTimeSeries
		timestamp: recomputationActions last timestamp.
	endScope isNil
		ifTrue: [
			self system 
				logDebugTwo: #RECOMP_ERROR
				text: 'No inputs for time series ', aTimeSeries printString, ' at or before ', (PvTimestamp fromSeconds: recomputationActions last timestamp) printString.
			^nil].

	startScope := recomputationActions size = 1
		ifTrue: [endScope]
		ifFalse: [
			self pvModel calendarManager resetLocalizedSchedules.
			queryInterface
				getScopeFor: aTimeSeries
				timestamp: recomputationActions first timestamp].
	scopeStartTimestamp := startScope first key.
	scopeEndTimestamp := endScope first value.
	periodStartTimestamp := startScope last key.
	periodEndTimestamp := endScope last value.

	self system 
		logDebugTwo: #RECOMP_SCOPE
		text: ['Scope: %1 -&gt; %2'
			bindWith: scopeStartTimestamp pvOpportunisticPrintString
			with: scopeEndTimestamp pvOpportunisticPrintString].

	self system 
		logDebugFour: #RECOMP_PERIOD
		text: ['Scope: %1 -&gt; %2'
			bindWith: periodStartTimestamp pvOpportunisticPrintString
			with: periodEndTimestamp pvOpportunisticPrintString].

	"Since we sometimes end up messing up localized schedules when we compute the scope, we need to reset them."
	self pvModel calendarManager resetLocalizedSchedules.</body>

<body package="PV-DC-Recomputations" selector="computeMetadataChangeForMetricId:resourceId:between:and:">computeMetadataChangeForMetricId: metricId resourceId: resourceId between: startTime and: endTime 
	"This method needs to figure out what metadata has changed for the given mid / rid, in the given scope.
	Non-input metadata changes can include formula definition changes, and subelement changes."
	
	|  formula changes elapsed |
	changes := OrderedCollection new.
	formula := pvModel formulaManager itemWithId: metricId.
	elapsed := Time millisecondsToRun: [ 
	self dbSession 
		readObjectsOfClass: PvFormula
		with: 
			(PvFormula selectStatementWithParameters: 
				#startSeconds -&gt; startTime , (#endSeconds -&gt; endTime) , 
					(#id -&gt; metricId))
		into: 
			[:each | 
			changes add: 
				(RecomputationDbChangeWrapper 
					on: 
						(self 
							buildUpdateBlockForFormula: formula
							from: each)
					from: each timestamp
					to: endTime)]].
	elapsed &gt;= 100 
		ifTrue:
			[self system 
				logDebugThree: #RECOMP_DB_QUERY_PERF
				text: 'Getting formula with metricId: ', (self printStringForMetricId: metricId), ' took ', elapsed printString, ' ms']
		ifFalse:
			[self system 
				logDebugFour: #RECOMP_DB_QUERY_PERF
				text: ['Getting formula with metricId: ', (self printStringForMetricId: metricId) , ' took ', elapsed printString, ' ms']].

	elapsed := Time millisecondsToRun: [
		PvCmeSubelement
			getSubelementChangesForId: resourceId 
			from: startTime 
			to: endTime
			do: [:each | 
				changes add: 
					(RecomputationDbChangeWrapper 
						on: (self buildUpdateBlockForSubelement: each)
						from: each timestamp
						to: endTime)]].
	elapsed &gt;= 100 
		ifTrue: 
			[self system 
				logDebugThree: #RECOMP_DB_QUERY_PERF
				text: 'Getting resource with resourceId: ', (self printStringForResourceId: resourceId) , ' took ', elapsed printString, ' ms']
		ifFalse:
			[self system 
				logDebugFour: #RECOMP_DB_QUERY_PERF
				text: 'Getting resource with resourceId: ', (self printStringForResourceId: resourceId) , ' took ', elapsed printString, ' ms'].
	^changes</body>

<body package="PV-DC-Recomputations" selector="gatherMetricsFor:passing:">gatherMetricsFor: aTimeSeries passing: recompActions
	"Collect the set of metrics that were originally produced on all the inputs. Also, produce an updated list of metrics after applying the receiver's recomputation action to the original set."

	| metrics window |
	metrics := OrderedCollection new.
	window := queryInterface getWindowFor: aTimeSeries.
	inputsByTime do: [:eachTimeSeriesWrapper |
		| metricsForInput |
		metricsForInput := queryInterface
			getMetricsForMid: eachTimeSeriesWrapper metricId
			rid: eachTimeSeriesWrapper resourceId
			between: eachTimeSeriesWrapper startTimestamp
			and: eachTimeSeriesWrapper endTimestamp
			passing: recompActions.
		metricsForInput := self reduceInputMetrics: metricsForInput for: window.
		metrics add: metricsForInput].
	originalMetricsByTime := metrics
		inject: SortedCollection new
		into: [:sum :each |
			sum addAll: (each collect: [:eachSub | RecomputationMetricRecordWrapper on: eachSub]); yourself].
	updatedMetricsByTime := (originalMetricsByTime collect: [:each | each copy]) asSortedCollection.
	recomputationActions do: [:each | each applyTo: updatedMetricsByTime].

	self pvModel calendarManager resetLocalizedSchedules.

"	second := OrderedCollection new: updatedMetricsByTime size.
	updatedMetricsByTime do: [:each |
		| found |
		found := second
			detect: [:eachOther |
				each metricId = eachOther metricId
					and: [each resourceId = eachOther resourceId
					and: [each timestamp = eachOther timestamp]]]
			ifNone: [nil].
		found
			ifNil: [second add: each]
			ifNotNil: [:f | self halt]]."</body>
</methods>

<methods>
<class-id>PROVISO.RecomputationEngine</class-id> <category>logging</category>

<body package="PV-DC-Recomputations" selector="logComputingInputDataFor:">logComputingInputDataFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_INPUTDATA
		text: 'Computing input data for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logComputingTimeSeriesFor:">logComputingTimeSeriesFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_TIMESERIES
		text: 'Computing time series for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logComputingMetadataFor:">logComputingMetadataFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_METADATA
		text: 'Computing metadata changes for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logComputingGenericsFor:">logComputingGenericsFor: aTimeSeries

	self system
		logDebugFour: #RECOMP_STEP_GENERIC
		text: 'Computing generic for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logComputingOriginalResultsFor:">logComputingOriginalResultsFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_ORIGINAL
		text: 'Computing original results for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logMissingFormulaFromCommand:">logMissingFormulaFromCommand: command

	self system 
		logWarning: #NO_FORMULA
		messageId: #DC10437
		template: 'No formula for: &lt;1p&gt;'
		arguments: (Array with: command)</body>

<body package="PV-DC-Recomputations" selector="logComputingDatabaseNonInputMetadataFor:">logComputingDatabaseNonInputMetadataFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_DB_NON_INPUT_METADATA
		text: 'Computing time series for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logComputingInputsFor:">logComputingInputsFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_INPUT
		text: 'Computing inputs for ', aTimeSeries printString</body>

<body package="PV-DC-Recomputations" selector="logComputingScopeFor:">logComputingScopeFor: aTimeSeries

	self system
		logDebugThree: #RECOMP_STEP_SCOPE
		text: 'Computing scope for ', aTimeSeries printString</body>
</methods>


<methods>
<class-id>PROVISO.RecompServer</class-id> <category>transactions</category>

<body package="PV-DC-Recomputations" selector="outputRecompTuplesToDatabase:originLabel:">outputRecompTuplesToDatabase: recompTuples originLabel: originLabel

	| aFilename collToSend |

	self testMode ifTrue: [^self].

	collToSend := recompTuples.
	"Reject all deletes.  If we try to load deletes the db sees them as dups"
	collToSend := collToSend reject: [:each | each isActionDelete].
	collToSend isEmpty
		ifTrue: [^self].

	self logOutputRecompTuplesToDatabase: collToSend.

	"The db load requires the records to be sorted"
	"Note however, that RCM now sorts the tuples, and this function sorts them incorrectly, so we'll get rid of it here..."
"	sortedTuples := SortedCollection new: collToSend size.
	sortedTuples sortBlock: [:a :b | a &lt; b].
	sortedTuples addAll: collToSend."

	aFilename := 
		self 
			writeRecompTuplesToUniqueTempFile: collToSend 
			in: self fileInterface stateLoadDirectory.

	self loadDatafileToDatabase: aFilename.

	"Once we have loaded, delete all files in the state load directory"
	self fileInterface stateLoadDirectory directoryContents do:
		[ :ea | | tmp |
		tmp := self fileInterface stateLoadDirectory construct: ea.
		tmp isDirectory ifTrue:
			[[tmp deepDelete] on: Error do: [ :ex |]]]</body>

<body package="PV-DC-Recomputations" selector="handleTupleContainer:">handleTupleContainer: aTupleContainer 

	| theLabel |
	"Reject dups sent from TSE but allow dups sent by me"
	(self isDuplicateContainer: aTupleContainer) 
		ifTrue: [^self rejectDuplicateContainer: aTupleContainer].

	aTupleContainer isForRecomputations
		ifFalse: [
			(RecompCommandLog on: self) transactionDo: [:txn | 
				self releaseNonRecompTupleContainer: aTupleContainer in: txn.
				self updateLastContainerTimestamp: aTupleContainer timestamp in: txn].
			^nil].

	"Now we may need to wait for the CMEs to catch up..."
	[self isReadyForTupleContainer: aTupleContainer]
		whileFalse: [(Delay forSeconds: 10) wait].

	self system extendedStatus: 'Tuple Processing'.
	"Process the entire tuple container as an xlog"
	self logAboutToProcesesTupleContainer: aTupleContainer.
	theLabel := aTupleContainer label.
	(RecompCommandLog on: self) transactionDo: 
		[:txn | | resultsFn bufferFn sourceFn tempFn tuples |
		self releaseProcessedTupleContainer: aTupleContainer in: txn.
		resultsFn := self fileInterface recompResultsStateFilename.
		sourceFn := self fileInterface recompSourceStateFilename.
		tempFn := self fileInterface recompTempFilename.
		bufferFn := self fileInterface outputBufferForTseStateFilename.
		"We can only call #recomputeAll... once per tuple container, so this has changed..."
		tuples := OrderedCollection new.
		aTupleContainer do: [:each | tuples add: each].
		self fileInterface saveRecompTuples: tuples to: tempFn. 
		txn recomputeAll: tempFn saveResultsTo: resultsFn saveActionsTo: sourceFn originLabel: theLabel.
		self handlePostRecomputeIn: txn for: resultsFn and: sourceFn to: bufferFn on: theLabel.
		txn deleteBufferedRecompResult: tempFn.
		txn outputBufferedRecompResultsToTse: bufferFn.
		txn deleteBufferedRecompResult: bufferFn.
		self updateLastContainerTimestamp: aTupleContainer timestamp in: txn].

	self system extendedStatus: 'Idle'.</body>

<body package="PV-DC-Recomputations" selector="computeScopeFor:on:">computeScopeFor: aTimeSeries on: recomputationActions
	"Determine the scope of the receiver's operation, which involves finding the period of the formula the given time series represents, and then finding the boundaries of that period."

	| startScope endScope scopeStartTimestamp scopeEndTimestamp |
	"Note - We have to do these in reverse order, because part of doing the scope calculation is to resync the formula itself into the model,
	and we need to end up with the original one in the model at the start time, not what was there at the end time..."
	endScope := recompEngine queryInterface
		getScopeFor: aTimeSeries
		timestamp: recomputationActions last timestamp.
	endScope isNil
		ifTrue: [
			self system 
				logDebugTwo: #RECOMP_ERROR
				text: 'No inputs for time series ', aTimeSeries printString, ' at or before ', (PvTimestamp fromSeconds: recomputationActions last timestamp) printString.
			^nil].

	startScope := recomputationActions size = 1
		ifTrue: [endScope]
		ifFalse: [
			self pvModel calendarManager resetLocalizedSchedules.
			recompEngine queryInterface
				getScopeFor: aTimeSeries
				timestamp: recomputationActions first timestamp].
	scopeStartTimestamp := startScope first key.
	scopeEndTimestamp := endScope first value.

	"Since we sometimes end up messing up localized schedules when we compute the scope, we need to reset them."
	self pvModel calendarManager resetLocalizedSchedules.

	^scopeStartTimestamp -&gt; scopeEndTimestamp</body>

<body package="PV-DC-Recomputations" selector="acquireTupleContainer:">acquireTupleContainer: aTupleContainer 
	
	| acquired |
	^self critical: 
		[aTupleContainer validate
			ifFalse: 
				[self system 
					logWarning: #BAD_CONTAINER 
					messageId: #DC12354 
					text: 'Bad container: ', aTupleContainer printString.
				^nil].
		self transactionDo: 
			[:txn | 
			acquired := aTupleContainer acquireIn: txn.
			acquired ifNotNil: [txn addTupleContainer: acquired]].
		acquired]</body>

<body package="PV-DC-Recomputations" selector="handlePostRecomputeIn:for:and:to:on:">handlePostRecomputeIn: txn for: resultsFn and: sourceFn to: bufferFn on: theLabel

	txn outputRecompResultsToDatabase: resultsFn originLabel: theLabel.
	txn outputRecompResultsToDatabase: sourceFn originLabel: theLabel.
	txn bufferOutputRecompResultsForTse: resultsFn in: bufferFn originLabel: theLabel.
"	txn bufferOutputRecompResultsForTse: sourceFn in: bufferFn originLabel: theLabel."
"	txn outputRecompResultsToRecompEngine: resultsFn."
	txn deleteRecompResultsFile: resultsFn.
	txn deleteRecompResultsFile: sourceFn.</body>

<body package="PV-DC-Recomputations" selector="isReadyForTupleContainer:">isReadyForTupleContainer: aTupleContainer
	"Figure out if we can do the recomputation action(s) in the given tuple container. 
	Return true or false to answer the question."

	| recomputationActions cmeTimes referenceDateString returnValue maxRefDate allAffectedTimeSeries |

	testMode
		ifTrue: [^true].

	"If we don't have any recomp actions, we're done. This should never happen, since we've already tested for this."
	recomputationActions := (aTupleContainer allTuples
		select: [:each | each isRecomputationAction]) asOrderedCollection.

	recomputationActions isEmpty
		ifTrue: [^true].

	"For each affected time series, find the labels, and then ask each one where it is at in the timeline."
	cmeTimes := Dictionary new.
	maxRefDate := Infinity negative.
	allAffectedTimeSeries := OrderedCollection new.
	recomputationActions do: 
		[:recompAction | 
		maxRefDate := maxRefDate max: recompAction referenceDate.
		allAffectedTimeSeries addAll: (recompEngine queryInterface getAffectedTimeSeriesFor: recompAction)].
	allAffectedTimeSeries isEmpty
		ifTrue: [^true].
	allAffectedTimeSeries do: [:eachTimeSeries |
		| labels scope |
		scope := self computeScopeFor: eachTimeSeries on: recomputationActions.
		labels := PvTimeSeriesBuildCommand
			labelsForMetricId: eachTimeSeries metricId
			subelementId: eachTimeSeries resourceId
			between: scope key
			and: (scope value == Infinity positive ifTrue: [self timeFacade nowAsSeconds] ifFalse: [scope value]).
		labels do: [:eachLabel |
			| cmePair |
			cmePair := CMETimeSeries new getApplicationForOperatorLabel: eachLabel asNumber.
			(cmePair value notNil and: [(cmeTimes includesKey: cmePair key) not])
				ifTrue: [
					| cmeApplication currentTime |
					cmeApplication := cmePair value.
					[currentTime := cmeApplication server streamLabelOperator periodPolicy last]
						on: Error do: [:signal | signal return: nil].
					cmeTimes at: cmePair key put: currentTime]]].

	"Compare each label's current position with the scope, and log any that aren't far enough along."
	referenceDateString := (PvTimestamp fromSeconds: maxRefDate) printString.
	returnValue := true.
	cmeTimes keysAndValuesDo: [:eachServerName :eachTime |
		eachTime isNil 
			ifTrue: [
				self system 
					logDebugTwo: #RECOMP_NOT_READY
					text: eachServerName, ' is at at an unknown time and needs to be past ', referenceDateString, ' in order to continue with this recomputation.'.
				returnValue := false]
			ifFalse: [
				eachTime &lt; maxRefDate
					ifTrue: [
						self system 
							logDebugTwo: #RECOMP_NOT_READY
							text: eachServerName, ' is at ', (PvTimestamp fromSeconds: eachTime) printString, ' and needs to be past ', referenceDateString, ' in order to continue with this recomputation.'.
						returnValue := false]]].

	^returnValue</body>
</methods>

<methods>
<class-id>PROVISO.RecompServer</class-id> <category>logging</category>

<body package="PV-DC-Recomputations" selector="logAboutToProcesesTupleContainer:">logAboutToProcesesTupleContainer: aTupleContainer
		
	| contents |
	contents := aTupleContainer contents.
	self system 
		logInfo: #DO_CONTAINER
		text: 'About to process tuple container: ', aTupleContainer printString, ' with ', contents size asString, ' actions'.
	(contents copyFrom: 1 to: (5 min: contents size)) 
	 	keysAndValuesDo: [:ix :record | 
			self system 
				logInfo: #DO_CONTAINER_RECORD
				text: ix printString, ':', record printString].</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationAddInputWrapper</class-id> <category>replay</category>

<body package="PV-DC-Recomputations" selector="replayFor:on:">replayFor: aRecomputationEngine on: aTupleRepository
	"Apply the receiver's record to the tuple repository during a recompute..."

	aRecomputationEngine buildInputFromCommand: self record.

	"We need to clean up spurious heartbeat brokers, because we are only interested
	in getting heartbeats to the current time series."
	aTupleRepository heartbeatHandlers do: [:each |
		each dependents asArray do: [:eachBroker |
			((eachBroker isKindOf: CMETimeSeries) and: [eachBroker formula isKindOf: LocalizedSchedule]) 
				ifFalse: 
					[eachBroker metricId = aRecomputationEngine currentTimeSeries metricId
						ifFalse: [each removeDependent: eachBroker]]]].</body>
</methods>


<methods>
<class-id>PROVISO.RecomputationAddTimeSeriesWrapper</class-id> <category>replay</category>

<body package="PV-DC-Recomputations" selector="replayFor:on:">replayFor: aRecomputationEngine on: aTupleRepository
	"Apply the receiver's record to the tuple repository during a recompute..."

	self record metricId = aRecomputationEngine currentTimeSeries metricId
		ifTrue: [aRecomputationEngine disconnectAllHeartbeatSources].

	aRecomputationEngine buildTimeSeriesFromCommand: self record.

	"We need to clean up spurious heartbeat brokers, because we are only interested
	in getting heartbeats to the current time series."
	aTupleRepository heartbeatHandlers do: [:each |
		each dependents asArray do: [:eachBroker |
			((eachBroker isKindOf: CMETimeSeries) and: [eachBroker formula isKindOf: LocalizedSchedule]) 
				ifFalse: [	eachBroker metricId = aRecomputationEngine currentTimeSeries metricId
					ifFalse: [each removeDependent: eachBroker]]]].</body>
</methods>



<methods>
<class-id>PROVISO.PvChannelManagerDbInterface</class-id> <category>stored procedures</category>

<body package="PV-CMG" selector="registerCurrentChannelsFor:">registerCurrentChannelsFor: aConfiguration 
	
	self dbSession doProtected:
		[self dbSession withSessionNoTimeoutDo: 
			[:session | 
			session connection begin.
	[aConfiguration do:[ :anArray|
		session prepare: 
			'INSERT INTO GTT_CHNL_COMPONENT_DESC (IDX_CHNL, IDX_SUBCHNL) VALUES(?,?)'.
		session bindInput: anArray.
	session
		execute].
session preparePLSQL: 'BEGIN ' , 'Pvm_Dataload.Update_Subchnl_Config_Status; END;'.
	session
		execute.
	session connection commit] ifCurtailed: [session connection rollback]]]</body>
</methods>


<methods>
<class-id>PROVISO.PvApplicationManager</class-id> <category>CORBA Interface</category>

<body package="PV-CMG" selector="isRunningApplication:">isRunningApplication: aPvApplicationSpec 
	"Answer true if the app is running or we were unable to tell (assume it is running).
	We will assume an app is running if we can't tell or get an order.  This will keep us from starting 2 instances of the same app (very bad)"

	^PvBlockingTask execute: 
			[self dstFacade corbaOnErrorIn: 
					[| processId |
					processId := self processIdForApplicationSpec: aPvApplicationSpec.
					processId notNil]
				doWithError: 
					[:error | 
					self dstFacade dumpWalkbackForException: error.
					self warnFailedTestIsRunningApplication: aPvApplicationSpec
						withError: error description.
					true]]
		named: self class name</body>
</methods>


<methods>
<class-id>PROVISO.PvChannelManager</class-id> <category>watchdog</category>

<body package="PV-CMG" selector="shouldRestartApplication:appManagerServer:">shouldRestartApplication: eachApplicationSpec appManagerServer: eachAppManagerServer 

	" Should we kill and restart this app? "	
	(self shouldKillAndRestartApplicationSpec: eachApplicationSpec) 
		ifFalse: [^false].

	" Yes, we should kill and restart the application. Try killing it first "
	(self 
		killApplication: eachApplicationSpec
		appManagerServer: eachAppManagerServer) 
			ifTrue: [^true].

	" We failed to kill it. Check maybe it is already stopped "
	eachAppManagerServer ifNil: [^false].		" Application manager is not available, we are not sure "

	" If there is an error while calling app manager, it could be down, so we are not sure "
	^(self dstFacade 
			corbaOnErrorIn: 
				[(eachAppManagerServer isRunningApplication: eachApplicationSpec) not]
			doWithError: 
				[:error | 
				self 
					warnFailedTestIsRunningApplication: eachApplicationSpec
					withError: error description.
				^false])</body>
</methods>

<methods>
<class-id>PROVISO.PvChannelManager</class-id> <category>private</category>

<body package="PV-CMG" selector="isRunningApplication:">isRunningApplication: aPvApplicationSpec 
	"Answer true if the app is running or if we cannot tell.
	It is safer to assume it is running on an error - that way we don't start 2 instances of the same app at the same time (very bad)"

	| application answer applicationManager |
	^self dstFacade corbaOnErrorIn: 
			[application := self dstFacade 
						getObjectNamed: aPvApplicationSpec applicationManagerName
						onErrorDo: 
							[:ex | 
							self warnFailedTestIsRunningApplication: aPvApplicationSpec
								withError: 'application manager: ' 
										, aPvApplicationSpec applicationManagerName , ' unreachable because of: ' 
										, ex description.
							^true].
			answer := application isNil 
						ifTrue: 
							[self warnFailedTestIsRunningApplication: aPvApplicationSpec
								withError: 'application manager: ' 
										, aPvApplicationSpec applicationManagerName , ' unreachable'.
							true]
						ifFalse: 
							[applicationManager := application server.
							applicationManager isRunningApplication: aPvApplicationSpec].
			answer = true]
		doWithError: 
			[:error | 
			self dstFacade dumpWalkbackForException: error.
			self warnFailedTestIsRunningApplication: aPvApplicationSpec
				withError: error description.
			true]</body>
</methods>



<methods>
<class-id>PROVISO.PvInstallerMfteInput</class-id> <category>testing</category>

<body package="PV-Installer-Core" selector="isValidPhysicalHostname:">isValidPhysicalHostname: aString

	^aString notEmpty and: [(IPSocketAddress primHostAddressByName: (IOAccessor convertSimpleStringForPlatform: aString)) notNil]</body>

<body package="PV-Installer-Core" selector="getAsBoolean:">getAsBoolean: aStringOrBoolean
	" return a boolean "
	" RA#503403 -Added method #getAsBoolean to deal with all conditions of the flag (whether boolean or string)"

	^aStringOrBoolean isString
		ifTrue: [aStringOrBoolean = 'true']
		ifFalse: [aStringOrBoolean = true]</body>
</methods>

<methods>
<class-id>PROVISO.PvInstallerMfteInput</class-id> <category>accessing</category>

<body package="PV-Installer-Core" selector="source">source
	" return the source string. If #useSecureFileTransfer is set to true use sftp else ftp
	RA#503403 -Added method #getAsBoolean to deal with all conditions of the flag (whether boolean or string)"
	
	| sourceString |
	sourceString := 
		(self getAsBoolean: self useSecureFileTransfer) 
			ifTrue: ['sftp://']
			ifFalse: ['ftp://'].
	^sourceString , self ftpUser , ':' , self ftpPass pvEncrypt , '@' , 
		self targetHostname , '/' , self targetOutputDirectory</body>
</methods>


<methods>
<class-id>PROVISO.PvInstallerScriptTask</class-id> <category>private</category>

<body package="PV-Installer-Core" selector="writeDccli">writeDccli
	stream nextPutAll:
'
while getopts c: opt
do
        case "$opt" in
            c) CLICOMMAND=$OPTARG ;;
        esac
done
                                                                                
SERVERDIR=$DC_BIN_HOME/server/$HOSTNAME
RESP_FIFO=$SERVERDIR/$$.response

### Find the best request fifo by finding the first one with an active process
for i in `ls $SERVERDIR/*.request 2&gt;/dev/null`; do
  if [ -p "$i" ]; then
    PIDFROMNAME=`basename $i | cut -f 1 -d .`
    if [ ! -z `ps -e -o pid | grep -w $PIDFROMNAME` ]; then
      REQ_FIFO=$i
      break
    fi
  fi
done
                                                                                
### Make sure that the server pipe exists (otherwise the server is not running)
if [ -z "$REQ_FIFO" ]; then
  echo server is not running, make sure the amgr process is started &gt;&amp;2
  exit 1
fi
                                                                                
### Create the response fifo
if [ ! -p $RESP_FIFO ]; then mkfifo $RESP_FIFO; fi
                                                                                
### if a command was given via a command line option, run it
if [ -n "$CLICOMMAND" ]; then
  echo $$:$CLICOMMAND &gt;$REQ_FIFO
  cat $RESP_FIFO
  exit
fi
                                                              
### Disable filename expansion
set -o noglob
                  
### Loop, sending commands to the server
while [ 1 ]; do
   read LINE?"&gt;&gt;&gt; "
   if [[ $? == 1 || "$LINE" == "exit" ]]; then rm $RESP_FIFO; exit; fi
   echo $$:$LINE &gt;$REQ_FIFO
   cat $RESP_FIFO
done &lt;$1
';

cr</body>
</methods>



<methods>
<class-id>PROVISO.PvInstallerMfteInputScreen</class-id> <category>actions</category>

<body package="PV-Installer-Screens" selector="createMenu">createMenu
"installerModel channelNumber collectorNumber collectorConfiguration pollInterval workLimit rootDirectory source "
	self menu: 
		(PvInstallerMenu new
			addMenuItem: 
				(self newValueMenuItem
					name: 'Poll Interval (in seconds)';
					selector: #setPollInterval;
					printReceiver: self mfteInput;
					printSelector: #pollInterval;
					yourself);
			addMenuItem: 
				(self newValueMenuItem
					name: 'Work limit';
					selector: #setWorkLimit;
					printReceiver: self mfteInput;
					printSelector: #workLimit;
					yourself);
			addMenuItem: 
				(self newValueMenuItem
					name: 'Root directory';
					selector: #setRootDirectory;
					printReceiver: self mfteInput;
					printSelector: #rootDirectory;
					yourself);
			addMenuItem: 
				(self newValueMenuItem
					name: 'FTP User';
					selector: #setFtpUser;
					printReceiver: self mfteInput;
					printSelector: #ftpUser;
					yourself);
			addMenuItem: 
				(self newValueMenuItem
					name: 'FTP Password';
					selector: #setFtpPass;
					printReceiver: self mfteInput;
					printSelector: #printFtpPass;
					yourself);
			addMenuItem: 
				(self newValueMenuItem
					name: 'Target output directory';
					selector: #setTargetOutputDirectory;
					printReceiver: self mfteInput;
					printSelector: #targetOutputDirectory;
					yourself);
			addMenuItem: 
				(self newValueMenuItem
					name: 'Use secure file transfer';
					selector: #setUseSecureFileTransfer;
					printReceiver: self mfteInput;
					printSelector: #useSecureFileTransfer;
					yourself); yourself).

                 self menu  addMenuItem: self newSpacerMenuItem;
                 
			addMenuItem: 
				(self newNavigationMenuItem
					name: 'Next';
					selector: #continueToNextScreen;
					yourself);
			addMenuItem: 
				(self newNavigationMenuItem
					name: 'Previous';
					selector: #returnToPreviousScreen;
					yourself);
			addMenuItem: 
				(self newNavigationMenuItem
					name: 'Exit';
					selector: #exitInstallation;
					yourself);
			defaultChoice: #continueToNextScreen;
			label: 'CHANNEL ' , self model currentChannelNumber printString, '.', self model currentCollectorNumber printString, ' Multiple File Transfer Engine (MFTE)'</body>

<body package="PV-Installer-Screens" selector="setTargetHostname">setTargetHostname
	
	| result |
	result := 
		self 
			promptFor: 'Enter the target host name'
			default: self mfteInput targetHostname.
	result isNil 
		ifTrue: [^nil].
	result := result asUppercase.
	(self mfteInput isValidPhysicalHostname: result) 
		ifTrue: [self mfteInput targetHostname: result]
		ifFalse: [self errorString: result printString , ' is invalid']</body>
</methods>



<class>
<name>PvPblStateFileViewer</name>
<environment>PROVISO</environment>
<super>Tools.FileTools.FileContentsViewer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Tools-File Browser</category>
<attributes>
<package>PV-Development Enhancements</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvPblStateFileViewer</class-id> <category>private</category>

<body package="PV-Development Enhancements" selector="textForEntireFile:">textForEntireFile: aFilename 
	
	^(PROVISO.SimpleSerializer forReading: aFilename asFilename readStream binary) read printString</body>

<body package="PV-Development Enhancements" selector="textForFileBeginning:">textForFileBeginning: aFilename 

	^self textForEntireFile: aFilename</body>

<body package="PV-Development Enhancements" selector="largeFileThreshold">largeFileThreshold
	"Files larges than this number of bytes are displayed in preview mode first."

	^10000</body>
</methods>


<methods>
<class-id>PROVISO.PvPblStateFileViewer class</class-id> <category>accessing</category>

<body package="PV-Development Enhancements" selector="tabPosition">tabPosition

	^2</body>

<body package="PV-Development Enhancements" selector="isInterestedInFile:">isInterestedInFile: aFilename 

	^#('versionBeingBuilt.state' 'versionLastBuilt.state' 'labelChangeHistory.state' 'aliasedCollectors.state' 'advanceCollectorRequests.state' 'operatorLabels.state' 'collectorLabels.state') includes: aFilename tail</body>

<body package="PV-Development Enhancements" selector="tabLabel">tabLabel

	^(self name &lt;&lt; #labels &gt;&gt; self name asString)</body>
</methods>



<methods>
<class-id>PROVISO.PvDiscoveryPipeline</class-id> <category>logging</category>

<body package="PV-Discovery-Core" selector="logProfileStucked">logProfileStucked
	
	self system 
		logWarning: #PROFILENOTPROGRESSING
		messageId: #DL39001
		text: self tag , '. Profile is not progressing during the last ' , self stuckTime asString, ' seconds, aborting ...'.</body>
</methods>



<methods>
<class-id>PROVISO.PvIPDiscoveryWorker</class-id> <category>control</category>

<body package="PV-Discovery-IP" selector="filterThruForcedList:">filterThruForcedList: tuples 
	" return either the exact same list of tuples, if forced list is empty, or return only the ones that ARE in the forcedList (and log a message) "

	^self profile isForcedIpList 
		ifTrue: 
			[| forced resultList |
			forced := self pipelineStage forcedIpList asSet.
			resultList := 
				tuples select: 
					[:eachTuple | 
					(forced includes: eachTuple ipAddress) or: 
						[eachTuple hostName isEmpty not and: 
							[(forced 
								detect: [:eachParam | eachTuple hostName , '*' match: eachParam ]
								ifNone: [nil]) isNil not]]].
			self 
				logFilterAddresses: tuples size
				downTo: (resultList collect: [:each | each ipAddress]).
			resultList]
		ifFalse: [tuples]</body>
</methods>



<methods>
<class-id>PROVISO.PvESFormulaEditor</class-id> <category>actions</category>

<body package="PV-CFL-UI" selector="buildComputation">buildComputation
	
	| treeBuilder |
	self validateBeforeBuild 
		ifFalse: 
			[self statusFailure: 'Formula not deployed'.
			^self].
	self results: OrderedCollection new.
	self removeBuildErrors.
	self resetTupleRepository.
	self environment do: 
		[treeBuilder := MockRequestEnumerator new.
		treeBuilder
			environment: Smee.SmeeEnvironment current;
			tupleRepository: self tupleRepository;
			shouldBuildRaAndGaBuckets: false;
			pvModel: self pvModel;
			collectorNumber: 1.
		treeBuilder associations: (Array with: self selectedFormula -&gt; self selectedSubelement).
		treeBuilder addDependent: self.
		[[treeBuilder build] 
			on: Error
			do: [:ex | ^Dialog notify: 'Fatal Build Error: ' , ex description]] 
				on: TreeBuildError
				do: 
					[:ex1 | 
					self addBuildError: ex1.
					ex1 resume]].
	self updateInputChoices.
	self updateStateOfTimeSeriesDependentControls.
	self statusSuccess: 
		'Ready for testing, click ''Show Tree'' at any time to see details'</body>
</methods>



<methods>
<class-id>PROVISO.UBA.AlcatelMRBalancer</class-id> <category>private</category>

<body package="PVAdaptor Core" selector="nextPutRecord:objectNameIndex:fieldsAndIndexes:">nextPutRecord: aNullDelimitedString
	objectNameIndex: nameIndex
	fieldsAndIndexes: fieldNamesAndIndexes
	
	| objectName nameMapEntry id collectorNumber outputStream |
	(aNullDelimitedString at: nameIndex equals: '-') ifTrue: [^self].
	objectName := aNullDelimitedString at: nameIndex.
	nameMapEntry := 
		nameMap 
			at: objectName
			ifAbsent: 
				[PvException generic raiseErrorString: 
					'No name map entry found for ' , objectName smeeToString].
	id := nameMapEntry key.
	collectorNumber := nameMapEntry value.
	outputStream := 
		outputStreams 
			at: collectorNumber
			ifAbsent: [nil].
	outputStream isNil 
		ifTrue: 
			[PvException generic raiseErrorString: 
				'No output stream found for collector #' , collectorNumber smeeToString].
	fieldNamesAndIndexes do: 
		[:each | 
		aNullDelimitedString write: each value on: outputStream.
		outputStream nextPut: $,].
	owner currentObject incrementProcessedRecordCount.
	outputStream
		print: id;
		cr</body>
</methods>


<methods>
<class-id>PROVISO.UBA.Record</class-id> <category>accessing</category>

<body package="PVAdaptor Core" selector="schema">schema
	&lt;getterNamed: #schema&gt;
	^schema</body>
</methods>



<methods>
<class-id>PROVISO.UBA.FecordSchema</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="inputSchema">inputSchema
	&lt;getterNamed: #inputSchema&gt;
	^(self parent ifNil: [^nil]) inputSchema</body>
</methods>


<class>
<name>InputSchema</name>
<environment>PROVISO.UBA</environment>
<super>PROVISO.UBA.AbstractSchema</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>uri uri2 username password recordNumber schemas onScan scannedInputs scannedInputs1 scannedInputs2 lastFoundNewInputsSeconds1 lastFoundNewInputsSeconds2 lateLimitSeconds minFileSize uriParser deleteOnAcquire localEnvironment precedence inputAgeLimit lastInputTimestamp inputTimeInterval lastProcessedTimestamp sequenceSkipDelay errorFileCount errorFileLimit retryLimit onOpen onClose onStartup acquireURI onFullDump ignoreProcessingErrors inputDescriptors handlerBlock multiFileJoin myEventTable scheduler executeCommand </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>PVAdaptor-Schema</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="preProcessInputStreamFor:">preProcessInputStreamFor: inputDescriptor 
	
	self lastInputTimestamp: inputDescriptor timestamp.
	inputDescriptor startTimestamp: SmeeDate nowUTC.
	self logStartProcessingInput: inputDescriptor uriInDoDirectory.
	self preRead 
		valueWithThis: self
		with: inputDescriptor</body>

<body package="PVAdaptor-Schema" selector="setTimestampFor:">setTimestampFor: inputDescriptor

	inputDescriptor correctTimestampIfNeeded</body>

<body package="PVAdaptor-Schema" selector="postProcessInputStreamFor:">postProcessInputStreamFor: inputDescriptor 
	
	self recordProcessingCompletion: inputDescriptor.
	inputDescriptor rejectedRecordCount &gt; 0 
		ifTrue: 
			[self incrementErrorFileCount]</body>

<body package="PVAdaptor-Schema" selector="process:">process: eachInput
	
	^handlerBlock value: eachInput</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>acquisition</category>

<body package="PVAdaptor-Schema" selector="purgeUnusedInputDescriptors">purgeUnusedInputDescriptors

	| keepers1 keepers2 descriptorCount toBeRemoved toBeUpdated time |
	self system 
		logDebugTwo: #PURGE_UNUSED_DESCRIPTORS
		text: 'Purging unused ', self name, ' descriptors.'.
	time := 
		Time millisecondsToRun: 
			[toBeRemoved := PvDictionary new: self inputDescriptors size.
			toBeUpdated := PvDictionary new: self inputDescriptors size.

			"Collect the names from the list of scanned inputs for each URI"
			keepers1 := (scannedInputs1 collect: [ :ea | ea name]) asSet.
			keepers2 := (scannedInputs2 collect: [ :ea | ea name]) asSet.
			
			descriptorCount := 0.
			self myInputDescriptorsDo: 
				[:each | 
				descriptorCount := descriptorCount + 1.
				self 
					updateDescriptorStatus: each 
					foundList: keepers1 
					locationName: 'uri1' 
					ifUpdated: [toBeUpdated at: each name put: each].
				self 
					updateDescriptorStatus: each 
					foundList: keepers2
					locationName: 'uri2' 
					ifUpdated: [toBeUpdated at: each name put: each].
				(each 
					canBePurgedAtSeconds: self currentSeconds 
					withRetentionDuration: (self inputAgeLimit * 3600)
					forInputSources: (uri2 ifNil: [#('uri1')] ifNotNil: [#('uri1' 'uri2')]))
						ifTrue: 
							[toBeUpdated removeKey: each name ifAbsent: [].
							toBeRemoved at: each name put: each]].
			toBeRemoved do: 
				[:each | | uriInDo | 	
				(uriInDo := each uriInDoDirectory) exists 
					ifTrue: [uriInDo delete].
				each delete.
				each uri].
			toBeUpdated do: [:each | self adaptor updateInputDescriptor: each]].

	self system 
		logDebugTwo: #PERF_PURGE_UNUSED_DESCRIPTORS
		text: 'Purged ', toBeRemoved size printString, ' out of ', descriptorCount printString, ' ', self name, ' descriptors in ', (time / 1000.0) printString, ' seconds'.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Schema" selector="initialize">initialize
	
	super initialize.
	environment := Smee.SmeeEnvironment current.
	recordNumber := 0.
	scannedInputs := SmeeArray new.
	scannedInputs1 := #().
	scannedInputs2 := #().
	localEnvironment := Dictionary new.
	precedence := 0.
	inputAgeLimit := 168.		"7 days expressed in hours"
	errorFileCount := 0.
	errorFileLimit := Infinity positive.
	deleteOnAcquire := false.
	retryLimit := 5.
	acquireURI := true.
	ignoreProcessingErrors := false.
	self heartbeatPeriod: 1.		" Generate heartbeats every second "
	handlerBlock := [:eachInput | self adaptor processInputDescriptor: eachInput]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchema</class-id> <category>private</category>

<body package="PVAdaptor-Schema" selector="handleRecordError:">handleRecordError: ex 

	self currentObject incrementRejectedRecordCount.

	self 
		invokeSmeeCallback: #recordErrorHandler 
		withArguments: {ex description}
		ifAbsent: [].

	self adaptor ifNotNil: [:a |
		a
			logRejectedRecordNumber: self currentObject processedRecordCount
			reason: ex description
			totalThusFar: self currentObject rejectedRecordCount].</body>

<body package="PVAdaptor-Schema" selector="recordProcessingAborted:">recordProcessingAborted: anInputDescriptor 
	
	anInputDescriptor stopTimestamp: SmeeDate nowUTC.
	self inputDescriptors at: anInputDescriptor name put: anInputDescriptor.
	^self</body>

<body package="PVAdaptor-Schema" selector="recordProcessingCompletion:">recordProcessingCompletion: anInputDescriptor 

	anInputDescriptor stopTimestamp: SmeeDate nowUTC.
	anInputDescriptor logStopProcessingInput.
	self inputDescriptors at: anInputDescriptor name put: anInputDescriptor.
	^self</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>deleteInputDescriptor:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>startTimestamp</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>logStopProcessingInput:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>rejectedRecordCount:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>logPerformanceStats</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>incrementRejectedRecordCount</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>recordsPerMinute</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>elapsedSeconds</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>startTimestamp:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>stopTimestamp</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>stopTimestamp:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>rejectedRecordCount</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>lastRejectedRecordNumber</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchema</class-id> <selector>lastRejectedRecordNumber:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.InputSchema class</class-id> <category>sorting</category>

<body package="PVAdaptor-Schema" selector="sortBlock">sortBlock

	^[:a :b | a precedence &gt;= b precedence]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>testing</category>

<body package="PVAdaptor-Schema" selector="canBePurgedAtSeconds:withRetentionDuration:forInputSources:">canBePurgedAtSeconds: seconds withRetentionDuration: retentionDuration forInputSources: inputSources
	"&lt;Boolean&gt; Answer whether or not the receiver is eligible to be purged for the given time and age limit for the given inputSources."

	"If the descriptor is younger than the given retention duration, then the answer is automatically false."
	(self ageDifference: seconds ifUnknown: [nil]) 
		ifNotNil: [ :ageDiff | (ageDiff &lt;= retentionDuration) ifTrue: [^false]].
	" if the descriptor has been processed. purge it now"
	(self alreadyProcessed and: [self isInDoDirectory not]) ifTrue: [^true].
	"If the file tracked by the receiver is present (or assumed present) at any of the supplied inputSources, then the receiver can not be purged.  Under no circumstances to we delete the input descriptor of a file that is still present at the source."
	(inputSources anySatisfy: [ :ea | self isAssumedPresentAtSource: ea ]) ifTrue: [^false].

	^true</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Schema" selector="initialize">initialize
	
	super initialize.
	ignore := false.
	self resetCommitMessages.
	inputSourceStatus := String new.
	noNewInputCount := 0.
	processedRecordCount := 0.
	rejectedRecordCount := 0.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="recordsPerMinute">recordsPerMinute
	| seconds |
	seconds := self elapsedSeconds.
	^seconds isZero
		ifTrue: [4.2d42]
		ifFalse: [((self processedRecordCount / seconds) * 60) asFloat]</body>

<body package="PVAdaptor-Schema" selector="scheduledTimestamp:">scheduledTimestamp: aDate 
	
	scheduledTimestamp := aDate</body>

<body package="PVAdaptor-Schema" selector="stopTimestamp:">stopTimestamp: anObject
	&lt;setterNamed: #stopTimestamp&gt;
	stopTimestamp := anObject.
	self processedTimestamp: anObject.</body>

<body package="PVAdaptor-Schema" selector="incrementProcessedRecordCount">incrementProcessedRecordCount

	processedRecordCount := processedRecordCount + 1</body>

<body package="PVAdaptor-Schema" selector="markScheduled">markScheduled

	scheduledTimestamp := SmeeDate nowUTC.
	self save.</body>

<body package="PVAdaptor-Schema" selector="incrementRejectedRecordCount">incrementRejectedRecordCount
	rejectedRecordCount := rejectedRecordCount + 1</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>commit actions</category>

<body package="PVAdaptor-Schema" selector="delete">delete

	self ifAlreadyProcessedMoveToDone.
	^self schema inputDescriptors removeKey: self name</body>

<body package="PVAdaptor-Schema" selector="ifAlreadyProcessedMoveToDone">ifAlreadyProcessedMoveToDone
	
	(self alreadyProcessed and: [self isInDoDirectory]) 
		ifTrue: [self enqueueMoveToDone]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>public</category>

<body package="PVAdaptor-Schema" selector="correctTimestampIfNeeded">correctTimestampIfNeeded
	
	self hasValidTimestamp 
		ifFalse: [self timestamp: (SmeeDate fromUTCSeconds: 0)]</body>

<body package="PVAdaptor-Schema" selector="acceptProcessor:">acceptProcessor: aProcessor

	aProcessor processInputDescriptor: self</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>private</category>

<body package="PVAdaptor-Schema" selector="resetCommitMessages">resetCommitMessages
	
	(self commitMessages isNil or: [self commitMessages notEmpty]) 
		ifTrue: [self commitMessages: OrderedCollection new]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>merging</category>

<body package="PVAdaptor-Schema" selector="mergeWith:">mergeWith: anInputDescriptor 
	
	| changed |
	changed := false.
	(self ignore not and: [anInputDescriptor ignore]) 
		ifTrue: 
			[changed := true.
			self ignore: true].
	(anInputDescriptor timestamp notNil and: [anInputDescriptor timestamp ~= self timestamp])
		ifTrue: 
			[changed := true.
			self timestamp: anInputDescriptor timestamp].
	(anInputDescriptor alreadyAcquired and: [self alreadyAcquired not])
		ifTrue: 
			[changed := true.
			self acquiredTimestamp: anInputDescriptor acquiredTimestamp].
	(anInputDescriptor alreadyProcessed and: [self alreadyProcessed not])
		ifTrue: 
			[changed := true.
			self processedTimestamp: anInputDescriptor processedTimestamp].
	(anInputDescriptor alreadyScheduled and: [self alreadyScheduled not])
		ifTrue: 
			[changed := true.
			self scheduledTimestamp: anInputDescriptor scheduledTimestamp].
	^changed</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptor</class-id> <category>logging</category>

<body package="PVAdaptor-Schema" selector="logPerformanceStats">logPerformanceStats

	self schema adaptor ifNotNil: [
		self system 
			logInfo: #PERF_INPUT_PROCESSING
			template: 'Processed &lt;1p&gt; records in &lt;2p&gt; seconds (&lt;3p&gt; records/minute); rejected &lt;4p&gt; records'
			arguments: 
				{self processedRecordCount.
				self elapsedSeconds.
				self recordsPerMinute.
				self rejectedRecordCount}]</body>

<body package="PVAdaptor-Schema" selector="logStopProcessingInput">logStopProcessingInput
	&lt;comment: 'The adaptor completed processing of the named input' 
	probableCause: 'Normal if 0 rejected records' 
	suggestedAction: 'If records were rejected, this could indicate a malformed file, file with missing fields (specified in an object adaptor and with no "default value" or problem with adaptor configuration'&gt; 
	
	self system 
		logInfo: #STOP_INPUT
		messageId: #DL39806
		template: ##('Completed processing input: &lt;1s:input_name&gt; uri: &lt;2s:uri&gt;' asLogTemplate)
		arguments: [{self schema name. self uriInDoDirectory asStringWithObfuscatedPassword}].
	self logPerformanceStats.</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputDescriptor</class-id> <selector>childRecordCountTotal</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.InputDescriptor class</class-id> <category>class initialization</category>

<body package="PVAdaptor-Schema" selector="initializeSmeeProperties">initializeSmeeProperties
	
	super initializeSmeeProperties.
	self smeeInterface propertyAccessorsForPersistence
		at: #schema
			put: 
				(SmeeAccessorProperty 
					key: #schema
					get: #serializeSchema
					put: #materializeSchema:);
		at: #scheduledTimestamp
			put: 
				(SmeeAccessorProperty 
					key: #scheduledTimestamp
					get: #scheduledTimestamp
					put: #scheduledTimestamp:)</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>public</category>

<body package="PVAdaptor-Schema" selector="processInputsForAdaptor:">processInputsForAdaptor: anAdaptor 
	
	| acquiredAnything scheduledAnything noNewInputBlock |
	noNewInputBlock := [:each | each incrementNoNewInputCount].
	[acquiredAnything := self acquireOnNoNewInputDo: noNewInputBlock.
	scheduledAnything := self schedule.
	acquiredAnything or: [scheduledAnything]] 
		whileTrue: 
			[schema shouldAcquireOnlyOnce 
				ifTrue: [^self].
			noNewInputBlock := [:each | ]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>scheduling</category>

<body package="PVAdaptor-Schema" selector="scheduleMostRecentInputs">scheduleMostRecentInputs
	
	| scheduledAnything |
	scheduledAnything := false.
	self inputsByPeriodDo: 
		[:eachSet | 
		(self shouldBeProcessed: eachSet) 
			ifTrue: 
				[scheduledAnything := true.
				self processAll: eachSet]
			ifFalse: [^scheduledAnything]].
	^scheduledAnything</body>

<body package="PVAdaptor-Schema" selector="nextPeriodInputsFrom:">nextPeriodInputsFrom: inputStream 
	
	| begin result |
	begin := nil.
	result := OrderedCollection new.
	inputStream do: 
		[:each | 
		| periodStart |
		periodStart := self startOfPeriod: each.
		begin ifNil: [begin := periodStart].
		periodStart = begin 
			ifTrue: [result add: each]
			ifFalse: 
				[inputStream skip: -1.
				^result]].
	^result</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Schema" selector="initializeWith:">initializeWith: anInputSchema 
	
	| filePeriod |
	schema := anInputSchema.
	filePeriod := schema filePeriod ifNil: [1].
	periodPolicy := PeriodPolicy length: filePeriod.
	self resetScheduledDescriptors</body>

<body package="PVAdaptor-Schema" selector="resetScheduledDescriptors">resetScheduledDescriptors
	
	schema inputDescriptors do: 
		[:each | 
		each alreadyProcessed 
			ifFalse: [each scheduledTimestamp: nil]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>processing</category>

<body package="PVAdaptor-Schema" selector="processAll:">processAll: inputs 
	" If the schema is not a multifile join, there should ordinarily be only one file to process at a time.
	If multiple files are found, it is probably a mistake (i.e. script did not bother to set a timestamp.
	In this case sort files by local name as a meek protection (increases likelihood files will be processed
	in desired order. Quite frankly, the only reason we bother is because there are some sloppy test cases
	that don't set descriptor's timestamp "
	
	| realInputs endTimestamp |
	realInputs := 
		(inputs size &gt; 1 and: [schema multiFileJoin not]) 
			ifTrue: 
				[self system 
					logWarning: #MULTIPLE_FILES_PER_PERIOD_DETECTED
					messageId: #DC10428
					text: 
						'Multiple files per period ' , 
							inputs anyOne timestamp smeeToNumber pvOpportunisticPrintString , 
								' are found -- this should not happen. Please check the design script and data feed mechanism'.
				(inputs asSortedCollection: [:i1 :i2 | i1 localName &lt; i2 localName]) asOrderedCollection]
			ifFalse: [inputs].
	realInputs do: 
		[:each | 
		schema process: each.
		each markScheduled].
	realInputs isEmpty 
		ifFalse: 
			[endTimestamp := 
				(periodPolicy endOfPeriodContainingTimestamp: 
					(self toSeconds: realInputs anyOne timestamp)) + 1.
			schema process: (PvStreamHeartbeat timestamp: endTimestamp)]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputDescriptorScheduler</class-id> <category>private</category>

<body package="PVAdaptor-Schema" selector="toSeconds:">toSeconds: aPvTimestampOrSmeeDate 
	
	^aPvTimestampOrSmeeDate isValid 
		ifTrue: [aPvTimestampOrSmeeDate asPvTimestamp asSeconds]
		ifFalse: [0]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.NoneInputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	self currentObject: inputDescriptor.
	self environment global at: self name put: inputDescriptor.
	inputDescriptor startTimestamp: SmeeDate nowUTC.
	self logStartProcessingInput: inputDescriptor uriInDoDirectory.
	self onRead valueWithThis: self with: inputDescriptor.
	self recordProcessingCompletion: inputDescriptor.
	^self</body>
</methods>


<methods>
<class-id>PROVISO.UBA.BOFInputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="handle:using:">handle: record using: client 
	
	| smeeRec |
	client parsedObject: record.
	self incrementRecordNumber.
	smeeRec := 
		self 
			convertToSmee: record
			using: client pvModel.
	smeeRec schema: self.
	^self schemas do: 
		[:eachRecordSchema | 
			eachRecordSchema onRead 
					valueWithThis: eachRecordSchema
					with: smeeRec.
			self currentObject incrementProcessedRecordCount]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.SAMPassThruSchema</class-id> <category>acquisition</category>

<body package="PVAdaptor-Schema" selector="inputsToAcquire">inputsToAcquire
	
	| all |
	all := super inputsToAcquire.
	^self lastExportTimestamp 
		ifNil: [all]
		ifNotNil: 
			[:lastExport | all select: [:each | each timestamp asPvTimestamp &lt; lastExport]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.SAMPassThruSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	| uriInDo cNumber |
	(self shouldProcessInput: inputDescriptor) ifFalse: [^self].
	self currentObject: inputDescriptor.
	self lastInputTimestamp: inputDescriptor timestamp.
	self environment global at: self name put: inputDescriptor.
	inputDescriptor startTimestamp: SmeeDate nowUTC.
	self logStartProcessingInput: inputDescriptor uriInDoDirectory.

	uriInDo := inputDescriptor uriInDoDirectory.
	(cNumber := self collectorNumberFor: inputDescriptor) = -1
		ifTrue: [^self error: 'no collector number for sam stats file'].
	inputDescriptor
		addCommitMessage: 
			(MessageSend 
				receiver: nil
				selector: #linkFrom:to:
				arguments: 
					(Array 
						with: uriInDo
						with: 
							(self fileInterface outputDirectory, 
								((uriInDo tail copyReplaceAll: ('.', self fileExtension) with: ''), '.', cNumber asString, '.', self fileExtension)))).
	self onRead valueWithThis: self with: inputDescriptor.
	self recordProcessingCompletion: inputDescriptor.
	^self</body>

<body package="PVAdaptor-Schema" selector="collectorNumberFor:">collectorNumberFor: inputDescriptor
	"&lt;Integer&gt; Answer the collector number for the given input descriptor (hopefully, we will actually be able to map any given SAM metric file to a single collector number)."

	"Update: it looks like we will have to crack open the files, so ultimately, this method will go away in favor of methods that do idmap lookups to determine the collector number for individual metric records."

" We are now no longer using ID-Maps so, get the collector number from the dc.cfg. But we are keeping the old code to be backward compatible. If the idmapSchema is present then we assume it is old code if not it is new code "

	| tmp |
	^(self adaptor inputSchemas at: #idmap ifAbsent: [nil])
		ifNil: [self environment collectorNumber]
		ifNotNil: 
			[ :schema | 
			(tmp := schema knownCollectorNumbers) isEmpty 
				ifTrue: [self environment collectorNumber]
			 	ifFalse: [tmp first]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.PassThruInputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	self currentObject: inputDescriptor.
	self environment global at: self name put: inputDescriptor.
	inputDescriptor startTimestamp: SmeeDate nowUTC.
	self logStartProcessingInput: inputDescriptor uriInDoDirectory.
	self lastInputTimestamp: inputDescriptor timestamp.
	inputDescriptor enqueueLinkToOutput.
	self onRead valueWithThis: self with: inputDescriptor.
	self recordProcessingCompletion: inputDescriptor.
	^self</body>
</methods>


<methods>
<class-id>PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <category>private-alcatel</category>

<body package="PVAdaptor-Schema" selector="enqueueAlcatelAvailFilesToBeMovedForInput:">enqueueAlcatelAvailFilesToBeMovedForInput: inputSourceDescriptor 
	
	| availInputs availInputsToMove inputTimestamp filename |
	availInputs := self alcatel5620AvailabilityInputs.
	inputTimestamp := inputSourceDescriptor timestamp.
	availInputsToMove := availInputs select: [:each | each timestamp &lt;= inputTimestamp].
	availInputsToMove isEmpty 
		ifTrue: 
			[self system 
				logWarning: #MISSING_AVAILABILITY_FILES
				messageId: #DL39209
				text: 'No availability files found for metric file ' , inputSourceDescriptor name]
		ifFalse: 
			[availInputsToMove do: 
				[:eachInput | 
				| eachURI |
				"Ordinarily, we would want to do something like the following to record the fact that the availability input has been acquired and processed, however, since we know that we'll always be deleting the source availability file, we can use that fact to indicate that we've processed the file instead, so don't waste time doing the following two lines. -spair"
				"eachInput acquiredTimestamp: SmeeDate nowUTC.
				eachInput processedTimestamp: eachInput acquiredTimestamp."
				eachURI := eachInput uri smeeToString asURI.
				filename := eachURI asFilename.
				inputSourceDescriptor
					addCommitMessage: 
						(MessageSend 
							receiver: nil
							selector: #linkFrom:to:
							arguments: 
								(Array 
									with: eachURI
									with: self fileInterface outputDirectory , filename tail));
					addCommitMessage: 
						(MessageSend 
							receiver: nil
							selector: #moveFrom:to:
							arguments: 
								(Array 
									with: eachURI
									with: self doneDirectory , filename tail)).
				"Delete the availability input descriptor (we can only do this because we know we are deleting the availability files from the QCIF directory).  In the future, we should implement a protocol on the descriptor to record that processing is complete and depending on whether the descriptors get deleted when acquired, we can either record the processing timestamp, or just delete the descriptor. -spair"
				eachInput delete]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	| balancer tmpStrm urix nullDelimitedString |
	(self shouldProcessAlcatelMRInput: inputDescriptor) 
		ifFalse: [^self].
	self recordNumber: 0.
	self enqueueAlcatelAvailFilesToBeMovedForInput: inputDescriptor.
	(urix := inputDescriptor uriInDoDirectory) exists 
		ifTrue: 
			[self lastInputTimestamp: inputDescriptor timestamp.
			self updateLastProcessedTimestamp.
			self currentObject: inputDescriptor.
			self environment global at: self name put: inputDescriptor.
			urix readStreamDo: 
				[:sourceStream :params | 
				inputDescriptor startTimestamp: SmeeDate nowUTC.
				self logStartProcessingInput: inputDescriptor uriInDoDirectory.
				self preRead valueWithThis: self with: inputDescriptor.
				params at: #InputDescriptor put: inputDescriptor.
				balancer := 
					AlcatelMRBalancer new
						owner: self;
						stream: sourceStream text;
						params: params.
				[balancer nameMap: self getNameMap.
				balancer atEnd ifFalse: [balancer nextHeader].
				nullDelimitedString := PvNullDelimitedString new.
				tmpStrm := (String new: 2000) writeStream.
				[balancer atEnd] 
					whileFalse: 
						[[tmpStrm reset.
						balancer nextRecordAsNullDelimitedStringOnto: tmpStrm.
						nullDelimitedString string: tmpStrm collection from: 1 to: tmpStrm position.
						balancer nextPutRecord: nullDelimitedString.
						self incrementRecordNumber.
						client parsedObject: nullDelimitedString] 
									on: Error
									do: [:ex | self handleRecordError: ex]]] 
										ensure: [balancer closeAll].
				self onRead valueWithThis: self with: inputDescriptor.
				self recordProcessingCompletion: inputDescriptor.
				self recordNumber: 0]]
		ifFalse: 
			["We should not ever get here"
			self system 
				logWarning: #ALCATEL_MR_NOT_FOUND
				messageId: #DL39215
				text: 
					'Alcatel MR file ' , inputDescriptor name , 
						' does not exist -- deleting file descriptor'.
			inputDescriptor delete].
	^self</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <selector>processedRecordCount:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <selector>processedRecordCount</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <selector>incrementProcessedRecordCount</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <selector>childRecordCountTotal</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.AlcatelMRBalancerInputSchema</class-id> <selector>logStopProcessingInput:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.CWMPassThruSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	| uriInDo cNumber |
	(self shouldProcessInput: inputDescriptor) ifFalse: [^self].
	self currentObject: inputDescriptor.
	self lastInputTimestamp: inputDescriptor timestamp.
	self environment global at: self name put: inputDescriptor.
	inputDescriptor startTimestamp: SmeeDate nowUTC.
	self logStartProcessingInput: inputDescriptor uriInDoDirectory.

	uriInDo := inputDescriptor uriInDoDirectory.
	(cNumber := self collectorNumberFor: inputDescriptor) = -1
		ifTrue: [^self error: 'no collector number for cwm stats file'].
	inputDescriptor
		addCommitMessage: 
			(MessageSend 
				receiver: nil
				selector: #linkFrom:to:
				arguments: 
					(Array 
						with: uriInDo
						with: 
							(self fileInterface outputDirectory, 
								(uriInDo tail, '.', cNumber asString, '.cwm')))).
	self onRead valueWithThis: self with: inputDescriptor.
	self recordProcessingCompletion: inputDescriptor.
	self enqueueAvailFilesToBeMovedForInput: inputDescriptor.
	^self</body>
</methods>


<methods>
<class-id>PROVISO.UBA.IdMapSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	| journal |
	inputDescriptor uriInDoDirectory exists 
		ifTrue: 
			[self currentObject: inputDescriptor.
			self environment global at: self name put: inputDescriptor.
			inputDescriptor startTimestamp: SmeeDate nowUTC.
			self logStartProcessingInput: inputDescriptor uriInDoDirectory.
			self preRead valueWithThis: self with: inputDescriptor.
			"Note: there is a chance here that we'll do some extra work...if multiple idmap files are in the do directory (which might happen if BLB/UBA has not been running for a while), we'll be reading the changes in all of them...the only harm in that is the extra work that we will be doing.  A solution would be to provide a mechanism in PvrJournal to only open a journal on a single file (as opposed to finding all log file matchine the name template)."
			journal := PvrJournal 
				recoverFromDirectory: inputDescriptor filenameInDoDirectory directory
				named: 'idmap'
				logNameTemplate: '&lt;1s&gt;~&lt;2s&gt;~&lt;3s&gt;.&lt;4s&gt;' 
				nameSeparator: '~'
				timeBlock: PvrExternalStreamFactory defaultTimeBlock.
			journal materializeCallback: [ :strm | strm upTo: Character lf ].
			[self readIdMapEntriesFrom: journal readStream]
				ensure: [journal close].
			self onRead valueWithThis: self with: inputDescriptor.
			self recordProcessingCompletion: inputDescriptor]
		ifFalse: [self ignoreInputDescriptor: inputDescriptor].
	inputDescriptor delete.
	^self</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.IdMapSchema</class-id> <selector>recordsPerMinute</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.RecordSchema</class-id> <category>events</category>

<body package="PVAdaptor-Schema" selector="triggerOnReadWith:">triggerOnReadWith: aFieldOrRecord 
	
	[self rootSchema currentObject incrementProcessedRecordCount] 
		on: MessageNotUnderstood
		do: [:ex | "do nothing"].
	^super triggerOnReadWith: aFieldOrRecord</body>
</methods>

<methods>
<class-id>PROVISO.UBA.RecordSchema</class-id> <category>copying</category>

<body package="PVAdaptor-Schema" selector="postCopy">postCopy

	super postCopy.
	properties := properties copy</body>
</methods>


<methods>
<class-id>PROVISO.UBA.SQLInputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	| stream |
	self currentObject: inputDescriptor.
	self environment global at: self name put: inputDescriptor.
	inputDescriptor uriInDoDirectory readStreamDo: 
		[:sourceStream :params | 
		inputDescriptor startTimestamp: SmeeDate nowUTC.
		self logStartProcessingInput: inputDescriptor uriInDoDirectory.
		self preRead valueWithThis: self with: inputDescriptor.
		stream := 
			self inputStreamClass 
				on: sourceStream
				schema: self
				params: params.
		(self recordSchemaFromLocalName: inputDescriptor localNameString)
			parseHeaderRecordFrom: stream;
			parseAllFrom: stream
				notifying: client].
	self onRead valueWithThis: self with: inputDescriptor.
	self recordProcessingCompletion: inputDescriptor.
	^self</body>
</methods>


<methods>
<class-id>PROVISO.UBA.PVLINEInputSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	self currentObject: inputDescriptor.
	self environment global at: self name put: inputDescriptor.
	inputDescriptor uriInDoDirectory readStreamDo: 
		[:sourceStream :params | 
		inputDescriptor startTimestamp: SmeeDate nowUTC.
		self logStartProcessingInput: inputDescriptor uriInDoDirectory.
		self preRead 
			valueWithThis: self
			with: inputDescriptor.
		self 
			parsePvLineStream: sourceStream
			params: params
			client: client.
		self onRead 
			valueWithThis: self
			with: inputDescriptor.
		self recordProcessingCompletion: inputDescriptor].
	^self</body>

<body package="PVAdaptor-Schema" selector="parsePvLineStream:params:client:">parsePvLineStream: sourceStream params: params client: client 
	
	| stream record |
	self schemas isEmpty 
		ifTrue: 
			[stream := 
				PvLineParser new
					stream: sourceStream text;
					params: params.
			[stream atEnd] 
				whileFalse: 
					[[record := stream nextRecord.
					record isNil 
						ifFalse: 
							[client parsedObject: record.
							self onRead 
								valueWithThis: self
								with: record].
							self currentObject incrementProcessedRecordCount.] 
									on: Error
									do: [:ex | self handleRecordError: ex]]]
		ifFalse: 
			[self schemas do: 
				[:eachRecordSchema | 
				eachRecordSchema 
					parsePvLineStream: sourceStream
					params: params
					client: client]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.PVLINERecordSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parsePvLineStream:params:client:">parsePvLineStream: sourceStream params: params client: client 
	
	| stream record |
	stream := 
		PvLineParser new
			stream: sourceStream text;
			params: params.
	[stream atEnd] 
		whileFalse: 
			[[record := stream nextRecord.
			record isNil 
				ifFalse: 
					[client parsedObject: record.
					self onRead 
						valueWithThis: self
						with: record].
					self rootSchema currentObject incrementProcessedRecordCount] 
							on: Error
							do: [:ex | self handleRecordError: ex]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.IdMapBLBSchema</class-id> <category>parsing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	
	| journal uriInDo |
	uriInDo := inputDescriptor uriInDoDirectory.
	uriInDo exists 
		ifTrue: 
			[self currentObject: inputDescriptor.
			self environment global at: self name put: inputDescriptor.
			inputDescriptor startTimestamp: SmeeDate nowUTC.
			self logStartProcessingInput: inputDescriptor uriInDoDirectory.
			self preRead valueWithThis: self with: inputDescriptor.
			"Note: there is a chance here that we'll do some extra work...if multiple idmap files are in the do directory (which might happen if BLB/UBA has not been running for a while), we'll be reading the changes in all of them...the only harm in that is the extra work that we will be doing.  A solution would be to provide a mechanism in PvrJournal to only open a journal on a single file (as opposed to finding all log file matchine the name template)."
			journal := PvrJournal 
				recoverFromDirectory: inputDescriptor filenameInDoDirectory directory
				named: 'idmap'
				logNameTemplate: '&lt;1s&gt;~&lt;2s&gt;~&lt;3s&gt;.&lt;4s&gt;' 
				nameSeparator: '~'
				timeBlock: PvrExternalStreamFactory defaultTimeBlock.
			journal materializeCallback: [ :strm | strm upTo: Character lf ].
			[self readIdMapEntriesFrom: journal readStream]
				ensure: [journal close].
			self knownCollectorNumbers do: 
				[ :cNumber |
				inputDescriptor addCommitMessage: 
					(MessageSend 
						receiver: nil
						selector: #linkFrom:to:
						arguments: 
							(Array 
								with: uriInDo
								with: 
									(self fileInterface outputDirectory, (cNumber asString, '.', uriInDo tail))))].
			self onRead valueWithThis: self with: inputDescriptor.
			self recordProcessingCompletion: inputDescriptor]
		ifFalse: [self ignoreInputDescriptor: inputDescriptor].
	inputDescriptor delete.
	^self</body>
</methods>


<methods>
<class-id>PROVISO.UBA.CDWPassThruSchema</class-id> <category>accessing</category>

<body package="PVAdaptor-Schema" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client 
	| uriInDo cNumber |
	(self shouldProcessInput: inputDescriptor) 
		ifTrue: 
			[self currentObject: inputDescriptor.
			self lastInputTimestamp: inputDescriptor timestamp.
			self environment global at: self name put: inputDescriptor.
			inputDescriptor startTimestamp: SmeeDate nowUTC.
			self logStartProcessingInput: inputDescriptor uriInDoDirectory.
			uriInDo := inputDescriptor uriInDoDirectory.
			(cNumber := self collectorNumberFor: inputDescriptor) = -1 
				ifTrue: [^self error: 'no collector number for cwm stats file'].
			inputDescriptor addCommitMessage: (MessageSend 
						receiver: nil
						selector: #linkFrom:to:
						arguments: (Array with: uriInDo
								with: self fileInterface outputDirectory 
										, (uriInDo tail , '.' , cNumber asString , '.cwm'))).
			self onRead valueWithThis: self with: inputDescriptor.
			self recordProcessingCompletion: inputDescriptor]
		ifFalse: 
			[inputDescriptor doNotProcess].
	self enqueueAvailFilesToBeMovedForInput: inputDescriptor.
	^self</body>
</methods>



<methods>
<class-id>PROVISO.UBA.UBAApplication</class-id> <category>initialization</category>

<body package="PVAdaptor-Application" selector="initializePvModel">initializePvModel
	
	self pvModel initializeForUBA.
	self testMode 
		ifFalse: 
			[self pvModel formulaManager shouldBuildSmalltalkFormulas: false.
			self pvModel
				idManager: nil;
				idManagerRU: nil;
				idManagerEvent: nil]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAAbstractProcessingStrategy</class-id> <category>private</category>

<body package="PVAdaptor-Application" selector="langolierInputDescriptorsIfInTestMode">langolierInputDescriptorsIfInTestMode
	
	self rootOperator ifNotNil: 
		[:root | 
		root testMode 
			ifTrue: 
				[root langolierOperatorStateOlderThan: Infinity positive.
				owner inputDescriptors do: 
					[:each | 
					each commitMessages notEmpty 
						ifTrue: [root transactionDo: [:log | each addCommitMessagesTo: log]]]]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UBAAbstractProcessingStrategy</class-id> <category>controlling</category>

<body package="PVAdaptor-Application" selector="hookStop">hookStop
	
	self environment do: 
		[self inputDescriptors ifNotNil: [:rep | rep close].
		self inputSchemas do: [:eachInputSchema | eachInputSchema stop].
		self langolierInputDescriptorsIfInTestMode]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAEngineFileInterface</class-id> <category>As yet unclassified</category>

<body package="PVAdaptor-Application" selector="earliestTimeFrom:startingAt:">earliestTimeFrom: aFilename startingAt: anArrayWithDayAndTime 
	
	| result |
	result := anArrayWithDayAndTime.
	aFilename dates do: 
		[:each | 
		(each first &lt; result first or: [each first = result first and: [each second &lt; result second]]) 
			ifTrue: [result := each]].
	^result</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAAbstractServer</class-id> <category>logging</category>

<body package="PVAdaptor-Application" selector="logInvalidLicense:">logInvalidLicense: licenseName

	self system 
		logWarning: #INVALID_LICENSE
		messageId: #DL39206
		template: 'License(&lt;1s&gt;) is invalid or missing'
		arguments: (Array with: licenseName)</body>
</methods>


<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PVAdaptor-Application" selector="initializeForNGUBA">initializeForNGUBA
	
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvElementManager new.
	subelementManager := PvSubelementManager new.
	eventManager := PvEventManager new.
	eventPropertyManager := PvEventPropertyManager new.
	eventRelationManager := PvEventRelationManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvPropertyManager new.
	relationManager := PvRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAServiceInstance</class-id> <category>adapting</category>

<body package="PVAdaptor-Application" selector="commit:">commit: inputSourceDescriptor 
	
	(inputSourceDescriptor notNil and: 
		[inputSourceDescriptor ignore not and: [self shouldCommit: inputSourceDescriptor]]) 
			ifTrue: 
				[self system extendedStatus: 'Commiting ' , inputSourceDescriptor localName.
				"send #flushAll instead of commitAll to avoid doing duplicate 
				moveTempFilesToOutputUsing"
				self modelInterface 
					ifNotNil: [:mi | mi flushAll].
				self transactionDo: 
					[:log | 
					inputSourceDescriptor addCommitMessagesTo: log.
					self moveTempFilesToOutputUsing: log].
				^self onCommit valueWithThis: self]</body>

<body package="PVAdaptor-Application" selector="processInputs">processInputs
	
	(Array streamContents: 
		[:joins | 
		(self inputSchemas asSortedCollection: InputSchema sortBlock) do: 
			[:each | 
			| wait |
			wait := Semaphore new.
			joins nextPut: wait.
			Bindings 
				fork: 
					[[self rootOperator executeWithWriteControl: [each scheduler processInputs]] 
						ensure: [wait signal]]
				named: self class name , '-' , each name
				at: Processor activeProcess priority]]) do: [:eachWait | eachWait wait]</body>

<body package="PVAdaptor-Application" selector="shouldCommit:">shouldCommit: anInputSourceDescriptor
	(self showOnly or: [self shouldDumpXML]) 
		ifTrue: [^false].
	^(anInputSourceDescriptor rejectedRecordCount = 0 or: [self failOnRejectedRecords not])</body>

<body package="PVAdaptor-Application" selector="langolierAll">langolierAll
	
	self environmentDo: 
		[self rootOperator 
			ifNil: 
				[self inputDescriptors do: 
					[:each | 
					each ifAlreadyProcessedMoveToDone]]
			ifNotNil: [:root | root langolierOperatorState].
		self transactionDo: 
			[:log | 
			self inputDescriptors do: 
				[:each | 
				each commitMessages notEmpty
					ifTrue: [each addCommitMessagesTo: log]]]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UBAServiceInstance</class-id> <category>testing</category>

<body package="PVAdaptor-Application" selector="processedRecordCount">processedRecordCount
	"USE ONLY FOR TESTING!!!!"
	^self inputDescriptors inject: 0 into: [:sum :each | sum + each processedRecordCount]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.UBAServiceInstance</class-id> <selector>rejectedRecordCount</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.UBAServiceInstance</class-id> <selector>shouldCommit</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.UBAServer</class-id> <selector>builderFromXml:withId:ifPresent:ifAbsent:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.UBANPServiceInstance</class-id> <category>adapting</category>

<body package="PVAdaptor-Application" selector="commit:">commit: inputSourceDescriptor 
	
	inputSourceDescriptor isNil 
		ifTrue: 
			[self transactionDo: 
				[:log | self moveTempFilesToOutputUsing: log].
			self onCommit valueWithThis: self]
		ifFalse: 
			[(inputSourceDescriptor ignore not and: [self shouldCommit: inputSourceDescriptor]) 
				ifTrue: 
					[self system extendedStatus: 'Commiting ' , inputSourceDescriptor localName.
					self objectBuilders do: [:each | each prepare].
					self objectBuilders do: [:each | each finish].
					self  transactionDo: 
						[:log | 
						inputSourceDescriptor addCommitMessagesTo: log.
						self moveTempFilesToOutputUsing: log].
					self onCommit valueWithThis: self]]</body>
</methods>



<methods>
<class-id>PROVISO.PvWATupleRepositoryEditor</class-id> <category>actions</category>

<body package="PV-UBA-GUI" selector="clearTuples">clearTuples

	self tupleStorage metricTimeSeries do:
		[ :ts | ts initBufferedTuples]</body>
</methods>


<methods>
<class-id>PROVISO.PvWATupleRepository</class-id> <category>actions</category>

<body package="PV-UBA-GUI" selector="clearTuples">clearTuples

	self tupleStorage metricTimeSeries do:
		[ :ts | ts initBufferedTuples]</body>
</methods>



<methods>
<class-id>PROVISO.PvInventorySubelementManager</class-id> <category>adding/removing</category>

<body package="PV-NM-Inventory-Application" selector="addItem:withId:name:record:">addItem: anObject withId: id name: aString record: aPvrObjectRecord
	
	self pvModel elementManager 
		itemWithId: aPvrObjectRecord object third
		ifPresent: 
			[:element | 
			anObject element: element.
			element subelements add: anObject.
			self 
				addItem: anObject
				withId: id
				name: aString]
		ifAbsent: 
			[self system 
				logInfo: #ELEMENT_MISSING
				messageId: #DC10593
				text: 
					'Element with id ' , aPvrObjectRecord object third printString , 
						' is not found for subelement ' , aPvrObjectRecord object second , '(' , 
							id printString , ')'].</body>
</methods>


<methods>
<class-id>PROVISO.PvInventoryPropertyManager</class-id> <category>database queries - private</category>

<body package="PV-NM-Inventory-Application" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := Dictionary new
		at: #collectors put: collectors;
		at: #startSeconds put: startSeconds;
		at: #endSeconds put: endSeconds;
		yourself.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParametersForInventory: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each]</body>
</methods>


<class>
<name>PvQCF5620PropertyManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvInventoryPropertyManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-NM-Inventory-Application</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvQCF5620PropertyManager</class-id> <category>database queries - private</category>

<body package="PV-NM-Inventory-Application" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := Dictionary new
		at: #collectors put: collectors;
		at: #startSeconds put: startSeconds;
		at: #endSeconds put: endSeconds;
		yourself.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParametersForQCF5620: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each]</body>
</methods>



<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-QCF-5620-Application" selector="initializeForQCF5620">initializeForQCF5620
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvInventoryElementManager new.
	subelementManager := PvInventorySubelementManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvQCF5620PropertyManager new.
	relationManager := PvInventoryRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self; bufferActions: false; yourself).
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>


<methods>
<class-id>PROVISO.PvProperty class</class-id> <category>database support</category>

<body package="PV-QCF-5620-Application" selector="selectStatementWithParametersForInventory:">selectStatementWithParametersForInventory: parametersDictionary 
	"self dbSession execute: 
		(self 
		selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 0 #endSeconds 1028821796 #collectors #(1))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := 
		self lastResyncDate isNil 
			ifTrue: [startSeconds]
			ifFalse: [self lastResyncDate + 1].
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 
				' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt; ' , endSeconds asString , ' '].
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT /*+ NO_MERGE(VIEW1) USE_NL(VIEW1 t1)  ORDERED */ 
		%COLUMNLIST 
	FROM (
			SELECT /*+ push_subq */
				E.idx_ind as idx_ind
			FROM %ELEMENTHISTORYTABLE E
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se)  */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE E,
				%SUBELEMENTHISTORYTABLE SE 
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
				AND E.IDX_IND = SE.IDX_HOST
				AND SE.DTE_DATE = ( SELECT MAX(SE1.DTE_DATE)
									FROM %SUBELEMENTHISTORYTABLE SE1
									WHERE SE1.IDX_IND = SE.IDX_IND
										AND SE1.IDX_HOST = SE.IDX_HOST
										AND SE1.DTE_DATE %SUBQUERYDATECONDITION)
				AND SE.STR_ACTION IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.DTE_HIST_DATE = ( SELECT MAX (t2.DTE_HIST_DATE)
									FROM %TABLE t2
									WHERE t1.IDX_METRIC = t2.IDX_METRIC
										AND t1.IDX_RESOURCE = t2.IDX_RESOURCE
										AND t2.DTE_HIST_DATE %PRIMARYDATECONDITION)
		AND t1.DTE_HIST_DATE %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>

<body package="PV-QCF-5620-Application" selector="selectStatementWithParametersForQCF5620:">selectStatementWithParametersForQCF5620: parametersDictionary 
	"(self selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 0 #endSeconds 1028821796 #collectors #(1 2 3 4 5 6))))"
	"(self selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 12123123 #endSeconds 1028821796 #collectors #(1 2 3 4 5 6))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := 
		self lastResyncDate isNil 
			ifTrue: [startSeconds]
			ifFalse: [self lastResyncDate + 1].
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 	' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt; ' , endSeconds asString , ' '].
	namedReplacements at: 'HINT' put: ' /*+ NO_MERGE(VIEW1) USE_HASH(VIEW1 t1) ORDERED PUSH_SUBQ ALL_ROWS */ '.
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT %HINT 
		%COLUMNLIST 
	FROM (
			SELECT /*+ push_subq */
				E.idx_ind as idx_ind
			FROM %ELEMENTHISTORYTABLE E
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se)  */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE E,
				%SUBELEMENTHISTORYTABLE SE 
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
				AND E.IDX_IND = SE.IDX_HOST
				AND SE.DTE_DATE = ( SELECT MAX(SE1.DTE_DATE)
									FROM %SUBELEMENTHISTORYTABLE SE1
									WHERE SE1.IDX_IND = SE.IDX_IND
										AND SE1.IDX_HOST = SE.IDX_HOST
										AND SE1.DTE_DATE %SUBQUERYDATECONDITION)
				AND SE.STR_ACTION IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.DTE_HIST_DATE = ( SELECT MAX (t2.DTE_HIST_DATE)
									FROM %TABLE t2
									WHERE t1.IDX_METRIC = t2.IDX_METRIC
										AND t1.IDX_RESOURCE = t2.IDX_RESOURCE
										AND t2.DTE_HIST_DATE %PRIMARYDATECONDITION)
		AND t1.DTE_HIST_DATE %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>
</methods>



<methods>
<class-id>PROVISO.UBA.CWMInputSchema</class-id> <category>parsing</category>

<body package="PV-CWM-Application" selector="parseInput:notifying:">parseInput: inputDescriptor notifying: client
	
	self currentObject: inputDescriptor.
	SmeeEnvironment current global at: self name put: inputDescriptor.
      self resetProcessedRecordCounts.
	self recordNumber: 0.
	inputDescriptor rejectedRecordCount: 0.
	inputDescriptor uriInDoDirectory exists 
		ifTrue: 
			[inputDescriptor uriInDoDirectory readStreamDo: 
				[:sourceStream :params | 
				self lastInputTimestamp: inputDescriptor timestamp.
				inputDescriptor startTimestamp: SmeeDate nowUTC.
				self logStartProcessingInput: inputDescriptor uriInDoDirectory.
				self preRead valueWithThis: self with: inputDescriptor.

				sourceStream binary.
				self processor parser stream: sourceStream.
				self processor inputDescriptor: inputDescriptor.
				[self processor reduce]
					on: Error
					do: [ :ex | self logParsingError: inputDescriptor].

				self processor parser stream: nil.
				self processor currentRecord: nil.

				self recordProcessingCompletion: inputDescriptor.
				inputDescriptor delete.
				inputDescriptor rejectedRecordCount &gt; 0 ifTrue: 
					[inputDescriptor rejectedRecordCount: 0.
					self incrementErrorFileCount]]]
		ifFalse: 
			[self system 
				logWarning: #INPUT_MISSING
				messageId: #DL39214
				text: 'Input ' , inputDescriptor name , ' not found'.
			self recordProcessingAborted: inputDescriptor].
	^self</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.CWMInputSchema</class-id> <selector>recordsPerMinute</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-CWM-Application" selector="initializeForCWM">initializeForCWM
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvInventoryElementManager new.
	subelementManager := PvInventorySubelementManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvInventoryPropertyManager new.
	relationManager := PvInventoryRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self; bufferActions: false; yourself).
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>



<methods>
<class-id>PROVISO.PvAbstractSAMInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="secondaryDescriptor">secondaryDescriptor

	^self descriptors at: 2 ifAbsent: [nil]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>parsing</category>

<body package="SAM-Interface" selector="stop">stop
	
	connection ifNotNil: [connection disconnect].
	self domainModel ifNotNil: 
		[:model | model connection ifNotNil: [:modelConn | modelConn disconnect]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="processFullDumpFor:">processFullDumpFor: anInterface 
	
	| retries |
	retries := 0.
	anInterface connection ifNotNil: 
		[:conn | 
		conn jmsInterface doInventoryChange: 
			[self adaptor environmentDo: 
				[[conn jmsInterface cleanInventoryQueue.
				anInterface preFullDump.
				self onFullDump valueWithThis: self.
				anInterface postFullDump] 
					on: Error
					do: 
						[:ex | 
						(ex isResumable or: [ex isKindOf: SmeeError]) 
							ifFalse: 
								[(self timeFacade delayForMilliseconds: 500) wait.
								retries &lt; 10 
									ifTrue: 
										[retries := retries + 1.
										self logFullDumpRetried: ex.
										ex retry]].
						self logFullDumpInterrupted: ex.
						anInterface markNotInFullDump.
						conn jmsInterface markFullDumpInterrupted]]]].
	^'A full dump has been scheduled'</body>
</methods>

<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>logging</category>

<body package="SAM-Interface" selector="logFullDumpRetried:">logFullDumpRetried: ex
	&lt;comment: 'A full dump of inventory objects had an error and is being retried.'&gt;
	&lt;probableCause: 'A communications interruption with the server'&gt;
	&lt;suggestedAction: 'Initiate another full dump.'&gt;

	self system
		logDebugFour: #FULL_DUMP_RETRIED
		messageId: #DL39002
		template: ##('Full inventory dump is being retried due to the following reason: &lt;1s:problem description&gt;)' asLogTemplate)
		arguments: [{ex description}]</body>
</methods>


<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>connection</category>

<body package="SAM-Interface" selector="jmsInterfaceClass">jmsInterfaceClass
	
	^PvSAMJmsInterface</body>

<body package="SAM-Interface" selector="basicConnect">basicConnect
	"&lt;self&gt; Create an HttpClient and try to ping the server...an exception will be signaled if there is any problem"
	
	self critical: 
		[self client: self newClient.
		self descriptor jmsURI ifNotNil: 
			[self jmsInterface: (self jmsInterfaceClass on: self).
			self setEventCallbackBlock]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>testing</category>

<body package="SAM-Interface" selector="jmsStillAlive">jmsStillAlive
	
	^self jmsInterface 
		ifNil: [false]
		ifNotNil: [:jms | jms stillAlive]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>private</category>

<body package="SAM-Interface" selector="logSendError:">logSendError: error 
	
	self system 
		logWarning: #SEND_ERROR
		messageId: #DC10014
		text: error description</body>

<body package="SAM-Interface" selector="sendAndRetry:">sendAndRetry: request 
	
	| retries |
	retries := 0.
	^[self client request: request.
	self client executeAndGetResponse] 
		on: Error
		do: 
			[:httpIssue | 
			retries := retries + 1.
			retries &lt;= 5 
				ifTrue: 
					[self reconnect.
					(Delay forMilliseconds: 500) wait.
					httpIssue retry]
				ifFalse: [httpIssue pass]]</body>

<body package="SAM-Interface" selector="send:timeout:">send: aString timeout: msecs 
	"&lt;HttpResponse&gt; Send the given XML string to the server and get the response...if we fail, try to disconnect the current client, create a new client, and resend the request.

	NOTE: we may need to fork the #executeAndGetResponse in the future so that we can kill it if it takes longer than the timeout to execute"
	
	| request |
	request := self newRequestWithContents: aString.
	^self critical: 
		[[self sendAndRetry: request] 
			on: Error
			do: 
				[:error | 
				self logSendError: error.
				self serverUnreachable: error description]]</body>
</methods>


<class>
<name>PvSAMJmsInterface</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>stdioConnection stdin stdout stderr eventStream externalProcess lastKeepAlive eventCallback stdoutListener stderrListener receivedKeepAlive connection environment inventoryChangeQueue inventoryChangeService lastServerStartTime lock </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>testing</category>

<body package="SAM-Interface" selector="stillAlive">stillAlive
	
	^self isActive and: [self isStale not]</body>

<body package="SAM-Interface" selector="isStale">isStale
	
	^Time microsecondClock - lastKeepAlive &gt; (self jmsTimeout * 1000000)</body>

<body package="SAM-Interface" selector="hasConnectedSuccessfully">hasConnectedSuccessfully

	^self isActive and: [receivedKeepAlive]</body>

<body package="SAM-Interface" selector="isActive">isActive
	
	^self critical: [inventoryChangeService isRunning and: 
			[externalProcess 
				ifNil: [false]
				ifNotNil: 
					[:process | 
					process isActive and: 
						[stdioConnection 
							ifNil: [false]
							ifNotNil: [:conn | conn isActive]]]]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>initialize-release</category>

<body package="SAM-Interface" selector="resetInventoryQueue">resetInventoryQueue
	
	inventoryChangeQueue := SharedQueue new</body>

<body package="SAM-Interface" selector="initialize">initialize

	super initialize.
	eventCallback := [ :event | ].
	lastKeepAlive := Time microsecondClock.
	receivedKeepAlive := false.
	lock := RecursionLock new.
	stdoutListener :=
		Kom.PluggableService new
			name: 'SAM JMS stdout listener';
			runCallback: [ :testBlock | self reportDeathOf: [self processStdout: testBlock] as: 'JMS stdout listener'];
			priority: 45;
			yourself.
	stderrListener :=
		Kom.PluggableService new
			name: 'SAM JMS stderr listener';
			runCallback: [ :testBlock |  self reportDeathOf: [self processStderr: testBlock] as: 'JMS stderr listener'];
			priority: 45;
			yourself.
	self resetInventoryQueue.
	inventoryChangeService := 
		Kom.PluggableService new
			name: 'Inventory Change Service';
			runCallback: [ :testBlock |  self reportDeathOf: [self processInventoryChangeEvents: testBlock] as: 'JMS stderr listener'];
			priority: 45;
			yourself.</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>constants</category>

<body package="SAM-Interface" selector="terminateClientSessionEventXmlString">terminateClientSessionEventXmlString
	
	^(self jmsEvents keys 
		detect: [:each | each asLowercase includesSubString: 'terminateClientSession']
		ifNone: [#TerminateClientSession]) asString</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="javaPath">javaPath
	^self descriptor javaPath</body>

<body package="SAM-Interface" selector="queueId">queueId
	^self descriptor queueId</body>

<body package="SAM-Interface" selector="jmsProperties">jmsProperties
	^self descriptor jmsProperties</body>

<body package="SAM-Interface" selector="uri">uri
	^self descriptor jmsURI</body>

<body package="SAM-Interface" selector="inventoryChangeQueue">inventoryChangeQueue

	^inventoryChangeQueue</body>

<body package="SAM-Interface" selector="jarPath">jarPath
	^self descriptor jarPath</body>

<body package="SAM-Interface" selector="jmsEvents">jmsEvents
	^self descriptor jmsEvents</body>

<body package="SAM-Interface" selector="jmsClasses">jmsClasses
	^self descriptor jmsClasses</body>

<body package="SAM-Interface" selector="filter">filter
	^self descriptor jmsFilter</body>

<body package="SAM-Interface" selector="user">user
	^self descriptor user</body>

<body package="SAM-Interface" selector="password">password
	^self descriptor password</body>

<body package="SAM-Interface" selector="descriptor">descriptor

	^connection ifNotNil: [:conn | conn descriptor]</body>

<body package="SAM-Interface" selector="jmsTimeout">jmsTimeout
	"&lt;Integer&gt; Answer the number of seconds that the receiver is allowed to go without a keep alive message from the JMS listener before the listener is considered stale."

	^self descriptor jmsTimeout</body>

<body package="SAM-Interface" selector="samVersion">samVersion
	^self descriptor samVersion</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>starting and stopping</category>

<body package="SAM-Interface" selector="forceRestartOrSwitch:">forceRestartOrSwitch: shouldFork 
	
	| block |
	block := 
		self hasConnectedSuccessfully 
			ifTrue: [[self forceRestart]]
			ifFalse: [[self forceSwitch]].
	shouldFork 
		ifTrue: [block fork]
		ifFalse: [block value]</body>

<body package="SAM-Interface" selector="stopExternalProcess">stopExternalProcess
	
	| process |
	self critical: 
		[self stop: stderrListener.
		self stop: stdoutListener.
		process := externalProcess ifNil: [^self].
		process isActive 
			ifTrue: 
				[self cmdQuit.
				(Delay forSeconds: 1) wait]].
	self waitForExternalProcessToStop: (self basicStopExternalProcess: process)</body>

<body package="SAM-Interface" selector="stop">stop
	
	self critical: 
		[self stop: inventoryChangeService.
		self stopExternalProcess.
		ObjectMemory removeDependent: self]</body>

<body package="SAM-Interface" selector="start">start
	
	self uri ifNil: [^self].
	self critical: 
		[self isActive ifTrue: [^self].
		ObjectMemory addDependent: self.
		self resetInventoryQueue.
		self startExternalProcess.
		self restart: inventoryChangeService]</body>

<body package="SAM-Interface" selector="startExternalProcess">startExternalProcess
	
	| args |
	args := 
		Array 
			with: '-jar'
			with: self jarPath
			with: self uri host , ':' , self uri port asString.
	externalProcess ifNotNil: [self stopExternalProcess].
	self critical: 
		[receivedKeepAlive := false.
		stdioConnection := 
			ExternalProcess defaultClass 
				pipeConnectionWithErrorFor: self javaPath
				arguments: args
				setProcessDescriptor: [:p | externalProcess := p].
		self logProcessStarted: externalProcess pid.
		stdin := stdioConnection writeStream.
		stdout := stdioConnection readStream.
		stderr := stdioConnection errorReadStream.
		lastKeepAlive := Time microsecondClock.
		self restart: stderrListener.
		self restart: stdoutListener.
		"Only do the following if we talking to the 2.1 jms interface."
		self samVersion = '2.1' 
			ifTrue: 
				[self cmdAddUser: self user.
				self cmdAddPassword: self hashedPassword.
				self cmdAddQueueId: self queueId].
		self samVersion = '3.0' 
			ifTrue: 
				[self cmdAddUser: self user.
				self cmdAddPassword: self password pvDecrypt.
				self cmdAddQueueId: self queueId.
				self cmdAddFilter: self filter]
			ifFalse: 
				[self jmsClasses do: [:ea | self cmdAddClass: ea].
				self jmsProperties do: [:ea | self cmdAddProperty: ea]]]</body>

<body package="SAM-Interface" selector="update:with:from:">update: anAspect with: arguments from: anObject
	"Shut down the external process when the image is exiting"

	anAspect == #aboutToQuit
		ifTrue: 
			[[self stop] on: Error do: [:ex | ]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>processing</category>

<body package="SAM-Interface" selector="processTerminateClientSession">processTerminateClientSession
	"attempt to immediately reconnect"
	
	self forceRestartOrSwitch: true</body>

<body package="SAM-Interface" selector="processStateChangeXmlEvent:objectType:">processStateChangeXmlEvent: anElement objectType: aType 
	
	| result primaryIP startTime subResult secondaryIP |
	(self isMissedJmsEvent: anElement) 
		ifTrue: 
			[self descriptor schema processFullDumpFor: self connection samInterface.
			^#()].
	result := 
		self 
			processXmlEvent: anElement
			objectType: aType.
	result size ~= 4 
		ifTrue: [^result].
	subResult := result at: 4.
	subResult isEmpty 
		ifTrue: [^result].
	primaryIP := 
		subResult first 
			at: 'sysPrimaryIp'
			ifAbsent: [nil].
	self 
		updateDescriptor: self connection samInterface primaryDescriptor
		with: primaryIP.
	secondaryIP := 
		subResult first 
			at: 'sysStandbyIp'
			ifAbsent: [nil].
	self 
		updateDescriptor: self connection samInterface secondaryDescriptor
		with: secondaryIP.
	startTime := 
		(subResult first 
			at: 'sysStartTime'
			ifAbsent: [^result]) asNumber.
	self runFullDumpIfNeeded: startTime.
	^result</body>

<body package="SAM-Interface" selector="isMissedJmsEvent:">isMissedJmsEvent: anElement 
	
		| tag body |
	body := 
		anElement anyElementNamed: 
			(XML.NodeTag 
				qualifier: ''
				ns: 'xmlapi_1.0'
				type: 'jms').
	body ifNotNil: 
		[tag := 
			body anyElementNamed: 
				(XML.NodeTag 
					qualifier: ''
					ns: 'xmlapi_1.0'
					type: 'state')].
	(tag isNil or: [tag elements isEmpty]) 
		ifTrue: [^nil].
	^tag elements first text includesSubString: 'jmsMissedEvent'</body>

<body package="SAM-Interface" selector="forceFullDumpOnRestart">forceFullDumpOnRestart
	
	lastServerStartTime := nil</body>

<body package="SAM-Interface" selector="processEvent:">processEvent: strm 
	"Process a string coming from the JMS interface (this could be an event or heartbeat)"
	
	| event tmp |
	strm next.
	"Consume the 'C'"
	self environment do: [event := Smee.SmeeArray new].
	[strm atEnd] 
		whileFalse: 
			[tmp := String readNetStringFrom: strm.
			tmp = self keepAliveEventString 
				ifTrue: [^self processKeepAlive].
			tmp = self stateChangeEventString 
				ifTrue: [^self processStateChangeEvent: strm].
			tmp = self generalExceptionString 
				ifTrue: [^self].
			tmp = self jmsExceptionString 
				ifTrue: [^self processJmsException: strm].
			tmp := 
				tmp 
					copyFrom: 2
					to: tmp size.
			event add: tmp].
	self doEvent: event</body>

<body package="SAM-Interface" selector="processXmlEvent:objectType:eventType:objectName:">processXmlEvent: anElement
	objectType: anObjectType
	eventType: anEventType
	objectName: anObjectName
	
	| eventColl |
	eventColl := OrderedCollection new.
	eventColl
		add: anEventType;
		add: anObjectType;
		add: anObjectName.
	self 
		processFilteredXmlEvent: anElement
		eventType: anEventType
		into: eventColl.
	self doEvent: eventColl.
	^eventColl</body>

<body package="SAM-Interface" selector="markFullDumpInterrupted">markFullDumpInterrupted
	
	self forceFullDumpOnRestart.
	self forceRestartOrSwitch: true.</body>

<body package="SAM-Interface" selector="doInventoryChange:">doInventoryChange: aBlock

	inventoryChangeQueue nextPut: aBlock</body>

<body package="SAM-Interface" selector="runFullDumpIfNeeded:">runFullDumpIfNeeded: startTime 
	
	(self isFullDumpNeeded: startTime) 
		ifTrue: 
			[self descriptor schema processFullDumpFor: self connection samInterface.
			lastServerStartTime := startTime]</body>

<body package="SAM-Interface" selector="processXmlEvent:">processXmlEvent: strm 
	"Process an xml element coming from the JMS interface (this could be an event or heartbeat)"
	
	| aType anElement |
	strm next.
	"Consume the 'X'"
	[anElement := XML.XMLParser new parseElement: strm.
	aType := self getObjectType: anElement.
	aType = self keepAliveEventXmlString 
		ifTrue: 
			[self processKeepAlive.
			^self 
				processXmlEvent: anElement
				objectType: aType
				eventType: aType
				objectName: nil].
	aType = self terminateClientSessionEventXmlString 
		ifTrue: 
			[^self processTerminateClientSession].
	self updateLastKeepAliveTimestamp.
	aType = self stateChangeEventXmlString 
		ifTrue: 
			[^self 
				processStateChangeXmlEvent: anElement
				objectType: aType].
	^(self jmsClasses includes: aType) 
		ifTrue: 
			[self 
				processXmlEvent: anElement
				objectType: aType]
		ifFalse: 
			[self 
				processXmlEvent: anElement
				objectType: aType
				eventType: 'IgnoredEvent'
				objectName: nil]] 
					on: Error
					do: [:ex | self logEventProcessingError: ex]</body>

<body package="SAM-Interface" selector="processJmsException:">processJmsException: strm 
	"Process a jms exception string coming from the JMS interface"
	
	| tmp |
	tmp := String readNetStringFrom: strm.
	self processErr: tmp.
	self forceRestartOrSwitch: true.</body>

<body package="SAM-Interface" selector="doEvent:">doEvent: event 
	
	self doInventoryChange: 
		[[self eventCallback value: event] 
			on: Error
			do: [:ex | self logEventProcessingError: ex]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>private</category>

<body package="SAM-Interface" selector="updateDescriptor:with:">updateDescriptor: aDescriptor with: anIpString 
	
	"aDescriptor ifNil: [^self].
	anIpString ifNil: [^self].
	#(soapURI jmsURI exportURI) do: 
		[:each | 
		(aDescriptor perform: each) ifNotNil: 
			[:uri | 
			uri 
				host: anIpString
				port: uri port]]"</body>

<body package="SAM-Interface" selector="isFullDumpNeeded:">isFullDumpNeeded: startTime 
	
	"a;lways return true until we can distinguish between new and old subscriptions on JMS connection"
	"^self attemptResync or: 
		[lastServerStartTime isNil or: [lastServerStartTime ~= startTime]]"
	^true</body>

<body package="SAM-Interface" selector="restart:">restart: aService

	self stop: aService.
	aService start</body>

<body package="SAM-Interface" selector="reportDeathOf:as:">reportDeathOf: aBlock as: aString 
	
	aBlock 
		on: Error
		do: 
			[:ex | 
			self processErr: aString , ' died: ' , ex description.
			self forceRestartOrSwitch: true]</body>

<body package="SAM-Interface" selector="waitForExternalProcessToStop:">waitForExternalProcessToStop: extProc

	| pid |
	extProc ifNil: [^self].
	pid := extProc pid.

	"Now, wait for the external process to die (logging messages if it refuses)"
	[[extProc wait.
	true]
		timeoutSeconds: 60
		onTimeout: 
			[self logStuckProcess: pid.
			false]] whileFalse.

	self logProcessStopped: pid.</body>

<body package="SAM-Interface" selector="processStrings:do:while:">processStrings: stringCallback do: processCallback while: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	| str |
	[testBlock value] 
		whileTrue: 
			[[str := stringCallback value] 
				timeoutSeconds: 1
				onTimeout: [str := nil].
			str ifNotNil: [Process unsafeRegion: [processCallback value: str]]]</body>

<body package="SAM-Interface" selector="isInFullDump">isInFullDump
	
	^self connection 
		ifNil: [false]
		ifNotNil: 
			[:conn | 
			conn samInterface 
				ifNil: [false]
				ifNotNil: [:samInterface | samInterface isInFullDump ifNil: [false]]]</body>

<body package="SAM-Interface" selector="forceRestart">forceRestart
	
	self stop.
	(Delay forSeconds: 5) wait.
	self start</body>

<body package="SAM-Interface" selector="forceSwitch">forceSwitch
	
	self connection ifNotNil: 
		[:conn | 
		conn samInterface ifNotNil: 
			[:samInterface | 
			self stop.
			(Delay forSeconds: 10) wait.
			samInterface setNextDescriptor.
			self forceFullDumpOnRestart.
			self start]]</body>

<body package="SAM-Interface" selector="cleanInventoryQueue">cleanInventoryQueue
	
	[inventoryChangeQueue isEmpty] 
		whileFalse: [inventoryChangeQueue nextNoWait]</body>

<body package="SAM-Interface" selector="stop:">stop: aService

	aService stop.
	aService waitForStopForSeconds: 1.
	aService isStopped ifFalse: [aService kill].</body>

<body package="SAM-Interface" selector="attemptResync">attemptResync
	
	^self connection 
		ifNil: [false]
		ifNotNil: 
			[:conn | 
			conn samInterface 
				ifNil: [false]
				ifNotNil: [:samInterface | samInterface attemptResync ifNil: [true]]]</body>

<body package="SAM-Interface" selector="critical:">critical: aBlock

	^lock critical: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>process management</category>

<body package="SAM-Interface" selector="getStringFrom:">getStringFrom: aStream 
	
	^self getStringFrom: aStream onError: [:ex | self logProtocolError: ex]</body>

<body package="SAM-Interface" selector="processStderr:">processStderr: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: [self getStringFrom: stderr onError: [:ex | ]]
		do: [:str | self processErr: str]
		while: [testBlock value and: [self isActive]]</body>

<body package="SAM-Interface" selector="processStdout:">processStdout: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: [self getStringFrom: stdout]
		do: [:str | self process: str]
		while: [testBlock value and: [self isActive]]</body>

<body package="SAM-Interface" selector="getStringFrom:onError:">getStringFrom: aStream onError: aOneArgumentBlock 
	
	aStream ifNil: [^nil].
	^[aStream peek ifNotNil: [String readNetStringFrom: aStream]] 
		on: Error
		do: 
			[:ex | 
			aOneArgumentBlock value: ex.
			aStream setToEnd.
			nil]</body>

<body package="SAM-Interface" selector="processInventoryChangeEvents:">processInventoryChangeEvents: testBlock 
	
	[testBlock value] 
		whileTrue: [self processNextInventoryChangeEvent]</body>

<body package="SAM-Interface" selector="basicStopExternalProcess:">basicStopExternalProcess: process

	[stdioConnection close] on: Error do: [:ex | ].
	[process kill: 9] on: Error do: [ :ex | ].
	externalProcess := stdioConnection := stdin := stdout := stderr := nil.
	^process</body>

<body package="SAM-Interface" selector="processNextInventoryChangeEvent">processNextInventoryChangeEvent
	
	^inventoryChangeQueue next value</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>commands</category>

<body package="SAM-Interface" selector="sendCommand:">sendCommand: aString 
	"Transcript show: 'COMMAND: ', aString;cr."
	
	[stdin ifNotNil: 
		[:s | 
		self system 
			logDebugFour: #JMS_STDCMD
			messageId: nil
			template: '&lt;1s&gt;'
			arguments: (Array with: aString).
		aString writeNetStringOn: s.
		s flush]] 
			on: Error
			do: 
				[:ex | 
				self processErr: ex description.
				self forceRestartOrSwitch: true]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>logging</category>

<body package="SAM-Interface" selector="logProtocolError:">logProtocolError: ex
	&lt;comment: 'An error occurred in the SAM JMS communication protocol'&gt;
	&lt;probableCause: 'The SAM JMS process died.'&gt;
	&lt;suggestedAction: 'Contact technical support'&gt;

	self system
		logWarning: #SAM_JMS_PROTOCOL_ERROR
		messageId: #DL39217
		template: ##('There was an error communicating with the SAM interface &lt;1s:uri&gt;: &lt;2s:message&gt;' asLogTemplate)
		arguments: [{self uri asString. ex description}].</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>password:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>jarPath:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>queueId:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>user:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>filter:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>samVersion:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>jmsClasses:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>basicStopExternalProcess</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>jmsProperties:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>jmsEvents:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>runJmsProcess:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>uri:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>jmsTimeout:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>javaPath:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvSAMJmsInterface class</class-id> <category>creation</category>

<body package="SAM-Interface" selector="on:">on: aJmsConnection

	^self new
		connection: aJmsConnection;
		yourself</body>
</methods>


<class>
<name>PvSAMInterface</name>
<environment>PROVISO</environment>
<super>PROVISO.PvAbstractSAMInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>primarySwitchOverPollInterval lastPrimarySwitchOverAttempt connection attemptResync environment inFullDump </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>testing</category>

<body package="SAM-Interface" selector="jmsStillAlive">jmsStillAlive
	
	^connection 
		ifNil: [false]
		ifNotNil: [:conn | conn jmsStillAlive]</body>

<body package="SAM-Interface" selector="isInFullDump">isInFullDump

	^inFullDump</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="markNotInFullDump">markNotInFullDump

	inFullDump := false</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="preFullDump">preFullDump
	
	self currentApplication setStatusMessage: 
		'SAM full dump started at: ' , self timeFacade now printString.
	"self stopJms."
	"this is no longer needed because JMS should always be up"
	self cleanupTempDirectory.
	self attemptResync: true.
	inFullDump := true</body>

<body package="SAM-Interface" selector="basicCheckForPrimaryAvailability">basicCheckForPrimaryAvailability
	
	| oldConnection oldPosition |
	self system 
		logWarning: #SAM_CHECK_PRIMARY
		messageId: #DC10617
		text: 'Check for primary SAM server availability'.
	self lastPrimarySwitchOverAttempt: self timeFacade now asSeconds.
	oldPosition := self currentDescriptorPosition.
	"oldDescriptor := self descriptor."
	self currentDescriptorPosition: 1.
	oldConnection := connection.
	self testConnection 
		ifFalse: 
			[connection disconnect.
			self 
				rollbackCurrentConnection: oldConnection
				using: oldPosition.
			^self].
	oldConnection notNil 
		ifTrue: [oldConnection disconnect].
	"self deactivateDescriptor: oldDescriptor."
	self activateSwitchedConnection</body>

<body package="SAM-Interface" selector="postFullDump">postFullDump
	
	self currentApplication ifNotNil: 
		[:anApp | anApp setStatusMessage: 'SAM full dump ended at: ' , self timeFacade now printString].
	"self startJms."
	"this is no longer needed because JMS should always be up"
	self attemptResync: false.
	inFullDump := false</body>

<body package="SAM-Interface" selector="haPerform:">haPerform: aBlock 
	
	| retries |
	retries := 0.
	^self critical: 
		[self isInFullDump ifTrue: [^aBlock value: self connection].
		self tryReconnectInTurnUntilSuccessful.
		[self waitUntilReady.
		
		aBlock value: self connection] 
			on: PvSAMDeviceConnection serverUnreachableError
			do: 
				[:ex | 
				self connection disconnect.
				self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server was lost due to the following error: ' ,	ex messageText printString,'...Retrying connection.'.
				(self 
					test: self normalStateId
					set: self connectingStateId) 
						ifTrue: 
							[self tryReconnectInTurnUntilSuccessful.
							self state: self normalStateId].
				(self timeFacade delayForMilliseconds: 20) wait.
				retries := retries + 1.
				(retries \\ 10 = 0 and: 
					[self system debugFlags at: #DEBUG_WALKBACK_ON_INPUT_ERROR ifAbsent: [false]]) 
						ifTrue: [PvWalkbackWriter new dumpWalkbackForException: ex].
				self startJms.
				ex retry]]</body>

<body package="SAM-Interface" selector="startJms">startJms
	
	connection ifNotNil: [connection jmsInterface ifNotNil: [:jms | jms stillAlive ifFalse: [jms start]]]</body>

<body package="SAM-Interface" selector="activateDescriptor:">activateDescriptor: aDescriptor 
	"enable this connection"
	
	self startJms</body>

<body package="SAM-Interface" selector="rollbackCurrentConnection:using:">rollbackCurrentConnection: oldConnection using: oldPosition 
	
	self currentDescriptorPosition: oldPosition.
	connection := oldConnection.
	self system 
		logWarning: #SAM_PRIMARY_UNAVAILABLE
		messageId: #DC10619
		text: 'Failed to connect to SAM service.'</body>

<body package="SAM-Interface" selector="activateSwitchedConnection">activateSwitchedConnection
	
	self activateDescriptor: self descriptor.
	self attemptResync: true.
	self system 
		logWarning: #SAM_RESTORED_PRIMARY
		messageId: #DC10620
		text: 'Successfully switched back to primary SAM server'</body>

<body package="SAM-Interface" selector="peformFullResync">peformFullResync
	
	self attemptResync 
		ifTrue: [self critical: [self privateResync]]</body>

<body package="SAM-Interface" selector="checkForPrimaryAvailability">checkForPrimaryAvailability
	
	self shouldAttemptPrimarySwitchOver 
		ifFalse: [^self].
	self isInFullDump 
		ifTrue: [^self].
	self basicCheckForPrimaryAvailability</body>

<body package="SAM-Interface" selector="testConnection">testConnection
	
	self jmsStillAlive ifTrue: [^true].
	connection := self connect.
	self system 
		logInfo: #SAM_CONNECT
		messageId: nil
		text: 'Attempting connection to sam server: ' , self descriptor soapURI asString.
	^[connection testConnection.
	true] 
		on: Error
		do: 
			[:err | 
			self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server failed on ' , self descriptor soapURI asString , '. ' , 
						err messageText printString.
			false]</body>

<body package="SAM-Interface" selector="shouldAttemptPrimarySwitchOver">shouldAttemptPrimarySwitchOver
	"subclasses should override to detect availability of the primary cwm server and attempt to reestablish a connection to the primary"
	
	^self isInFullDump not and: 
		[self currentDescriptorPosition ~= 1 and: 
			[self timeFacade now asSeconds - self lastPrimarySwitchOverAttempt &gt;= 
				self primarySwitchOverPollInterval]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>initialize-release</category>

<body package="SAM-Interface" selector="initialize">initialize
	
	super initialize.
	self attemptResync: true.
	lastPrimarySwitchOverAttempt = 0.
	primarySwitchOverPollInterval = 60.
	inFullDump := false.</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>private</category>

<body package="SAM-Interface" selector="cleanupTempDirectory">cleanupTempDirectory

	"do nothing - RA503503"
	"This method was deleted for unknown reasons"</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMInterface</class-id> <selector>isFullDumpPending</selector>
</remove-selector>


<methods>
<class-id>PROVISO.ForeignDomainMethod</class-id> <category>private</category>

<body package="SAM-DomainModel" selector="copy:to:">copy: aURI to: localURI 
	
	| delay copyAttempts |
	delay := 500.
	copyAttempts := 0.
	[(copyAttempts := copyAttempts + 1) &gt; 5 
		ifTrue: 
			[^aURI fileSize isZero 
				ifTrue: 
					[self system 
						logDebugFour: #ACQUIRE_FILE
						text: 'Acquired zero length ' , localURI printString]
				ifFalse: [self error: 'copy attempt limit reached']].
	aURI copyTo: localURI.
	localURI fileSize = aURI fileSize and: [aURI fileSize isZero not]] 
		whileFalse: [(self timeFacade delayForMilliseconds: (delay := delay * 2)) wait]</body>

<body package="SAM-DomainModel" selector="waitFor:">waitFor: aURI 
	
	"Wait up to 5 minutes for an export file to appear"
	| delay deadline |
	deadline := Time totalSeconds + 300.
	delay := 500.
	[aURI exists] 
		whileFalse: 
			[Time totalSeconds &gt; deadline 
				ifTrue: [self error: 'export file not found'].
			(self timeFacade delayForMilliseconds: (delay := delay * 2)) wait]</body>
</methods>

<methods>
<class-id>PROVISO.ForeignDomainMethod</class-id> <category>invocation</category>

<body package="SAM-DomainModel" selector="acquireFile:">acquireFile: aURI 
	
	| localURI |
	self system 
		logDebugFour: #ACQUIRE_FILE
		text: 'Acquiring file ' , aURI asEncryptedString.
	localURI := self exportFilenameLocalDirectory , aURI tail.
	self waitFor: aURI.
	self 
		copy: aURI
		to: localURI.
	self system 
		logDebugFour: #ACQUIRE_FILE
		text: 'Successfully acquired file into ' , localURI printString.
	^localURI</body>
</methods>



<methods>
<class-id>PROVISO.PvSamifApplication</class-id> <category>restart</category>

<body package="SAM-Application" selector="restartIfNeeded">restartIfNeeded
	
	
	self ifServerReady: [:svr | svr restartIfNeeded]</body>
</methods>

<methods>
<class-id>PROVISO.PvSamifApplication</class-id> <category>accessing</category>

<body package="SAM-Application" selector="cronJobSpecification">cronJobSpecification

	"Consolidate the SAM registry on a cron schedule (default is every day at 3:12am)"
	^super cronJobSpecification,
		#(
			(#consolidateSamifRegistry 'SAM_CONSOLIDATION_SCHEDULE' '12 3 * * *')
			(#restartIfNeeded 'RESTART_IF_NEEDED' 'every 1 min')
		)</body>
</methods>


<methods>
<class-id>PROVISO.SamifServiceInstance</class-id> <category>restart</category>

<body package="SAM-Application" selector="isConnectionStillAliveFor:">isConnectionStillAliveFor: aSchema 
	
	self 
		connectionUsing: aSchema
		do: 
			[:schemaConnection | 
			(schemaConnection 
				ifNil: [false]
				ifNotNil: [:conn | conn isConnected]) 
					ifFalse: [^false].
			(schemaConnection jmsInterface 
				ifNil: [false]
				ifNotNil: [:interface | interface stillAlive]) 
					ifFalse: [^false]].
	^true</body>

<body package="SAM-Application" selector="samDeviceSchemaDo:">samDeviceSchemaDo: aBlock 
	
	self inputSchemas do: 
		[:eachSchema | 
		(self isSamDeviceSchema: eachSchema) 
			ifTrue: [aBlock value: eachSchema]]</body>

<body package="SAM-Application" selector="forceRestartOrSwitch">forceRestartOrSwitch
	
	self jmsInterfaceDo: [:interface | interface forceRestartOrSwitch: false]</body>

<body package="SAM-Application" selector="logRestartNeeded">logRestartNeeded
	
	self system 
		logDebugFour: #RESTART_NEEDED
		messageId: #DC10013
		text: 'SAM Processes Down. Restarting now'</body>

<body package="SAM-Application" selector="jmsInterfaceDo:">jmsInterfaceDo: aBlock 
	
	self connectionDo: [:connection | connection jmsInterface ifNotNil: aBlock]</body>

<body package="SAM-Application" selector="restartIfNeeded">restartIfNeeded
	
	[self samDeviceSchemaDo: 
		[:schema | 
		(self isConnectionStillAliveFor: schema) 
			ifFalse: 
				[self logRestartNeeded.
				self forceRestartOrSwitch].
		"simply do an haPerform: and it will do the right thing"
		schema samInterface haPerform: [:conn | ]]] 
			on: Error
			do: [:ex | "ignore"]</body>

<body package="SAM-Application" selector="connectionUsing:do:">connectionUsing: aSchema do: aBlock 
	
	aSchema samInterface ifNotNil: 
		[:samInterface | samInterface connection ifNotNil: aBlock]</body>

<body package="SAM-Application" selector="isSamDeviceSchema:">isSamDeviceSchema: eachSchema 
	
	^eachSchema respondsTo: #samInterface</body>

<body package="SAM-Application" selector="connectionDo:">connectionDo: aBlock 
	
	self samDeviceSchemaDo: 
		[:schema | 
		self 
			connectionUsing: schema
			do: aBlock]</body>
</methods>


<methods>
<class-id>PROVISO.PvSamifServer</class-id> <category>restart</category>

<body package="SAM-Application" selector="restartIfNeeded">restartIfNeeded
	
	self adaptors do: [:eachAdaptor | eachAdaptor restartIfNeeded]</body>
</methods>



<component-property>
<name>PV-SNMP Collector Library</name> <type>package</type>
<property>comment</property> <value>'#
#  SNMP DL, build control file
#  By Stephane ROBIN
#
#
#  CODENAME	: Stream codenames ARUBA, BORNEO, CANARY, DEVON, FIJI, GUAM...
#								Gil, Hawaii, Iona, Jura
#  OS_VERSION	: SOL8/AIX5
#
CODENAME=Jura
#
#  BUILD_NUMBER : corresponding label in the source control for that system	
#
BUILD_NUMBER=65
BUILD_COMMENT=automatic rollup on 081024 1940
#
# Compilations options, a RELEASE build should ALWAYS have CHECKS=DEBUG=PURIFY=0
#
#	-- This introduce assertion in the code, 
#		with error messages visible in the pvmd.log
BUILD_CHECKS=0

#	-- This forces compilation with debug symbols,
BUILD_DEBUG=0

#	-- This produces a binary usable with Rational Purify
#		for memory checks (very significant performace hit)
BUILD_PURIFY=0

#	-- This produces a binary usable with Rational PureCoverage
#		for code coverage reports
BUILD_PURECOV=0

#	-- This produces a binary usable with Rational Quantify
#		for profiling
BUILD_QUANTIFY=0

#	-- Use with lock_lint SUN tool
BUILD_LOCKLINT=0


# 	IMPORTANT !!
#	This section is NOT used by this version of the build tool
#	This section has been added to the VERSION_CONTROl file, for the
#	sole benefit of the checkBuild scripts, that needs this information
#	to asses whether or not all build targets have been produced/tested
#
#[uname]		[uname -p]	[Targets ...]					:[suggested build machine name]
SunOS			sparc		PROX	ORA8 	ORA9			:cme4
'</value>
</component-property>


<methods>
<class-id>PROVISO.ProbeDatabaseInterface</class-id> <category>accessing</category>

<body package="PV-SNMP Collector" selector="routerProbePropertiesForCollector:do:">routerProbePropertiesForCollector: collectorId do: aBlock

	| sql propMap propertyList propIdString bindVars |
	propertyList := #('probeRebootCheckInterval' 'probeResyncInterval').
	propMap := Dictionary new.
	propertyList do: [ :propName | propMap at: (self propertyIdFor: propName) put: propName].
	
	sql := 
		'Select /*+ USE_NL(r p) NO_MERGE(r) */ r.Idx_Ind, p.Idx_Metric, p.Str_Value
  			From Prop_Desc p,
       			( Select e.Idx_Ind
           				From ELMT_DESC e
          				Where e.Int_Collector = :1
          			Union All
         			Select /*+ USE_NL(e s) */ s.Idx_Ind
           				From SE_DESC s, ELMT_DESC e
					Where 
						e.Idx_Ind = s.Idx_Host And 
						e.Int_Collector = :1 ) r
			Where 
				p.Idx_Resource = r.Idx_Ind And 
				p.Idx_Metric In ( &lt;1s&gt; )'.

	propIdString := String streamContents: [ :s | (2 to: (propMap size + 1)) do: [ :i | s nextPutAll: ':'; print: i] separatedBy: [s nextPutAll: ', ']].
	bindVars := (Array with: collectorId), propMap keys asArray.
	self dbSession 
		readRowsWith: (sql expandMacrosWith: propIdString)
		bindVars: bindVars
		into: [ :row | aBlock value: row first value: (propMap at: row second) value: row third ].</body>
</methods>



<methods>
<class-id>PROVISO.UBA.UBAComponent</class-id> <category>state recovery</category>

<body package="NGUBA-Application" selector="langolierOperatorState">langolierOperatorState
	" Find out what is the earliest period in the graph and langolier all saved state that precedes this period "
	
	self langolierOperatorStateOlderThan: self earliestPeriod</body>

<body package="NGUBA-Application" selector="langolierOperatorStateOlderThan:">langolierOperatorStateOlderThan: aTimestampInteger
	
	StreamOperatorVisitor 
		visit: self
		forEachOperatorDo: 
			[:each | each ifNotNil: [:operator | operator langolierOlderThan: aTimestampInteger]]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.PvAggregator class</class-id> <selector>smeeNewWith:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.ModelAccessor</class-id> <category>events</category>

<body package="NGUBA-Application" selector="onResync:">onResync: aNiladicBlock 
	
	self pvModel resyncAgent onPostResync: aNiladicBlock</body>
</methods>

<methods>
<class-id>PROVISO.UBA.ModelAccessor</class-id> <category>private-metadat resync</category>

<body package="NGUBA-Application" selector="resetMetadataSelectors">resetMetadataSelectors
	
	metadataSelectors := #(elementManager subelementManager formulaManager propertyManager relationManager eventManager eventPropertyManager eventRelationManager)</body>
</methods>


<methods>
<class-id>PROVISO.UBA.AbstractStreamWriter</class-id> <category>private</category>

<body package="NGUBA-Application" selector="filenameForStream:">filenameForStream: aPvFmBofStreamOrInternalStream 
	
	^[aPvFmBofStreamOrInternalStream filename] onImmediateNotUnderstoodDo: [nil]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>back end callbacks</category>

<body package="NGUBA-Application" selector="process:">process: aProcessorAcceptor

	aProcessorAcceptor acceptProcessor: self</body>

<body package="NGUBA-Application" selector="processInputDescriptor:">processInputDescriptor: anInputDescriptor 
	
	[self maxTimestamp: 0.
	self 
		process: anInputDescriptor
		ifValidDo: 
			[:validDesc | 
			self schema triggerOnOpenWith: validDesc.
			self sendStartHeartbeat: validDesc timestamp.
			self system extendedStatus: 
				'Processing ' , validDesc localName , ' for ' , 
					validDesc timestamp pvOpportunisticPrintString.
			self schema 
				parseInput: validDesc
				notifying: self.
			self schema triggerOnCloseWith: validDesc.
			self finishParsingFor: validDesc]] 
				on: Error
				do: 
					[:ex | 
					self 
						handleInputError: ex
						for: anInputDescriptor]</body>

<body package="NGUBA-Application" selector="processHeartbeat:">processHeartbeat: aPvHeartbeat

	"do nothing"</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>state recovery</category>

<body package="NGUBA-Application" selector="saveStateFor:">saveStateFor: anInputDescriptor 
	" Transfer all stats from the schema to the input descriptor and commit it "
	
	anInputDescriptor maxTimestamp: self maxTimestamp.
	anInputDescriptor save</body>

<body package="NGUBA-Application" selector="langolierOlderThan:">langolierOlderThan: aTsNumber 
	" Delete old state versions older than aTsNumber. In our case simply move all input files with data older than aTsNumber 
	that are already processed to done directory "

	| count all time |
	self system 
		logInfo: #SCAVENGE_OLD_DESCRIPTORS
		text: 'Scavenging old input descriptors'.
	count := 0.
	all := 0.
	time := Time millisecondsToRun: 
		[self schema myInputDescriptorsDo: 
			[:eachDescriptor | 
			all := all + 1.
			(self 
				canLangolier: eachDescriptor
				ifOlderThan: aTsNumber) 
					ifTrue: 
						[count := count + 1.
						eachDescriptor ifAlreadyProcessedMoveToDone]]].
	self system 
		logInfo: #PERF_SCAVENGE_OLD_DESCRIPTORS
		template: 'Found &lt;1p&gt; obsolete input descriptors among total of &lt;2p&gt; in &lt;3s&gt; seconds'
		arguments: {count. all. (time / 1000.0d) asDouble asPvPrintString}</body>

<body package="NGUBA-Application" selector="canLangolier:ifOlderThan:">canLangolier: eachDescriptor ifOlderThan: aTsNumber 
	
	^(eachDescriptor maxTimestamp ifNil: [0]) &lt;= aTsNumber</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>building</category>

<body package="NGUBA-Application" selector="connectAsInputToSingleInputOperator:builder:">connectAsInputToSingleInputOperator: aClientOperator builder: aPlanBuilder 
	" Second leg of dispatch. We now know that the client is a single-input operator, 
	now dispatch based on the input type -- in this case input schema "
	
	self schema handlerBlock: [:eachInput | self process: eachInput].
	self startAsDaemon: false.		" Processing is synchronous "
	^aPlanBuilder 
		connectInputSchema: self
		toSingleInputOperator: aClientOperator</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>parsing callbacks</category>

<body package="NGUBA-Application" selector="finishParsingFor:">finishParsingFor: anInputDescriptor 
	
	anInputDescriptor stopTimestamp: SmeeDate nowUTC.
	anInputDescriptor stream: nil.
	self sendEndHeartbeat: anInputDescriptor timestamp.
	self saveStateFor: anInputDescriptor.
	anInputDescriptor logStopProcessingInput.
	" Send heartbeat downstream "</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="processLoop">processLoop

	self process: self queue next</body>

<body package="NGUBA-Application" selector="process:ifValidDo:">process: anInputDescriptor ifValidDo: aBlock 
	
	| currentDesc |
	currentDesc := 
		self schema inputDescriptors
			at: anInputDescriptor name
			ifAbsent: [anInputDescriptor].
	currentDesc alreadyProcessed 
		ifTrue: [^self].
	currentDesc ignore 
		ifTrue: 
			[currentDesc doNotProcess.
			^self].
	(self schema isValidInputDesctriptor: anInputDescriptor) 
		ifFalse: 
			[self schema logInputDecriptorMissingFor: anInputDescriptor.
			anInputDescriptor doNotProcess.
			^self].
	((self hasValidTimestampForDescriptor: anInputDescriptor) and: 
		[self schema filePeriod notNil]) 
			ifFalse: [self logNoTimestampForDescriptor: anInputDescriptor].
	self descriptor: anInputDescriptor.
	anInputDescriptor adaptor: self.
	[aBlock value: currentDesc] 
		ensure: 
			[self descriptor: nil.
			anInputDescriptor adaptor: nil]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.InputSchemaProcessor</class-id> <selector>logStopProcessingInput:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>back end callbacks</category>

<body package="NGUBA-Application" selector="processHeartbeat:">processHeartbeat: aPvHeartbeat

	self checkForEndOfPeriod: aPvHeartbeat timestamp.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>public</category>

<body package="NGUBA-Application" selector="schema:">schema: anInputSchema

	super schema: anInputSchema.
	self setPeriod: (anInputSchema filePeriod ifNil: [1]).</body>

<body package="NGUBA-Application" selector="processInputDescriptor:">processInputDescriptor: anInputDescriptor 
	
	| stream seconds |
	(self shouldIgnore: anInputDescriptor) 
		ifTrue: [^self].
	((self hasValidTimestampForDescriptor: anInputDescriptor) or: 
		[self schema filePeriod isNil]) 
			ifFalse: [self logNoTimestampForDescriptor: anInputDescriptor].
	seconds := anInputDescriptor timestamp asPvTimestamp asSeconds.
	self checkForEndOfPeriod: seconds.
	stream := self newStreamFor: anInputDescriptor.
	descriptorStreams at: anInputDescriptor put: stream.
	mergeStream addStream: stream</body>
</methods>

<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>private</category>

<body package="NGUBA-Application" selector="checkForEndOfPeriod:">checkForEndOfPeriod: seconds 
	
	| period |
	period := self periodPolicy startOfPeriodContainingTimestamp: seconds.
	self periodPolicy start ifNil: [self periodPolicy start: period].
	self periodPolicy start = period 
		ifFalse: 
			[self processAll.
			self periodPolicy start: period]</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.UBA.ModelGenerator</class-id> <selector>onResync:</selector>
</remove-selector>


</st-source>
